{
Comentarii Interesante:

Pentru N MOD 3 = 0 -> SOL = 2*(2+4+6+..+N DIV 3*2) +
                               2+4+6+..+N DIV 3*2 - 2;

               = 1 -> SOL =    1+3+5+...+N DIV 3 * 2 + 1
                               1+3+5+...+N DIV 3 * 2 - 1 +
                               2+4+6+...+N DIV 3 * 2;

               = 2 -> SOL = 2*(1+3+5+...+N DIV 3 * 2 + 1)
                               2+4+6....+N DIV 3 * 2;

Reiau:

Pentru N MOD 3 = 0 -> SOL = 2*Progresie_Para_Cu_N_Div_3_Termeni +
                              Progresie_Para_Cu_N_Div_3-1_Termeni;

               = 1 -> SOL =   Progresie_Impara_Cu_N_Div_3+1_Termeni +
                              Progresie_Impara_Cu_N_Div_3_Termeni +
                              Progresie_Para_Cu_N_Div_3_Termeni

               = 2 -> SOL = 2*Progresie_Impara_Cu_N_Div_3+1_Termeni +
                              Progresie_Para_Cu_N_Div_3-1_Termeni;

}
program sala;
const
  sin='sala.in';
  sout='sala.out';
  maxn=101;
  MODULO=10;
  NCifre=1;
  NDigits=300;
type
  TBigNumber=array[0..NDigits]of longint;
  pBigNumber=^TBigNumber;
var
  fin,fout:text;
  Sol,N,N3,N3M,N3P:TBigNumber;
  EvenProgressionN3     : TBigNumber;
  EvenProgressionN3M    : TBigNumber;
  OddProgressionN3P     : TBigNumber;
  OddProgressionN3      : TBigNumber;
function max(a,b:longint):longint;
begin
  if a>b then max:=a
         else max:=b;
end;

procedure MultiplyOffset(return:pBigNumber;p:pBigNumber;q,offset:longint);
var
  poz:longint;
  rest:longint;
  new_rest:longint;
begin
  rest:=0;
  for poz:=1 to p^[0] do
    begin
      new_rest:=(return^[poz+offset]+rest+q*p^[poz]) div MODULO;
      return^[poz+offset]:=(return^[poz+offset]+rest+q*p^[poz]) mod MODULO;
      rest:=new_rest;
      return^[0]:=max(return^[0],poz+offset);
    end;
  while rest<>0 do
    begin
      inc(return^[0]);
      new_rest:=(return^[return^[0]]+rest) div MODULO;
      return^[return^[0]]:=(return^[return^[0]] + rest) mod MODULO;
      rest:=new_rest;
    end;
end;

procedure Multiply(return,a,b:pBigNumber);
var
  poz:longint;
begin
{  fillchar(return^,sizeof(return^),0);}
  for poz:=1 to a^[0] do
    MultiplyOffset(return,b,a^[poz],poz-1);
end;

procedure read_data;
var
  i:longint;
begin
  assign(fin,sin);
  reset(fin);
  read(fin,N[0]);
  for i:=1 to N[0] do
    read(fin,N[N[0]-i+1]);
  close(fin);
end;

procedure GetSquare(return,n:pBigNumber);
begin
  Multiply(return,n,n);
end;

function GetModulo3(p:pBigNumber):longint;
var
  poz,rest:longint;
begin
  rest:=0;
  for poz:=p^[0] downto 1 do
    rest:=(rest*MODULO+p^[poz]) mod 3;
  GetModulo3:=rest;
end;

procedure DivideBy3(return:pBigNumber;p:pBigNumber);
var
  poz,rest,new_rest:longint;
begin
  rest:=0;
  for poz:=p^[0] downto 1 do
    begin
      new_rest:=(p^[poz]+rest*MODULO) mod 3;
      return^[poz]:=(p^[poz]+rest*MODULO) div 3;
      rest:=new_rest;
    end;
  return^[0]:=p^[0];
  while (return^[return^[0]]=0)and(return^[0]<>1) do
    dec(return^[0]);
end;

procedure Increment(p:pBigNumber);
var
  rest,new_rest,poz:longint;
begin
  rest:=1;
  poz:=0;
  while rest<>0 do
    begin
      inc(poz);
      new_rest:=(rest+p^[poz])DIV MODULO;
      p^[poz]:=(rest+p^[poz])MOD MODULO;
      rest:=new_rest;
    end;
  if poz>p^[0] then
    p^[0]:=poz;
end;

procedure Decrement(p:pBigNumber);
var
  rest,new_rest,poz:longint;
begin
  rest:=1;
  poz:=0;
  while rest<>0 do
    begin
      inc(poz);
      if (p^[poz]-rest<0) then
        new_rest:=1
      else
        new_rest:=0;
      if (p^[poz]-rest<0) then
        p^[poz]:=p^[poz]+MODULO-rest
      else
        p^[poz]:=p^[poz]-rest;
      rest:=new_rest;
    end;
  while (p^[p^[0]]=0)and(p^[0]<>1) do
    dec(p^[0]);
end;

procedure MultiplyInt(p:pBigNumber;q:longint);
var
  poz:longint;
  rest:longint;
  new_rest:longint;
begin
  rest:=0;
  for poz:=1 to p^[0] do
    begin
      new_rest:=(rest+q*p^[poz]) div MODULO;
      p^[poz]:=(rest+q*p^[poz]) mod MODULO;
      rest:=new_rest;
    end;
  while rest<>0 do
    begin
      inc(p^[0]);
      p^[p^[0]]:=rest mod MODULO;
      rest:=rest div MODULO;
    end;
end;

function max_s(a,b:longint):longint;
begin
  if a>b then
    max_s:=a
  else
    max_s:=b;
end;

function min_s(a,b:longint):longint;
begin
  if a<b then
    min_s:=a
  else
    min_s:=b;
end;

procedure Add(p1,p2:pBigNumber);
var
  poz:longint;
  maxp:longint;
  minp:longint;
  rest:longint;
  new_rest:longint;
  ret,p3:pBigNumber;
begin
  ret:=p1;
  maxp:=max_s(p1^[0],p2^[0]);
  minp:=min_s(p1^[0],p2^[0]);
  rest:=0;
  for poz:=1 to minp do
    begin
      new_rest:=(rest+p1^[poz]+p2^[poz]) DIV MODULO;
      ret^[poz]:=(rest+p1^[poz]+p2^[poz]) MOD MODULO;
      rest:=new_rest;
    end;
  if p1^[0]<p2^[0] then
    begin
      p3:=p1;
      p1:=p2;
      p2:=p3;
    end;
  {p1^[0]>p2^[0]}
  for poz:=minp+1 to maxp do
    begin
      new_rest:=(rest+p1^[poz]) DIV MODULO;
      ret^[poz]:=(rest+p1^[poz]) MOD MODULO;
      rest:=new_rest;
    end;
  ret^[0]:=maxp;
  while rest<>0 do
    begin
      inc(ret^[0]);
      ret^[p1^[0]]:=rest mod MODULO;
      rest:=rest div MODULO;
    end;
end;

procedure OddProgression(return,n:pBigNumber);
begin
  GetSquare(return,n); {N^2}
end;

procedure EvenProgression(return,n:pBigNumber);
begin
  GetSquare(return,n);
  Add(return,n); {N^2 + N}
end;

procedure comp_data;
begin
  DivideBy3(@N3,@n); {N3 = N DIV 3}
  N3M:=N3;  Decrement(@N3M);
  N3P:=N3;  Increment(@N3P);
  case GetModulo3(@n) of
    0:begin
        EvenProgression(@EvenProgressionN3,@N3);
        EvenProgression(@EvenProgressionN3M,@N3M);
        sol:=EvenProgressionN3;
        MultiplyInt(@sol,2);
        Add(@sol,@EvenProgressionN3M);
      end;
    1:begin
        OddProgression(@OddProgressionN3P,@N3P);
        OddProgression(@OddProgressionN3,@N3);
        EvenProgression(@EvenProgressionN3,@N3);
        Add(@Sol,@OddProgressionN3P);
        Add(@Sol,@OddProgressionN3);
        Add(@Sol,@EvenProgressionN3);
      end;
    2:begin
        OddProgression(@OddProgressionN3P,@N3P);
        EvenProgression(@EvenProgressionN3,@N3);
        Add(@Sol,@OddProgressionN3P);
        MultiplyInt(@Sol,2);
        Add(@Sol,@EvenProgressionN3);
      end;
  end;
end;

procedure PrintNumber(p:pBigNumber);
var
  s:string;
  i,poz:longint;
begin
  Str(p^[p^[0]],s);
  write(fout,s);
  for poz:=p^[0]-1 downto 1 do
    begin
      Str(p^[poz]:NCifre,s);
      i:=1;
      while S[i]=' ' do
        begin
          s[i]:='0';
          inc(i);
        end;
      write(fout,s);
    end;
  writeln(fout);
end;

procedure write_sol;
begin
  assign(fout,sout);
  rewrite(fout);
  PrintNumber(@sol);
  close(fout);
end;

begin
  read_data;
  comp_data;
  write_sol;
  halt(0);
end.
