#include <stdio.h>

#define N 5010
#define T 110

int n, k, m;
int a[T][T], f[T][T], c[T], t[T];
int t1[N], t2[N], used[N];


void read ()
{
   FILE *f;
   int i;

   f = fopen( "ghizi.in", "rt" );
   fscanf( f, "%d%d", &n, &k );
   for ( i = 1; i <= n; i++ )
   {
      fscanf( f, "%d%d", &t1[i], &t2[i] );
      a[t1[i]][t2[i]]++;
   }
   fclose( f );
}

void bf ()
{
   int p, e, i, j;

   memset( t, 0, sizeof( t ) );

   c[1] = i = 0;
   for ( p = e = 1; p <= e; p++ )
      for ( i = c[p], j = 1; j <= 100; j++ )
         if ( !t[j] && ( a[i][j] && f[i][j] < a[i][j] ||
              a[j][i] && f[j][i] ) )
         {
            c[++e] = j;
            t[j] = i;
            if ( j == 100 ) return;
         }
}

void flow ()
{
   int i, j;
   int min = 0, flow;
   
   for ( flow = 0; flow < k; flow += min )
   {
      bf();
      min = 2000000000;
      for ( j = 100; j; j = t[j] )
      {
         i = t[j];
         if ( a[i][j] && a[i][j] - f[i][j] < min )
            min = a[i][j] - f[i][j];
         else if ( a[j][i] && f[j][i] < min )
            min = f[j][i];
      }

      if ( flow + min > k ) min = k - flow;

      for ( j = 100; j; j = t[j] )
      {
         i = t[j];
         if ( a[i][j] && f[i][j] < a[i][j] )
            f[i][j] += min;
         else if ( a[j][i] && f[j][i] )
            f[j][i] -= min;
      }
   }
}

void solve ()
{
   int i;
   
   flow();
   for ( i = 1; i <= n; i++ )
       if ( f[t1[i]][t2[i]] )
          f[t1[i]][t2[i]]--,
          used[i] = 1,
          m++;
}

void print ()
{
   int i;
   FILE *fout;

   fout = fopen( "ghizi.out", "wt" );
   fprintf( fout, "%d\n", m );
   for ( i = 1; i <= n; i++ )
       if ( used[i] )
          fprintf( fout, "%d ", i );
   fprintf( fout, "\n" );
   fclose( fout );
}

int main ()
{
   read();
   solve();
   print();
   return 0;
}
