{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,0}

Type TBigNo = Record
              Size: Word;
              Num: Array[1..300] Of Integer;
              End;

Var N, Np1, DRes, Res: TBigNo;

Procedure LargeInc(Var A: TBigNo);
Var Carry: Byte;
    Pos: Word;
Begin
Pos:=1;
Carry:=1;
While Carry=1 Do Begin
      If A.Size<Pos Then Begin
         A.Size:=Pos;
         A.Num[Pos]:=0;
         End;
      Inc(A.Num[Pos]);
      If A.Num[Pos]>9 Then Dec(A.Num[Pos], 10)
                      Else Carry:=0;
      Inc(Pos);
      End;
End;

Procedure LargeMul(Var A, B, C: TBigNo);
Var IA, IB, IC, Carry: Word;
Begin
For IA:=1 To A.Size Do
    For IB:=1 To B.Size Do Begin
        Carry:=A.Num[IA]*B.Num[IB];
        IC:=IA+IB-1;
        While Carry<>0 Do Begin
              If C.Size<IC then C.Size:=IC;
              Inc(C.Num[IC], Carry);
              Carry:=C.Num[IC] Div 10;
              C.Num[IC]:=C.Num[IC] Mod 10;
              Inc(IC);
              End;
        End;
End;

Function LargeDiv(Var A: TBigNo; Oszto: Byte; Var B: TBigNo): Byte;
Var IA, IB, Carry: Word;
Begin
Carry:=0;
IB:=A.Size;
B.Size:=IB;
For IA:=A.Size DownTo 1 Do Begin
    Carry:=10*Carry+A.Num[IA];
    B.Num[IB]:=Carry Div Oszto;
    Carry:=Carry Mod Oszto;
    Dec(IB);
    End;
While B.Num[B.Size]=0 Do
      Dec(B.Size);
LargeDiv:=Carry;
End;

Procedure Init;
Var F: Text;
    I: Word;
Begin
Assign(F, 'sala.in');
Reset(F);
ReadLn(F, N.Size);
For I:=N.Size DownTo 1 Do
    Read(F, N.Num[I]);
Close(F);
End;

Procedure Main;
Begin
If (N.Size=1)And(N.Num[1]=1) Then Begin
   Res.Size:=1;
   Res.Num[1]:=1;
   End
Else Begin
     Np1:=N;
     LargeInc(Np1);
     LargeMul(Np1, N, DRes);
     If LargeDiv(DRes, 3, Res)<>0 Then LargeInc(Res);
     End;
End;

Procedure Done;
Var F: Text;
    I: Word;
Begin
Assign(F, 'sala.out');
ReWrite(F);
For I:=Res.Size DownTo 1 Do
    Write(F, Res.Num[I]);
WriteLn(F);
Close(F);
End;

Begin
Init;
Main;
Done;
End.
