#include <stdio.h>

struct COD {
	int s;
	COD *urm;
};

struct alf {
	COD *l;
	};
alf a[36];

void calibr(int);

unsigned long frecv[37];

int partitie(int l, int r)
{
	long x = frecv[l];
	int i = l - 1, j = r + 1;
	while(1)
	{
		do i++; while(frecv[i] < x);
		do j--; while(frecv[j] > x);
		if(i<j) {frecv[i] ^= frecv[j] ^= frecv[i] ^= frecv[j];}
		else return j;
	}
}

void sortare(int l, int r)
{
	if(l<r)
	{
		int q = partitie(l,r);
		sortare(l,q);
		sortare(q+1,r);
	}
}

void citire()
{
	FILE *f = fopen("telegraf.in","rt");
	for(int i=1;i<=36;i++)
		fscanf(f,"%ld",&frecv[i]);
	fclose(f);

}

void AdaugaNod(COD *p, COD *q,int k)
{
	if(p->urm == NULL && q->urm == NULL)
	{
		COD *n = new COD; n->s = 1; n->urm = NULL; p->urm = n;
		COD *m = new COD; m->s = 2; m->urm = NULL; q->urm = m;
	}
	else
		{
			COD *n = new COD; n->urm = NULL;
			if(p->urm->s == 1) n->s = 2;
			else n->s = 1;
			q->urm = n; calibr(k);
		}

}

void calibr(int k)
{
	COD *c;  int ok = 1;
	for(int i=36;i>k;i--)
	{
		c = a[k].l; ok = 1;
		COD *p = a[i].l;
		while(c->s == p->s)
			if(c->urm == NULL || p->urm == NULL) {AdaugaNod(p,c,k);ok = 0; break;}
			else {c = c->urm; p = p->urm;}
		if(!ok) return;
	}
}

void codare(int k)
{
	COD *p = new COD;
	if(!(k%2)) p->s = 1;
	else p->s = 2;
	p->urm = NULL;
	a[k].l = p;
	calibr(k);

}

void calcul()
{
	COD *p;
	int i; unsigned long s = 0;
	for(i=36;i>0 && frecv[i];i--)
	{
		p = a[i].l;
		while(p) {s += frecv[i]*p->s; p = p->urm;}
	}
	FILE *f = fopen("telegraf.out","wt");
	fprintf(f,"%ld\n",s);
	fclose(f);

}

int main()
{
	citire();
	sortare(1,36);
	for(int i=36;i>0 && frecv[i];i--) codare(i);
	calcul();
	return 0;
}
