{$I-,Q-,R-}

uses math;

const MaxN=10000;
      err=0.001;

type punct=record
       x,y:longint;
     end;

var n:integer;
    m:punct;
    sz:array[1..MaxN] of byte;
    sl:integer;
    u:array[1..MaxN] of extended;

  procedure load;
  var f:text;
      i:integer;
  begin
    assign(f,'robot.in');
    reset(f);
    readln(f,n);
    for i:=1 to n do
      readln(f,sz[i]);
    readln(f,m.x,m.y);
    close(f);
  end;

  procedure solve;
  var d,x,_u_:extended;
      l,t:longint;
      i,q:integer;
  begin
    sl:=0;
    d:=sqrt(sqr(m.y)+sqr(m.x));
    l:=0;
    for i:=1 to n do
      l:=l+sz[i];
    if d>l+err then exit;
    t:=0;
    for i:=1 to n-1 do begin
      if sz[i]<=l-sz[i] then begin
         if (d>l-2*sz[i]-err) and (d<l+err) then begin
           sl:=1;
           q:=i;
           break;
         end else u[i]:=180;
      end else begin
        x:=sqrt(sqr(sz[i])+sqr(l-sz[i]));
        if (d>x-err) and (d<l+err) then begin
          sl:=1;
          q:=i;
        end else
        if (d>t-x-err) and (d<t+x+err) then begin
          sl:=1;
          q:=i;
        end;
        break;
      end;
      t:=t+sz[i];
      l:=l-2*sz[i];
    end;
    if sl=0 then exit;
    _u_:=arctan2(m.x,m.y);
    _u_:=_u_*180/pi;
    u[q]:=sqr(l-sz[q])+sqr(sz[q])-sqr(d-t);
    u[q]:=u[q]/((l-sz[q])*sz[q]);
    u[q]:=arccos(u[q]/2);
    u[q]:=u[q]*180/pi;
    u[q]:=360-u[q];
    for i:=1 to n do
      u[i]:=u[i]+_u_;
  end;

  procedure sol;
  var f:text;
      i:integer;
  begin
    assign(f,'robot.out');
    rewrite(f);
    if sl=0 then
      writeln(f,0)
    else
      for i:=1 to n do
        writeln(f,u[i]:1:4);
    close(f);
  end;

begin

  load;
  solve;
  sol;

end.