#include <stdio.h>

#define N 105
#define CIFRE 150

int n, k, p;
int a[N][N][CIFRE];
int b[CIFRE];

void ADD (int *x, int *y);
void ADD_MUL (int *x, int *y, int P);

void read ()
{
   FILE *f = fopen( "ex.in", "rt" );
   fscanf( f, "%d%d%d", &n, &k, &p );
   fclose( f );
}

void solve ()
{
   int i, j;
   
   a[k][k][0] = a[k][k][1] = 1;
   for ( i = k; i < n; i++ )
      for ( j = k; j <= p; j++ )
         ADD_MUL( a[i + 1][j], a[i][j], j ),
         ADD( a[i + 1][j + 1], a[i][j] );
}

void print ()
{
   int i;
   FILE *fout = fopen( "ex.out", "wt" );

   if ( !a[n][p][0] )
      a[n][p][0] = 1;

   i = a[n][p][0];
   if ( a[n][p][i] / 10 )
      fprintf( fout, "%d", a[n][p][i] / 10 );
   fprintf( fout, "%d", a[n][p][i] % 10 );
      
   for ( i--; i; i-- )
      fprintf( fout, "%d%d", a[n][p][i] / 10, a[n][p][i] % 10 );
   fprintf( fout, "\n" );
   fclose( fout );
}

int main ()
{
   read();
   solve();
   print();
   return 0;
}

void ADD (int *x, int *y)
{
   int i, t = 0;
   
   if ( y[0] > x[0] )
      x[0] = y[0];

   for ( i = 1; i <= x[0]; i++ )
      x[i] += y[i] + t,
      t = x[i] / 100,
      x[i] %= 100;

   while ( t ) x[++x[0]] = t % 100, t /= 100;
}

void ADD_MUL (int *x, int *y, int P)
{
   int t = 0, i;
   
   memcpy( b, y, sizeof( b ) );
   for ( i = 1; i <= b[0]; i++ )
      b[i] = b[i] * P + t,
      t = b[i] / 100,
      b[i] %= 100;

   while ( t ) b[++b[0]] = t % 100, t /= 100;

   ADD( x, b );
}

