#include<stdio.h>
#include<math.h>

int N;
double L[10002];
double LI[10002];
double LS[10002];
double XF,YF;
double U[10002];

#define MY_PI M_PI
#define eps 0.000001

int main()
{
	int i;
	double r,r2,min2,max2;
	double base,ut;
	FILE* f;
	f=fopen("robot.in","r");
	fscanf(f,"%d",&N);
	for(i=1;i<=N;i++)
		fscanf(f,"%lf",&L[i]);
	fscanf(f,"%lf%lf",&XF,&YF);
	fclose(f);
	LS[1]=L[1];
	LI[1]=L[1];
	for(i=2;i<=N;i++)
	{
		LS[i]=LS[i-1]+L[i];
		LI[i]=fabs(LI[i-1]-L[i]);
		if(LI[i]>fabs(LS[i-1]-L[i]))
			LI[i]=fabs(LS[i-1]-L[i]);
		if((LS[i-1]-L[i])*(LI[i-1]-L[i])<0)LI[i]=0;
	}
	r=hypot(XF,YF);
	base=(fabs(XF)<=eps && fabs(YF)<=eps)?0:atan2(YF,XF);
	f=fopen("robot.out","w");
	if(!(LI[N]-eps>=r || LS[N]+eps<=r))
	{
		for(i=N-1;i>=1;i--)
		{
			min2=fabs(r-L[i+1]);
			max2=r+L[i+1];
			if(min2<LI[i])r2=LI[i];
			else if(max2>LS[i])r2=LS[i];
			else r2=max2;
			//r2=(LS[i]+LI[i])/2;
			
			U[i+1]=acos((r2*r2+L[i+1]*L[i+1]-r*r)/(2*r2*L[i+1]));
			base+= acos((r2*r2+r*r-L[i+1]*L[i+1])/(2*r*r2));
			U[i+1]=-MY_PI+U[i+1]+base;
			r=r2;
		}
		U[1]=base;
		U[1]=fmod(U[1],2*MY_PI);
		for(i=1;i<=N;i++)
		{
			ut=U[1];
			if(i>1){ut=U[i]-U[i-1];ut+=10*M_PI;ut=fmod(ut,2*MY_PI);}
			fprintf(f,"%.5lf\n",ut*180.0/MY_PI);
		}
	}
	else fprintf(f,"0\n");
	fclose(f);
	return 0;
}
