// Baraj - Ziua 1 - Ex

#include <stdio.h>
#include <string.h>

#define input "ex.in"
#define output "ex.out"
#define NMAX 111

FILE *f;
int n, k, p;
char a[NMAX][NMAX][200];

void readdata()
{
	f = fopen(input, "rt");
	fscanf(f, "%d %d %d", &n, &k, &p);
	fclose(f);
}

void solve()
{
	int i, j, kk, l, pp;
	memset(a, 0, sizeof(a));
	a[k][k][0] = a[k][k][1] = 1;
	for (i = k; i <= p; i++, a[i][i][0] = a[i][i][1] = 1)    // p
		for (j = i + 1; j <= n; j++)                         // n
		{
			// imul cu i pe a[i][j - 1];
			// a[i][j] = a[i - 1][j - 1] + i * a[i][j - 1];
			kk = 0;
			a[i][j][0] = a[i][j - 1][0];
			for (l = 1; l <= a[i][j - 1][0]; l++)
			{
				pp = a[i][j - 1][l] * i + kk;
				kk = pp / 10; a[i][j][l] = pp % 10;
			}
			while (kk)
				a[i][j][++a[i][j][0]] = kk % 10, kk /= 10;

			// adun a[i - 1][j - 1] la a[i][j]
			if (a[i - 1][j - 1][0] > a[i][j][0]) a[i][j][0] = a[i - 1][j - 1][0];
			for (kk = 0, l = 1; l <= a[i][j][0]; l++)
			{
				a[i][j][l] += a[i - 1][j - 1][l] + kk;
				kk = a[i][j][l] / 10; a[i][j][l] %= 10;
			}
			if (kk) a[i][j][++a[i][j][0]] = kk;
		}
	f = fopen(output, "wt");
	for (i = a[p][n][0]; i; i--)
		fprintf(f, "%d", a[p][n][i]);
	fprintf(f, "\n");
	fclose(f);
}

int main()
{
	readdata();
	solve();
	return 0;
}