// Baraj - Ziua 1 - Telegraf

#include <stdio.h>
#include <string.h>

#define input "telegraf.in"
#define output "telegraf.out"

FILE *f;
int n;
long s[100], cmin = 0;

void readdata()
{
	int i;
	long ap;
	f = fopen(input, "rt");
	for (i = 0; i < 36; i++)
	{
		fscanf(f, "%ld", &ap);
		if (ap) s[n++] = ap;
	}
	fclose(f);
}

long min(long a, long b)
{
	return (a > b) ? b : a;
}

void solve()
{
	int i, j;
	for (i = 0; i < n; i++)
		for (j = i + 1; j < n; j++)
			if (s[i] < s[j])
				s[i] = (s[i] ^ s[j]) ^ (s[j] = s[i]);
	if (n == 2) cmin = s[0] + 2 * s[1];
	if (n == 3) cmin = min(s[0] + s[1] * 3 + s[2] * 4, s[0] * 2 + s[1] * 2 + s[2] * 3);
	if (n == 4) cmin = 2 * s[0] + 3 * s[1] + 3 * s[2] + 4 * s[3];
	f = fopen(output, "wt");
	fprintf(f, "%ld", cmin);
	fclose(f);
}

int main()
{
	readdata();
	solve();
	return 0;
}