#include <stdio.h>
#include <stdlib.h>
#include <string.h>

unsigned long freq[36];
FILE *file;

void Init(void);
void Free(void);

void Solve(void);
void _qsort(int ll, int rl);

void main(void)
{
 Init();
 Solve();
 Free();
}

void Init(void)
{
 int i;
 file=fopen("telegraf.in","r");
 for (i=0;i<36;i++)
  fscanf(file,"%d",freq+i);
 fclose(file);
 file=fopen("telegraf.out","w");
}

void Free(void)
{
 fclose(file);
}

void Solve(void)
{
 unsigned long n=0;
 int i;
 _qsort(0,35);
 for (i=0;i<36;i++)
  n+=freq[i];
 fprintf(file,"%d\n",n);
}

void _qsort(int ll, int rl)
{
 int i,j,i0,j0,c;
 if (ll<rl)
 {
  i=ll;
  j=rl;
  i0=1;
  j0=0;
  while (i<j)
  {
   if (freq[i]<freq[j])
   {
    c=freq[i];
    freq[i]=freq[j];
    freq[j]=c;
    c=i0;
    i0=-j0;
    j0=-c;
   }
   i+=i0;
   j+=j0;
  }
  _qsort(ll,i-1);
  _qsort(i+1,rl);
 }
}