#include <stdio.h>
#include <stdlib.h>
//Va rog sa compilati acest program cu g++
typedef struct nod
{
 long int data;
 nod* left,* right;
} nod;
typedef nod* noduri[36];
noduri tree;
int treesize;
long int simbs[37];
long sum;
void CombHeap(nod** h,int i,int n)
//combines heap of root 2*i w heap of root 2*i+1
{
int leaf,parent;
nod* v;
    parent=i;
    v=h[parent];
    leaf=2*i;
    while (leaf<=n) {
          if (leaf<n)
             if (h[leaf]->data>h[leaf+1]->data) leaf++;
          if (v->data>h[leaf]->data) {
             //v descends
             h[parent]=h[leaf];//leaf ascends
             parent=leaf;
             leaf=parent*2;
          }
          else break;
    }
    h[parent]=v;
}

nod* ExtractMin(nod** h,int& n)
{
nod* res = h[1];
     h[1]=h[n];
     n--;
     CombHeap(h,1,n);
     return res;
}

void CombHeap2(long int* h,int i,int n)
//combines heap of root 2*i w heap of root 2*i+1
{
int leaf,parent;
long int v;
    parent=i;
    v=h[i];
    leaf=2*i;
    while (leaf<=n) {
 if (leaf<n)
             if (h[leaf]>h[leaf+1]) leaf++;
          if (v>h[leaf]) {
             //v descends
             h[parent]=h[leaf];//leaf ascends
             parent=leaf;
             leaf=parent*2;
          }
          else break;
    }
    h[parent]=v;
}

void BuildHeap(long* h,int n)
{
int i;
    for(i=n/2;i>0;i--) CombHeap2(h,i,n);
}

int cmp(const void*a,const void*b)
{
if ( *((int*)a) < *((int*)b) ) return 1;
 else if  ( *((int*)a) > *((int*)b) ) return -1;
 else return 0;
}
/*
void Huffman();
{
int i;
nod* q;
 do {
    for (i=0;i<treesiz;i+=2,k++) {
       q = new nod;
       q->data=tre[i]->data+tree[i+1]->data;
       q->left=tree[i];
       q->right=tree[i+1];
       treenew[k]=q;
    }
    if (treesiz%2!=0) {
       q= new nod;
       q->data=tree[treesiz-1]->data;
       q->left=tree[treesiz-1];
       q->right=NULL;
       treenew[k]=q;
       k++;
    }
    treenewsiz=k;
    tree=treenew;
    treesiz=treenewsiz
    qsort(tree,treeniz,sizeof(nod),qcmp);
 } while (treesiz>1);

  */
void InsertHeap(nod** h,nod* val,int& n)
{
int leaf,parent;
nod *v =val;
     parent=(n+1)/2;
     n++;
    leaf=n;
 while (parent>=1) {
    if (leaf<n)
       if (h[leaf]->data>h[leaf+1]->data) leaf++;
    if (v->data<h[parent]->data) {
       //v ascends
       h[leaf]=h[parent];
       leaf=parent;
       parent/=2;
   }
   else break;
}
h[leaf]=val;

}

void Huffman()
{
nod* min1,*min2;
nod *q;
 do {
    min1 = ExtractMin(tree,treesize);
    min2 = ExtractMin(tree,treesize);
    q = (nod*)malloc(sizeof(nod));
    q->data=min1->data+min2->data;
    q->left=min2;
    q->right=min1;
    InsertHeap(tree,q,treesize);
 } while (treesize>1);
}
void walk(nod* x,long s)
{
 if (x->left)
    walk(x->left,s+1);
 if (x->right)
    walk(x->right,s+2);
 if (!x->left && !x->right)
    sum+=s*x->data;
}

int main()
{
FILE* fin=fopen("telegraf.in","r");
FILE* fout=fopen("telegraf.out","w");
int i;
nod* q;
 for(i=1;i<=36;i++)
  fscanf(fin,"%ld",&simbs[i]);
 fclose(fin);
 qsort(&simbs[1],36,sizeof(long),cmp);
 for(i=36;!simbs[i];i--) ;
 treesize=i;
 BuildHeap(simbs,treesize);
//   qsort(simbs,36,sizeof(long int),cmp);
  if ( (simbs[2]==0 && simbs[6]==0 && simbs[7]==0) ||
       (simbs[3]==0 && simbs[4]==0 && simbs[5]==0) ) {
           //we have only 2 elements
//                  fprintf(fout,"%ld\n",simbs[0]+2*simbs[1]);
                    fprintf(fout,"%ld\n",simbs[1]+2*simbs[2]+2*simbs[3]);
                  fclose(fout);
     }
 else {
 //Build the first tree
  for(i=1;i<=treesize;i++) {
                            q = (nod*)malloc(sizeof(nod));
                            q->data=simbs[i];
                            q->left=NULL;
                            q->right=NULL;
                            tree[i]=q;
  }
  Huffman();
  sum=0;
  walk(tree[1],0);
  fprintf(fout,"%ld\n",sum);
  fclose(fout);
 }
 return 0;
}
