{$I-,Q-,R-,S-}
{ limite, nume de fisiere, tipuri de date !!! }
{ ATENTIE LA CUM E ALES LMAX !!! }
const
  finame = 'telegraf.in';
  foname = 'telegraf.out';
type
  tbiti = array[0..9] of longint;
var
  fi, fo: text;
  suma, answer: longint;
  i, j, aux, n, lev, lmax, secvente: longint;
  a, s, t: array[0..37] of longint;
  biti: tbiti;
  z: array[1..1024] of tbiti;
  cost: array[1..1024] of longint;

procedure readdata;
begin
  assign(fi, finame);
  reset(fi);
  a[37] := 0;
  for i := 1 to 36 do
    read(fi, a[i]);
  close(fi);
end;

procedure sortdata;
begin
  for i := 1 to 35 do
    for j := i+1 to 36 do
      if a[i] < a[j] then
      begin
        aux := a[i];
        a[i] := a[j];
        a[j] := aux;
      end;

  n := 1;
  while a[n+1] <> 0 do inc(n);
end;

procedure generare;
begin
  inc(lev);
  if lev > lmax then
  begin
    inc(secvente);
    z[secvente] := biti;
    z[secvente][0] := lmax;
  end else
  begin
    biti[lev] := 0; generare;
    biti[lev] := 1; generare;
  end;
  dec(lev);
end;

procedure initdata;
begin
  fillchar(z, sizeof(z), 0);
  secvente := 0;
  for lmax := 1 to 6 do { ATENTIE LA CUM E ALES LMAX !!! }
  begin
    lev := 0; generare;
  end;

  for i := 1 to secvente do
  begin
    cost[i] := 0;
    for j := 1 to z[i][0] do
      cost[i] := cost[i] + z[i][j] + 1;
  end;

  for i := 1 to secvente-1 do
    for j := i+1 to secvente do
      if cost[i] > cost[j] then
      begin
        aux := cost[i]; cost[i] := cost[j]; cost[j] := aux;
        biti := z[i]; z[i] := z[j]; z[j] := biti;
      end;
end;

function matching(i, j: longint): boolean;
var k, kmax: longint;
begin
  if z[i][0] < z[j][0]
    then kmax := z[i][0]
    else kmax := z[j][0];

  matching := true;
  for k := 1 to kmax do
    if z[i][k] <> z[j][k] then
      begin matching := false; exit; end;
end;

procedure backtrak;
var i, j: longint; ok: boolean;
begin
  inc(lev);
  if suma < answer then
    if lev > n then
    begin
      t := s;
      answer := suma;
    end else
    begin
      for i := s[lev-1]+1 to secvente do
      begin
        ok := true;
        for j := 1 to lev-1 do
          if matching(i, s[j]) then
            begin ok := false; break; end;
        if ok then
        begin
          s[lev] := i;
          suma := suma + a[lev] * cost[i];
          backtrak;
          suma := suma - a[lev] * cost[i];
        end;
      end;
    end;
  dec(lev);
end;

procedure solvprob;
begin
  answer := maxlongint;
  lev := 0; s[0] := 0;
  secvente := 4*n;
  suma := 0; backtrak;
end;

procedure writesol;
begin
  assign(fo, foname);
  rewrite(fo);
  writeln(fo, answer);
  close(fo);
end;

begin
  readdata;
  sortdata;
  initdata;
  solvprob;
  writesol;
end.
