program excursii;
const dim=101;
type tip=array[byte]of byte;
var n,k,p:integer;
    a:array[0..dim,0..dim]of tip;
    pp:array[1..dim]of longint;

procedure readdata;
var f:text;
begin
  assign(f,'ex.in');reset(f);
  readln(f,n,k,p);
  close(f);
end;

procedure init(var nr:tip;cifra:byte);
begin
  nr[0]:=1;
  nr[1]:=cifra;
end;

procedure produs(a,b:tip;var c:tip);
var i,j,k,m,aa:integer;
begin
  fillchar(c,sizeof(c),0);
  for i:=1 to a[0] do
  begin
    k:=i;
    m:=0;
    for j:=1 to b[0] do
    begin
      aa:=c[k]+a[i]*b[j]+m;
      c[k]:=aa mod 10;
      m:=aa div 10;
      inc(k);
    end;
    if m<>0 then c[k]:=m else dec(k);
  end;
  while(k>1)and(c[k]=0)do dec(k);
  c[0]:=k;
end;

procedure suma(a,b:tip;var c:tip);
var i,m,l,aa:integer;
begin
  if a[0]>b[0] then
  begin
    for i:=b[0]+1 to a[0] do b[i]:=0;
    l:=a[0];
  end
  else
  begin
    for i:=a[0]+1 to b[0] do a[i]:=0;
    l:=b[0];
  end;
  m:=0;
  for i:=1 to l do
  begin
    aa:=a[i]+b[i]+m;
    c[i]:=aa mod 10;
    m:=aa div 10;
  end;
  if m<>0 then
  begin
    inc(l);
    c[l]:=m;
  end;
  c[0]:=l;
end;

procedure numar(k:integer;var a:tip);
var l:integer;
begin
  l:=0;
  while(k<>0)do
  begin
    inc(l);
    a[l]:=k mod 10;
    k:=k div 10;
  end;
  a[0]:=l;
end;

procedure matrice_a;
var i,j:integer;
    nr,jj:tip;
begin
  for i:=0 to n-k do
    for j:=0 to p-k do init(a[i,j],0);
  init(a[0,0],1);
  for i:=1 to n-k do init(a[i,1],1);
  for i:=2 to n-k do
    for j:=1 to p-k do
    begin
      numar(j,jj);
      produs(jj,a[i-1,j],nr);
      suma(nr,a[i-1,j-1],a[i,j]);
    end;
end;

procedure comb(n,k:integer;var c:tip);
var i,nr,f,j:integer;
    ii:tip;
begin
  init(c,1);
  fillchar(pp,sizeof(pp),0);
  for i:=k+1 to n do
  begin
    nr:=i;
    f:=2;
    while(nr<>1)do
    begin
      while(nr mod f=0)do
      begin
        inc(pp[f]);
        nr:=nr div f;
      end;
      inc(f);
    end;
  end;
  for i:=1 to n-k do
  begin
    nr:=i;
    f:=2;
    while(nr<>1)do
    begin
      while(nr mod f=0)do
      begin
        dec(pp[f]);
        nr:=nr div f;
      end;
      inc(f);
    end;
  end;
  init(c,1);
  for i:=1 to n do
  begin
    if pp[i]>0 then numar(i,ii);
    for j:=1 to pp[i] do produs(c,ii,c);
  end;
end;

procedure k_la(n:integer;var c:tip);
var i:integer;
    nr:tip;
begin
  init(c,1);
  numar(k,nr);
  for i:=1 to n do produs(c,nr,c);
end;

procedure solve;
var c,c1,c2,c3:tip; i:integer; f:text;
begin
  init(c,0);
  for i:=p-k to n-k do
  begin
    comb(n-k,i,c1);
    k_la(n-k-i,c2);
    produs(c1,c2,c3);
    produs(c3,a[i,p-k],c3);
    suma(c,c3,c);
  end;
  assign(f,'ex.out');rewrite(f);
  for i:=c[0] downto 2 do write(f,c[i]);
  writeln(f,c[1]);
  close(f);
end;

begin
  readdata;
  matrice_a;
  solve;
end.