#include <fstream.h>
#include <stdlib.h>
#include <time.h>

ifstream in("telegraf.in");
ofstream out("telegraf.out");

#define MAXN 50

int cost[MAXN],n,slv[MAXN][MAXN],sum[MAXN][MAXN],rcost[MAXN];

int qcmpint(const void *a,const void *b)
{return *(int*)b-*(int*)a;}

void read()
{
	for (int q=0;q<36;q++) in>>rcost[q];
	qsort(rcost,36,sizeof(int),qcmpint);
	for (n=0;rcost[n];n++);
}

template<class T>inline T min(T a,T b){return a>b?b:a;}
template<class T>inline T max(T a,T b){return a>b?a:b;}

int solve(int a,int b);
int _solve(int a,int b)
{
	//if (a>=b) out<<"WTF???\n";
	int sol=0xFFFFFF;
	for (int m=a+1;m<b;m++)
	{
		//out<<"solve("<<a<<','<<b<<")=solve("<<a<<','<<m<<")+"<<sum[a][m];
		//out<<"+solve("<<m<<','<<b<<")+2*"<<sum[m][b]<<'\n';
		sol=min(sol,solve(a,m)+sum[a][m]+
					solve(m,b)+sum[m][b]*2);
	}
	return sol;
}
int solve(int a,int b)
{if (slv[a][b]>=0) return slv[a][b];else return slv[a][b]=_solve(a,b);}

void init()
{
	for (int i=0;i<n;i++)
	{
		slv[i][i+1]=0;
		sum[i][i+1]=cost[i];
		for (int j=i+2;j<=n;j++)
		{
			sum[i][j]=sum[i][j-1]+cost[j-1];
			slv[i][j]=-1;
		}
	}
}

bool u[MAXN];
int bsol,glb=0;

bool rslv(int q=0)
{
	if (q==n)
	{
		init();
		//for (int i=0;i<n;i++) out<<cost[i]<<' ';out<<'\n';
		int c=solve(0,n);
		if (c<bsol) bsol=c;
		glb++;
		if (glb%1000==0&&clock()>0.08*CLOCKS_PER_SEC)return true;
		return false;
	}
	for (int i=0;i<n;i++)	
		if (!u[i])
		{
			u[i]=true;
			cost[q]=rcost[i];
			if (rslv(q+1)) return true;
			u[i]=false;
		}
	return false;
}

int main()
{
	read();
	bsol=0xFFFFFFF;
	for (int i=0;i<n;i++)
		u[i]=false;
	rslv();
	out<<bsol;
/*nit();
	out<<solve(0,n)<<'\n';*/
/*or (int i=0;i<n;i++)
		for (int j=i+1;j<=n;j++)
		{
			out<<"solve("<<i<<','<<j<<")="<<solve(i,j)<<'\n';
			out<<"sum("<<i<<','<<j<<")="<<sum[i][j]<<'\n';
		}*/
	return 0;
}

