{$DEFINE RELEASE}
{$I-,Q-,R-,S-}
program telegraf;
type va=array[1..36] of byte;
     vf=array[1..36] of longint;
type pnod=^nod;
     nod=record
       st,dr:pnod;
       n:byte;
       alf:va;
       frq:vf
     end;
var r:pnod;
    f:text;
    i,cnt,rez:longint;
    cost:array[1..36] of longint;

function ap(x,n:byte;var v:va):boolean;

begin
  while n>0 do
    if v[n]=x then
    begin
      ap:=true;
      exit
    end
  else
    dec(n);
  ap:=false
end;

procedure part(var p:pnod);
var i,ib,p2:qword;
    j:byte;
    s1,s2,m:longint;

begin
  m:=maxlongint;
  p2:=trunc(exp(p^.n*ln(2)));
  i:=0;
  while i<=p2 do
  begin
    s1:=0;
    s2:=0;
    for j:=0 to p^.n-1 do
      if i shr j and 1=0 then
        inc(s1,p^.frq[j+1])
      else
        inc(s2,p^.frq[j+1]);
      if abs(s1-s2)<m then
      begin
        m:=abs(s1-s2);
        if s1<s2 then
          ib:=not i
        else
          ib:=i
      end;
    inc(i)
  end;
  new(p^.st);
  new(p^.dr);
  p^.st^.st:=nil;
  p^.st^.dr:=nil;
  p^.dr^.st:=nil;
  p^.dr^.dr:=nil;
  p^.st^.n:=0;
  p^.dr^.n:=0;
  for j:=0 to p^.n-1 do
    if ib shr j and 1=0 then
    begin
      inc(p^.st^.n);
      p^.st^.alf[p^.st^.n]:=p^.alf[j+1];
      p^.st^.frq[p^.st^.n]:=p^.frq[j+1];
    end
    else
    begin
      inc(p^.dr^.n);
      p^.dr^.alf[p^.dr^.n]:=p^.alf[j+1];
      p^.dr^.frq[p^.dr^.n]:=p^.frq[j+1];
    end
end;

procedure build(r:pnod);

begin
  if r^.n>1 then
  begin
    part(r);
    build(r^.st);
    build(r^.dr)
  end
end;

procedure b(x:byte;p:pnod;var s:string);

begin
  if p<>nil then
    if p^.n=1 then
      exit
    else
      if ap(x,p^.n,p^.alf) then
      begin
        if (p^.st<>nil) and ap(x,p^.st^.n,p^.st^.alf) then
        begin
          s:=s+'.';
          b(x,p^.st,s)
        end
        else
        begin
          s:=s+'-';
          b(x,p^.dr,s)
        end
      end
end;

function c(x:byte;p:pnod):byte;
var i,cost:byte;
    s:string;

begin
  cost:=0;
  s:='';
  b(x,p,s);
  for i:=1 to length(s) do
    if s[i]='.' then
      inc(cost)
    else
      inc(cost,2);
  c:=cost
end;

begin
  assign(f,'telegraf.in');
  reset(f);
  new(r);
  while not seekeoln(f) do
  begin
    read(f,i);
    if i>0 then
    begin
      inc(r^.n);
      inc(cnt);
      r^.alf[r^.n]:=cnt;
      r^.frq[r^.n]:=i
    end
  end;
  close(f);
  build(r);
  for i:=1 to r^.n do
    cost[i]:=c(i,r);
  for i:=1 to r^.n do
    inc(rez,cost[i]*r^.frq[i]);
  assign(f,'telegraf.out');
  rewrite(f);
  writeln(f,rez);
  close(f)
end.
