#include <stdio.h>
#include <string.h>

#define input "telegraf.in"
#define output "telegraf.out"

const int c[5][5] = {1, 0, 0, 0, 0,
					 1, 2, 0, 0, 0,
					 2, 2, 3, 0, 0,
					 4, 4, 4, 3, 0,
					 5, 5, 5, 5, 4};

void readdata(void);

unsigned long seg[64], ind = 0, segs[64];

int main(void)
{
	int i, j, p;
	unsigned long cmin = 0;
	FILE *f;

	memset(seg, 0, sizeof(seg));
	memset(segs, 0, sizeof(segs));

	readdata();

	for (i = 0; i < 36; i++)
	{
		for (j = 0; j < 36; j++)
			if (seg[j] > segs[ind])
			{
				segs[ind] = seg[j];
				p = j;
			}
		seg[p] = 0;
		if (segs[ind])
			ind++;
		else
			break;
	}

	for (i = 0; i < ind; i++)
		cmin += segs[i] * c[ind - 1][i];

	f = fopen(output, "w");

	fprintf(f, "%lu\n", cmin);

	fclose(f);

	return 0;
}

void readdata()
{
	int i;
	FILE *f;

	f = fopen(input, "r");

	for (i = 0; i < 36; i++)
		fscanf(f, "%lu", &seg[i]);

	fclose(f);
}
