{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Program _paznici_greeedy_randomizat;

const filein='ghizi.in';
      fileout='ghizi.out';
      MAXT=100;
      MAXN=5001;
      selected=10000;

type plist=^list;
     list=record
            index:integer;
            urm:plist;
          end;

var edge:array[0..MAXT] of plist;
    sele:array[1..MAXN] of boolean;
    tmax,perm,sel:array[1..MAXN] of integer;
    t1,t2:array[1..MAXN] of integer;
    i,j,k,m,n,pa,ne,nroad,path:integer;
    ok:boolean;
    aux:plist;

procedure print(error:boolean);
begin
writeln(nroad,' drumuri!');

assign(output,fileout);
rewrite(output);

if (error) then
  writeln('----')
else
  begin
    n:=0;
    for k:=1 to m do
      if (sel[k]=selected) then
        inc(n);

    writeln(n);
    for k:=1 to m do
      if (sel[k]=selected) then
        write(k,' ');
  end;

close(output);
halt(0);
end;

begin
{ Read data }
assign(input,filein);
reset(input);
read(m,pa);
for k:=1 to m do
  read(t1[k],t2[k]);
close(input);

{ Shuffle edges }
randomize;
fillchar(sel,sizeof(sel),0);
for k:=1 to m do
  begin
    repeat
      i:=random(m)+1;
    until (sel[i]=0);

    sel[i]:=1;
    perm[k]:=i;
  end;

{ Build edge-lists }
for i:=1 to MAXT do
  edge[i]:=nil;

for k:=1 to m do
  begin
    i:=t1[perm[k]];
    new(aux);
    aux^.index:=perm[k];
    aux^.urm:=edge[i];
    edge[i]:=aux;
  end;

{ Smart-Stupid greedy }
fillchar(sel,sizeof(sel),0);
fillchar(tmax,sizeof(tmax),0);

ok:=false;
while (not ok) do
  begin
    ok:=true;

    for i:=0 to MAXT do
      begin
        { Reshuffle edges }
        aux:=edge[i]; ne:=0;
        while (aux<>nil) do
          begin
            inc(ne);
            t1[ne]:=aux^.index;
            aux:=aux^.urm;
          end;

        fillchar(sele,sizeof(sele),false);
        for k:=1 to ne do
          begin
            repeat
              j:=random(ne)+1;
            until (not sele[j]);

            sele[j]:=true;
            perm[k]:=j;
          end;

        { Use the edges }
        for k:=1 to ne do
          if (sel[t1[perm[k]]]=0) then
            begin
              for j:=1 to pa do
                if (tmax[j]<i) then
                  {print(true)}
                else
                if (tmax[j]=i) then
                  begin
                    tmax[j]:=t2[t1[perm[k]]];
                    sel[t1[perm[k]]]:=j;
                    break;
                  end;
            end;
      end;

    for j:=1 to pa do
      if (tmax[j]=MAXT) then
        begin
          inc(tmax[j]);
          {
          i:=j;
          }
          ok:=false;
          {
          break;
          }
        end;

    if (not ok) then
      begin
        for k:=1 to m do
          if (sel[k]>0) and (sel[k]<selected) and (tmax[sel[k]]=MAXT+1) then
            sel[k]:=selected
          else
          if (sel[k]<selected) then
            sel[k]:=0;
      end;

    for j:=1 to pa do
      if (tmax[j]<MAXT) then
        tmax[j]:=0;
  end;

{ Write data }
nroad:=0;
for k:=1 to pa do
  if (tmax[k]=MAXT+1) then
    inc(nroad);

print(false);
end.