{$I-,Q-,R-}

const MaxN=400;

type punct=record
       x,y:integer;
     end;

var f,g:text;
    j,i,n,m:longint;
    p:array[1..MaxN] of punct;
    x,y:array[1..MaxN] of integer;
    p1,p2:integer;
    ax,ay,tmp:integer;
    d:longint;
    around:array[0..6] of integer;

  procedure sortx(s,e:integer);
  var i,j:integer;
      pv:punct;
  begin
    i:=s;
    j:=e;
    pv:=p[x[(i+j) div 2]];
    repeat
      while (p[x[i]].x<pv.x) or ((p[x[i]].x=pv.x) and (p[x[i]].y<pv.y)) do inc(i);
      while (p[x[j]].x>pv.x) or ((p[x[j]].x=pv.x) and (p[x[j]].y>pv.y)) do dec(j);
      if i<=j then begin
        tmp:=x[i];
        x[i]:=x[j];
        x[j]:=tmp;
        inc(i);
        dec(j);
      end;
    until i>j;
    if i<e then sortx(i,e);
    if j>s then sortx(s,j);
  end;

  procedure sorty(s,e:integer);
  var i,j:integer;
      pv:punct;
  begin
    i:=s;
    j:=e;
    pv:=p[y[(i+j) div 2]];
    repeat
      while (p[y[i]].y<pv.y) or ((p[y[i]].y=pv.y) and (p[y[i]].x<pv.x)) do inc(i);
      while (p[y[j]].y>pv.y) or ((p[y[j]].y=pv.y) and (p[y[j]].x>pv.x)) do dec(j);
      if i<=j then begin
        tmp:=y[i];
        y[i]:=y[j];
        y[j]:=tmp;
        inc(i);
        dec(j);
      end;
    until i>j;
    if i<e then sorty(i,e);
    if j>s then sorty(s,j);
  end;

  function findx(s,e:integer):integer;
  var c:integer;
  begin
    if e-s<2 then begin
      if (p[x[e]].x=ax) and (p[x[e]].y=ay) then findx:=e else
        if (p[x[s]].x=ax) and (p[x[s]].y=ay) then findx:=s else begin
          findx:=-1;
          around[1]:=x[s]-1;
          around[2]:=x[s];
          around[3]:=x[s]+1;
          around[4]:=x[e]-1;
          around[5]:=x[e];
          around[6]:=x[e]+1;
        end;
      exit;
    end;
    c:=(s+e) div 2;
    if (p[x[c]].x=ax) and (p[x[c]].y=ay) then findx:=c else begin
      if (p[x[c]].x<ax) or ((p[x[c]].x=ax)and(p[x[c]].y<ay)) then
        findx:=findx(c,e) else findx:=findx(s,c);
    end;
  end;

  function findy(s,e:integer):integer;
  var c:integer;
  begin
    if e-s<2 then begin
      if (p[y[e]].x=ax) and (p[y[e]].y=ay) then findy:=e else
        if (p[y[s]].x=ax) and (p[y[s]].y=ay) then findy:=s else begin
          findy:=-1;
          around[1]:=y[s]-1;
          around[2]:=y[s];
          around[3]:=y[s]+1;
          around[4]:=y[e]-1;
          around[5]:=y[e];
          around[6]:=y[e]+1;
        end;
      exit;
    end;
    c:=(s+e) div 2;
    if (p[y[c]].x=ax) and (p[y[c]].y=ay) then findy:=c else begin
      if (p[y[c]].y<ay) or ((p[y[c]].y=ay)and(p[y[c]].x<ax)) then
        findy:=findy(c,e) else findy:=findy(s,c);
    end;
  end;

  function dist(z:integer):longint;
  begin
    dist:=abs(ax-p[z].x)+abs(ay-p[z].y);
  end;

  function min(a,b:longint):longint;
  begin
    if a<b then min:=a else min:=b;
  end;

  procedure sorta(s,e:integer);
  var i,j:integer;
      pv:integer;
  begin
    i:=s;
    j:=e;
    pv:=around[(i+j) div 2];
    repeat
      while around[i]>pv do inc(i);
      while around[j]<pv do dec(j);
      if i<=j then begin
        tmp:=around[i];
        around[i]:=around[j];
        around[j]:=tmp;
        inc(i);
        dec(j);
      end;
    until i>j;
    if i<e then sorta(i,e);
    if j>s then sorta(s,j);
  end;

  procedure normalize;
  var i:integer;
  begin
    for i:=1 to 6 do
      if (around[i]<0) or (around[i]>n) then around[i]:=0;
    sorta(1,6);
  end;

begin
  assign(f,'ajutor.in');
  reset(f);
  readln(f,n,m);
  for i:=1 to n do
    readln(f,p[i].x,p[i].y);
  for i:=1 to n do begin
    x[i]:=i;y[i]:=i;
  end;
  sortx(1,n);
  sorty(1,n);
  around[0]:=-1;
  assign(g,'ajutor.out');
  rewrite(g);
  for i:=1 to m do begin
    readln(f,ax,ay);
    d:=MaxLongInt;
    p1:=findx(1,n);
    if p1<>-1 then d:=0 else begin
      normalize;
      for j:=1 to 6 do
        if around[j]<>0 then begin
          if around[j]<>around[j-1] then
            d:=min(d,dist(around[j]));
        end else break;
    end;
    p2:=findy(1,n);
    if p2<>-1 then d:=0 else begin
      normalize;
      for j:=1 to 6 do
        if around[j]<>0 then begin
          if around[j]<>around[j-1] then
            d:=min(d,dist(around[j]));
        end else break;
    end;
    writeln(g,d);
  end;
  close(g);
  close(f);
end.
