#include <stdio.h>

#define CIFRE 120

int s;
int n[CIFRE], k[CIFRE];
int res[20000];
int ONE[CIFRE], TWO[CIFRE], THREE[CIFRE], FIVE[CIFRE], k3[CIFRE], k5[CIFRE];

void read ()
{
   int i;
   FILE *f = fopen( "sala.in", "rt" );
   fscanf( f, "%d", &n[0] );
   for ( i = n[0]; i; i-- )
   {
      fscanf( f, "%d", &n[i] );
      s += n[i];
   }
   fclose( f );
}

void calc_k ()
{
   int i, r = 0, aux;

   for ( i = n[0]; i; i-- )
   {
      r = r * 10 + n[i];
      k[++k[0]] = r / 3;
      r %= 3;
   }

   for ( i = 1; i <= k[0] / 2; i++ )
      aux = k[i], k[i] = k[k[0] - i + 1], k[k[0] - i + 1] = aux;

   while ( !k[k[0]] ) k[0]--;
}

void MUL (int *a, int *b, int *c)
{
   int i, j, t = 0;
   
   for ( i = 1; i <= b[0]; i++ )
       for ( j = 1; j <= c[0]; j++ )
           a[i + j - 1] += b[i] * c[j];

   a[0] = b[0] + c[0] - 1;
   for ( i = 1; i <= a[0]; i++ )
      a[i] += t,
      t = a[i] / 10,
      a[i] %= 10;

   while ( t ) a[++a[0]] = t % 10, t /= 10;
}

void ADD (int *a, int *b)
{
   int i, t = 0;

   if ( b[0] > a[0] ) a[0] = b[0];

   for ( i = 1; i <= a[0]; i++ )
      a[i] += b[i] + t,
      t = a[i] / 10,
      a[i] %= 10;

   if ( t ) a[++a[0]] = t;
}

void solve ()
{
   s %= 3;
   MUL( k3, k, THREE );
   MUL( res, k3, k );
   if ( s == 0 )
      ADD( res, k );
   else if ( s == 1 )
   {
      ADD( res, k3 );
      ADD( res, ONE );
   }
   else if ( s == 2 )
   {
      MUL( k5, k, FIVE );
      ADD( res, k5 );
      ADD( res, TWO );
   }
}

void init ()
{
   ONE[0] = ONE[1] = 1;
   TWO[0] = 1; TWO[1] = 2;
   THREE[0] = 1; THREE[1] = 3;
   FIVE[0] = 1; FIVE[1] = 5;
}

void print ()
{
   int i;
   FILE *fout;

   fout = fopen( "sala.out", "wt" );
   for ( i = res[0]; i; i-- )
       fprintf( fout, "%d", res[i] );
   fprintf( fout, "\n" );
   fclose( fout );
}

int main ()
{
   read();
   init();
   calc_k();
   solve();
   print();
   return 0;
}
