#include <stdio.h>
#include <stdlib.h>


#define N_MAX 400
#define IN_NAME "ajutor.in"
#define OUT_NAME "ajutor.out"


int q_x, q_y;
int p_x[N_MAX], p_y[N_MAX];
int n_points, n_queryies;


void read_data(void)
{
    FILE *in_file = fopen(IN_NAME, "rt");
    FILE *out_file = fopen(OUT_NAME, "wt");
    int i, j, step, minimal, start;

    fscanf(in_file, "%d %d\n", &n_points, &n_queryies);
    for (i = 0; i < n_points; i++)
	fscanf(in_file, "%d %d\n", p_x + i, p_y + i);
    for (i = 0; i < n_points; i++)
	for (j = 0; j < n_points; j++)
	    if (p_x[i] > p_x[j]) {
		p_x[i] ^= p_x[j] ^= p_x[i] ^= p_x[j];
		p_y[i] ^= p_y[j] ^= p_y[i] ^= p_y[j];
	    }
    for (i = 0; i < n_queryies; i++) {
	int l, h;
	int flag_1, flag_2;

	fscanf(in_file, "%d %d\n", &q_x, &q_y);
	/* compute distance */
#ifdef __DEBUG__
#define INF (1 << 30)
	minimal = INF;
	for (step = 256, start = 0;; step >>= 1) {
	    if (p_x[start + step] < q_x) {
		start += step;
	    }
	    if (step == 0) break;
	}
	l = step;
	h = step + 1;
	flag_1 = 0, flag_2 = 0;
	while (!flag_1 || !flag_2) {
#define __abs(x) ((x) < 0 ? -(x) : (x))
	    if (!flag_1 && l >= 0) {
		if (minimal > __abs(p_x[l] - q_x) + __abs(p_y[l] - q_y))
		    minimal = __abs(p_x[l] - q_x) + __abs(p_y[l] - q_y);
		l--;
		/*
		if (l >= 0 && abs(p_x[l] - q_x) > minimal) flag_1 = 1;
		*/
	    } else flag_1 = 1;
	    if (!flag_2 && h < n_points) {
		if (minimal > __abs(p_x[h] - q_x) + __abs(p_y[h] - q_y))
		    minimal = __abs(p_x[h] - q_x) + __abs(p_y[h] - q_y);
		h++;
		/*
		if (h < n_points && abs(p_x[h] - q_x) > minimal) flag_2 = 1;
		*/
	    } else flag_2 = 1;
	}
#else /* __DEBUG__ */
#   define __abs(x) ((x) < 0 ? -(x) : (x))
#   define INF	(1 << 30)
	minimal = INF;
	for (j = 0; j < n_points; j++)
	    if (minimal > __abs(p_x[j] - q_x) + __abs(p_y[j] - q_y)) 
		minimal = __abs(p_x[j] - q_x) + __abs(p_y[j] - q_y); 
#endif
	fprintf(out_file, "%d\n", minimal);
    }
    fclose(in_file);
    fclose(out_file);
}


int main(void)
{
    read_data();

    return EXIT_SUCCESS;
}
