// Baraj - Ziua 2 - Ghizi

#include <stdio.h>
#include <string.h>

#define input "ghizi.in"
#define output "ghizi.out"
#define NMAX 5001

FILE *f;
int n, k, hn, ns;
int a[200], old[NMAX], flag[NMAX], fl2[NMAX];
struct ghida
{
	int t1, t2;
} g[NMAX];

void readdata()
{
	int i;
	f = fopen(input, "rt");
	fscanf(f, "%d %d", &n, &k);
	for (i = 0; i < n; i++)
		fscanf(f, "%d %d", &g[i].t1, &g[i].t2), old[i] = i;
	fclose(f);
}

void sift(int pos)
{
	int minpos = pos, son;
	do
	{
		son = 2 * pos + 1;
		if (son < hn && (g[son].t1 > g[minpos].t1 ||
		(g[son].t1 == g[minpos].t1 && g[son].t2 > g[minpos].t2))) minpos = son;
		son = 2 * pos + 2;
		if (son < hn && (g[son].t1 > g[minpos].t1 ||
		(g[son].t1 == g[minpos].t1 && g[son].t2 > g[minpos].t2))) minpos = son;
		if (pos == minpos) break;
		son = g[pos].t1; g[pos].t1 = g[minpos].t1; g[minpos].t1 = son;
		son = g[pos].t2; g[pos].t2 = g[minpos].t2; g[minpos].t2 = son;
		son = old[pos]; old[pos] = old[minpos]; old[minpos] = son;
		pos = minpos;
	}
	while (1);
}

void heapsort()
{
	int i, aa;
	hn = n;
	for (i = hn / 2; i >= 0; sift(i--));
	while (hn)
	{
		aa = g[0].t1; g[0].t1 = g[hn - 1].t1; g[hn - 1].t1 = aa;
		aa = g[0].t2; g[0].t2 = g[hn - 1].t2; g[hn - 1].t2 = aa;
		aa = old[0]; old[0] = old[hn - 1]; old[hn - 1] = aa;
		hn--; sift(0);
	}
}

void solve()
{
	int i, j, sol = 0, start;
	heapsort();
	for (ns = i = 0; i < n; i++)
	{
		memset(a, -1, sizeof(a));
		for (j = 0; j < n; j++)
			if (!g[j].t1 && !fl2[j]) break;
		start = j;
		a[g[j].t2] = j; fl2[start] = 1;
		for (j++; j < n; j++)
			if (a[g[j].t1] >= 0 && !fl2[j])
				a[g[j].t2] = j;
		j = 100;
		if (a[100] == -1) continue;
		fl2[a[100]] = 1; sol++;
		while (a[j] != -1)
			flag[old[a[j]]] = 1, ns++, j = g[a[j]].t1, fl2[a[j]] = 1;
		if (sol == k) break;
	}

	f = fopen(output, "wt");
	fprintf(f, "%d\n", ns);
	for (i = 0; i < n; i++)
		if (flag[i])
			fprintf(f, "%d ", i + 1);
	fclose(f);
}

int main()
{
	readdata();
	solve();
	return 0;
}
