program ghizi;
type tmp=record t1,t2:byte; end;
     nod=^el;
     el=record inf:word; urm:nod; end;
     vc=array[1..5000] of tmp;
var g:^vc;
    s:array[1..5000] of word;
    v,v2:array[1..5000] of byte;
    l1,l2:array[1..5000] of nod;
    n,k,ds:word;

procedure readdata;
var f:text;
    i:word;
begin
     assign(f,'ghizi.in');
     reset(f);
     readln(f,n,k);
     new(g);
     fillchar(g^,sizeof(g^),0);
     for i:=1 to n do
     readln(f,g^[i].t1,g^[i].t2);
     close(f);
end;

procedure make_lists;
var i,j:word;
    q:nod;
begin
     for i:=1 to n do
     l1[i]:=nil;

     for i:=1 to n do
     for j:=1 to n do
     if i<>j then
     if g^[i].t2=g^[j].t1 then
     begin
          new(q);
          q^.inf:=j;
          q^.urm:=l1[i];
          l1[i]:=q;
          new(q);
          q^.inf:=i;
          q^.urm:=l2[j];
          l2[j]:=q;
     end;
end;

procedure df(k:word);
var q:nod;
begin
     v[k]:=1;
     q:=l1[k];
     while q<>nil do
     begin
          if (v[q^.inf]=0)and(v2[q^.inf]=0) then
          df(q^.inf);
          q:=q^.urm;
     end;
end;

procedure sort(l, r: word);
var
  i, j, x, y: word;
begin
  i := l; j := r; x := s[(l+r) DIV 2];
  repeat
    while s[i] < x do i := i + 1;
    while x < s[j] do j := j - 1;
    if i <= j then
    begin
      y := s[i]; s[i] := s[j]; s[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then sort(l, j);
  if i < r then sort(i, r);
end;

procedure drum(k:word);
begin
     v2[k]:=1;
     if l2[k]<>nil then drum(l2[k]^.inf);
end;

procedure print(sw:boolean);
var f:text;
    i:word;
begin
     assign(f,'ghizi.out');
     rewrite(f);
     if sw then
     begin
     writeln(f,ds);
     for i:=1 to ds do
     write(f,s[i],' ');
     writeln(f);
     end
     else writeln(f,'0');
     close(f);
     halt(0);
end;


procedure solve;
var i,j,poz:word;
begin
     make_lists;
     for i:=1 to n do
     if (v[i]=0)and(g^[i].t1=0) then df(i);

     for i:=1 to k do
     begin
          poz:=0;
          for j:=1 to n do
          if (g^[j].t2=100)and(v[j]=1) then
          begin
               poz:=j;
               break;
          end;

          if poz=0 then print(false);
          drum(poz);

          fillchar(v,sizeof(v),0);
          for j:=1 to n do
          if (v[j]=0)and(v2[j]=0)and(g^[i].t1=0) then df(j);

     end;

     for i:=1 to n do
     if v2[i]=1 then
     begin
          inc(ds);
          s[ds]:=i;
     end;
     sort(1,ds);
end;

begin
     readdata;
     solve;
     print(true);
end.




