# include <stdio.h>
FILE *fi,*fo;
int n,k,t1[5000],t2[5000],u[5000];
int *mat,*v,nr,dim;

void citire()
{
int i;
fi=fopen("ghizi.in","r");
fscanf(fi,"%d %d",&n,&k);
for (i=0;i<n;i++)
   fscanf(fi,"%d %d",&t1[i],&t2[i]);
fclose(fi);
}

void init()
{
int i,j;
for (i=0;i<n;i++)
   u[i]=0;
for (i=0;i<=k;i++)
   for (j=0;j<101;j++)
      mat[i*101+j]=-2;
for (i=0;i<=k;i++)
  mat[i*101]=-1;
for (i=0;i<101;i++)
   mat[i]=-1;
}

void adanceste(int i)
{
int max,l,r,aux;
max=i;
l=2*i+1;
r=2*i+2;
if (l<dim && v[i]<v[l]) max=l;
if (r<dim && v[max]<v[r]) max=r;
if (max!=i)
   {aux=v[max];
   v[max]=v[i];
   v[i]=aux;
   adanceste(max);
   }
}

void construieste_heap()
{
int i;
for(i=nr/2;i>-1;i--)
  adanceste(i);
}

void heapsort()
{
int aux,i;
 dim=nr;
 construieste_heap();
 for (i=nr-1;i>0;i++)
    {dim--;
    aux=v[i];
    v[i]=v[0];
    v[0]=aux;
    adanceste(0);
    }
}

void rezolva()
{
int i,j,l,gasit;
mat=new int[(k+1)*101];
init();
for(i=1;i<=k;i++)  //nr ghizi
  for (j=1;j<101;j++)    //intervalul [0,j)
     {gasit=0;
     for (l=0;l<n && !gasit;l++)
	if(!u[l] && t2[l]==j && mat[i*101+t1[l]]!=-2 && mat[(i-1)*101+j]!=-2)
	   {u[l]=1;
	   mat[i*101+j]=l;
	   gasit=1;}
      }
//bag toate persoanele intr-un vector
v=new int[5000];
nr=0;
for (i=k;i>0;i--)
   {j=100;
   while(j>0)
     {v[nr++]=mat[i*101+j];
     j=t1[v[nr-1]];
     }
   }
heapsort();
}

void scriere()
{
int i;
fo=fopen("ghizi.out","w");
fprintf(fo,"%d\n",nr);
for (i=0;i<nr;i++)
  fprintf(fo,"%d ",v[i]);
fprintf(fo,"\n");
fclose(fo);
}

int main()
{
citire();
rezolva();
scriere();
return 0;
}
