{$M 65520,0,655360}
program sala;
type vector=array[1..32000] of 0..9;
     vec=^vector;

var a,b,k:vec;
    n,i,na,nb,nk,rest:integer;
    f:text;

procedure inmultire(var a:vec;var n:integer;x:integer);
var i,t:integer;
    aux:longint;
begin
  t:=0;
  for i:=1 to n do
    begin
      aux:=t+a^[i]*x;
      a^[i]:=aux mod 10;
      t:=aux div 10;
    end;
  while t>0 do
    begin
      inc(n);
      a^[n]:=t mod 10;
      t:=t div 10;
    end;
end;

procedure divide(var a:vec;var n:integer;x:integer);
var i,t:integer;
    aux:longint;
begin
  t:=0;
  for i:=n downto 1 do
    begin
      aux:=t*10+a^[i];
      a^[i]:=aux div x;
      t:=aux mod x;
    end;
  rest:=t;
  while a^[n]=0 do dec(n);
end;

procedure adun_scalar(var a:vec;var n:integer;x:integer);
var i,t:integer;
    aux:longint;
begin
  t:=x;i:=1;
  while t>0 do
    begin
      if i>n then inc(n);
      aux:=t+a^[i];
      a^[i]:=aux mod 10;
      t:=aux div 10;
      inc(i);
    end;
end;

procedure adun_vector(var a:vec;var na:integer;var b:vec;var nb:integer);
var max,i,t:integer;
    aux:longint;
begin
  if na>nb then max:=na   else max:=nb;
  t:=0;
  for i:=1 to max do
    begin
      if i>na then inc(na);
      aux:=t+a^[i]+b^[i];
      a^[i]:=aux mod 10;
      t:=aux div 10;
    end;
  while t>0 do
    begin
      inc(na);
      a^[na]:=t mod 10;
      t:=t div 10;
    end;
end;

procedure inmultesc_vector(var a:vec;var na:integer;var b:vec;var nb:integer);
var c,d:vec;
    nc,nd,j,i:integer;
begin
  new(c);new(d);fillchar(d^,sizeof(d^),0);nd:=0;
  for i:=1 to na do
    begin
      c^:=b^;nc:=nb;
      inmultire(c,nc,a^[i]);
      if i>1 then
        begin
          for j:=nc downto 1 do c^[j+i-1]:=c^[j];
          for j:=i-1 downto 1 do c^[j]:=0;
          nc:=nc+i-1;
        end;
      adun_vector(d,nd,c,nc);
    end;
  dispose(c);
  a^:=d^;
  na:=nd;
  dispose(d);
end;

procedure impart(var a:vec;var n:integer;x:integer);
var i,t:integer;
    aux:longint;
begin
  t:=0;
  for i:=n downto 1 do
    begin
      aux:=t*10+a^[i];
      a^[i]:=aux div x;
      t:=aux mod x;
    end;
  while a^[n]=0 do dec(n);
end;

procedure scad_scalar(var a:vec;var n:integer;x:integer);
var i,t:integer;
    aux:longint;
begin
  t:=x;i:=1;
  while t>0 do
    begin
      aux:=a^[i]-t;
      if aux>=0 then t:=0
                else
        begin
          aux:=aux+10-t;
          t:=1;
        end;
      a^[i]:=aux mod 10;
      inc(i);
    end;
  if a^[n]=0 then dec(a^[n]);
end;

begin
  assign(f,'sala.in');
  reset(f);
  readln(f,na);
  new(a);fillchar(a^,sizeof(a^),0);
  new(b);fillchar(b^,sizeof(b^),0);
  for i:=1 to na do read(f,b^[i]);
  for i:=1 to na do a^[i]:=b^[na-i+1];
  close(f);assign(f,'sala.out');rewrite(f);
  inmultire(a,na,2);
  rest:=0;
  divide(a,na,3);
  if rest=0 then
    begin
      new(k);
      k^:=a^;nk:=na;
      adun_scalar(a,na,1);
      inmultesc_vector(a,na,k,nk);
      impart(a,na,2);
      b^:=k^;nb:=nk;
      inmultesc_vector(b,nb,k,nk);
      impart(b,nb,4);
      adun_vector(a,na,b,nb);
      for i:=na downto 1 do write(f,a^[i]);
    end     else
    if rest=2 then
      begin
        adun_scalar(a,na,1);
        new(k);
        k^:=a^;nk:=na;
        adun_scalar(a,na,1);
        inmultesc_vector(a,na,k,nk);
        impart(a,na,2);
        scad_scalar(k,nk,1);
        b^:=k^;nb:=nk;
        inmultesc_vector(b,nb,k,nk);
        impart(b,nb,4);
        adun_vector(a,na,b,nb);
        for i:=na downto 1 do write(f,a^[i]);
      end    else
        begin
{          adun_scalar(a,na,1);}
          new(k);
          k^:=a^;nk:=na;
          adun_scalar(a,na,1);
          inmultesc_vector(a,na,k,nk);
          impart(a,na,2);
          adun_scalar(k,nk,1);
          b^:=k^;nb:=nk;
          inmultesc_vector(b,nb,k,nk);
          impart(b,nb,4);
          adun_vector(a,na,b,nb);
          for i:=na downto 1 do write(f,a^[i]);
        end;
  writeln(f);
  close(f);
end.

