
//	#define	ACUM_TESTEZ

	#include <stdio.h>
	#include <stdlib.h>

	#define MAXN	5010

struct interval
	{
		int a, b;
	};

struct elem
	{
		int info;

		elem *next, *prev;
	};

elem *G[MAXN];
interval I[MAXN];
int n, k, sol[MAXN], sc;

void ldel(elem *x, int b)
{
	if (x->next) x->next->prev=x->prev;
	if (x->prev) x->prev->next=x->next;
	if (G[b]==x) G[b]=x->next;
	delete x;
}

void m_read()
{
	FILE *f=fopen("ghizi.in", "rt");
	int i;

	fscanf(f, "%d%d\n", &n, &k);

	for (i=0; i<n; i++)	G[i]=NULL;

	int a, b;
	elem *e;

	for (i=0; i<n; i++)
		{
			fscanf(f, "%d%d\n", &a, &b);
			I[i].a=a;
			I[i].b=b;

			e=new elem;
			e->info=i;
			e->next=G[a];
			e->prev=NULL;

			if (G[a]) G[a]->prev=e;

			G[a]=e;
		}

	fclose(f);
}

#define l1(z)	I[z->info].a
#define l2(z)	I[z->info].b

int df_go(elem *x)
{
	if (l2(x)>=100) return 1;
	else
		{
			elem *e=G[l2(x)];

			while (e)
				{
					if (df_go(e))
						{
							sol[sc++]=(e->info+1);
							ldel(e, l2(x));
							return 1;
						}
					else e=e->next;
				}
		}
	return 0;
}

#undef l2
#undef l1

#define a	*(int *)_a
#define b	*(int *)_b

int sf(const void *_a, const void *_b)
{
	if (a<b) return -1;
	else
		if (a>b) return 1;
		else return 0;
}

#undef b
#undef a

void m_solve()
{
	int i;
	elem *e;

	sc=0;
	for (i=0; i<k; i++)
		{
			// drumul i

			e=G[0];
			while (e)
				{
					if (df_go(e))
						{
							sol[sc++]=(e->info+1);
							ldel(e, 0);
							break;
						}
					e=e->next;
				}
		}

	// solutie
	qsort((void *)sol, sc, sizeof(sol[0]), sf);
}

void m_write()
{
	#ifdef ACUM_TESTEZ
		FILE *f=stdout;
	#else
		FILE *f=fopen("ghizi.out", "w");
	#endif

	fprintf(f, "%d\n", sc);
	int i;
	for (i=0; i<sc; i++)
		fprintf(f, "%d ", sol[i]);
	fprintf(f, "\n");

	fclose(f);
}

int main(void)
{
	m_read();
	m_solve();
	m_write();

	return 0;
}
