
#include <fstream.h>
#include <stdlib.h>

void read();
void solve();
void write();

int main()
{
	read();
	solve();
	write();
	return (0);
}

#define MAXT 102
#define MAXN 5002
#define min(a, b) (a>b)?(b):(a)

int N, K, mat[MAXT][MAXT], ars[MAXN], count;

struct elem {
				int info;
				elem *next;
			 };

#ifdef __BORLANDC__
	elem * huge vec[MAXT][MAXT];
#else
	elem *vec[MAXT][MAXT];
#endif

void Add(int x, int y, int info)
{
 elem *tmp=new elem;
 tmp->info=info;

 if(vec[x][y]==NULL)
	 {
		vec[x][y]=tmp;
		vec[x][y]->next=NULL;
		return ;
	 }

 tmp->next=vec[x][y];
 vec[x][y]=tmp;
}

void read()
{
	ifstream in("ghizi.in");

	in>>N>>K;

	int i, x, y;

	for(i=0;i<N;i++)
	 {
		in>>x>>y;

		mat[x][y]+=1;
		Add(x, y, i+1);
	 }

	in.close();
}

int flow[MAXT], viz[MAXT], tata[MAXT], max_flow;
#define oo 10000

void scoate(int x, int y)
{
	elem *tmp=vec[x][y];
	ars[vec[x][y]->info]=1;
	vec[x][y]=vec[x][y]->next;
	delete(tmp);
}

void solve()
{
//bag un flux

 int i, min, min_loc;

 while(1)
	{
		for(i=0;i<=100;i++)
		 {
			flow[i]=oo; tata[i]=-1; viz[i]=0;
		 }

		flow[0]=1;

		while(1)
		 {
			 min=oo; min_loc=-1;

			 for(i=0;i<=100;i++)
				if(flow[i]<min && viz[i]==0)
				 {
					min=flow[i];
					min_loc=i;
					break;
				 }

			 viz[min_loc]=1;
			 if(min_loc==100)break;

			 //if(min_loc==-1)break;
						//de altfel imposibil

			 for(i=1;i<=100;i++)
				if(viz[i]==0 && mat[min_loc][i])
				 {
					 flow[i]=min(flow[min_loc], mat[min_loc][i]);
					 tata[i]=min_loc;
				 }
		 }

		//if(min_loc==-1)break;

		max_flow++;
		i=100;

		while(i)
			{
				mat[tata[i]][i]-=1;
				mat[i][tata[i]]+=1;
				i=tata[i];
			}

		if(max_flow==K)break;
	}

	int coada[MAXN], in, fin;
	in=fin=0;
	coada[fin++]=100;


	while(in<fin)
	{
	 for(i=coada[in]-1;i>=0;i--)
		while(mat[coada[in]][i])
		 {
		 //cauta interval
		 mat[coada[in]][i]--;
		 coada[fin++]=i;
		 scoate(i, coada[in]);
		 count++;
		 }
		in++;
	}
}

void write()
{
	ofstream out("ghizi.out");

	out<<count<<'\n';

	int i, gasit=0;

	for(i=1;i<=N;i++)
	 if(ars[i])
		{
		 if(gasit)out<<' ';
		 out<<i;
		 gasit=1;
		}
	 out<<'\n';
	out.close();
}
