#include <stdio.h>

struct _ghid {
    int l, r;
    int id;
};
typedef struct _ghid GHID, *PGHID;

GHID a[5001], b[5001];
int N, K;

/* sortare dupa timpul final T2 */
void sorteaza(void)
{
    int i, count[101];
    for(i=0;i<=100;i++)
	count[i]=0;
    for(i=0;i<N;i++)
	count[a[i].r]++;
    for(i=1;i<=100;i++)
	count[i]+=count[i-1];
    for(i=0;i<N;i++)
	b[--count[a[i].r]]=a[i];
}

/* numarul de moduri de a acoperi exact pana la pozitia i cu intervale */
int c[101], dec[101][5001], ls;
GHID sol[5001];

void print_sol(int pos)
{
    int id; GHID cur;
    if(pos==0) return;
    id=dec[pos][--c[pos]];
    cur=a[id-1];
    sol[ls++]=cur;
    print_sol(cur.l);
}

void sorteaza_sol(void)
{
    int i, count[5003];
    for(i=0;i<=5002;i++)
	count[i]=0;
    for(i=0;i<ls;i++)
	count[sol[i].id]++;
    for(i=1;i<=5002;i++)
	count[i]+=count[i-1];
    for(i=0;i<ls;i++)
	b[--count[sol[i].id]]=sol[i];
    for(i=0;i<ls;i++)
	sol[i]=b[i];
}

void solve(void)
{
    GHID cur; FILE *pf; int i;
    c[0]=100;
    for(i=0;i<N;i++) {
	cur=b[i];
	if(c[cur.r]<c[cur.l]) 
	    dec[cur.r][c[cur.r]++]=cur.id;
    }
    pf=fopen("ghizi.out", "wt");
    /* c[100]>=K */
    for(;K--;) print_sol(100);
    sorteaza_sol();
    fprintf(pf, "%d\n", ls);
    for(i=0;i<ls;i++)
	fprintf(pf, "%s%d", i ? " " : "",  sol[i].id);
    fprintf(pf, "\n");
    fclose(pf);
}

void init(void)
{
    FILE *pf; int i;
    pf=fopen("ghizi.in", "rt");
    fscanf(pf, "%d %d", &N, &K);
    for(i=0;i<N;i++) {
	fscanf(pf, "%d %d", &a[i].l, &a[i].r);
	a[i].id=i+1;
    }
    sorteaza();
    fclose(pf);
}

int main(void)
{
    init();
    solve();
    return 0;
}
