program ajutor;
var mat : array[0..32767, 0..32767] of Word;
    f, g : text;
    toFill : array[0..$FFFF] of record
                                  x, y : Word;
                                end;
    n, x, y, minX, maxX, minY, maxY, fa, fb : Word;
    m : LongInt;

procedure Fill;
var value : Integer;
begin
  with toFill[fa] do begin
    value := mat[x, y] + 1;
    if (x > minX) and ((mat[x-1, y] > value) or (mat[x-1, y] < 1)) then begin
      fb := fb + 1;
      toFill[fb].x := x-1;
      toFill[fb].y := y;
      mat[x-1, y] := value;
      end;
    if (x < maxX) and ((mat[x+1, y] > value) or (mat[x+1, y] < 1)) then begin
      fb := fb + 1;
      toFill[fb].x := x+1;
      toFill[fb].y := y;
      mat[x+1, y] := value;
      end;
    if (y > minY) and ((mat[x, y-1] > value) or (mat[x, y-1] < 1)) then begin
      fb := fb + 1;
      toFill[fb].x := x;
      toFill[fb].y := y-1;
      mat[x, y-1] := value;
      end;
    if (x < minX) and ((mat[x, y+1] > value) or (mat[x, y+1] < 1)) then begin
      fb := fb + 1;
      toFill[fb].x := x;
      toFill[fb].y := y+1;
      mat[x, y+1] := value;
      end;
    end;
  fa := fa + 1;
end;

procedure Simple;
var i, j, min, mx : Word;
    tmp : Integer;
begin
for i := 1 to n do begin
  Readln(f, x, y);
  toFill[i].x := x;
  toFill[i].y := y;
  end;
for i := 1 to m do begin
  ReadLn(f, x, y);
  tmp := x - toFill[1].x;
  min := abs(tmp);
  tmp := y - toFill[1].y;
  min := min + abs(tmp);
  for j := 2 to n do begin
    tmp := x - toFill[j].x;
    mx  := abs(tmp);
    tmp := y - toFill[j].y;
    mx  := mx + abs(tmp);
    if mx < min then
      min := mx;
    end;
  WriteLn(g, min);
  end;
end;

procedure Complex;
var i : Word;
begin
Readln(f, x, y);
minX := x;  maxX := x;
minY := y;  maxY := y;
toFill[1].x := x;
toFill[1].y := y;
mat[x, y] := 1;
for i := 2 to n do begin
  Readln(f, x, y);
  toFill[i].x := x;
  toFill[i].y := y;
  mat[x, y] := 1;
  if minX > x
    then minX := x
    else if maxX < x
      then maxX := x;
  if minY > y
    then minY := y
    else if maxY < y
      then maxY := y;
  end;
fa := 1;
fb := n;
while fa <> fb do
  Fill;
for i := 1 to m do begin
  ReadLn(f, x, y);
  if x <= maxX
    then if x >= minX
      then if y <= maxY
        then if y >= minY
          then WriteLn(g, mat[x, y] -1)
          else WriteLn(g, mat[x, minY] + minY-y -1)
        else WriteLn(g, mat[x, maxY] + y-maxY -1)
      else if y <= maxY
        then if y >= minY
          then WriteLn(g, mat[minX, y] + minX-x -1)
          else WriteLn(g, mat[minX, minY] + minX-x + minY-y -1)
        else WriteLn(g, mat[minX, maxY] + minX-x + y-maxY -1)
    else if y <= maxY
      then if y >= minY
        then WriteLn(g, mat[maxX, y] + x-maxX -1)
        else WriteLn(g, mat[maxX, minY] + x-maxX + minY-y -1)
      else WriteLn(g,mat[maxX, maxY] + x-maxX + y-maxY -1);
  end;
end;

begin
Assign(f, 'ajutor.in');
Reset(f);
ReadLn(f, n, m);
Assign(g, 'ajutor.out');
ReWrite(g);
if (n * m) <= 100000
  then Simple
  else Complex;
Close(f);
Close(g);
end.