#include <fstream.h>
#include <assert.h>
#include <stdlib.h>
ifstream fin("ajutor.in");
ofstream fout("ajutor.out");
struct punct
{ int x,y; } Ao[401],P,Av[401];
long i,j,N,M,min,k,imin,st,dr,pos,st1,dr1,gasit;

void Read()
{
 fin>>N>>M;
 for (i=1;i<=N;Av[i]=Ao[i],i++)
  fin>>Ao[i].x>>Ao[i].y;
}

int sortf(const void *a, const void *b)
{
punct *x=(punct*)a,*y=(punct*)b;
 if (x->x!=y->x) return x->x-y->x;
  else return (x->y-y->y);
}

int sortf2(const void *a, const void *b)
{
punct *x=(punct*)a,*y=(punct*)b;
 if (x->y!=y->y) return x->y-y->y;
  else return (x->x-y->x);
}

void Compute()
{
 qsort((void*)(Ao+1),M,sizeof(Ao[0]),sortf);
 qsort((void*)(Av+1),M,sizeof(Av[0]),sortf2);
 for (i=1;i<=M;i++)
 {
  fin>>P.x>>P.y;
  // Caut binar coloana (Ao)
  st=1; dr=N; gasit=0;
  while ((st<=dr)&&(!gasit))
  {
   st1=st; dr1=dr;
   pos=(st+dr)/2;
   if (Ao[pos].x>P.x) dr=pos-1;   else
   if (Ao[pos].x<P.x) st=pos+1;   else
   gasit=1;
  }
  if (st<=dr)
  {
   // Am gasit ajutoare pe coloana A[pos].x
   min=abs(P.x-Ao[pos].x)+abs(P.y-Ao[pos].y);
   j=pos;
   while ((Ao[j].x==Ao[pos].x)&&(j>0))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j--;
   }
   st1=j;
   j=pos+1;
   while ((Ao[j].x==Ao[pos].x)&&(j<=N))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j++;
   }
   dr1=j;
   // Caut ajutoare pe coloana din stanga
   j=st1;
   while ((Ao[j].x==Ao[st1].x)&&(j>0))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j--;
   }
   st1=j;
   // Caut ajutoare pe coloana din dreapta
   j=dr1;
   while ((Ao[j].x==Ao[dr1].x)&&(j<=N))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j++;
   }
   dr1=j;
   // Mai caut ajutoare in stanga in limita posibilului
   j=st1;
   while ((abs(Ao[j].x-Ao[st1].x)<min)&&(j>0))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j--;
   }
   // Mai caut ajutoare in dreapta in limita posibilului
   j=dr1;
   while ((abs(Ao[j].x-Ao[dr1].x)<min)&&(j<=N))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j++;
   }
  }
  else
  {
   // Nu am gasit coloana punctului
   min=abs(P.x-Ao[pos].x)+abs(P.y-Ao[pos].y);
   j=pos+1;
   while ((Ao[j].x==Ao[pos+1].x)&&(j>0))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j--;
   }
   st1=j;
   while ((Ao[j].x==Ao[st1].x)&&(j>0))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j--;
   }
   st1=j;
   j=pos;
   while ((Ao[j].x==Ao[pos].x)&&(j<=N))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j++;
   }
   dr1=j;
   while ((Ao[j].x==Ao[dr1].x)&&(j<=N))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j++;
   }
   dr1=j;
   // Mai caut ajutoare in stanga in limita posibilului
   j=st1;
   while ((abs(Ao[j].x-Ao[st1].x)<min)&&(j>0))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j--;
   }
   // Mai caut ajutoare in dreapta in limita posibilului
   j=dr1;
   while ((abs(Ao[j].x-Ao[dr1].x)<min)&&(j<=N))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j++;
   }
  }
//*******************************************************
  // Caut binar linia (Av)
  st=1; dr=N; gasit=0;
  while ((st<=dr)&&(!gasit))
  {
   st1=st; dr1=dr;
   pos=(st+dr)/2;
   if (Av[pos].y>P.y) dr=pos-1;   else
   if (Av[pos].y<P.y) st=pos+1;   else
   gasit=1;
  }
  if (st<=dr)
  {
   // Am gasit ajutoare pe coloana A[pos].x
   if (min>abs(P.x-Av[pos].x)+abs(P.y-Av[pos].y))
    min=abs(P.x-Av[pos].x)+abs(P.y-Av[pos].y);
   j=pos;
   while ((Av[j].y==Av[pos].y)&&(j>0))
   {
    if (min>abs(P.x-Av[j].x)+abs(P.y-Av[j].y))
     min=abs(P.x-Av[j].x)+abs(P.y-Av[j].y);
    j--;
   }
   st1=j;
   j=pos;
   while ((Av[j].y==Av[pos].y)&&(j<=N))
   {
    if (min>abs(P.x-Av[j].x)+abs(P.y-Av[j].y))
     min=abs(P.x-Av[j].x)+abs(P.y-Av[j].y);
    j++;
   }
   dr1=j;
   // Caut ajutoare pe coloana din stanga
   j=st1;
   while ((Av[j].y==Av[st1].y)&&(j>0))
   {
    if (min>abs(P.x-Av[j].x)+abs(P.y-Av[j].y))
     min=abs(P.x-Av[j].x)+abs(P.y-Av[j].y);
    j--;
   }
   st1=j;
   // Caut ajutoare pe coloana din dreapta
   j=dr1;
   while ((Av[j].y==Av[pos].y)&&(j<=N))
   {
    if (min>abs(P.x-Av[j].x)+abs(P.y-Av[j].y))
     min=abs(P.x-Av[j].x)+abs(P.y-Av[j].y);
    j++;
   }
   dr1=j;
   // Mai caut ajutoare in stanga in limita posibilului
   j=st1;
   while ((abs(Ao[j].x-Ao[st1].x)<min)&&(j>0))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j--;
   }
   // Mai caut ajutoare in dreapta in limita posibilului
   j=dr1;
   while ((abs(Ao[j].x-Ao[dr1].x)<min)&&(j<=N))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j++;
   }
  }
  else
  {
   // Nu am gasit coloana punctului
   if (min>abs(P.x-Av[pos].x)+abs(P.y-Av[pos].y))
    min=abs(P.x-Av[pos].x)+abs(P.y-Av[pos].y);
   j=pos+1;
   while ((Av[j].y==Av[pos].y)&&(j>0))
   {
    if (min>abs(P.x-Av[j].x)+abs(P.y-Av[j].y))
     min=abs(P.x-Av[j].x)+abs(P.y-Av[j].y);
    j--;
   }
   st1=j;
   while ((Av[j].y==Av[st1].y)&&(j>0))
   {
    if (min>abs(P.x-Av[j].x)+abs(P.y-Av[j].y))
     min=abs(P.x-Av[j].x)+abs(P.y-Av[j].y);
    j--;
   }
   st1=j;
   j=pos;
   while ((Av[j].y==Av[pos].y)&&(j<=N))
   {
    if (min>abs(P.x-Av[j].x)+abs(P.y-Av[j].y))
     min=abs(P.x-Av[j].x)+abs(P.y-Av[j].y);
    j++;
   }
   dr1=j;
   while ((Av[j].y==Av[dr1].y)&&(j<=N))
   {
    if (min>abs(P.x-Av[j].x)+abs(P.y-Av[j].y))
     min=abs(P.x-Av[j].x)+abs(P.y-Av[j].y);
    j++;
   }
   dr1=j;
   // Mai caut ajutoare in stanga in limita posibilului
   j=st1;
   while ((abs(Ao[j].x-Ao[st1].x)<min)&&(j>0))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j--;
   }
   // Mai caut ajutoare in dreapta in limita posibilului
   j=dr1;
   while ((abs(Ao[j].x-Ao[dr1].x)<min)&&(j<=N))
   {
    if (min>abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y))
     min=abs(P.x-Ao[j].x)+abs(P.y-Ao[j].y);
    j++;
   }
  }

  fout<<min<<endl;
 }
 fout.close();
}

int main()
{
 Read();
 Compute();
 return 0;
}

