#include <stdio.h>

#define INF 666666
#define abs(x) (((x) < 0) ? (-(x)) : (x))
#define dist(x1, y1, x2, y2) (abs(x1 - x2) + abs(y1 - y2))

int N, M, X[400], Y[400];

int main()
{
    FILE *fin, *fout;
    int i, j, x, y, dmin, tmp;

    fin = fopen("ajutor.in", "r");
    fout = fopen("ajutor.out", "w");
    
    fscanf(fin, "%d %d\n", &N, &M);
    for (i = 0; i < N; i++)
        fscanf(fin, "%d %d\n", &X[i], &Y[i]);
    for (i = 0; i < M; i++)
    {
        fscanf(fin, "%d %d\n", &x, &y);
        dmin = INF;
        for (j = 0; j < N; j++)
            if ((tmp = dist(x, y, X[j], Y[j])) < dmin)
               dmin = tmp;
        fprintf(fout, "%d\n", dmin);
    }

    fclose(fin);
    fclose(fout);

    return 0;
}
