#include <stdio.h>
#include <string.h>

#define input "sala.in"
#define output "sala.out"

void readdata(void);
void multiplicate(void);

int x[32000], y[32000], z[64000], s[64000];

int main(void)
{
	int t = 1, i, r = 0;
    FILE *f;

	readdata();

    memcpy(y, x, sizeof(x));

	for (i = 1; i <= y[0]; i++)
    {
    	y[i] += t;
        if (y[i] > 10)
        {
        	t = 1;
            y[i] %= 10;
        }
        else
        	break;
    }

    multiplicate();

    memcpy(s, z, sizeof(z));

    r = 0;

    for (i = z[0]; i >= 1; i--)
    {
    	r = r * 10 + z[i];
		s[i] = r / 6;
        r %= 6;
    }

    r = 0;

    for (i = z[0]; i >= 1; i--)
    {
    	r = r * 10 + z[i];
		z[i] = r / 2;
        r %= 2;
    }    

    t = 0;

    for (i = 1; i <= z[0]; i++)
    {
    	z[i] -= s[i] + t;
        if (z[i] < 0)
        {
        	z[i] += 10;
            t = 1;
        }
        else
        	t = 0;
    }

    while (!z[z[0]] && z[0] > 1)
    	z[0]--;

    f = fopen(output, "w");

    for (i = z[0]; i >= 1; i--)
    	fprintf(f, "%d", z[i]);

	fprintf(f, "\n");
    
    fclose(f);

    return 0;
}

void readdata(void)
{
	int i;
	FILE *f;

    f = fopen(input, "r");

    fscanf(f, "%d", &x[0]);

    for (i = x[0]; i >= 1; i--)
		fscanf(f, "%d", &x[i]);
    
    fclose(f);
}

void multiplicate(void)
{
	int i, j, t = 0;

	memset(z, 0, sizeof(z));
    z[0] = x[0] + y[0] - 1;

    for (i = 1; i <= x[0]; i++)
    	for (j = 1; j <= y[0]; j++)
        	z[i + j - 1] += x[i] * y[j];

	for (i = 1; i <= z[0]; i++)
    {
    	z[i] += t;
        t = z[i] / 10;
        z[i] %= 10;
    }

    while (t)
    {
    	z[++z[0]] = t % 10;
        t /= 10;
    }
}
