#include <fstream.h>
#define INFILE "circular.in"
#define OUTFILE "circular.out"
#define MAX 10000000
#define NMAX 10

unsigned long int n, nr, nrc;

void Citeste();
void Solutie();
void Scrie();
int Circular(unsigned long int nr);

int main()
{
	Citeste();
	Solutie();
	Scrie();

	return 0;
}

void Citeste()
{
	ifstream fin(INFILE);

	fin >> n;

	fin.close();
}

void Solutie()
{
	unsigned long int i;

	for ( i = 1; i < n; i++ )
		if ( Circular(i) ) nr++;
}

void Scrie()
{
	ofstream fout(OUTFILE);

	fout << nr << " " << nrc << endl;

	fout.close();
}

int Circular ( unsigned long int nr )
{
	unsigned long int n = nr, k = 0, nh = nr;
	int c[NMAX] = { 0 }, s[NMAX] = { 0 };

	while ( nr )
	{
		nr /= 10;
		k++;
	}

	int i = k;

	while ( n )
	{
		c[i--] = n % 10;
		n /= 10;
	}

	if ( k == 1 )
	{
		nrc = nh;
		return 1;
        }

	int gata = 0;
	int cifra = c[1];
	s[1] = 1;
	int l, p = 1;

	do
	{
		if ( p + cifra <= k )
		{
			p += cifra;
			cifra = c[p];
		}
		else
		{
			p += cifra;
			while ( p > k )
			{
				p -= k;
			}
			cifra = c[p];
		}
		if ( s[p] && p == 1 && nr == k - 1 ) gata = 1;
		else
		if ( s[p] && nr < k ) return 0;
			else
			{
				s[p] = 1;
				nr++;
			}
	} while ( !gata );

	nrc = nh;

	return 1;
}







