#include <stdio.h>
#include <string.h>

#define input "circular.in"
#define output "circular.out"

void readdata(void);
void bfs(int k);
int circle(int n);

long int n, st = 0, s[32], bestsofar, nrsol = 0, se[32], stack[32], nrcf = 0;

int main(void)
{
	long int temp;
	FILE *f;

	memset(s, 0, sizeof(s));
    s[0] = 1;

	readdata();

	temp = n;
	while (temp)
	{
		nrcf++;
		temp /= 10;
	}

	bfs(0);

	if (n >= 1849625)
		nrsol -= 9;

	f = fopen(output, "w");

	fprintf(f, "%ld %ld\n", nrsol, bestsofar);

	fclose(f);

	return 0;
}

void readdata(void)
{
	FILE *f;

	f = fopen(input, "r");

	fscanf(f, "%ld", &n);

	fclose(f);
}

void bfs(int k)
{
	int i;

	if (st && st < n && circle(k))
	{
		nrsol++;
		if (st > bestsofar)
			bestsofar = st;
	}
	if (st < n && k < nrcf)
		for (i = 1; i < 10; i++)
			if (!s[i])
			{
				s[i] = 1;
				st *= 10;
				st += i;
				stack[k] = i;
				bfs(k + 1);
				s[i] = 0;
				st /= 10;
			}
}

int circle(int n)
{
	int i, nr = 0, s = 0;

	memset(se, 0, sizeof(se));

	i = 0;
	while (1)
	{
		if (!i && nr == n)
			return 1;
		if (se[stack[i]])
			return 0;
		nr++;
		se[stack[i]] = 1;
		i += stack[i];
		while (i >= n)
			i -= n;
	}
}