#include <stdio.h>
#include <string.h>

#define input "scaune.in"
#define output "scaune.out"

#define INF 9999

void readdata(void);
int getlen(int p1, int p2);

int ns, wait[256], out[256], nout = 0, nc, fin[256], s[256];

int main(void)
{
	int j, min, len, poz, i;
	FILE *fout;

	memset(wait, 0, sizeof(wait));
	memset(out, 0, sizeof(out));
	memset(s, 0, sizeof(s));

	readdata();

	memcpy(fin, wait, sizeof(wait));

	for (i = 0; i < nout; i++)
	{
		min = INF;
		for (j = 0; j < nc; j++)
			if (!s[j])
			{
					len = getlen(out[i], fin[j]);
					if (len < min)
					{
						min = len;
						poz = j;
					}
			}

		for (j = 0; j < nc; j++)
			if (!s[j])
			{
				fin[j] += min;
				while (fin[j] > ns)
					fin[j] -= ns;
			}

		s[poz] = 1;
	}

	fout = fopen(output, "w");

	for (i = 0; i < nc; i++)
		if (s[i])
			fprintf(fout, "%d %d\n", wait[i], fin[i]);
		else
			fprintf(fout, "%d %d\n", wait[i], 0);

	fclose(fout);

	return 0;
}

void readdata(void)
{
	int i;
	FILE *f;

	f = fopen(input, "r");

	fscanf(f, "%d %d", &ns, &nc);

	for (i = 0; i < nc; i++)
		fscanf(f, "%d", &wait[i]);

	while (!feof(f))
	{
		if (fscanf(f, "%d", &out[nout]))
			nout++;
	}         

	fclose(f);
}

int getlen(int p1, int p2)
{
	if (p2 <= p1)
		return p1 - p2;
	else
		return ns - p2 + p1;
}