#include <fstream.h>
#define INFILE "masina.in"
#define OUTFILE "masina.out"
#define MAX 30001

long int n, a[MAX], b[MAX];

void Citeste();
void Solutie();
int  Parcurge(int i);

int main()
{
	Citeste();
	Solutie();

	return 0;
}

void Citeste()
{
	ifstream fin(INFILE);

	fin >> n;

	int i = 0;

	for ( i = 1; i <= n; i++ )
		fin >> a[i];

	for ( i = 1; i <= n; i++ )
		fin >> b[i];

	fin.close();
}

void Solutie()
{
	int i = 0, gasit = 0;

	ofstream fout(OUTFILE);

	for ( i = 1; i <= n && !gasit; i++ )
		if ( a[i] && a[i] >= b[i] )
			if ( Parcurge(i) )
			{
				fout << i << endl;
				gasit = 1;
			}

	fout.close();
}

int Parcurge(int i)
{
	unsigned long int j = 0, nr = 0, total = 0;

	for ( j = i; nr < n; j++ )
	{
		total += a[j];
		if ( b[i] > total ) return 0;
                	else total -= b[i];
		nr++;
	}

	return 1;
}





