#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define input "criptare.in"
#define output "criptare.out"

void readdata(void);
int search(int col);
int compare(const void *k1, const void *k2);
int searchl(char c);

int ord[32], lencuv, m, lencr;
char cript[1024], cuv[32], mesaj[32][64], tmpcuv[32];

int main(void)
{
	int i, poz, j, k;
	FILE *fout;

	memset(cript, 0, sizeof(cript));
	memset(mesaj, 0, sizeof(mesaj));
	memset(cuv, 0, sizeof(cuv));
	memset(ord, 0, sizeof(ord));

	readdata();

	lencuv = strlen(cuv);
	lencr = strlen(cript);
	m = lencr / lencuv;
	memcpy(tmpcuv, cuv, sizeof(cuv));
	qsort(tmpcuv, lencuv, sizeof(char), compare);

	for (i = 0; i < lencuv; i++)
		ord[i] = searchl(cuv[i]);

	j = 0;
	for (i = 0; i < lencuv; i++)
	{
		poz = search(i);
		for (k = 0; k < m; k++)
		{
			mesaj[k][poz] = cript[j];
			j++;
		}
	}

	for (i = lencuv - 1; i >= 0; i--)
		if (mesaj[m - 1][i] == '*')
			mesaj[m - 1][i] = 0;

	fout = fopen(output, "w");

	for (i = 0; i < m; i++)
		for (j = 0; j < lencuv; j++)
			if ((mesaj[i][j] != '*') && (mesaj[i][j] != 0))
				fprintf(fout, "%c", mesaj[i][j]);
			else
				if (mesaj[i][j] != 0)
					fprintf(fout, " ");

	fclose(fout);

	return 0;
}

void readdata(void)
{
	FILE *f;

	f = fopen(input, "r");

	fscanf(f, "%s %s", cript, cuv);

	fclose(f);
}

int search(int col)
{
	int i;

	for (i = 0; i < lencuv; i++)
		if (ord[i] == col)
			return i;
	return 0;
}

int compare(const void *k1, const void *k2)
{
	char *a1 = (char *) k1, *a2 = (char *) k2;

	return (*a1) - (*a2);
}

int searchl(char c)
{
	int i;

	for (i = 0; i < lencuv; i++)
		if (tmpcuv[i] == c)
			return i;
	return 0;
}