#include <stdio.h>
#include <string.h>

char msg[1024], key[32], big[64][32];
int N, M, num[26], label, code[32];

int main()
{
    FILE *f;
    int i, j, min, where;

    f = fopen("criptare.in", "r");
    fscanf(f, "%s\n", msg);
    fscanf(f, "%s", key);
    fclose(f);

    N = strlen(msg); M = strlen(key);
    for (i = 0; i < N / M; i++)
        for (j = 0; j < M; j++)
            big[i][j] = '*';

    for (i = 0; i < M; i++)
    {
        min = 666, where = -1;
        for (j = 0; j < M; j++)
            if (!code[j] && key[j] < min) min = key[j], where = j;
        code[where] = ++label;
    }

    for (i = 0; i < M; i++)
    {
        code[i]--;
        for (j = (N / M) * code[i]; j < (N / M) * (code[i] + 1); j++)
            big[j % (N / M)][i] = msg[j];
    }

    for (i = N / M - 1; i >= 0; i--)
        for (j = M - 1; j >= 0; j--)
            if (big[i][j] == '*')
               big[i][j] = 0;
            else
               j = -1, i = -1;

    f = fopen("criptare.out", "w");
    for (i = 0; i < N / M; i++)
    for (j = 0; j < M; j++)
        if (big[i][j] && big[i][j] != '*')
           fprintf(f, "%c", big[i][j]);
        else
        if (!big[i][j])
           i = N / M, j = M;
        else
           fprintf(f, " ");
    fclose(f);
    
    return 0;
}
