{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
var fi,fo:text;
    ii,i,j,k,l,m,n,v,dist:longint;
    x,y:array[1..100]of real;
    a:array[1..30,1..100]of real;
    t:array[1..30,1..100]of integer;
    ok:array[1..100,1..100]of integer;
    yy,aa,bb:real;
    d,optim,ss:real;
    sol:array[1..100]of integer;


procedure readdata;
begin
  assign(fi,'munte.in');
  assign(fo,'munte.out');
  reset(fi);
  readln(fi,n,k,l);
  for i:=1 to n do
      readln(fi,x[i],y[i]);
  close(fi);
end;

procedure calc_ok;
begin
  for i:=1 to n do
      for j:=i+1 to n do
          begin
            aa:=(y[i]-y[j])/(x[i]-x[j]);
            bb:=y[i]-aa*x[i];

            ok[i,j]:=1;
            for v:=i+1 to j-1 do
                begin
                  yy:=aa*x[v]+bb;
                  if (y[v]>yy)or(abs(y[v]-yy)<=0.000001) then
                     ok[i,j]:=0;
                end;
            if sqrt(sqr(x[i]-x[j])+sqr(y[i]-y[j]))>l then
               ok[i,j]:=0;
            ok[j,i]:=ok[i,j];
          end;
end;

procedure rec(i,j:integer);
begin
  if j=1 then
     begin
       write(fo,j);
       exit;
     end;
  rec(i-1,t[i,j]);
  write(fo,' ',j);
end;

procedure solve;
begin
  calc_ok;

  a[1,1]:=0;
  for i:=2 to n do
      a[1,i]:=maxlongint;
  for i:=2 to k do
      a[i,1]:=maxlongint;

  for i:=2 to k do
      for j:=2 to n do
          begin
            a[i,j]:=maxlongint;
            for ii:=1 to j-1 do
                if ok[ii,j]=1 then
                   begin
                     d:=sqrt(sqr(x[ii]-x[j])+sqr(y[ii]-y[j]));
                     if a[i-1,ii]+d<a[i,j] then
                        begin
                          a[i,j]:=a[i-1,ii]+d;
                          t[i,j]:=ii;
                        end;
                   end;
          end;

  optim:=a[k,n];
  optim:=round(optim);
{  if optim=maxlongint then
     writeln('MAXLONGINT!!!');
  rewrite(fo);
  writeln(fo,round(optim));
  rec(k,n);
  close(fo);
}
end;

procedure eroare(pct:integer;s:string);
begin
  writeln(pct,' ',s);
  close(fo);
  halt;
end;

procedure evalConcurent;
begin
  assign(fo,'munte.out');
  reset(fo);
  if ioresult<>0 then
     eroare(0,'Eroare la deschiderea fisierului de iesire.');
  readln(fo,dist);
  if dist>optim then
     eroare(0,'Lungimea totala nu este minima.');

  for i:=1 to k do
      begin
        read(fo,sol[i]);
        if ioresult<>0 then
           eroare(0,'Eroare la citirea statiilor de telecabine.');
      end;
  if sol[1]<>1 then
     eroare(0,'Prima statie nu a fost plasata in 1.');
  if sol[k]<>n then
     eroare(0,'Ultima statie nu a fost plasata in N.');
  ss:=0;
  for i:=1 to k-1 do
      if ok[sol[i],sol[i+1]]=0 then
         eroare(0,'Ati conectat 2 statii intre care conectarea nu era posibila.');
  for i:=1 to k-1 do
      ss:=ss+sqrt(sqr(x[sol[i]]-x[sol[i+1]])+sqr(y[sol[i]]-y[sol[i+1]]));

  if round(ss)<>dist then
     eroare(0,'Lungimea totala obtinuta nu este cea declarata.');

  eroare(10,'Corect.');


end;

begin
  readdata;
  solve;

  readdata;
  evalConcurent;
end.