#include <stdio.h>
#include <string.h>

#define intrare "muzeu.in"
#define iesire  "muzeu.out"


int m,n;

unsigned char x[51][51][11];
int y[51][51];

unsigned char mat[51][51];

int nrmut[51][51];

int cost[11];

char mutari[10000];

void citire()
{
 int i,j;
 FILE *f=fopen (intrare,"r");
 fscanf(f,"%d%d",&m,&n);
 for (i=1;i<m+1;i++)
    for (j=1;j<n+1;j++)
       fscanf(f,"%d",&mat[i][j]);
 for (i=1;i<11;i++) fscanf(f,"%d",&cost[i]);
 fclose(f);
}

void init()
{
 int i,j;
 for (i=0;i<m+2;i++)
    for (j=0;j<n+2;j++)
       {
        y[i][j]=2000000000;
        nrmut[i][j]=2000000000;
       }
 y[1][1]=0;
 cost[0]=0;
 memset(x,0,sizeof(x));
 x[1][1][0]=1;
 nrmut[1][1]=0;
}

void rezolvare()
{
 int i,j,k;
 bool modif=true;
 while (modif)
   {
    modif=false;
    for (i=1;i<m+1;i++)
       for(j=1;j<n+1;j++)
          {
           if ((y[i][j]>y[i-1][j]+cost[mat[i-1][j]])&&(x[i-1][j][mat[i-1][j]]==1))
             {
              y[i][j]=y[i-1][j]+cost[mat[i-1][j]];
              x[i][j][mat[i][j]]=1;
              x[i][j][mat[i-1][j]]=1;
              modif=true;
             }
           if ((y[i][j]>y[i+1][j]+cost[mat[i+1][j]])&&(x[i+1][j][mat[i+1][j]]==1))
             {
              y[i][j]=y[i+1][j]+cost[mat[i+1][j]];
              x[i][j][mat[i][j]]=1;
              x[i][j][mat[i+1][j]]=1;
              modif=true;
             }
           if ((y[i][j]>y[i][j-1]+cost[mat[i][j-1]])&&(x[i][j-1][mat[i][j-1]]==1))
             {
              y[i][j]=y[i][j-1]+cost[mat[i][j-1]];
              x[i][j][mat[i][j]]=1;
              x[i][j][mat[i][j-1]]=1;
              modif=true;
             }
           if ((y[i][j]>y[i][j+1]+cost[mat[i][j+1]])&&(x[i][j+1][mat[i][j+1]]==1))
             {
              y[i][j]=y[i][j+1]+cost[mat[i][j+1]];
              x[i][j][mat[i][j]]=1;
              x[i][j][mat[i][j+1]]=1;
              modif=true;
             }
           if ((y[i][j]==y[i-1][j]+cost[mat[i-1][j]])&&
		(x[i-1][j][mat[i-1][j]]==1)&&
		(nrmut[i-1][j]+1<nrmut[i][j]))
             {
              y[i][j]=y[i-1][j]+cost[mat[i-1][j]];
              x[i][j][mat[i][j]]=1;
              x[i][j][mat[i-1][j]]=1;
	      nrmut[i][j]=nrmut[i-1][j]+1;
              modif=true;
             }
           if ((y[i][j]==y[i+1][j]+cost[mat[i+1][j]])&&(x[i+1][j][mat[i+1][j]]==1)
		&&
		(nrmut[i+1][j]+1<nrmut[i][j]))
             {
              y[i][j]=y[i+1][j]+cost[mat[i+1][j]];
              x[i][j][mat[i][j]]=1;
              x[i][j][mat[i+1][j]]=1;
	      nrmut[i][j]=nrmut[i+1][j]+1;
              modif=true;
             }
           if ((y[i][j]==y[i][j-1]+cost[mat[i][j-1]])&&(x[i][j-1][mat[i][j-1]]==1)
		&&
		(nrmut[i][j-1]+1<nrmut[i][j]))
             {
              y[i][j]=y[i][j-1]+cost[mat[i][j-1]];
              x[i][j][mat[i][j]]=1;
              x[i][j][mat[i][j-1]]=1;
	      nrmut[i][j]=nrmut[i][j-1]+1;
              modif=true;
             }
           if ((y[i][j]==y[i][j+1]+cost[mat[i][j+1]])&&(x[i][j+1][mat[i][j+1]]==1)
	   &&
		(nrmut[i][j+1]+1<nrmut[i][j])
	   )
             {
              y[i][j]=y[i][j+1]+cost[mat[i][j+1]];
              x[i][j][mat[i][j]]=1;
	      nrmut[i][j]=nrmut[i][j+1]+1;
              x[i][j][mat[i][j+1]]=1;
              modif=true;
             }
          }
   }
}

void reconst(int i,int j)
{
 int min=2000000000;
 if (!((i==1)&&(j==1)))
   {
    if ((y[i-1][j]<min)&&(nrmut[i-1][j]==nrmut[i][j]-1))
      {
       mutari[nrmut[i][j]]='S';
       min=y[i-1][j];
      }
    if ((y[i+1][j]<min)&&(nrmut[i+1][j]==nrmut[i][j]-1))
      {
       mutari[nrmut[i][j]]='N';
       min=y[i+1][j];
      }
    if ((y[i][j-1]<min)&&(nrmut[i][j-1]==nrmut[i][j]-1))
      {
       min=y[i][j-1];
       mutari[nrmut[i][j]]='E';
      }
    if ((y[i+1][j]<min)&&(nrmut[i+1][j]==nrmut[i][j]-1))
      {
       mutari[nrmut[i][j]]='V';
       min=y[i][j+1];
      }
    if (mutari[nrmut[i][j]]=='N') reconst(i+1,j);
    else if (mutari[nrmut[i][j]]=='S') reconst(i-1,j);
    else if (mutari[nrmut[i][j]]=='E') reconst(i,j-1);
    else if (mutari[nrmut[i][j]]=='V') reconst(i,j+1);
   }
}
void scriere()
{
 FILE *f=fopen(iesire,"w");
 fprintf(f,"%d\n%d\n",y[m][n],nrmut[m][n]);
 reconst(m,n);
 fprintf(f,"%s\n",mutari+1);
 fclose(f);
}

int main()
{
 citire();
 init();
 rezolvare();
 scriere();
 return 0;
}

