#include <fstream.h>
#include <iostream.h>

ifstream in("asediu.in");
ofstream out("asediu.out");

#define MAXC 100

struct vlint
{
    char v[MAXC];
    inline char& operator[](int index){return v[index];}
    inline const char& operator[](int index)const{return v[index];}
    vlint(){};
    vlint(long x);
    void operator*=(int x);
    void operator+=(long long x);
};

vlint::vlint(long x)
{
    for (int i=0;i<MAXC;i++)
    {
        v[i]=x%10;
        x=x/10;
    }
}

ostream& operator<<(ostream &os,const vlint &v)
{
    int i;
    for (i=MAXC-1;v[i]==0&&i>0;i--);
    for (;i>=0;i--)
        os<<(int)v[i];
    return os;
}

void vlint::operator*=(int x)
{
    int t=0;
    for (int i=0;i<MAXC;i++)
    {
        t+=v[i]*x;
        v[i]=t%10;
        t=t/10;
    }
    if (t) out<<"OVERFLOW\n";
}

void vlint::operator+=(long long x)
{
    int t=0;
    for (int i=0;i<MAXC;i++)
    {
        t+=x%10+v[i];
        v[i]=t%10;
        t=t/10;
        x=x/10;
    }
    if (t||x)
        out<<"OVERFLOW\n";
}

void solve(long long n)
{
    vlint rez=1;
    int q=24;
    for (long tz=n;tz>n-4;tz--)
    {
        long tzz=tz;
        while (q%2==0&&tzz%2==0) {q=q/2;tzz=tzz/2;}
        while (q%3==0&&tzz%3==0) {q=q/3;tzz=tzz/3;}
        rez*=tzz;
    }
    long long qqq=n*(n-1)/2+1;
    rez+=qqq;
    /*out<<n*(n-1)*(n-2)*(n-3)/24<<'\n';
    out<<rez<<'\n';*/
    //out<<n*(n-1)/2+1+n*(n-1)*(n-2)*(n-3)/24<<'\n';
    out<<rez<<'\n';
}

int main()
{
    long long n;
    in>>n;
    solve(n);
    return 0;
}

