#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define abs(a) a>=0?a:-a
#define round(x) (fmod(x, 1.0)<0.5)?floor(x):ceil(x)

int N, K, L;
int vx[128], vh[128];
unsigned int s[64], c[64];
float lngth;

void readdata()
  {
  FILE *f = fopen("munte.in", "r");
  fscanf(f, "%d %d %d", &N, &K, &L);
  int i;
  for (i = 0; i < N; i++)
    fscanf(f, "%d %d", &vx[i], &vh[i]);
  fclose(f);
  }

int valid(int index)
  {
  int i, iii1, iii2;
  float h;
  iii1 = c[index-1];
  iii2 = c[index];
  for (i = iii1+1; i < iii2; i++)
    {
    h = vh[iii1] + (vx[i]-vx[iii1])*(vh[iii2]-vh[iii1])/(vx[iii2]-vx[iii1]);
    if (!(h>vh[i]))
      return 0;
    }
  if (sqrt( abs((vx[iii1]-vx[iii2])*(vh[iii1]-vh[iii2])) ) > L)
    return 0;
  return 1;
  }

void solutie()
  {
  int i;
  float l;
  l = 0;
  for (i = 1; i < K; i++)
    l += sqrt((vx[c[i-1]]-vx[c[i]])*(vx[c[i-1]]-vx[c[i]])+
	(vh[c[i-1]]-vh[c[i]])*(vh[c[i-1]]-vh[c[i]]));
  if (l < lngth)
    {
    lngth = l;
    for (i = 1; i < K; i++)
      s[i] = c[i]+1;
    }
  }

void bktrk(int index)
  {
  int vmax;
  vmax = N-(K-index);
  for (c[index] = c[index-1]+1; c[index] <= vmax; c[index]++)
    {
    if (valid(index))
      if (index == K-2)
	  solutie();
	else
	  bktrk(index + 1);
    }
  }

void writedata()
  {
  FILE *f = fopen("munte.out", "w");
  int lngt, i;
  lngt = round(lngth);
  fprintf(f, "%d\n1", lngt);
  for (i = 1; i < K; i++)
    fprintf(f, " %d", s[i]);
  fclose(f);
  }

int main()
  {
  readdata();
  c[0] = 0; c[K-1] = N-1; lngth = 10000000;
  bktrk(1);
  writedata();
  return 0;
  }