#include <stdio.h>

unsigned int m, n, da, db;
unsigned int mat[64][64];
char t[64][64];
unsigned long int c[64][64];
unsigned int p[64][64];
unsigned int nr[64][64];
unsigned int ni[2500], nj[2500];
unsigned int costuri[11];

FILE *g = fopen("muzeu.out", "w");

void readdata()
  {
  FILE *f = fopen("muzeu.in", "r");
  fscanf(f, "%d %d", &m, &n);
  int i, j;
  for (i = 0; i < m; i++)
    for (j = 0; j < n; j++)
      {
      fscanf(f, "%d", &mat[i][j]);
      c[i][j] = 0xFFFFFFFF;
      nr[i][j] = 0xFFFF;
      }
  for (i = 1; i < 10; i++)
    fscanf(f, "%d", &costuri[i]);
  c[0][0] = 0;
  nr[0][0] = 0;
  fclose(f);
  }

void add(int i, int j, char d)
  {
  int cost, np;
  cost = 0;
  np = p[ni[da]][nj[da]];
  if (((np >> mat[i][j]) & 1) == 0)
    {
    cost = costuri[mat[i][j]];
    np = np | (1 << mat[i][j]);
    }
  cost += c[ni[da]][nj[da]];
  int nx;
  nx = nr[ni[da]][nj[da]] + 1;
  if (cost < c[i][j])
    {
    db++;
    db = db % 2500;
    ni[db] = i;
    nj[db] = j;
    t[i][j] = d;
    c[i][j] = cost;
    p[i][j] = np;
    nr[i][j] = nx;
    }
    else if ((cost == c[i][j]) && (nx < nr[i][j]))
      {
      db++;
      db = db % 2500;
      ni[db] = i;
      nj[db] = j;
      t[i][j] = d;
      c[i][j] = cost;
      p[i][j] = np;
      nr[i][j] = nx;
      }
  }

void calc()
  {
  p[0][0] = 1;
  ni[0] = 0;
  nj[0] = 0;
  da = 0;
  db = 0;
  do {
    if (ni[da] < m-1)
      add(ni[da]+1, nj[da], 'S');
    if (nj[da] < n-1)
      add(ni[da], nj[da]+1, 'E');
    if (ni[da] > 0)
      add(ni[da]-1, nj[da], 'N');
    if (nj[da] > 0)
      add(ni[da], nj[da]-1, 'S');
    da++;
    } while (da != db+1);
  }

void write(int i, int j)
  {
  switch (t[i][j]) {
    case 'E' : write(i, j-1); break;
    case 'S' : write(i-1, j); break;
    case 'V' : write(i, j+1); break;
    case 'N' : write(i+1, j); break;
    default : break;
    }
  char s[2];
  s[0] = t[i][j];
  s[1] = '\0';
  fprintf(g, s);
  }

void writedata()
  {
  int i, j;
  i = m-1; j = n-1;
  fprintf(g, "%ld\n", c[i][j]);
  fprintf(g, "%d\n", nr[i][j]);
  write(i, j);
  fclose(g);
  }

int main()
  {
  readdata();
  calc();
  writedata();
  return 0;
  }