#include <fstream.h>
#include <math.h>
#define n_max 100
#define k_max 30
#define oo 100000000

ofstream w("munte.out");
int n,k; long l;
double x[n_max];
double h[n_max];
double lmin[n_max][k_max];
int p[n_max][k_max];

long round(double x){return (long)floor(x+0.5);}

void in(){
	int i,j;

	ifstream r("munte.in");
	r>>n; r>>k; r>>l;
	for(i=1;i<=n;i++){
		r>>x[i]; r>>h[i];
	}
	r.close();
	for(i=1;i<=n;i++)for(j=1;j<=k;j++)lmin[i][j]=oo;
	lmin[1][1]=0;
}

void v_out(int nv, int v){
	if(nv){
		v_out(nv-1,p[v][nv]);
		w<<v<<" ";
	}
}

void out(){
	w<<round(lmin[n][k])<<"\n";
	v_out(k,n);
	w<<"\n";
}

void calc(){
	int i,j,c;
	double d,ang,maxang,dx,dy;

	for(i=1;i<=n;i++){
		maxang=oo;
		for(j=i-1;j>=1;j--){
			dx=x[i]-x[j];
			dy=h[i]-h[j];
			ang=dy/dx;
			if(ang<maxang){
				maxang=ang;
				d=sqrt(dx*dx+dy*dy);
				if(d<=l)for(c=2;c<=k;c++)
					if(lmin[j][c-1]+d<lmin[i][c]){
						lmin[i][c]=lmin[j][c-1]+d;
						p[i][c]=j;
					}
			}
		}
	}
}

void main(){
	in();
	calc();
	out();
	w.close();
}