program muzeu;
type pnod=^nod;
     nod=record
         l,c:byte;
         next:pnod;
     end;
var
   dir:array [1..4,1..2] of shortint;
   m:array [0..51,0..51] of byte;
   drum:array [1..50,1..50,1..2] of longint;
   prec:array [1..50,1..50,1..2] of byte;
   cost:array [1..10] of word;
   lm,ln,i,j,k,l,c,tmp,cont:byte;
   sol:array [1..2500] of char;
   fi,fo:text;
   list,listend,t:pnod;
begin
     assign(fi, 'muzeu.in');
     reset(fi);
     readln(fi,lm,ln);
     for i:=1 to lm do
         for j:=1 to ln do
         begin
              read(fi, m[i,j]);
              drum[i,j,1]:=maxlongint;
         end;
     for i:=1 to 10 do read(fi, cost[i]);
     for i:=1 to lm do
     begin
          m[i,0]:=200;
          m[i,ln+1]:=200;
     end;
     for j:=1 to ln do
     begin
          m[0,j]:=200;
          m[lm+1,j]:=200;
     end;
     close(fi);
     dir[1,1]:=-1;dir[1,2]:=0;
     dir[2,1]:=0;dir[2,2]:=1;
     dir[3,1]:=1;dir[3,2]:=0;
     dir[4,1]:=0;dir[4,2]:=-1;

     new(list);
     list^.l:=1;list^.c:=1;list^.next:=nil;
     listend:=list;
     prec[1,1,1]:=0;prec[1,1,2]:=0;
     if m[1,1]<>0 then
     begin
          drum[1,1,1]:=cost[m[1,1]];
          drum[1,1,2]:=1 shl (m[1,1]-1);
     end
     else drum[1,1,1]:=0;

     while list<>nil do
     begin
          for k:=1 to 4 do
          begin
               l:=list^.l+dir[k,1];
               c:=list^.c+dir[k,2];
               if (m[l,c]<=10) then
               begin
                    if ((m[l,c]>0) and (drum[list^.l,list^.c,2] and (1 shr (m[l,c]-1)) = 1)) or (m[l,c]=0) then
                    begin
                       if drum[list^.l,list^.c,1]<drum[l,c,1] then
                       begin
                            drum[l,c,1]:=drum[list^.l,list^.c,1];
                            prec[l,c,1]:=list^.l;prec[l,c,2]:=list^.c;
                            listend^.next:=new(pnod);
                            listend:=listend^.next;
                            listend^.l:=l;listend^.c:=c;listend^.next:=nil;
                       end;
                    end
                    else
                        if drum[list^.l,list^.c,1]+cost[m[l,c]]<drum[l,c,1] then
                        begin
                             drum[l,c,1]:=drum[list^.l,list^.c,1]+cost[m[l,c]];
                             drum[l,c,2]:=drum[l,c,2] or (1 shl (m[l,c]-1));
                             prec[l,c,1]:=list^.l;prec[l,c,2]:=list^.c;
                             listend^.next:=new(pnod);
                             listend:=listend^.next;
                             listend^.l:=l;listend^.c:=c;listend^.next:=nil;
                        end;
               end;
          end;
          t:=list^.next;
          dispose(list);
          list:=t;
     end;

     {for i:=1 to lm do
     begin
          writeln;
          for j:=1 to ln do
              write(drum[i,j,1], '  ');
     end;
     writeln;writeln;
     for i:=1 to lm do
     begin
          writeln;
          for j:=1 to ln do
              write(prec[i,j,1],prec[i,j,2]);
     end;}

     l:=lm;c:=ln;
     cont:=0;
     while (l<>1) or (c<>1) do
     begin
          inc(cont);
          if prec[l,c,1] < l then sol[cont]:='S'
          else if prec[l,c,1] > l then sol[cont]:='N'
          else if prec[l,c,2] < c then sol[cont]:='E'
          else sol[cont]:='V';
          tmp:=l;
          l:=prec[tmp,c,1];
          c:=prec[tmp,c,2];
     end;

     assign(fo, 'muzeu.out');
     rewrite(fo);
     writeln(fo, drum[lm,ln,1]);
     writeln(fo, cont);
     for i:=cont downto 1 do
         write(fo, sol[i]);
     close(fo);
end.