#include <stdio.h>

int n, m;
int muzeu[50][50];
int bilete[10];
long LEE[50][50][2];
char drum[50][50];

int xInc[4] = {1, 0, -1, 0};
int yInc[4] = {0, 1, 0, -1};
char dr[5] = "SENV";

void citire() {
	FILE *intrare;
	int i, j;

	intrare = fopen("muzeu.in", "r");

	fscanf(intrare, "%d %d", &m, &n);
	for (i = 0; i < m; i++)
		for (j = 0; j < n; j++)
			fscanf(intrare, "%d", &muzeu[i][j]);
	for (i = 0; i < 10; i++)
		fscanf(intrare, "%d", &bilete[i]);

	fclose(intrare);
  }

int sePoateMuta(int x, int y) {
	return (x >= 0 && x < m && y >= 0 && y < n);
  }

void Lee() {
	int i, j;
	int len, len2;
	long curent[1000][15], curent2[1000][13];
	int x, y;

	curent[0][0] = 0; curent[0][1] = 0;
	for (i = 2; i < 12; i++) curent[0][i] = 0;
	if (muzeu[0][0])
		curent[0][1+muzeu[0][0]] = 1;
	curent[0][12] = 1;
	curent[0][13] = 0;
	curent[0][14] = (int)' ';
	len = 1;

	LEE[0][0][0] = muzeu[0][0];
	LEE[0][0][1] = 1;
	drum[0][0] = ' ';

	while(len > 0) {
		int pret;
		for (len2 = 0, i = 0; i < len; i++) {
			x = curent[i][0];
			y = curent[i][1];
			int pret2 = LEE[x][y][0];

			for (j = 0; j < 4; j++) {
				int xx, yy, k;
				xx = x+xInc[j];
				yy = y+yInc[j];
				pret = pret2;

				if (sePoateMuta(xx, yy)) {
					if(muzeu[xx][yy] != 0 && curent[i][1+muzeu[xx][yy]] == 0)
						pret += bilete[muzeu[xx][yy]-1];
					if (LEE[xx][yy][0] == -1 || LEE[xx][yy][0] > pret) {
						curent2[len2][0] = xx;
						curent2[len2][1] = yy;
						for (k = 2; k < 12; k++)
							curent2[len2][k] = curent[i][k];
						if (muzeu[xx][yy] != 0 && curent2[len2][1+muzeu[xx][yy]] == 0)
							curent2[len2][1+muzeu[xx][yy]] = 1;
						curent2[len2][12] = curent[i][12]+1;
						curent2[len2][13] = pret;
						curent2[len2][14] = (int)dr[j];

						LEE[xx][yy][0] = curent2[len2][13];
						LEE[xx][yy][1] = curent2[len2][12];
						drum[xx][yy] = (char)curent2[len2][14];
						len2++;
					  }
					else if (LEE[x][y][0] == pret
					  && curent[i][12]+1 < LEE[xx][yy][1]) {
						curent2[len2][0] = xx;
						curent2[len2][1] = yy;
						for (k = 2; k < 12; k++)
							curent2[len2][k] = curent[i][k];
						if (muzeu[xx][yy] != 0 && curent2[len2][1+muzeu[xx][yy]] == 0)
							curent2[len2][1+muzeu[xx][yy]] = 1;
						curent2[len2][12] = curent[i][12]+1;
						curent2[len2][13] = pret;
						curent2[len2][14] = (int)dr[j];

						LEE[xx][yy][0] = curent2[len2][13];
						LEE[xx][yy][1] = curent2[len2][12];
						drum[xx][yy] = (char)curent2[len2][14];

						len2++;
					  }
				  }
			  }
		  }

		for (i = 0; i < len2; i++)
			for (j = 0; j < 15; j++)
				curent[i][j] = curent2[i][j];
		len = len2;
	  }
  }

void afisare() {
	FILE *iesire;
	int i, x, y;
	char drum2[2501];

	iesire = fopen("muzeu.out", "w");
	fprintf(iesire, "%ld\n%ld\n", LEE[m-1][n-1][0], LEE[m-1][n-1][1]-1);
	x = m-1; y = n-1;

	for (i = 0; i < LEE[m-1][n-1][1]; i++) {
		 drum2[i] = drum[x][y];
		switch(drum[x][y]) {
			case 'N': x++;break;
			case 'S': x--;break;
			case 'E': y--;break;
			case 'V': y++;break;
		  }
	  }

	for (i = LEE[m-1][n-1][1]-2; i >= 0; i--)
		fprintf(iesire, "%c", drum2[i]);
	fprintf(iesire, "\n");
	fclose(iesire);
  }

void main(void) {
	citire();

	int i, j;
	for (i = 0; i < m; i++)
		for (j = 0; j < n; j++)
			LEE[i][j][0] = -1;

	Lee();
	afisare();
  }