#include <fstream.h>
#include <iomanip.h>

ifstream in("rubine.in");
ofstream out("rubine.out");

#define MAXL 60
#define MAXC 60
#define MAXN 60
#define MAXREL 500

int l,c,n,mat[MAXL][MAXC],px[MAXN],py[MAXN],rub[MAXN];
bool kill[MAXN][MAXN];

void dumpmat()
{
    for (int i=0;i<l;i++)
    {
        for (int j=0;j<c;j++)
            out<<setw(4)<<mat[i][j];
        out<<'\n';
    }
    out<<'\n';
}

void read()
{
    int i,j;
    in>>l>>c;
    for (i=0;i<l;i++)
        for (j=0;j<c;j++)
            in>>mat[i][j];
    in>>n;
    for (i=0;i<n;i++)
        in>>px[i]>>py[i];
    for (i=0;i<n;i++)
        for (j=0;j<n;j++)
            kill[i][j]=false;
    while (in>>i>>j)
        kill[i-1][j-1]=true;
}

template<class T>inline T max(T a,T b){return a>b?a:b;}

int best[MAXL][MAXC];

int calcmat(int x,int y)
{
    int mx=-10;
    if (best[x][y]>0)
        return best[x][y];
    if (x+1<l&&y+1<c) mx=max(mx,calcmat(x+1,y+1));
    if (x+c-y-1<l-1) mx=max(mx,calcmat(x+1,y));
    if (y&&x+c-y-1<l-2) mx=max(mx,calcmat(x+1,y-1));
    if (y+l-x-1<c-1) mx=max(mx,calcmat(x,y+1));
    if (x&&y+l-x-1<c-2) mx=max(mx,calcmat(x-1,y+1));
    if (mx==-10) out<<"All your base are belong to us\n";
    mx+=mat[x][y];
    best[x][y]=mx;
    return mx;
}

void calcrub()
{
    int i,j;
    for (i=0;i<l;i++)
        for (j=0;j<c;j++)
            best[i][j]=-10;
    best[l-1][c-1]=mat[l-1][c-1];
    for (i=0;i<n;i++) rub[i]=calcmat(px[i]-1,py[i]-1);
//    dumpmat();
//  for (i=0;i<l;i++){for (j=0;j<c;j++) out<<setw(4)<<calcmat(i,j);out<<'\n';}
    //for (i=0;i<n;i++) out<<"Thief "<<i+1<<" = "<<rub[i]<<'\n';
}

int nump,pi[MAXREL],pj[MAXREL];

void solve()
{
    int i,j;
    bool dead[MAXN],cont=true;
    nump=0;
    for (i=0;i<n;i++)
        dead[i]=false;
    while (cont)
    {
        cont=false;
        for (i=0;i<n;i++)
        {
            bool cankill=false;
            int killer=-10;
            for (j=0;j<n;j++)
            {
                if (kill[i][j])
                {
                    cankill=true;
                    break;
                }
                if (kill[j][i])
                    killer=j;
            }
            if (!cankill&&killer>=0)
            {
                //out<<killer+1<<" il omoara pe "<<i+1<<'\n';
                out.flush();
                dead[i]=true;
                pi[nump]=killer;
                pj[nump]=i;
                nump++;
                for (j=0;j<n;j++)
                    kill[i][j]=kill[j][i]=false;
                cont=true;
                break;
            }
        }
    }
    out<<nump<<'\n';
    for (i=0;i<nump;i++)
        out<<pi[i]+1<<' '<<rub[pi[i]]<<' '<<pj[i]+1<<' '<<rub[pj[i]]<<'\n';
    int ss=0;
    for (int i=0;i<n;i++)
        if (!dead[i])
        {
            out<<i+1<<' ';
            ss+=rub[i];
        }
    out<<'\n'<<ss<<'\n';
}

int main()
{
    read();
    calcrub();
    solve();
    return 0;    
}

