#include <stdio.h>
#include <mem.h>

#define min(a,b) a<=b?a:b

int mat[64][64], m1[64][64], m2[64][64];
int l, c, n, rel;
int hoti[50], h[50], hl[50], hc[50], relatii[50][50], fol[50][50];
int util1[128], util2[128], used;


void readdata()
  {
  FILE *f = fopen("rubine.in", "r");
  fscanf(f, "%d %d", &l, &c);
  int i, j;
  for (i = 0; i < l; i++)
    for (j = 0; j < c; j++)
      fscanf(f, "%d", &mat[i][j]);
  fscanf(f, "%d", &n);
  for (i = 0; i < n; i++)
    fscanf(f, "%d %d", &hl[i], &hc[i]);
  do {
    fscanf(f, "%d %d", &i, &j);
    relatii[i][j] = 1;
    } while (!(feof(f)));
  fclose(f);
  }

void use(int a, int b)
  {
  int i;
  for (i = 0; i < n; i++)
    if ((relatii[b][i] == 1) && (h[i] == 0))
      use(b, i);
  util1[used] = a;
  util2[used] = b;
  h[b] = 1;
  used++;
  }

void calc()
  {
  /* */
  int i, j, k, diag;
  for (i = 0; i< n; i++)
    {
    memset(m1, 0, sizeof(m1));
//    diag = min(l-hl[i], c-hc[i]);
    m1[hl[i]][hc[i]] = mat[hl[i]][hc[i]];
    for (j = hc[i]+1; j < c; j++)
      m1[hl[i]][j] = mat[hl[i]][j];
    for (j = hl[i]+1; j < l; j++)
      m1[j][hc[i]] = mat[j][hc[i]];
    for (j = hl[i]+1; j < l; j++)
      for (k = hc[i]+1; k < c; k++)
	{
	m1[j][k]=m1[j-1][k];
	if (m1[j][k-1] >= m1[j][k])
	  m1[j][k] = m1[j][k-1];
	if (m1[j-1][k-1] >= m1[j][k])
	  m1[j][k] = m1[j-1][k-1];
	m1[j][k] += mat[j][k];
	}
    hoti[i] = m1[l-1][c-1];
    }
  /* */
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      if (relatii[i][j] == 1)
	use(i, j);
  }

void writedata()
  {
  FILE *f = fopen("rubine.out", "w");
  fprintf(f, "%d\n", used);
  int i;
  for (i = 0; i < used; i++)
    fprintf(f, "%d %d %d %d\n", util1[i]+1, hoti[util1[i]], util2[i]+1, hoti[util2[i]]);
  int val = 0;
  for (i = 0; i < n; i++)
    if (h[i] == 0)
      {
      val += hoti[i];
      fprintf(f, "%d ", i+1);
      }
  fprintf(f, "\n");
  fprintf(f, "%d", val);
  fclose(f);
  }

int main()
  {
  readdata();
  calc();
  writedata();
  return 0;
  }