#include <stdio.h>
#include <mem.h>

unsigned int m, n, da, db;
unsigned int mat[16][16];
char t[16][16];
unsigned int nr[16][16];
//unsigned int n[16];
unsigned int used[16][16];
int ni[16], nj[16];

unsigned int lup[16];
unsigned int lupul[16][16];

char sol[16];
unsigned int solval;

int di[4], dj[4], tryval;
char vec[16], depl[5];

FILE *g = fopen("scufita.out", "w");

void readdata()
  {
  FILE *f = fopen("scufita.in", "r");
  fscanf(f, "%d", &n);
  int i, j;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      {
      fscanf(f, "%d", &mat[i][j]);
      used[i][j] = 1;
      }
  nr[0][0] = 0;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      {
      fscanf(f, "%d", &lupul[i][j]);
      }
  fclose(f);
  }

void makewolf()
  {
  int i, j, nr, cost, i1, j1;
  i = 0;
  j = 0;
  nr = 0;
  cost = lupul[0][0];
  lupul[0][0] = 0;
  lup[0] = cost;
  do {
    i1 = i;  j1 = j;
    if ((i > 0) && (lupul[i-1][j] > lupul[i1][j1]))
      { i1 = i-1;  j1 = j; }
    if ((j > 0) && (lupul[i][j-1] > lupul[i1][j1]))
      { i1 = i;  j1 = j-1; }
    if ((i < n-1) && (lupul[i+1][j] > lupul[i1][j1]))
      { i1 = i+1;  j1 = j; }
    if ((j < n-1) && (lupul[i][j+1] > lupul[i1][j1]))
      { i1 = i;  j1 = j+1; }
    nr++;
    i = i1;  j = j1;
    cost += lupul[i][j];
    lupul[i][j] = 0;
    lup[nr] = cost;
    } while (nr < 15);
  }

int valid(int index)
  {
  int i;
  if (lup[index] > tryval)
    return 0;
  if (ni[index]*nj[index] < 0)
    return 0;
  if (mat[ni[index]][nj[index]] == 0)
    return 0;
  return 1;
  }

void solutie()
  {
  if (solval < tryval)
    {
    solval = tryval;
    memcpy(&sol, &vec, sizeof(sol));
    }
  }

void bktrk(int index)
  {
  int t;
  for (t = 0; t < 4; t++)
    {
    ni[index] = ni[index-1] + di[t];
    nj[index] = nj[index-1] + dj[t];
    tryval += mat[ni[index]][nj[index]];
    if ((used[ni[index]][nj[index]] == 1) && (valid(index)))
      {
      used[ni[index]][nj[index]] = 0;
      vec[index-1] = depl[t];
	index==15?solutie():bktrk(index+1);
      used[ni[index]][nj[index]] = 1;
      }
    tryval -= mat[ni[index]][nj[index]];
    }
  }

void calc()
  {
  makewolf();
  ni[0] = 0;
  nj[0] = 0;
  solval = 0;
  used[0][0] = 0;
  tryval = mat[0][0];
  di[0] = -1;  dj[0] =  0;
  di[1] =  0;  dj[1] = -1;
  di[2] =  1;  dj[2] =  0;
  di[3] =  0;  dj[3] =  1;
  depl[0] = 'N';
  depl[1] = 'V';
  depl[2] = 'S';
  depl[3] = 'E';
  bktrk(1);
  }

void write(int i, int j)
  {
  switch (t[i][j]) {
    case 'E' : write(i, j-1); break;
    case 'S' : write(i-1, j); break;
    case 'V' : write(i, j+1); break;
    case 'N' : write(i+1, j); break;
    default : break;
    }
  char s[2];
  s[0] = t[i][j];
  s[1] = '\0';
  fprintf(g, s);
  }

void writedata()
  {
  int i, j, i1, j1;
  fprintf(g, "%d\n", solval);
  sol[15] = '\0';
  fprintf(g, sol);
  fclose(g);
  }

int main()
  {
  readdata();
  calc();
  writedata();
  return 0;
  }