#include <fstream.h>
#define dim 51

int l, c, n, mat[dim][dim], i, j, uz[dim], s,
    val[dim], rel[dim][dim], vec[dim], sol[dim][2];

struct {
int x, y;
} poz[dim];

void readinput()
{
    ifstream in("rubine.in");
    in>>l>>c;
    for(i=1; i<=l; i++)
       for(j=1; j<=c; j++) in>>mat[i][j];
    in>>n;
    for(i=1; i<=n; i++) in>>poz[i].x>>poz[i].y;
    while(in>>i)
       {
	   in>>j;
	   rel[i][j]=rel[j][i]=1;
	   vec[i]++; vec[j]++;
       }
    in.close();
}

void det_rubine(int k)
{ int x, y, sol[dim][dim], v, i, j;

    for(i=1; i<=l; i++)
       for(j=1; j<=c; j++) sol[i][j]=mat[i][j];

    x=poz[k].x;
    y=poz[k].y;
    if(x==l && y==c);
    else
    if(x==l)
       {
	   sol[x-1][y+1]+=sol[x][y];
	   sol[x][y+1]+=sol[x][y];
	   for(j=y+2; j<=c; j++)
	      if(sol[x][j-1]>sol[x-1][j-1])
		 {
		     sol[x][j]+=sol[x][j-1];
		     sol[x-1][j]+=sol[x][j-1];
		 }
	      else
		 {
		     sol[x][j]+=sol[x-1][j-1];
		     sol[x-1][j]+=sol[x-1][j-1];
		 }
       }
    else
    if(y==c)
       {
	   sol[x+1][y-1]+=sol[x][y];
	   sol[x+1][y]+=sol[x][y];
	   for(i=x+2; i<=l; i++)
	      if(sol[i-1][y]>sol[i-1][y-1])
		 {
		     sol[i][y]+=sol[i-1][y];
		     sol[i][y-1]+=sol[i-1][y];
		 }
	      else
		 {
		     sol[i][y]+=sol[i-1][y-1];
		     sol[i][y-1]+=sol[i-1][y-1];
		 }
       }
    else
       for(i=x+1; i<=l; i++)
	  {
	      sol[i][y+i-x]+=sol[i-1][y+i-x-1];
	      for(j=y+i-x+1; j<=c; j++)
		 if(sol[i][j-1]>sol[i-1][j-1]) sol[i][j]+=sol[i][j-1];
		 else sol[i][j]+=sol[i-1][j-1];
	  }
    val[k]=sol[l][c];
}

void go()
{ int min, pozmin;

    while(1)
       {
	   min=n*(n+1);
	   for(i=1; i<=n; i++)
	      if(vec[i]<min && !uz[i] && vec[i])
		 {
		     min=vec[i];
		     pozmin=i;
		 }
	      if(min==n*(n+1)) break;
	   uz[pozmin]=1; s++;
	   for(i=1; i<=n; i++)
	      if(rel[i][pozmin]) break;
	   sol[s][0]=i;
	   sol[s][1]=pozmin;
	   for(i=1; i<=n; i++)
	      if(rel[pozmin][i])
		 {
		     rel[pozmin][i]=rel[i][pozmin]=0;
		     vec[pozmin]--;
		     vec[i]--;
		 }
       }
}

void writeoutput()
{ int sum=0;

    ofstream out("rubine.out");
    out<<s<<endl;
    for(i=1; i<=s; i++)
       out<<sol[i][0]<<' '<<val[sol[i][0]]<<' '<<sol[i][1]<<' '<<val[sol[i][1]]<<endl;
    for(i=1; i<=n; i++)
       if(!uz[i])
	  { out<<i<<' '; sum+=val[i];}
    out<<endl;
    out<<sum<<endl;
    out.close();
}

int main()
{
    readinput();
    for(i=1; i<=n; i++) det_rubine(i);
    go();
    writeoutput();
    return 0;
}