#include <fstream.h>
#define dim 11

const dx[5]={0,  0, -1,  1},
      dy[5]={1, -1,  0,  0};

int n, m1[dim][dim], m2[dim][dim], sol[20], solmax, s[20],
    i, j, vec[2*dim], k, t, dir, max;

void readinput()
{
    ifstream in("scufita.in");
    in>>n;
    for(i=1; i<=n; i++)
       for(j=1; j<=n; j++) in>>m1[i][j];
    for(i=1; i<=n; i++)
       for(j=1; j<=n; j++) in>>m2[i][j];
    in.close();
}

void calc_vec()
{
    i=j=1;
    vec[0]=m2[i][j];
    for(t=1; t<=15; t++)
       {
	   max=-1;
	   for(k=0; k<4; k++)
	      if(i+dx[k]>0 && i+dx[k]<=n &&
		 j+dy[k]>0 && j+dy[k]<=n &&
		 m2[i+dx[k]][j+dy[k]]>max)
		    { max=m2[i+dx[k]][j+dy[k]];
		      dir=k;
		    }
	   vec[t]=vec[t-1]+max;
	   m2[i][j]=0;
	   i+=dx[dir];
	   j+=dy[dir];
       }
}

void go(int x, int y, int t)
{ int i;

    if(t==16 && max>solmax)
       {
	   solmax=max;
	   for(i=1; i<=15; i++) sol[i]=s[i];
       }
    else
       for(i=0; i<4; i++)
	  if(x+dx[i]>0 && x+dx[i]<=n &&
	     y+dy[i]>0 && y+dy[i]<=n &&
	     m1[x+dx[i]][y+dy[i]]>=0 &&
	     max+m1[x+dx[i]][y+dy[i]]>=vec[t])
		{
		    max+=m1[x+dx[i]][y+dy[i]];
		    s[t]=i;
		    m1[x][y]=-m1[x][y];
		    go(x+dx[i], y+dy[i], t+1);
		    max-=m1[x+dx[i]][y+dy[i]];
		    m1[x][y]=-m1[x][y];
		}
}

void writeoutput()
{
    ofstream out("scufita.out");
    out<<solmax<<endl;
    for(i=1; i<=15; i++)
       switch (sol[i]) {
       case 0: out<<'E'; break;
       case 1: out<<'V'; break;
       case 2: out<<'N'; break;
       case 3: out<<'S';
       }
    out<<endl;
    out.close();
}

int main()
{
    readinput();
    calc_vec();
    max=m1[1][1];
    go(1, 1, 1);
    writeoutput();
    return 0;
}