{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program rubine;
type matr = array[1..50,1..50] of byte;
     vect = array[1..50] of byte;
     coord = record
        ll,cc : byte;
     end;
     pchoice = ^choice;
     choice = record
        i,j : byte;
        urm : pchoice;
     end;
     pnod = ^nod;
     nod = record
         lin,col : byte;
         urm : pnod;
     end;

var l,c,n : byte;
    a,m : matr;
    hoti : array[1..50] of coord;
    vsac : array[1..50] of word;
    cap,coa : pchoice;
    nchoice : word;
    parinte,nrfii,go : vect;

    rmax : array[1..50,1..50] of longint;
    dmin : array[1..50,1..50] of word;
    p1,p2 : pnod;

procedure ReadData;
var f : text;
    i,j : byte;
begin
     assign(f,'rubine.in'); reset(f);
     readln(f,l,c);
     for i:=1 to l do begin
         for j:=1 to c do read(f,a[i,j]);
         readln(f);
     end;
     readln(f,n);
     for i:=1 to n do readln(f,hoti[i].ll,hoti[i].cc);
     while not eof(f) do begin
           readln(f,i,j);
           m[i,j]:=1;
           parinte[j]:=i; nrfii[i]:=nrfii[i]+1;
     end;
     close(f);
end;

procedure Push(lin,col:byte);
var q : pnod;
begin
     new(q); q^.lin:=lin; q^.col:=col; q^.urm:=nil;
     if p1=nil then begin
        p1:=q; p2:=q;
     end
     else begin
          p2^.urm:=q;
          p2:=q;
     end;
end;

procedure Pop(var lin,col:byte);
var q : pnod;
begin
     lin:=p1^.lin; col:=p1^.col;
     if p1=p2 then begin
        dispose(p1);
        p1:=nil; p2:=nil;
     end
     else begin
          q:=p1;
          p1:=p1^.urm;
          dispose(q);
     end;

end;

procedure GasesteVSac;
const dl : array[1..8] of shortint = (-1,-1,0,1,1,1,0,-1);
      dc : array[1..8] of shortint = (0,1,1,1,0,-1,-1,-1);
      inf = 60000;
var d : byte;
    nl,nc : integer;
    lin,col : byte;
    i,j : byte;
begin
     for i:=1 to l do
         for j:=1 to c do begin
             rmax[i,j]:=0;
             dmin[i,j]:=inf;
         end;
     rmax[l,c]:=a[l,c]; dmin[l,c]:=1; Push(l,c);
     while p1<>nil do begin
           Pop(lin,col);
           for d:=1 to 8 do begin
               nl:=lin+dl[d]; nc:=col+dc[d];
               if (1<=nl) and (nl<=l) and (1<=nc) and (nc<=c) then begin
                  if (dmin[lin,col]+1<dmin[nl,nc]) or
                        ((dmin[lin,col]+1=dmin[nl,nc]) and
                        (rmax[lin,col]+a[nl,nc]>rmax[nl,nc])) then begin
                           dmin[nl,nc]:=dmin[lin,col]+1;
                           rmax[nl,nc]:=rmax[lin,col]+a[nl,nc];
                           Push(nl,nc);
                        end;
               end;
           end;
     end;
     {***}
     for i:=1 to n do begin
         lin:=hoti[i].ll; col:=hoti[i].cc;
         vsac[i]:=rmax[lin,col];
     end;
end;

procedure Add(i,j:byte);
var q : pchoice;
begin
     new(q); q^.i:=i; q^.j:=j; q^.urm:=nil;
     if cap=nil then begin
        cap:=q; coa:=q;
     end
     else begin
          coa^.urm:=q;
          coa:=q;
     end;
end;

procedure FindChoice;
var nrf : vect;
    i,k : byte;
    noch : boolean;
begin
     repeat
           nrf:=nrfii;
           noch:=true;
           for i:=1 to n do
               if (nrfii[i]=0) and (go[i]=0) and (parinte[i]>0) then begin
                  Add(parinte[i],i);
                  nchoice:=nchoice+1;
                  go[i]:=1;
                  for k:=1 to n do
                      if m[k,i]=1 then begin
                         m[k,i]:=0;
                         nrf[k]:=nrf[k]-1;
                      end;
                  noch:=false;
               end;
           nrfii:=nrf;
     until noch;
end;

procedure WriteData;
var f : text;
    i : byte;
    suma : longint;
begin
     assign(f,'rubine.out'); rewrite(f);
     writeln(f,nchoice);
     while cap<>nil do begin
           writeln(f,cap^.i,' ',vsac[cap^.i],' ',cap^.j,' ',vsac[cap^.j]);
           cap:=cap^.urm;
     end;
     suma:=0;
     for i:=1 to n do
         if go[i]=0 then begin
            write(f,i,' ');
            suma:=suma+vsac[i];
         end;
     writeln(f);
     writeln(f,suma);
     close(f);
end;

begin
     ReadData;
     GasesteVSac;
     FindChoice;
     WriteData;
end.