{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65384,0,655360}
const dirx:array[1..5] of shortint=(0,1,1,1,-1);
      diry:array[1..5] of shortint=(1,0,-1,1,1);

var a:array[0..51,0..51] of integer;
    x,y:array[1..50] of byte;
    lx,ly:array[1..2500] of byte;
    rubine:array[1..50] of integer;
    rf:array[1..2500,1..2] of byte;
    mut:array[1..2500] of integer;
    duc:array[1..50] of integer;
    ducsol,rfsol:integer;
    cules:array[1..2500] of integer;
    trecut,cm:array[0..51,0..51] of integer;
    rel:array[0..50,0..50] of byte;
    start,fin,i,j,k,l,m,h,n,sol:integer;
    f,g:text;

procedure citire;
begin
  assign(f,'rubine.in');
  assign(g,'rubine.out');
  reset(f);
  read(f,n,m);
  for i:=1 to n do
      for j:=1 to m do
          read(f,a[i,j]);
  read(f,h);
  for i:=1 to h do
      read(f,x[i],y[i]);
  while not eof(f) do
    begin
      read(f,i,j);
      rel[i,j]:=1;
    end;
  close(f);
  for i:=0 to n+1 do
      begin
        a[i,0]:=-1;
        a[i,m+1]:=-1;
      end;
  for i:=0 to m+1 do
      begin
        a[0,i]:=-1;
        a[n+1,i]:=-1;
      end;
end;

function merge(j,start:integer):boolean;
begin
  merge:=false;
  if a[lx[start]+dirx[j],ly[start]+diry[j]]<0 then
     exit;
  if (trecut[lx[start]+dirx[j],ly[start]+diry[j]]<mut[start]+1)
     and (trecut[lx[start]+dirx[j],ly[start]+diry[j]]>0) then
     exit;
  if (trecut[lx[start]+dirx[j],ly[start]+diry[j]]=mut[start]+1) and
     (cm[lx[start]+dirx[j],ly[start]+diry[j]]>cules[start]+a[lx[start]+dirx[j],ly[start]+diry[j]]) then
     exit;
  merge:=true;
end;

procedure calcrubine;
begin
  for i:=1 to h do
      begin
        fillchar(trecut,2500,0);
        fillchar(lx,2500,0);
        fillchar(ly,2500,0);
        fillchar(cules,2500,0);
        sol:=maxint;
        lx[1]:=x[i];
        cules[1]:=a[x[i],y[i]];
        ly[1]:=y[i];
        start:=1;
        fin:=1;
        while start<=fin do
          begin
            if (lx[start]=n) and (ly[start]=m) then
               begin
                 if mut[start]=sol then
                    if (rubine[i]<cules[start]) then
                       rubine[i]:=cules[start];
                 if mut[start]<sol then
                    begin
                      rubine[i]:=cules[start];
                      sol:=mut[start];
                    end;
               end
            else
            for j:=1 to 5 do
                if merge(j,start) then
                   begin
                     fin:=fin+1;
                     lx[fin]:=lx[start]+dirx[j];
                     ly[fin]:=ly[start]+diry[j];
                     trecut[lx[start]+dirx[j],ly[start]+diry[j]]:=mut[start]+1;
                     cules[fin]:=cules[start];
                     if a[lx[start]+dirx[j],ly[start]+diry[j]]>0 then
                        cules[fin]:=cules[fin]+a[lx[start]+dirx[j],ly[start]+diry[j]];
                     cm[lx[fin],ly[fin]]:=cules[fin];
                     mut[fin]:=mut[start]+1;
                   end;
            start:=start+1;
          end;
      end;
end;

procedure iesiri;
var count,hh:integer;
begin
  ducsol:=0;
  rfsol:=0;
  hh:=h;
  repeat
    for i:=1 to h do
        begin
          count:=0;
          for j:=1 to h do
              begin
                if (rel[i,j]=1) or (rel[i,j]=2) then
                   begin
                     count:=count+1;
                     break;
                   end;
              end;
          if count=0 then
             begin
               for j:=1 to h do
                   if rel[j,i]=1 then
                      begin
                        count:=count+1;
                        break;
                      end;
               if count=0 then
                  begin
                    ducsol:=ducsol+1;
                    duc[ducsol]:=i;
                    hh:=hh-1;
                  end
                  else
                  begin
                    hh:=hh-1;
                    rfsol:=rfsol+1;
                    rf[rfsol,1]:=j;
                    rf[rfsol,2]:=i;
                    for j:=1 to h do
                        if rel[j,i]=1 then
                           rel[j,i]:=0;
                    for j:=1 to h do
                        rel[i,j]:=2;
                    break;
                  end;
             end;
        end;

  until hh=0;
end;

procedure rezolvare;
begin
  calcrubine;
  iesiri;
end;

procedure afisare;
var s:longint;
begin
  rewrite(g);
  s:=0;
  writeln(g,rfsol);
  for i:=1 to rfsol do
      writeln(g,rf[i,1],' ',rubine[rf[i,1]],' ',rf[i,2],' ',rubine[rf[i,2]]);
  for i:=1 to ducsol do
      begin
        write(g,duc[i]);
        s:=s+rubine[duc[i]];
      end;
  writeln(g);
  writeln(g,s);
  close(g);
end;

begin
  citire;
  rezolvare;
  afisare;
end.