#include <stdio.h>

int n;
int scufita[10][10];
int lup[10][10];
int limita[16];
int xf, yf;
int ciuperci;
int xInc[4] = {1, 0, -1, 0};
int yInc[4] = {0, 1, 0, -1};
char dir[4] = "SENV";
char drum[10][10];
char directii[15];

void citire() {
	FILE *intrare;
	int i, j;

	intrare = fopen("scufita.in", "r");

	fscanf(intrare, "%d", &n);

	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++)
			fscanf(intrare, "%d", &scufita[i][j]);
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++)
			fscanf(intrare, "%d", &lup[i][j]);

	fclose(intrare);
  }

int sePoateMuta2(int x, int y) {
	return(x >= 0 && x < n && y >= 0 && y < n);
  }

void gasesteLimite() {
	int x, y, i, j, max;
	int x2, y2, xn, yn;

	for (limita[0] = lup[0][0], i = 1, x = 0, y = 0; i <= 15; i++) {
		for (max = 0, j = 0; j < 4; j++) {
			x2 = x+xInc[j];
			y2 = y+yInc[j];
			if (sePoateMuta2(x2, y2) && max < lup[x2][y2]) {
				xn = x2;
				yn = y2;
				max = lup[x2][y2];
			  }
		  }
		x = xn;
		y = yn;

		limita[i]  = limita[i-1] + lup[x][y];
		lup[x][y] = -1;
	  }
  }

int sePoateMuta(int x, int y) {
	return (sePoateMuta2(x, y) && scufita[x][y] != 0);
  }

void Lee() {
	int i, j;
	int curent[100][3], curent2[100][3];
	int len = 1, len2;
	int t = 1;
	int x, y, x2, y2;

	curent[0][0] = 0;
	curent[0][1] = 0;
	curent[0][2] = scufita[0][0];

	while(t <= 15) {
		for (len2 = 0, i = 0; i < len; i++) {
			x = curent[i][0];
			y = curent[i][1];
			scufita[x][y] = 0;

			for (j = 0; j < 4; j++) {
				x2 = x+xInc[j];
				y2 = y+yInc[j];
				if (sePoateMuta(x2, y2) && curent[i][2]+scufita[x2][y2] > limita[t]) {
					curent2[len2][0] = x2;
					curent2[len2][1] = y2;
					curent2[len2][2] = curent[i][2] + scufita[x2][y2];
					drum[x2][y2] = dir[j];
					len2++;
				  }
			  }
		  }

		for (i = 0; i < len2; i++) {
			curent[i][0] = curent2[i][0];
			curent[i][1] = curent2[i][1];
			curent[i][2] = curent2[i][2];
		  }

		len = len2;
		t++;
	  }

	for (ciuperci = 0, i = 0; i < len; i++)
		if (curent[i][2] > ciuperci) {
			ciuperci = curent[i][2];
			xf = curent[i][0];
			yf = curent[i][1];
		  }
  }

void gasesteDrum() {
	int x = xf, y = yf;
	int i;

	for (i = 14; i >= 0; i--) {
		directii[i] = drum[x][y];
		switch(drum[x][y]) {
			case 'S': x--;break;
			case 'E': y--;break;
			case 'N': x++;break;
			case 'V': y++;break;
		  }
	  }
  }

void afisare() {
	FILE *iesire;

	iesire = fopen("scufita.out", "w");
	fprintf(iesire, "%d\n", ciuperci);
	fprintf(iesire, "%s\n", directii);

	fclose(iesire);
  }

void main(void) {
	citire();

	gasesteLimite();
	Lee();
	gasesteDrum();
	afisare();
  }