{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65012,0,655360}
const dim=5000;
type tip=array[1..dim] of double;
     pt=record x,y:double;end;
     tip2=array[1..dim] of ^pt;
type punct=record
                 x,y:double;
           end;
     pozpseg=(stanga,dreapta,fata,spate,intre,orig,dest);
     pozppol=(interior,exterior,frontiera);
     intersectie=(secant,paralel,coliniar);
var poz,i,j,n:integer;
    m,x1,x2,y1,y2:^tip;
    f:text;
    max:double;
    o:array[1..dim] of integer;
    p:tip2;
    t:double;
    transx,transy:double;

const eps:double=0.0001;


procedure Sort(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := l;
  repeat
    while p[o[i]]^.y*p[o[x]]^.x<p[o[i]]^.x*p[o[x]]^.y do i := i + 1;
    while p[o[j]]^.y*p[o[x]]^.x>p[o[j]]^.x*p[o[x]]^.y do j := j - 1;
    if i <= j then
    begin
      y:=o[i];o[i]:=o[j];o[j]:=y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;


var x:double;

procedure Sortm(l, r: Integer);
var
  i, j, y: integer;
begin
  i := l; j := r; x := m^[o[l]];
  repeat
    while m^[o[i]] < x do i := i + 1;
    while x < m^[o[j]] do j := j - 1;
    if i <= j then
    begin
      y := o[i]; o[i] := o[j]; o[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sortm(l, j);
  if i < r then Sortm(i, r);
end;


{consideram segmentul orientat p1 -> p2 si punctul p}
function clasif_p_seg(p,p1,p2:punct):pozpseg;
var a,b:punct;
    s:double;
begin
a.x:=p2.x-p1.x;
a.y:=p2.y-p1.y;
b.x:=p.x-p1.x;
b.y:=p.y-p1.y;

s:=a.x*b.y-b.x*a.y;
if (s<0) then begin clasif_p_seg:=stanga;exit;end;
if (s>0) then begin clasif_p_seg:=dreapta;exit;end;
if (a.x*b.x<0) or (a.y*b.y<0) then begin clasif_p_seg:=spate;exit;end;
if (a.x*a.x+a.y*a.y<b.x*b.x+b.y*b.y) then begin clasif_p_seg:=fata;exit;end;
if ((p1.x-p.x)<eps) and ((p1.y-p.y)<eps) then begin clasif_p_seg:=orig;exit;end;
if ((p2.x-p.x)<eps) and ((p2.y-p.y)<eps) then begin clasif_p_seg:=dest;exit;end;
clasif_p_seg:=intre;
end;


{intersectia a doua drepte
dreapta 1 este m1 (definita de a si b), evident cine e a doua
t e parametru din a+t(b-a)
}
function dr_inters(m1a,m1b,m2c,m2d:punct;var t:double):intersectie;
var normal,da,db:punct;
    numarator, numitor:double;
    clasa_m1:pozpseg;
begin
normal.x:=m2d.y-m2c.y;
normal.y:=m2c.x-m2d.x;
da.x:=m1a.x-m1b.x;
da.y:=m1a.y-m1b.y;
numitor:=normal.x*da.x+normal.y*da.y;{produs scalar - normal,da}
if numitor=0 then begin
   clasa_m1:=clasif_p_seg(m1a,m2c,m2d);
   if (clasa_m1=stanga) or (clasa_m1=dreapta) then dr_inters:=paralel else dr_inters:=coliniar;
   exit;
end;
db.x:=m1a.x-m2c.x;
db.y:=m1a.y-m2c.y;
numarator:=normal.x*db.x+normal.y*db.y;
t:=numarator/numitor;
dr_inters:=secant;
end;


var p1,p2,p3,p4:punct;

procedure rezolva;
var st:array[1..dim+1] of integer;
    k,i1:integer;
    s:double;
begin
transx:=p[1]^.x;
transy:=p[1]^.y;
poz:=1;
for i:=1 to n do begin
                 if transy=p[i]^.y then if transx>p[i]^.x then begin
                                 transx:=p[i]^.x;
                                 transy:=p[i]^.y;
                                 poz:=i;
                                 end;
                 if transy>p[i]^.y then begin
                                 transx:=p[i]^.x;
                                 transy:=p[i]^.y;
                                 poz:=i;
                                 end;
                 end;
for i:=1 to n do begin
                 p[i]^.x:=p[i]^.x-transx;
                 p[i]^.y:=p[i]^.y-transy;
                 end;
for i:=1 to n do o[i]:=i;
o[poz]:=1;
o[1]:=poz;
sort(2,n);
st[1]:=o[1];
st[2]:=o[2];
k:=2;
for i1:=3 to n do begin
              k:=k+1;
              st[k]:=o[i1];
while (k<>2) and ((p[st[k-2]]^.x-p[st[k-1]]^.x)*(p[st[k-1]]^.y-p[st[k]]^.y)-
      (p[st[k-1]]^.x-p[st[k]]^.x)*(p[st[k-2]]^.y-p[st[k-1]]^.y)<=eps)
      do
       begin
       st[k-1]:=st[k];
       k:=k-1;
       end;
end;

st[k+1]:=st[1];
s:=0;
for i:=1 to k do
begin
     s:=s+p[st[i]]^.x*p[st[i+1]]^.y-p[st[i+1]]^.x*p[st[i]]^.y;
end;

s:=s/2;

assign(f,'inter.out');rewrite(f);
writeln(f,s:0:2);
close(f);

end;


begin
new(x1);new(x2);new(y1);new(y2);
new(m);
for i:=1 to dim do new(p[i]);
assign(f,'inter.in');reset(f);
read(f,n);
for i:=1 to n do begin
    read(f,x1^[i],y1^[i],x2^[i],y2^[i]);
end;
close(f);
max:=0;
for i:=1 to n do begin
if (x2^[i]-x1^[i]<>0) then begin
   m^[i]:=(y2^[i]-y1^[i])/(x2^[i]-x1^[i]);
end else m^[i]:=0;
if max<m^[i] then max:=m^[i];
end;
for i:=1 to n do begin
if (x2^[i]-x1^[i]=0) then m^[i]:=max+1;
end;

for i:=1 to n do o[i]:=i;
Sortm(1,n);

for i:=1 to n-1 do if m^[o[i]]=m^[o[i+1]] then begin
writeln('Pante egale!!!');
exit;
end;

for i:=1 to n-1 do begin
    p1.x:=x1^[o[i]];
    p1.y:=y1^[o[i]];
    p2.x:=x2^[o[i]];
    p2.y:=y2^[o[i]];
    p3.x:=x1^[o[i+1]];
    p3.y:=y1^[o[i+1]];
    p4.x:=x2^[o[i+1]];
    p4.y:=y2^[o[i+1]];
    dr_inters(p1,p2,p3,p4,t);
    p[i]^.x:=p1.x+t*(p2.x-p1.x);
    p[i]^.y:=p1.y+t*(p2.y-p1.y);
end;

    p1.x:=x1^[o[1]];
    p1.y:=y1^[o[1]];
    p2.x:=x2^[o[1]];
    p2.y:=y2^[o[1]];
    p3.x:=x1^[o[n]];
    p3.y:=y1^[o[n]];
    p4.x:=x2^[o[n]];
    p4.y:=y2^[o[n]];
    dr_inters(p1,p2,p3,p4,t);
    p[n]^.x:=p1.x+t*(p2.x-p1.x);
    p[n]^.y:=p1.y+t*(p2.y-p1.y);


    rezolva;

end.