{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }
{
  Time Complexity : O(P*logN)
  Memory          : O(1)
}

{$N+}
Program _proc_OK;

const filein='proc.in';
      fileout='proc.out';

var i,n,p,unu,doi,li,ls,mid,sol,sum,n1,n2:longint;

function ok(t:longint):boolean;
var i,s:longint;
    n1,n2:extended;
begin
n1:=0; n2:=0;
for i:=1 to p do
  begin
    s:=t div i;
    n2:=n2+(s div 2);
    n1:=n1+(s mod 2);
  end;

ok:=((n2>=doi) and ((n1+2.0*(n2-doi))>=unu));
end;

begin
{ Read input data }
assign(input,filein);
reset(input);
read(n,unu,p);
doi:=n-unu;
close(input);

{ Search the minimum completion time binary }
li:=0; ls:=2*n;
sol:=ls;

while (li<=ls) do
  begin
    mid:=(li+ls) shr 1;

    if (ok(mid)) then
      begin
        sol:=mid;
        ls:=mid-1;
      end
    else
      li:=mid+1;
  end;

{ Write output data }
assign(output,fileout);
rewrite(output);
writeln(sol);
close(output);
end.