#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int n;
char *v;
char *res;
int rep[10];
char mid;
int midpos;
FILE *file;

void Init(void);
void Free(void);
void Solve(void);

int _valin(void);
void _movechar(int src, int dest);
int _getsamepos(void);

int main(void)
{
 Init();
 Solve();
 Free();
 return 0;
}

void Init(void)
{
 int i;
 file=fopen("nr.in","r");
 fscanf(file,"%d\n",&n);
 v=malloc(sizeof(char)*n);
 res=malloc(sizeof(char)*n);
 for (i=0;i<n;i++)
  fscanf(file,"%c",v+i);
 memcpy(res,v,n);
 fclose(file);
 file=fopen("nr.out","w");
}

void Free(void)
{
 fclose(file);
 free(v);
 free(res);
}

void Solve(void)
{
 int i,j,k;
 if ((_valin()==0)||(n<3))
 {
  fprintf(file,"0\n");
  return;
 }
 if (n%2==1)
 {
  _movechar(midpos,n/2);
  rep[mid-'0']--;
 }
 k=_getsamepos();

 for (i=0;i<k;i++)
 {
  res[i]=res[n-i-1]=v[i];
  rep[v[i]-'0']-=2;
 }

 j=1;
 i=v[k]-'0';
 while (((rep[j]==0)||((rep[j]!=0)&&(j<=i)))&&(j<10))
  j++;
 if (j>9)
 {
  fprintf(file,"0\n");
  return;
 }
 res[k]=res[n-k-1]=j+'0';
 rep[j]-=2;

 for (i=k+1;i<n/2;i++)
 {
  j=0;
  while ((rep[j]==0)&&(j<10))
   j++;
  if (j>9)
  {
   fprintf(file,"0\n");
   return;
  }
  res[i]=res[n-i-1]=j+'0';
  rep[j]-=2;
 }

 for (i=0;i<n;i++)
  fprintf(file,"%c",res[i]);
 fprintf(file,"\n");
}

int _valin(void)
{
 int i,j;
 for (i=0;i<n;i++)
  rep[v[i]-'0']++;
 j=0;
 for (i=0;i<10;i++)
  if (rep[i]%2==1)
  {
   j++;
   if (j>1)
    return 0;
   mid=i+'0';
  }
 if ((j==1)&&(n%2==0))
  return 0;
 if ((j==0)&&(n%2==1))
  return 0;
 for (i=0;i<n;i++)
  if (v[i]==mid)
  {
   midpos=i;
   break;
  }
 return 1;
}

void _movechar(int src, int dest)
{
 char ch=res[src];
 res[src]=res[dest];
 res[dest]=ch;
}

int _getsamepos(void)
{
 int _rep[10];
 int i,j,k;
 memcpy(_rep,rep,sizeof(int)*10);
 i=0;
 while (i<n/2)
 {
  j=v[i]-'0';
  _rep[j]-=2;
  if (_rep[j]<0)
   return i;
  i++;
 }
 for (k=i-1;k>=0;k--)
 {
  for (j=v[k]-'0'+1;j<10;j++)
   if (_rep[j]>0)
    return k;
  _rep[v[k]-'0']+=2;
 }
 return 0;
}