#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#define fn "inter.in"
#define fo "inter.out"
#define MAX 5002

float l[MAX][4];
int eval[MAX];
int used[MAX];
int n;
const float ERR=0.0001;

float poly[MAX][3];	//x,y,i
int polyp=0;

int jx, jy;

int comp(const void *a, const void *b)
{
float e1x=((float*)a)[0] - jx;
float e1y=jy-((float*)a)[1];

float e2x=((float*)b)[0] - jx;
float e2y=jy-((float*)b)[1];

float h1=sqrt(e1x*e1x + e1y*e1y);
float h2=sqrt(e2x*e2x + e2y*e2y);


return (e1y/h1 > e2y/h2 ) ? 1:-1;
}

int equal(float a, float b)
{
return (fabs(a-b) < ERR);
}

void inters(float x1, float y1, float x2, float y2, float x1p, float y1p, float x2p, float y2p, float &rx, float &ry)
{
if (equal(y2,y1))
    {
    ry = y2;
    if (equal(y2p, y1p))
	{
	if (!equal(y2p, y2))
	    {
	    rx=20000000;
	    ry=20000000;
	    return;
	    }
	rx=2000000;
	ry=2000000;
	return;
	}
    else
    rx = (ry - y1p)*(x2p-x1p)/(y2p-y1p) + x1p;
    return;
    }
if (equal(x2,x1))
    {
    rx=x2;
    if (equal(x2p, x1p))
	{
	if (!equal(x2p, x2))
	    {
	    rx=20000000;
	    ry=20000000;
	    return;
	    }
	rx=ry=20000000; 
	return;
	}
	else
        ry = (rx - x1p)*(y2p-y1p)/(x2p-x1p) + y1p;
    return;    
    }


if (equal(y2p,y1p))
    {
    ry = y2p;
    if (equal(y2, y1))
	{
	if (!equal(y2p, y2))
	    {
	    rx=20000000;
	    ry=20000000;
	    return;
	    }
	rx=2000000;
	ry=2000000;
	return;
	}
    else
    rx = (ry - y1)*(x2-x1)/(y2-y1) + x1;
    return;
    }
if (equal(x2p,x1p))
    {
    rx=x2p;
    if (equal(x2, x1))
	{
	if (!equal(x2p, x2))
	    {
	    rx=20000000;
	    ry=20000000;
	    return;
	    }
	rx=ry=20000000; 
	return;
	}
	else
        ry = (rx - x1)*(y2-y1)/(x2-x1) + y1;
    return;    
    }

ry= ( y1*(x2-x1)/(y2-y1) - y1p*(x2p-x1p)/(y2p-y1p) + x1p - x1) / ( (x2-x1)/(y2-y1) - (x2p-x1p)/(y2p-y1p) );
rx= ( x1*(y2-y1)/(x2-x1) - x1p*(y2p-y1p)/(x2p-x1p) + y1p - y1) / ( (y2-y1)/(x2-x1) - (y2p-y1p)/(x2p-x1p) );
return;
//rx = (ry - y1)*(x2-x1)/(y2-y1) + x1;
}

int check(float x, float y, float x1, float y1, float x2, float y2)
{
float t;
if (x1 > x2)
    {
    t=x1;
    x1=x2;
    x2=t;
    }
if (y1 > y2)
    {
    t=y1;
    y1=y2;
    y2=t;
    }

if ( (x > x1) && (x< x2) && (y>y1) && (y<y2) )
    return 1;
return 0;

}

int in()
{
FILE *in;
in=fopen(fn ,"r");
if (in==NULL)
    return 1;

fscanf(in, "%d\n", &n);

for (int i=0;i<n;i++)
    {
    fscanf(in, "%f %f %f %f\n", &l[i][0], &l[i][1], &l[i][2], &l[i][3]);
    }

fclose(in);
return 0;
}

int out()
{
FILE *out;
out=fopen(fo, "w+");
if (out==NULL)
    return 1;

fclose(out);
return 0;
}

void getminmax(int cline, float &maxx, float &maxy, float &minx, float &miny, int &maxi, int &mini)
{
float tx, ty;
maxx=maxy=-20000000;
minx=miny=200000000;
for (int i=0;i<n;i++)
    {
    if (i!=cline)
	{
	inters(l[cline][0], l[cline][1], l[cline][2], l[cline][3], l[i][0],l[i][1], l[i][2], l[i][3], tx,ty);	
//	if (check(tx, ty, l[cline][0], l[cline][1], l[cline][2], l[cline][3]))
//	    && (check(tx, ty, l[i][0], l[i][1], l[i][2], l[i][3]))	//diont need to ca asiura ca oricare 2 se intersecteaza
	
	if (ty < miny)
	    {
	    miny=ty;
	    minx=tx;
	    mini=i;
	    }
	    else if (equal(maxy,miny))
		{
		if (tx < minx)
		    {
        	    miny=ty;
    		    minx=tx;
    		    mini=i;
		    }
		if (tx > maxx)
		    {
        	    maxy=ty;
    		    maxx=tx;
    		    maxi=i;
		    }
		    
		}
		
	if (ty > maxy)
	    {
	    maxy=ty;
	    maxx=tx;
	    maxi=i;
	    }
	    else if (equal(miny,maxy))
		{
		if (tx < minx)
		    {
        	    miny=ty;
    		    minx=tx;
    		    mini=i;
		    }
		if (tx > maxx)
		    {
        	    maxy=ty;
    		    maxx=tx;
    		    maxi=i;
		    }
		    
		}

	}
    }

}

void sfmax(float,float,int,int);

void sfmin(float minx, float miny, int mini, int i)
{

if (eval[mini])	return;	//will never happend, da fie...

float tminx, tmaxx, tminy,tmaxy;
int tmini, tmaxi;
getminmax(mini, tmaxx, tmaxy, tminx, tminy, tmaxi, tmini);
eval[mini]=1;
if (tmini==i)
    {
    poly[polyp][0]=minx;
    poly[polyp][1]=miny;
    polyp++;
    }
if (!eval[tmaxi])
    sfmax(tmaxx, tmaxy, tmaxi, mini);
}

void sfmax(float maxx, float maxy, int maxi, int i)
{
if (eval[maxi]) return;
float tminx, tmaxx, tminy,tmaxy;
int tmini, tmaxi;
getminmax(maxi, tmaxx, tmaxy, tminx, tminy, tmaxi, tmini);
eval[maxi]=1;
if (tmaxi==i)
    {
    poly[polyp][0]=maxx;
    poly[polyp][1]=maxy;
    polyp++;
    }
    
if (!eval[tmini])
    sfmin(tminx, tminy, tmini, maxi);
}

float dist(float x1, float y1, float x2, float y2)
{
return sqrt( (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) );

}

void process()
{
int cline=0;
float maxx,maxy,minx,miny;
float tx,ty;
int mini, maxi;
getminmax(0, maxx,maxy,minx,miny,maxi,mini);
//eval[0]=1;

sfmax(maxx,maxy, maxi, 0);
eval[mini]=0;
sfmin(minx,miny,mini,0);

int ti=0;
for (int i=0;i<polyp;i++)
    {
    if (jy < poly[i][1])
	{
	jy=poly[i][1];
	jx=poly[i][0];
	ti=i;
	}
    
    }
poly[ti][0]=poly[polyp-1][0];
poly[ti][1]=poly[polyp-1][1];
polyp--;

qsort(poly, polyp, sizeof(poly[0]), comp);

float sum=0;
sum=dist(jx,jy, poly[0][0], poly[0][1]);
sum+=dist(jx,jy, poly[polyp-1][0], poly[polyp-1][1]);

for (int i=1;i<polyp;i++)
    {
    sum+=dist(poly[i][0], poly[i][1], poly[i-1][0], poly[i-1][1]);
    }
FILE *out;
out=fopen(fo, "w+");
fprintf(out, "%f\n", sum);
fclose(out);
}

int main()
{
long tt=(long)clock();
//*
if (in())
    {
    printf("Couldn't open file %s!\n",fn);
    return 1;
    }
//*/    
//printf("42 is the answer to life.\n");
//process();

long tt2=(long)clock();

float x1=3, y1=-1, x2=3,y2=5;
float x1p=1, y1p=3, x2p=4, y2p=0;
float rx,ry;

//inters(x1,y1,x2,y2,x1p,y1p,x2p,y2p, rx,ry);

//printf("%f %f\n", rx,ry);
process();
printf("%f sec\n", (tt2-tt + 0.0) / CLOCKS_PER_SEC);

return 0;
}
