#include <stdio.h>
#include <stdlib.h>

#define	MAXN			1000
#define	MAXC			10

int n;
char nr1[MAXN+2], nr2[MAXN+2], fc[MAXC];

void nosol( )
{
	freopen( "nr.out", "w", stdout );
	printf( "0" );
	fclose( stdout );
	exit( 0 );
}

int nr2_cmp_fn( const void *pa, const void *pb )
{
	char *a = (char*)pa, *b = (char*)pb;

	return a[0]-b[0];
}

int main( )
{
	int i, j, k, eg;

	freopen( "nr.in", "r", stdin );
	scanf( "%d%s", &n, nr1 );
	fclose( stdin );

	for( i = 0 ; i < n ; i++ )
		fc[nr1[i]-'0']++;
	for( i = j = 0 ; i < MAXC ; i++ )
		j += (fc[i]&1);

	if( j > (n&1) )
		nosol( );

	if( (n&1) )
	{
		for( i = 0 ; i < MAXC && !(fc[i]&1) ; i++ );
		if( i == MAXC )
			nosol( );

		nr2[n/2] = i+'0';
		fc[i]--;
	}

	eg = 1;
	for( i = 0 ; i < n/2 ; i++ )
	{
		for( j = eg*(nr1[i]-'0') ; j < MAXC && !fc[j] ; j++ );
		if( j == MAXC )
			nosol( );
		nr2[i] = nr2[n-i-1] = j+'0';
		fc[j] -= 2;
		eg &= (j==(nr1[i]-'0'));
	}

	for( i = 0 ; i < n && nr1[i] == nr2[i] ; i++ );
	if( i == n || nr1[i] > nr2[i] )
	{
		for( i = (n/2)-1 ; i > 0 && nr2[i] <= nr2[i-1] ; i-- );
		if( i == 0 )
			nosol( );
		k = -1;
		for( j = i ; j < n/2 ; j++ )
			if( nr2[j] > nr1[i-1] && ( k == -1 || nr2[j] < nr2[k] ) )
				k = j;
		if( k == -1 )
			nosol( );
		j = nr2[i-1];
		nr2[i-1] = nr2[k];
		nr2[k] =  j;
		qsort( nr2+i, (n/2)-i, sizeof( nr2[i] ), nr2_cmp_fn );
		for( i = 0 ; i < n/2 ; i++ )
			nr2[n-i-1] = nr2[i];
	}

	freopen( "nr.out", "w", stdout );
	printf( "%s", nr2 );
	fclose( stdout );
	return 0;
}
