#include<stdio.h>
#include<values.h>
#include<alloc.h>
#define min(x,y) (((x)<(y))?(x):(y))
#define st(x) (2*(x))
#define dr(x) (2*(x)+1)

long n,k,p;

long *a;
long *h1,*h2;

inline void schimba(long &x,long &y)
{
	x += y;
	y = x - y;
	x = x - y;
}


void reconstituieHeap(long *h,long i,int d)
{
long imin;
	if(st(i)<=p&&a[h[i]]+h[i]*d>a[h[st(i)]]+h[st(i)]*d) imin = st(i);
	else imin = i;
	if(dr(i)<=p&&a[h[imin]]+h[imin]*d>a[h[dr(i)]]+h[dr(i)]*d) imin = dr(i);
	if(imin!=i)
	{
		schimba(h[i],h[imin]);
		reconstituieHeap(h,imin,d);
	}
}

void construiesteHeap(long *&h,int d)
{
	h = (long*) malloc((p+1) * sizeof(long));
	for(int i=1;i<=p;i++)
		h[i] = i;
	for(i=1;i<n/2;i++)
		reconstituieHeap(h,i,d);
}

long getTMax()
{
long tmax = 0;
	for(int i=1;i<=p;i++)
		if(a[i]>tmax) tmax = a[i];
	return tmax;
}

inline long getHMin(long *h)
{
	return h[1];
}

void citeste()
{
FILE *f1;
	f1 = fopen("proc.in","r");
	fscanf(f1,"%ld %ld %ld",&n,&k,&p);
	a = (long*) malloc((p+1) * sizeof(long));
	fclose(f1);
}

void completeazaRamas()
{
long nrP;
	for(int i=0;i<n-k;i++)
	{
		nrP = getHMin(h2);
		a[nrP] += nrP * 2;
		reconstituieHeap(h2,1,2);
		reconstituieHeap(h1,1,1);
	}
	for(i=0;i<k;i++)
	{
		nrP = getHMin(h1);
		a[nrP] += nrP;
		reconstituieHeap(h1,1,1);
		reconstituieHeap(h2,1,2);
	}
}

double calculeazaPutere()
{
double putere = 0;
	for(int i=1;i<=p;i++)
	{
		putere += 1/(double)i;
	}
return putere;
}

void completeazaSigur()
{
long tm = ((double)(2*(n-k)+k))/calculeazaPutere();
long Msmb,msmb;
	for(int i=p;i>0;i--)
	{
		Msmb = min(tm/(2*i),(n-k));
		n -= Msmb;
		a[i] = Msmb * 2 * i;
		if(!Msmb)
		{
			msmb = min((tm-a[i])/i,k);
			n -= msmb;
			k -= msmb;
			a[i] += msmb * i;
		}
	}
}


void proceseaza()
{
completeazaSigur();
construiesteHeap(h1,1);
construiesteHeap(h2,2);
completeazaRamas();
}

void afiseaza()
{
FILE *f2;
	f2 = fopen("proc.out","w");
	fprintf(f2,"%ld",getTMax());
	fclose(f2);
}

void main()
{
	citeste();
	proceseaza();
	afiseaza();
}