#include <stdio.h>

struct _numar {
    char dig[1024];
    int n, count[10], posibil;
};

typedef struct _numar NUMAR, *PNUMAR;

NUMAR x;

void init(void)
{
    int i; FILE *pf;
    pf=fopen("nr.in", "rt");
    fscanf(pf, "%d %s", &x.n, &x.dig);
    for(i=0;i<x.n;i++) {
	x.dig[i]=x.dig[i]-'0';
	x.count[x.dig[i]]++;
    }
    fclose(pf);
}

NUMAR sol;
int have_sol;

/* cel mai mic palindrom mai mare sau egal cu x, resp mai mare ca x */

NUMAR c, d, nc, nd;

void write_sol(void)
{
    FILE *pf;
    pf=fopen("nr.out", "wt");
    if(have_sol==0)
	fprintf(pf, "0\n");
    else {
	int i;
	for(i=0;i<x.n;i++)
	    fprintf(pf, "%d", (int)sol.dig[i]);
	fprintf(pf, "\n");
    }
    fclose(pf);
}

/* compara primele si ultimele cifre ale lui c cu x */
int compara(NUMAR c, NUMAR x, int tip)
{
    int i;
    for(i=0;i<c.n;i++)
	if(x.dig[i]!=c.dig[i])
	    return c.dig[i]-x.dig[i];
    if(tip==0)
	return 0;
    for(i=c.n-1;i>=0;i--)
	if(x.dig[x.n-i-1]!=c.dig[i])
	    return c.dig[i]-x.dig[x.n-i-1];
    return 0;
}

void solve(void)
{
    int i, sw, dig, rv, mijloc, j;
    NUMAR z;
    for(i=0, sw=0;i<10;i++)
	if(x.count[i]%2)
	    sw++;
    if(sw>1) 
	return;
    for(i=1, sw=0;i<10;i++)
	if(x.count[i]>=2)
	    sw=1;
    if(sw==0)
	return;
    c=d=x; c.n=d.n=0;
    c.posibil=1; d.posibil=0;
    for(i=0;i<(x.n/2)+(x.n%2);i++) {
	nc.posibil=0; nd.posibil=0;
	if((x.n%2)&&(i==((x.n/2)+(x.n%2)-1)))
	    mijloc=1;
	else
	    mijloc=0;
	if(c.posibil) {
	    for(dig=(i ? 0 : 1);dig<=9;dig++) {
	        z=c; z.n++;
		z.dig[z.n-1]=dig;
		if(z.count[dig]==0)
		    continue;
		if((z.count[dig]==1)&&(mijloc==0))
		    continue;
		z.count[dig]-=2-mijloc;
		rv=compara(z, x, 0);
		if(rv<0)
		    continue;
		if((rv>=0)&&(nc.posibil==0))
			nc=z;
		if((rv>0)&&(nd.posibil==0))
			nd=z;
	    }
	}
	if(d.posibil) {
	    for(dig=(i ? 0 : 1);dig<=9;dig++) {
	        z=d; z.n++;
		z.dig[z.n-1]=dig;
		if(z.count[dig]==0)
		    continue;
		if((z.count[dig]==1)&&(mijloc==0))
		    continue;
		z.count[dig]-=2-mijloc;
		rv=compara(z, x, 0);
		if(rv<0)
		    continue;
		if((rv>=0)&&(nc.posibil==0))
			nc=z;
		if((rv>0)&&(nd.posibil==0))
			nd=z;
	    }
	}
	c=nc; d=nd;
    }
    if(d.posibil==0)
	return;
    else {
	have_sol=1;
	if(compara(c, x, 1)>0)
	    sol=c;
	else
	    sol=d;
	for(i=0;;i++) {
	    j=x.n-1-i;
	    if(j<i)
		break;
	    sol.dig[j]=sol.dig[i];
	}
    }    
}

int main(void)
{
    init();
    solve();
    write_sol();
    return 0;
}
