#include <stdio.h>

#define MAXP 65537

unsigned long N, K, P;

unsigned long liber[MAXP];

/* alocare task-uri pe procesoare, intai task-uri de 2 apoi de 1 */
int posibil(unsigned long timp)
{
    unsigned long task[2], i, nr;
    task[0]=K; task[1]=N-K;
    for(i=1;i<=P;i++)
	liber[i]=timp;
    for(i=1;i<=P;i++) {
	nr=liber[i]/(i*2);
	if(nr>task[1])
	    nr=task[1];
	task[1]-=nr;
	liber[i]-=2*nr*i;
    }
    for(i=1;i<=P;i++) {
	nr=liber[i]/i;
	if(nr>task[0])
	    nr=task[0];
	task[0]-=nr;
	liber[i]-=nr*i;
    }
    if((task[0]==0)&&(task[1]==0))
	return 1;
    return 0;
}

int main(void)
{
    unsigned long l, r, m;
    FILE *pf;
    pf=fopen("proc.in", "rt");
    fscanf(pf, "%lu %lu %lu", &N, &K, &P);
    fclose(pf);
    l=0;r=2*N-K+2;
    for(;l<r;) {
	m=(l+r)/2;
	if(posibil(m))
	    r=m;
	else
	    l=m+1;
    }
    pf=fopen("proc.out", "wt");
    fprintf(pf, "%lu\n", l);
    fclose(pf);
    return 0;
}
