#include <stdio.h>
#include <stdlib.h>
#include <math.h>
typedef struct dreapta
{
  float x1,y1,x2,y2,m;
} dreapta;
typedef struct punct
{
  float x,y;
}punct;
int n;
dreapta* dr;
punct* puncte;
float z1,z2,x0,yy0;
#define sqr(x) ((x)*(x))
int cmp2(const void*a,const void*b)
{
  punct* c,*d;
  c = (punct*)a;
  d=(punct*)b;
  z1=c->x*d->y-c->y*d->x;
  if (z1<0) return -1;
  else if (z1>0) return 1;
  else {
    z1=sqr(c->x-x0)+sqr(c->y-yy0);
    z2=sqr(d->x-x0)+sqr(d->y-yy0);
    if (z1<z2) return -1;
    else if (z1>z2) return 1;
    else return 0;
  }
}

int cmp(const void*a,const void*b)
{
  dreapta *c,*d;
  c = ((dreapta*)a);
  d = ((dreapta*)b);
  if (isinf(c->m)) return 1;
  if (isinf(d->m)) return -1;
  if (c->m < d->m) return 1;
  else if (c->m > d->m) return -1;
  else return 0;
}
#define det(a11,a12,a13,a21,a22,a23,a31,a32,a33) (a11*a22*a33+a21*a32*a13+a31*a12*a23-a13*a12*a31-a12*a21*a33-a11*a23*a32)

int main()
{
  int i,kgo;
  float arie,px,py,m1,m2,de;
  int k,j;
  FILE* fin=fopen("inter.in","r");
  FILE* fout=fopen("inter.out","w");
  fscanf(fin,"%d\n",&n);
  dr = new dreapta[n];
  puncte = new punct[n];
  for(i=0;i<n;i++) {
    fscanf(fin,"%f %f %f %f\n",&dr[i].x1,&dr[i].y1,&dr[i].x2,&dr[i].y2);
    dr[i].m = (dr[i].y1-dr[i].y2)/(dr[i].x1-dr[i].x2);
  }
  fclose(fin);
  //intersections
  qsort(dr,n,sizeof(dreapta),cmp);
  k=0;
  for(i=0;i<n;i++) {
    for(j=i+1;j<n;j++) {
      //calculez px,py intersecita dr[i] cu dr[j]
      m1 = dr[i].m;
      m2=dr[j].m;
      if (isinf(m1)) {
	px = dr[j].x1;
	py = dr[j].y1+m2*(px-dr[j].x1);
      }
      else if (isinf(m2)) {
	px=dr[i].x1;
	py=dr[i].y1+m1*(px-dr[i].x1);
      }
      else if (m1==0) {
	py=0;
	px = dr[j].x1-dr[j].y1/m2;
      }
      else if (m2==0) {
	py=0;
	px=dr[i].x1-dr[i].y1/m1;
      }
      else{
	px = (dr[i].y1-dr[j].y1+m2*dr[j].x1-m1*dr[i].x1)/(m2-m1);
        py= dr[i].y1+m1*(px-dr[i].x1);
      }
      kgo=0;
      if (k>=2) {
	kgo=1;
	while (kgo==1 && k>=1) {
	  kgo=0;
	  de=det(1,px,py,
	      1,puncte[k-1].x,puncte[k-1].y,
	      1,puncte[k-2].x,puncte[k-2].y);
	  if (de<0) kgo=1;
	  else {
	    if (!(px==puncte[k-1].x && py==puncte[k-1].y)) {
	      if (de==0) {
		m1 = sqr(puncte[k-1].x-puncte[k-2].x)+sqr(puncte[k-1].y-puncte[k-2].y);
		m2=sqr(px-puncte[k-2].x)+sqr(py-puncte[k-2].y);
		if (m1<=m2) kgo=1;
		if (m1>m2) kgo=-1;
	      }
	    }
	    else kgo=-1;
	  }
	  if (kgo==1)  k--;
	}
      }
      if (kgo!=-1) {      
 	puncte[k].x=px;
	puncte[k].y=py;
	k++;
      }
      
    }
  }     
  //aria
  arie=0;
  x0=puncte[0].x;
  yy0=puncte[0].y;
  qsort(&puncte[1],k-1,sizeof(punct),cmp2);
  puncte[k]=puncte[0];
  for(i=0;i<k;i++)
    arie += fabs(det(1,puncte[i+1].x,puncte[i+1].y,
		     1,puncte[i].x,puncte[i].y,
		     1,puncte[0].x,puncte[0].y)/2.0);
  fprintf(fout,"%.2f\n",arie/2);
  fclose(fout);
  return 0;
}
