 #include <stdio.h>
 #include <mem.h>
 #include <stdlib.h>
 #include <math.h>
 #define MAX 501
 #define INF 500000

 struct point{ float x,y;};
 struct dreapta{ float m, n, x1, x2;};
 point pct[5500];
 dreapta dr[MAX];
 int n, pt, st[MAX], lev;
 float x0, y0;

 int sort_function( const void *a, const void *b)
 { float x1, y1, x2, y2, ar;
   x1 = (*(point *)a).x;
   y1 = (*(point *)a).y;
   x2 = (*(point *)b).x;
   y2 = (*(point *)b).y;
   ar = x1*y2+x0*y1+y0*x2-x1*y0-x2*y1-y2*x0;
   if (ar>0) return -1;
     else if(ar<0) return 1;
   return 0;
 }

 float arie(point a, point b, point c)
 { return b.x*c.y+a.x*b.y+a.y*c.x-b.x*a.y-c.x*b.y-c.y*a.x;
 }

 void push(int a)
 { st[lev++] = a;
 }

 void pop()
 { lev--;
 }

 float calc_arie()
 { float ar=0.0;
   int i;
   for (i=0;i<lev;i++)
     ar = ar + pct[st[i]].x*pct[st[i+1]].y-pct[st[i+1]].x*pct[st[i]].y;
   return fabs(ar/2);
 }

 int intre(float x, float a, float b)
 { float m=a, n=b;
   if (a>b)
     { m=b;
       n=a;
     }
   if ((m<=x)&&(x<=n)) return 1;
     else return 0;
 }

 void main()
 { int i, j, poz;
   float x1, y1, x2, y2, a, b, ar, x, y, dy1, dy2;
   point aux;
   FILE *fi=fopen("INTER.IN", "rt");
   fscanf(fi, "%d", &n);
   pt=0;
   x0 = 500000;
   y0 = 500000;
   for (i=1;i<=n;i++)
     { fscanf(fi, "%f %f %f %f", &x1, &y1, &x2, &y2);
       if (x1==x2)
	 { a = INF;
	   b = x1;
	 } else
	 { a = (y2-y1)/(x2-x1);
	   b = y1-a*x1;
	 }
       dr[i].m = a;
       dr[i].n = b;
       if (dr[i].m!=INF)
	 { dr[i].x1 = x1;
	   dr[i].x2 = x2;
	 } else
	 { dr[i].x1 = y1;
	   dr[i].x2 = y2;
	 }
       for (j=i-1;j>=1;j--)
	 { if (a==dr[j].m) continue;
	   if (a==INF)
	     { pct[pt++].x = b;
	       pct[pt-1].y = dr[j].m*pct[pt-1].x+dr[j].n;
	       dy1 = dr[j].m*dr[j].x1+dr[j].n;
	       dy2 = dr[j].m*dr[j].x2+dr[j].n;
	       if (!((intre(b, dr[j].x1, dr[j].x2)&&intre(pct[pt-1].y, y1, y2)&&intre(pct[pt-1].y, dy1, dy2))))
		{ pt--;
		  continue;
		}
	     } else
	     {
	       if (dr[j].m==INF)
		 { pct[++pt].x = dr[j].n;
		   pct[pt-1].y = a*dr[j].n + b;
		   if (!((intre(dr[j].n, x1, x2)&&intre(pct[pt-1].y, dr[j].x1, dr[j].x2)&&intre(pct[pt-1].y, y1, y2))))
		     { pt--;
		       continue;
		     }
		 } else
		 { pct[pt++].x = (dr[j].n - b) / (a - dr[j].m);
		   pct[pt-1].y = a*pct[pt-1].x + b;
  //		   x = pct[pt-1].x;
   //		   y = pct[pt-1].y;
//		   dy1 = dr[j].m*dr[j].x1+dr[j].n;
 //		   dy2 = dr[j].m*dr[j].x2+dr[j].n;
//		   if (!((intre(x, x1, x2)&&intre(y, y1, y2)&&intre(x, dr[j].x1, dr[j].x2)&&intre(y, dy1, dy2))))
 //		     { pt--;
  //		       continue;
   //		     }
		 }
	     }
	   if (pct[pt-1].x<x0)
	     { x0 = pct[pt-1].x;
	       y0 = pct[pt-1].y;
	       poz = pt-1;
	     } else
	     if (pct[pt-1].x == x0)
	       if (pct[pt-1].y<y0)
		 y0 = pct[pt-1].y, poz = pt-1;
	 }
     }
   aux = pct[poz];
   pct[poz] = pct[n-1];
   pct[n-1] = aux;
   qsort((void *)pct, pt-1, sizeof(pct[0]), sort_function);
   memmove(pct+1, pct, (pt-1)*sizeof(pct[0]));
   pct[0]=aux;
   lev = 0;
   push(0);
   push(1);
   pct[pt] = pct[0];
   for (i=2;i<=pt;i++)
   { ar = arie(pct[lev-2], pct[lev-1], pct[i]);
     if (ar<0)
      { pop();
	i--;
      } else push(i);
   }
   ar = calc_arie();
   fclose(fi);
   FILE *fo=fopen("INTER.OUT", "wt");
   fprintf(fo, "%.2f", ar);
   fclose(fo);
 }