#include <stdio.h>

unsigned int N, K, P;

int ok(int);

int main(void)
{
	FILE *fp;
	unsigned int l, r, m;
	
	fp = fopen("proc.in", "r");
	fscanf(fp, "%u %u %u", &N, &K, &P);
	fclose(fp);
	N -= K;
	
	l = 0;
	r = K + 2 * N;
	while (l <= r)
	{
		m = (l + r) >> 1;
/*		printf("test %d\n", m);*/
		if (ok(m))
		{
			r = m;
			if (l == r) break;
		}
		else
			l = m + 1;
	}
	
	fp = fopen("proc.out", "w");
	fprintf(fp, "%u\n", l);
	fclose(fp);

	return 0;
}

int ok(int max)
{
	int i, NN, NK, c1, c2;
	
	NK = K;
	NN = N;

	for (i = P - 1; i >= 0; i--)
	{
		c1 = max / (i + 1);
		if (c1 > NK) c1 = NK;
		c2 = (max - c1 * (i + 1)) / (i + 1) / 2;
/*		printf("%d %d\n", c1, c2);*/
		if (NK - c1 > 0) NK -= c1;
		else NK = 0;
		if (NN - c2 > 0) NN -= c2;
		else NN = 0;
	}
/*	printf("NN=%d NK=%d\n", NN, NK);*/
	return (NN == 0) && (NK == 0);
}

