#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int k,n;
//float *x, *y;
float x[100], y[100];
float *a, *b, *c;
const float de = 0.0001;

int readin()
{
  FILE *f = fopen("inter.in", "r");
  fscanf(f, "%d", &n);
  a = (float *)malloc(sizeof(float)*n);
  b = (float *)malloc(sizeof(float)*n);
  c = (float *)malloc(sizeof(float)*n);
  for (int i=0;i<n;i++)
  {
    float x1, y1, x2, y2;
    fscanf(f, "%f %f %f %f", &x1, &y1, &x2, &y2);
    a[i] = y2-y1;
    b[i] = x1-x2;
    c[i] = -x1*a[i]-y1*b[i];
  }
  fclose(f);
  return 0;
}

int intersectii()
{
  //x = (float *)malloc(sizeof(float)*n*(n-1));
  //y = (float *)malloc(sizeof(float)*n*(n-1));

  int i,j;

  k = 0;
  for (i=0; i<n; i++)
  for (j=0; j<n; j++)
    if (i!=j)
    {
      float d  = a[i]*b[j] - a[j]*b[i];
      float dx = -c[i]*b[j] + c[j]*b[i];
      float dy = -a[i]*c[j] + a[j]*c[i];

      x[k] = dx/d;
      y[k] = dy/d;
      if (fabs(x[k])<de) x[k] = 0;
      k++;
    }
  return 0;
}

void sort(int, int);
void sort(int l, int r)
{
  int i,j;
  float a,t;

  i = l; j = r; a = x[(l+r)/2];
  while (i<=j)
  {
    while (x[i] < a) i++;
    while (a < x[j]) j--;
    if (i <= j)
    {
      t = x[i]; x[i] = x[j]; x[j] = t;
      t = y[i]; y[i] = y[j]; y[j] = t;
      i++; j--;
    }
  }
  if (l < j) sort(l, j);
  if (i < r) sort(i, r);
}

short int st[5000];
int acoperire()
{
  n = k;
  sort(0,n-1);

  int i = 0;
  while (i<n-1)
  {
    if ((fabs(x[i] - x[i+1])<de) && (y[i] == y[i+1]))
    {
      for (int j = i+1; j<n-1; j++)
      {
        x[j] = x[j+1];
        y[j] = y[j+1];
      }
      n--;
    }
    else
      i++;
  }

  st[0] = 0;
  st[1] = 0;
  st[2] = 1;
  k = 2;

  float a,b,c;

  i = 2;
  while (i<n)
  {
    if (k>=2)
    {
      a = y[st[k]]-y[st[k-1]];
      b = x[st[k-1]]-x[st[k]];
      c = -x[st[k-1]]*a-y[st[k-1]]*b;
    }

    if ((k<2) || (a*x[i]+b*y[i]+c>=0))
    {
      k++;
      st[k] = i;
      i++;
    }
    else
    {
      k--;
    }
  }

  i = n-2;
  while (i>0)
  {
    a = y[st[k]]-y[st[k-1]];
    b = x[st[k-1]]-x[st[k]];
    c = -x[st[k-1]]*a-y[st[k-1]]*b;

    if (a*x[i]+b*y[i]+c>=0)
    {
      k++;
      st[k] = i;
      i--;
    }
    else
    {
      k--;
    }
  }


  return 0;
}

int arie()
{
  float s = 0;
  int i;

  for (i = 0;i<k; i++)
    s += x[st[i]]*y[st[i+1]]-x[st[i+1]]*y[st[i]];
  s+=x[st[k]]*y[st[1]]-x[st[1]]*y[st[k]];
  s /= 2;

  return 0;
}

int writeout()
{
  return 0;
}


int main()
{
  readin();
  intersectii();
  acoperire();
  arie();
  writeout();
  return 0;
}