{$I-,Q-,R-}

const MaxN=5000;

type dreapta=record
       a,b,c:real;
       o:byte;
     end;
     punct=record
       x,y:real;
     end;
     dr_list=array[1..MaxN] of dreapta;
     p_list=array[1..2*MaxN] of punct;

var n,np,ns:integer;
    d:^dr_list;
    p:^p_list;
    tmp:punct;
    sel:array[1..2*MaxN] of byte;
    st:array[1..2*MaxN] of integer;
    sum:real;

  procedure load;
  var f:text;
      x1,x2,y1,y2:real;
      i:integer;
      o:byte;
  begin
    assign(f,'inter.in');
    reset(f);
    readln(f,n);
    new(d);
    for i:=1 to n do begin
      readln(f,x1,y1,x2,y2);
      d^[i].a:=y2-y1;
      d^[i].b:=x1-x2;
      d^[i].c:=y1*x2-x1*y2;
      if y1=y2 then o:=1 else
        if x1=x2 then o:=2 else
         if ((x1<x2)and(y1<y2))or((x2<x1)and(y2<y1)) then o:=4 else
           o:=3;
      d^[i].o:=o;
    end;
    close(f);
  end;

  procedure sortp(s,e:integer);
  var pv:punct;
      i,j:integer;
  begin
    i:=s;
    j:=e;
    pv:=p^[(i+j) div 2];
    repeat
      while (p^[i].y<pv.y) or ((p^[i].y=pv.y) and (p^[i].x<pv.x)) do inc(i);
      while (p^[j].y>pv.y) or ((p^[j].y=pv.y) and (p^[j].x>pv.x)) do dec(j);
      if i<=j then begin
        tmp:=p^[i];
        p^[i]:=p^[j];
        p^[j]:=tmp;
        inc(i);
        dec(j);
      end;
    until i>j;
    if i<e then sortp(i,e);
    if s<j then sortp(s,j);
  end;

  function unghiok(p1,p2,p3:integer):boolean;
  var a,b,c:real;
  begin
    a:=p^[p2].y-p^[p1].y;
    b:=p^[p1].x-p^[p2].x;
    c:=p^[p1].y*p^[p2].x-p^[p1].x*p^[p2].y;
    unghiok:=a*p^[p3].x+b*p^[p3].y+c<0;
  end;

  procedure hill;
  label fin;
  var dir:byte;
      i,z:integer;
      p1,p2:punct;
  begin
    fillchar(sel,sizeof(sel),0);
    st[1]:=1;
    st[2]:=2;
    sel[2]:=1;
    ns:=2;
    dir:=1;
    z:=2;
    repeat
      repeat
        if dir=1 then inc(z) else dec(z);
        if z=0 then goto fin;
        if z>np then begin
          dir:=2;
          z:=np;
        end;
      until (sel[z]=0);
      while not unghiok(st[ns-1],st[ns],z) do begin
        sel[st[ns]]:=0;
        dec(ns);
      end;
      inc(ns);
      st[ns]:=z;
      sel[z]:=1;
    until false;
    fin:
    sum:=0;
    for i:=1 to ns-1 do begin
      p1:=p^[st[i]];
      p2:=p^[st[i+1]];
      sum:=sum+(p1.x*p2.y-p1.y*p2.x);
    end;
    sum:=abs(sum/2);
  end;

  procedure solve;
  var i,j:integer;
      x,y:real;
      o:byte;
      p1,p2:punct;
      u1,u2:boolean;
  begin
    np:=0;
    new(p);
    for i:=1 to n do begin
      o:=d^[i].o;
      u1:=false;
      u2:=false;
      for j:=1 to n do begin
        if i=j then continue;
        y:=(d^[j].a*d^[i].c-d^[i].a*d^[j].c)/(d^[i].a*d^[j].b-d^[j].a*d^[i].b);
        if d^[i].a<>0 then
          x:=-(d^[i].b*y+d^[i].c)/d^[i].a
        else
          x:=-(d^[j].b*y+d^[j].c)/d^[j].a;
        case o of
        1: begin
            if not u1 then begin
              p1.x:=x;
              p1.y:=y;
              u1:=true;
            end else begin
              if p1.x>x then p1.x:=x;
            end;
            if not u2 then begin
              p2.x:=x;
              p2.y:=y;
              u2:=true;
            end else begin
              if p2.x<x then p2.x:=x;
            end;
           end;
        2: begin
            if not u1 then begin
              p1.x:=x;
              p1.y:=y;
              u1:=true;
            end else begin
              if p1.y>y then p1.y:=y;
            end;
            if not u2 then begin
              p2.x:=x;
              p2.y:=y;
              u2:=true;
            end else begin
              if p2.y<y then p2.y:=y;
            end;
           end;
        3: begin
            if not u1 then begin
              p1.x:=x;
              p1.y:=y;
              u1:=true;
            end else begin
              if (p1.x>x) and (p1.y<y) then begin
                p1.x:=x;
                p1.y:=y;
              end;
            end;
            if not u2 then begin
              p2.x:=x;
              p2.y:=y;
              u2:=true;
            end else begin
              if (p2.x<x) and (p2.y>y) then begin
                p2.x:=x;
                p2.y:=y;
              end;
            end;
           end;
        4: begin
            if not u1 then begin
              p1.x:=x;
              p1.y:=y;
              u1:=true;
            end else begin
              if (p1.x>x) and (p1.y>y) then begin
                p1.x:=x;
                p1.y:=y;
              end;
            end;
            if not u2 then begin
              p2.x:=x;
              p2.y:=y;
              u2:=true;
            end else begin
              if (p2.x<x) and (p2.y<y) then begin
                p2.x:=x;
                p2.y:=y;
              end;
            end;
           end;
        end;
      end;
      if u1 then begin
        inc(np);
        p^[np]:=p1;
      end;
      if u2 then begin
        inc(np);
        p^[np]:=p2;
      end;
    end;
    sortp(1,np);
    hill;
  end;

  procedure sol;
  var f:text;
  begin
    assign(f,'inter.out');
    rewrite(f);
    writeln(f,sum:1:2);
    close(f);
  end;

begin

  load;
  solve;
  sol;

end.