/*

inter

*/

#include <mem.h>
#include <stdio.h>
#include <stdlib.h>

#define N  0
#define S  1
#define E  2
#define V  3

typedef struct dreapta
{
float a;
float b;
float c;
dreapta* next;
}DREAPTA;

dreapta* prima_d = NULL;
int nd;
float aria = 0;

typedef struct punct
{
float x;
float y;
}PUNCT;

punct pex[4];  // vectorul cu puncte extreme

void insereaza_dreapta(float x1,float y1,float x2, float y2)
{
dreapta* td = NULL;
td = new(dreapta);
// calculeaza parametrii dreptelor
td->a = y2 - y1;
td->b = x2 - x1;
td->c = x1 * td->a + y1 * td->b;
td->next = prima_d;
prima_d = td;
}

void citire()
{
FILE *fin;
fin = fopen("inter.in","r");
fscanf(fin,"%d",&nd);
float tx1,tx2,ty1,ty2;
typedef char str[25];
str stx1,stx2,sty1,sty2;
for (int i = 0; i < nd; i++)
    {
    fscanf(fin,"%s %s %s %s",&stx1,&stx2,&sty1,&sty2);
    tx1 = strtod(stx1, NULL);  tx2 = strtod(stx2, NULL);
    ty1 = strtod(sty1, NULL);  ty2 = strtod(sty2, NULL);
    insereaza_dreapta(tx1,tx2,ty1,ty2);
    }
fclose(fin);
//memset(pex,sizeof(pex),0);
}

float abs (float a)
{
if (a > 0 ) return a;
else return -a;
}

float arie_triunghi(punct p1,punct p2,punct p3)
{
float a = abs ( (p1.x*p2.y + p2.x*p3.y + p1.y*p3.x) - (p2.y * p3.x + p2.x*p1.y + p3.y*p1.x) / 2);
return a;
}


punct calc_punct(dreapta* d1,dreapta* d2)
{
punct p = {0};
float d = d1->a * d2->b - d2->a * d1->b;
if (d!=0)
{
p.x = ( d1->c * d2->b - d2->c * d1->b) / d;
p.y = ( d1->a * d2->c - d2->a * d1->c) / d;
}
return p;
}

void verifica(punct pcx)
{
// determin extremul din fiecare directie,
// iar daca pcx este mai mic, devine noul extrem

//extrem vest
if (pcx.x < pex[V].x) { pex[V].x = pcx.x; pex[V].y = pcx.y; }
//extrem sud
if (pcx.y < pex[S].y) { pex[S].x = pcx.x; pex[S].y = pcx.y; }
//extrem nord
if (pcx.y > pex[N].y) { pex[N].x = pcx.x; pex[N].y = pcx.y; }
//extrem est
if (pcx.x > pex[E].x) { pex[E].x = pcx.x; pex[E].y = pcx.y; }
}

void calculextrem()
{
// determina punctele extreme
// p1. calculeaza punctele de extrem initiale
dreapta* td1 = prima_d;
dreapta* td2 = NULL;
while (td1!=NULL)
{
 td2 = td1->next;
while (td2!=NULL)
{

 // determina punct de intersectie si verifica daca nu este extrem
 verifica(calc_punct(td1,td2));
 td2 = td2->next;
}
td1 = td1->next;
}
}

void arie()
{
// determina aria determinata de punctele extreme
// daca N si S sunt pe aceeasi linie
aria = arie_triunghi(pex[N],pex[V],pex[E]) + arie_triunghi(pex[S],pex[V],pex[E]);
}

void afisare()
{
  // afiseaza aria minima
  FILE *fout = fopen("inter.out","w");
  fprintf(fout,"%1.2f\n",aria);
  fclose(fout);
}

void cleanup()
{
dreapta* td = prima_d;
while ( prima_d != NULL)
 {
 td = prima_d;
 prima_d = td->next;
 td->next = NULL;
 delete td;
 }
}

int main()
{
citire();
calculextrem();
arie();
afisare();
cleanup();
return 0;
}
