#include <stdio.h>
long pct[401][2], N, M, i, j, X, Y, d, dMin, cXi, cYi;
int  ord[401][2];

//------------------------------------------------
inline long absl(long a)
{
   if (a<0L) return -a;
   else      return  a;
}

inline void swap(int &a, int &b)
{
   int k = a;
   a = b;
   b = k;
}

//------------------------------------------------
int findVal(int val, int axis)
{
   int a = 0, b = N-1, k;

   while (a<b)
   {
      k = (a+b+1) / 2;

      if (pct[ ord[k][axis] ][axis] > val) a = k;
      else                                 b = k;
   }

   return a;
}

inline long _dist(int to)
{
    return absl(X - pct[to][0]) + absl(Y - pct[to][1]);
}

//------------------------------------------------
int main(void)
{
    FILE *fin  = fopen("ajutor.in" , "r");
    FILE *fout = fopen("ajutor.out", "w");

    fscanf(fin, "%ld %ld", &N, &M);

    for (i=0; i<N; i++)
    {
       fscanf(fin, "%ld %ld\n", &pct[i][0], &pct[i][1]);
       ord[i][0] = ord[i][1] = i;
    }

    for (i=0; i<N-1; i++)
	for (j=i+1; j<N; j++)
	{
	   if (pct[ ord[i][0] ][0] > pct[ ord[j][0] ][0])
	       swap(ord[i][0], ord[j][0]);

	   if (pct[ ord[i][1] ][1] > pct[ ord[j][1] ][1])
	       swap(ord[i][1], ord[j][1]);
	}


    ord[N][0] = ord[N-1][0];
    ord[N][1] = ord[N-1][1];

    for (i=0; i<M; i++)
    {
       fscanf(fin, "%ld %ld\n", &X, &Y);

       dMin = 100000L;

       cXi = findVal(X, 0);
       cYi = findVal(Y, 0);

       d = _dist(ord[cXi  ][0]); if (d<dMin) dMin = d;
       d = _dist(ord[cXi+1][0]); if (d<dMin) dMin = d;

       d = _dist(ord[cYi  ][1]); if (d<dMin) dMin = d;
       d = _dist(ord[cYi+1][2]); if (d<dMin) dMin = d;

       fprintf(fout, "%ld\n", dMin);
    }

    fclose(fin);
    fclose(fout);

    return 0;
}