#include <stdio.h>
#include <string.h>
#include <memory.h>
#define m_size 1000
typedef char longNum [m_size+2];

char temp2[256], temp3[256], tempM[256];
long total, tMax = 0;
/////////////////////////////////////////////////////
void set(char *me, unsigned long val)
{
   memset(me, '0', m_size-20);
   sprintf(me+m_size-20, "%020lu", val);
   me[m_size] = 0;
}

void add(char *mr, char *m1, long sup)
{
    int i, cur;

    for (i=m_size-1; i>=0; i--)
    {
       cur = m1[i] + sup - '0';
       sup = cur / 10;

       mr[i] = cur % 10 + '0';
    }

    if (sup) printf("Out of range");
}

void mul(char *mr, char *m1, long val)
{
    long i, cur, sup = 0;

    for (i=m_size-1; i>=0; i--)
    {
       cur = (m1[i] -'0') * val + sup;
       sup = cur / 10;

       mr[i] = cur % 10 + '0';
    }
    if (sup)
      printf("Out of range");
}

long div(char *mr, char *m1, long val)
{
    long i, cur, sup = 0;

    for (i=0; i<m_size; i++)
    {
	sup = sup * 10 + m1[i]-'0';
	cur = sup / val;
	mr[i] = cur + '0';
	sup -= cur * val;
    }

    return sup;
}

//////////////////////////////////////////////////
void add(char *mr, char *m1, char *m2)
{
    int i, cur, sup = 0;

    for (i=m_size-1; i>=0; i--)
    {
       cur = m1[i] + m2[i] + sup - '0' * 2;
       sup = cur / 10;

       mr[i] = cur % 10 + '0';
    }

    if (sup) printf("Out of range");
}

void mul(char *mr, char *m1, char *m2)
{
    longNum temp, temp2;

    memset(mr, '0', m_size);
    mr[m_size] = 0;
    strcpy(temp, mr);

    for (int i=m_size-1; i>=0; i--)
    {
	if (m2[i] == 0) continue;

	strncpy(temp  , m1+(m_size-1)-i, i+1);
	memset (temp+i+1, '0', m_size-1 - i);


	mul(temp2, temp, m2[i]-'0');
	add(mr, mr, temp2);
    }
}

//////////////////////////////////////////////////
void gen(int i, int t, int prn)
{
    if (i == t)
    {
       total = 0;
       strcpy(temp3, temp2);

       int i, j;
       for (j=t; j>=1; j--)
       {
	  temp3[j] = 0;
	  if (prn) printf("%s\n", temp3);

	  for (i=0; i<j; i++)
	  {
	    if (temp3[i] == 'B') total++;
	  }

	  for (i=0; i<j-1; i++)
	  {
	     if (temp3[i] == temp3[i+1]) temp3[i] = 'F';
	     else                        temp3[i] = 'B';
	  }
       }


       if (total >= tMax)
       {
	  tMax =total;
	  strcpy(tempM, temp2);
       }
    } else {
	for (int j=0; j<2; j++)
	{
	   temp2[i] = (j) ? 'B':'F';
	   gen(i+1, t, prn);
	}
    }
}

int main(void)
{
   int i, cif, m_c;

   FILE *f = fopen("sala.in", "r");
   fscanf(f, "%d", &cif);

   if (cif < 7)
   {
      long n = 0;
      for (i=0; i<cif; i++)
      {
	  fscanf(f, "%d", &m_c);

	  n = n*10 + m_c;
      }

      long k, b=0, x;

      k = n/3;
      b = k*(3*k+1);

      x = n%3;

      if (x == 1) b += 2*k+1;
      if (x == 2) b += 4*k+2;

      FILE *f2 = fopen("sala.out", "w");
      fprintf(f2, "%ld\n", b);

      fclose(f2);
   } else {
      longNum n, k, b, q, m;
      int x;
      set(n, 0L);

      for (i=0; i<cif; i++)
      {
	  fscanf(f, "%d", &m_c);

	  n[m_size+i-cif] = m_c + '0';
      }

      set(b,  0L);
      x = div(k, n, 3L);

      mul(q, k, 3L);
      add(m, q, 1L);

      mul(q, k, m);

      add(b, b, q);

      if (x == 1) { mul(k, k, 2L); add(b, b, k); add(b, b, 1L);}
      if (x == 2) { mul(k, k, 4L); add(b, b, k); add(b, b, 2L);}


      FILE *f2 = fopen("sala.out", "w");
      for (i=0; i<m_size; i++) if (b[i]!='0') break;

      fprintf(f2, "%s\n", b+i);

      fclose(f2);
   }

   fclose(f);

   return 0;
}
