 #include <stdio.h>
 #include <stdlib.h>
 #include <math.h>
 #define MAX 401

 struct point{
   long x, y;
 };
 point pct[MAX];
 long xc, yc, n, xp, yp;
 long m, dstpc, dstmin;

 long dist(long x1, long y1, long x2, long y2)
 { return abs(x1-x2)+abs(y1-y2);
 }

 int sort_function( const void *a, const void *b)
 { long x1 = (*(point *)a).x,
	y1 = (*(point *)a).y,
	x2 = (*(point *)b).x,
	y2 = (*(point *)b).y;
   long dst1, dst2;
   dst1 =  dist(x1, y1, xc, yc);
   dst2 =  dist(x2, y2, xc, yc);
   if (dst1-dst2 > 0 ) return 1;
     else
       if (dst1-dst2 < 0) return -1;
   return 0;
 }

 long lookup(long a, long b)
 { long j = (a+b)/2;
   long dst1;
   if (abs(a-b)<=1) return a;
   dst1 = dist(pct[j].x, pct[j].y, xc, yc);
   if (dst1>dstpc)
       lookup(j+1, b);
     else
       lookup(a, j-1);
   return a;
 }

 long max(long a, long b)
 { if (a>b) return a; else return b;
 }

 int main()
 { long i, p, t;
   FILE *fi=fopen("ajutor.in", "rt");
   fscanf(fi, "%ld %ld", &n, &m);
   xc=0;
   yc=0;
   for (i=0;i<n;i++)
     { fscanf(fi, "%ld %ld", &pct[i].x, &pct[i].y);
       xc = xc+pct[i].x;
       yc = yc+pct[i].y;
     }
   xc = xc/n;
   yc = yc/n;
   qsort((void *)pct, n, sizeof(pct[0]), sort_function);
   FILE *fo=fopen("ajutor.out", "wt");
   for (;m;m--)
     {
       fscanf(fi, "%ld %ld", &xp, &yp);
       dstpc = dist(xp, yp, xc, yc);
       p = lookup(0, n-1);
       dstmin = dist(xp, yp, pct[p].x, pct[p].y);
       t=max(40, n/2);
       for (i=1;i<t;i++)
	 { if (p-i>=0)
	     { dstpc = dist(xp, yp, pct[p-i].x, pct[p-i].y);
	       if (dstpc<dstmin)
		 dstmin=dstpc;
	     }
	   if (p+i<n)
	     { dstpc = dist(xp, yp, pct[p+i].x, pct[p+i].y);
	       if (dstpc<dstmin)
		   dstmin=dstpc;
	     }
	 }
       fprintf(fo, "%d\n", dstmin);
     }
   fclose(fo);
   fclose(fi);
   return 0;
 }