#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct list_t
{
    int entrynr;
    struct list_t *next;
} *L[101][101];

typedef struct list_t list_t;

int K, Flow;
int C[101][101], F[101][101];

int coada[101], cl, cr, tata[101];

void bf()
{
    int i, j, c;
    for (i = 0; i <= 100; i++) tata[i] = -1;
    coada[0] = 0, tata[0] = -2;
    for (cl = cr = 0; cl <= cr && tata[100] == -1;)
       for (i = coada[cl++], j = 100; j > 0; j--)
       if (i != j && tata[j] == -1 && F[i][j] < C[i][j])
          coada[++cr] = j, tata[j] = i;

    c = K - Flow;
    for (i = 100; i; i = tata[i])
        if (c > C[tata[i]][i] - F[tata[i]][i])
            c = C[tata[i]][i] - F[tata[i]][i];
           
    for (i = 100; i; i = tata[i])
        F[tata[i]][i] += c, F[i][tata[i]] -= c;
    Flow += c;
}

void solve()
{
    for (Flow = 0; Flow < K; )
        bf();
}

int R[5001];

void print()
{
    FILE *fo = fopen("ghizi.out", "wt");
    int i, j, k, nr = 0;
    list_t *l;
    for (i = 0; i < 100; i++)
     for (j = i+1; j <= 100; j++)
      for (l = L[i][j], k = 0; k < F[i][j]; k++, l = l->next)
          R[l->entrynr] = 1, nr++;

    fprintf(fo, "%d\n", nr);
    for (i = 1; i <= 5000; i++)
        if (R[i])
           fprintf(fo, "%d ", i);
    fprintf(fo, "\n");
    fclose(fo);
}

void read_data()
{
    FILE *fi = fopen("ghizi.in", "rt");
    int i, j, x, n;
    list_t *l;
    fscanf(fi, "%d %d", &n, &K);
    for (x = 1; x <= n; x++)
    {
        fscanf(fi, "%d %d", &i, &j);
        C[i][j]++;
        l = (list_t *) malloc(sizeof(list_t));
        l->entrynr = x, l->next = L[i][j], L[i][j] = l;
    }
    fclose(fi);
}

int main()
{
    read_data();
    solve();
    print();
    return 0;
}
