#include<stdio.h>
#define MAXN 102
#define MAX 100
#define MULT 5002

int G[MAXN][MAXN];
int R[MAXN][MAXN];
int TS[MULT],TE[MULT];
int P[MAXN];
int SOL[MULT],SOLN;
int Q[MAXN],QS,QE;
int N,K;

int drum()
{
	int i;
	for(i=0;i<MAXN;i++)
		P[i]=-1;
	QS=QE=1;
	Q[1]=0;
	while(QS<=QE)
	{
		int el;
		el=Q[QS];QS++;
		for(i=el+1;i<MAXN;i++)
			if(R[el][i] && P[i]==-1)
			{
				P[i]=el;
				if(i==MAX+1)return 1;
				QE++;Q[QE]=i;
			}
	}
	return 0;
}

int main()
{
	int min;
	int t1,t2;
	int i,j;
	FILE* f;
	f=fopen("ghizi.in","r");
	fscanf(f,"%d%d",&N,&K);
	for(i=0;i<MAXN;i++)
		for(j=0;j<MAXN;j++)
			G[i][j]=R[i][j]=0;
	for(i=1;i<=N;i++)
	{
		fscanf(f,"%d%d",&t1,&t2);
		TS[i]=t1;
		TE[i]=t2;
		G[t1][t2]++;
		R[t1][t2]++;
	}
	fclose(f);
	G[MAX][MAX+1]=R[MAX][MAX+1]=K;
	while(drum())
	{
		int k;
		min=32000;
		k=MAX;
		while(k)
		{
			if(R[P[k]][k]<min)min=R[P[k]][k];
			k=P[k];
		}
		k=MAX;
		while(k)
		{
			R[P[k]][k]-=min;
			R[k][P[k]]+=min;
			k=P[k];
		}
	}
	SOLN=0;
	for(i=1;i<=N;i++)
		if(R[TE[i]][TS[i]])
		{
			SOLN++;
			SOL[SOLN]=i;
			R[TE[i]][TS[i]]--;
		}
	f=fopen("ghizi.out","w");
	fprintf(f,"%d\n",SOLN);
	for(i=1;i<=SOLN;i++)
		fprintf(f,"%d ",SOL[i]);
	fprintf(f,"\n");
	fclose(f);
	return 0;
}