#include <iostream.h>
#include <fstream.h>

#define ABS(a) (((a) > 0) ? (a) : (-(a)))

int pct[401][2];

int poz(int x, int y)
{
	int mx=1,my=0,aux;
	while (x != y)
	{
		if (pct[x][0] > pct[y][0] ||
		   (pct[x][0] == pct[y][0] && pct[x][1] > pct[y][1]))
		{
			aux = pct[x][0];
			pct[x][0] = pct[y][0];
			pct[y][0] = aux;
			aux = pct[x][1];
			pct[x][1] = pct[y][1];
			pct[y][1] = aux;
			if (mx == 0 && my == -1)
			{
				mx = 1;
				my = 0;
			}
			else if (mx == 1 && my == 0)
			{
				mx = 0;
				my = -1;
			}
		}
		x+=mx;
		y+=my;
	}
	return x;
}

void ord(int ld, int ls)
{
	int mij=0;
	if (ld < ls)
	{
		mij = poz(ld,ls);
		ord(ld,mij-1);
		ord(mij+1,ls);
	}
}

void calc(int x, int y, int ls, int ld, unsigned int &d)
{
	if (ls < ld)
	{
		unsigned int dist = (ABS(pct[(ls+ld)/2][0]-x)+ABS((pct[(ls+ld)/2][1])-y));
		if (dist < d)
		{
			d = dist;
		}
		if ((x < pct[(ls+ld)/2][0] && pct[(ls+ld)/2][0]-x < d) ||
		    (x >= pct[(ls+ld)/2][0]))
			calc(x,y,(ls+ld)/2+1,ld,d);
		if ((x > pct[(ls+ld)/2][0] && x-pct[(ls+ld)/2][0] < d) ||
		    (x <= pct[(ls+ld)/2][0]))
			calc(x,y,ls,(ls+ld)/2-1,d);
	}
	else
	{
		int dist = ABS(pct[ld][0]-x)+ABS(pct[ld][1]-y);
		if (dist < d)
		{
			d = dist;
		}
	}
}

void citire(int &m, int &n)
{
	ifstream in;
	in.open("ajutor.in");
	in >> n >> m;
	int i=0,x=0,y=0;
	unsigned int d=0;
	for (;i<n;i++)
	{
		in >> pct[i][0] >> pct[i][1];
	}
	ord(0,n-1);
	ofstream out;
	out.open("ajutor.out");
	for (i=0;i<n;i++)
	{
		d = 64001;
		in >> x >> y >> ws;
		calc(x,y,0,n-1,d);
		out << d << endl;
	}
}


int main()
{
	int m,n;
	citire(m,n);
	return 0;
}