#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define _maxint 65535
int _len;

int n,m;
unsigned int **M;
int d[2][4][2]={{{0,1},{1,0},{0,-1},{-1,0}},{{1,1},{1,-1},{-1,-1},{-1,1}}};
FILE *fi;
FILE *fo;

void Init(void);
void Free(void);
void _getlen(void);

void Solve(void);
void _lee(void);

int main(void)
{
 Init();
 Solve();
 Free();
 return 0;
}

void Init(void)
{
 int i,j,k;
 _getlen();
 fi=fopen("ajutor.in","r");
 fo=fopen("ajutor.out","w");
 fscanf(fi,"%d %d\n",&n,&m);
 M=malloc(sizeof(unsigned int*)*_len);
 for (i=0;i<_len;i++)
 {
  M[i]=malloc(sizeof(unsigned int)*_len);
  memset(M[i],_maxint,sizeof(unsigned int)*_len);
 }
 for (k=0;k<n;k++)
 {
  fscanf(fi,"%d %d\n",&i,&j);
  M[i][j]=0;
 }
}

void _getlen(void)
{
 int n,m;
 int i,k;
 FILE *file=fopen("ajutor.in","r");
 fscanf(file,"%d %d",&n,&m);
 _len=-1;
 for (i=0;i<2*n;i++)
 {
  fscanf(file,"%d",&k);
  if (_len<k)
   _len=k;
 }
 for (i=0;i<2*m;i++)
 {
  fscanf(file,"%d",&k);
  if (_len<k)
   _len=k;
 }
 _len++;
 fclose(file);
}

void Free(void)
{
 int i;
 fclose(fo);
 fclose(fi);
 for (i=0;i<n;i++)
  free(M[i]);
 free(M);
}

void Solve(void)
{
 int i,j,k;
 _lee();
 for (k=0;k<m;k++)
 {
  fscanf(fi,"%d %d\n",&i,&j);
  fprintf(fo,"%d\n",M[i][j]);
 }
}

void _lee(void)
{
 int i,j,k,b,i0,j0;
 do
 {
  b=0;
  for (i=0;i<_len;i++)
   for (j=0;j<_len;j++)
   {
    for (k=0;k<4;k++)
    {
     i0=i+d[0][k][0];
     j0=j+d[0][k][1];
     if ((i0>-1)&&(i0<_len+1)&&(j0>-1)&&(j0<_len+1))
      if ((M[i0][j0]!=_maxint)&&(M[i][j]>M[i0][j0]+1))
      {
       M[i][j]=M[i0][j0]+1;
       b=1;
      }
    }
    for (k=0;k<4;k++)
    {
     i0=i+d[1][k][0];
     j0=j+d[1][k][1];
     if ((i0>-1)&&(i0<_len+1)&&(j0>-1)&&(j0<_len+1))
      if ((M[i0][j0]!=_maxint)&&(M[i][j]>M[i0][j0]+2))
      {
       M[i][j]=M[i0][j0]+2;
       b=1;
      }
    }
   }
 }
 while (b==1);
}