
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

long *l;
long *hm;
long *hM;
double *pxx, *pyy;
int n;
long hx, hy;

double lenn;

void input()
{
	long sum=0;
	long max=0;

	FILE *f = fopen("robot.in", "r");

	fscanf(f, "%d", &n);

	l = new long[n];
	hm = new long[n];
	hM = new long[n];

	int kk;
	for (int i=0;i<n;i++)
	{
		fscanf(f, "%d", &kk);

		l[i]=kk;
		sum+=l[i];
		hM[i]=sum;
		if (max<l[i]) max=l[i];
		if (i!=0) hm[i]=hm[i-1]-l[i];
			else hm[i]=l[i];
	}

	fscanf(f, "%d%d", &hx, &hy);

	fclose(f);

	lenn = sqrt(abs(hx*hx+hy*hy));

	if ((lenn>sum) || ( 2*max-sum>sqrt(abs(hx*hx+hy*hy)) ))
	{
		FILE *f = fopen("robot.out", "w");
		fprintf(f, "0\n");
		fclose(f);
		exit(0);
	}

}

double lx, ly;

void amplasare(int num, double px, double py)
{
	double lf;

	lenn = sqrt(px*px+py*py);

	double a, b, c;

	if (num!=1)
	{
		lf = (lenn-l[num] + hM[num-1])/2;
		if (lf>lenn+l[num]) lf = lenn+l[num];
	} else {
		lf = l[0];
	}

	b = lenn;
	a = lf;
	c = l[num];

	double X = asin(py/lenn);

	double C = acos( (a*a + b*b - c*c) / (2*a*b) );
	C = X+C;

	double nx, ny;

		nx = cos(C)*a;
		ny = sin(C)*a;

//	printf("%5.2f %5.2f -> %5.2f %5.2f (%5.2f)\n", px, py, nx, ny, sqrt( (px-nx)*(px-nx) + (py-ny)*(py-ny) ) );

	pxx[num] = nx;
	pyy[num] = ny;

	if (num>1)
	{
		amplasare(num-1, nx, ny);
	} else {
		pxx[0]=0;
		pyy[0]=0;
//		printf("%5.2f %5.2f -> 0 0 (%5.2f)\n", px, py, sqrt( (nx)*(nx) + (ny)*(ny) ) );
	}

}

int main()
{
	input();

	pxx = new double[n];
	pyy = new double[n];
	pxx[n] = hx;
	pyy[n] = hy;

//	printf("\n\n");
	amplasare(n-1, hx, hy);

	FILE *f=fopen("robot.out", "w");

	double a, b, len, deg, w1, w2, degp;
	double olddeg=0;
	for (int i=0;i<n;i++)
	{
		w1 = pyy[i+1]-pyy[i];
		w2 = pxx[i+1]-pxx[i];

		len = sqrt(w1*w1+w2*w2);

		a = ( w1 / len );

		b = asin(a);

		deg = (b*180.0)/M_PI;
		if (w2<0) deg+=180;

		degp = (deg-olddeg);

		if (degp<0) degp=360+degp;


		fprintf(f, "%.4f\n", degp);
		olddeg=deg;
	}

	fclose(f);

	return 0;
}