
#include <stdio.h>

long freq[40];
long total;

typedef struct nod
{
	unsigned long val;
	int u;
	nod *l, *r;
	nod *nx;
} nod;

void input()
{
	FILE *f = fopen("telegraf.in", "r");

	for (int i=0;i<36;i++)
	{
		fscanf(f, "%ld", &freq[i]);
	}

	fclose(f);
}

nod *n;

nod *huffman()
{
	int i;

	nod *c;
	n = new nod;
	c = n;
	for (i=0;i<35;i++)
	{
		c->val = freq[i];
		c->l = NULL;
		c->r = NULL;
		c->u = 0;
		c->nx = new nod;
		c = c->nx;
	}
	c->val = freq[36];
	c->l = NULL;
	c->r = NULL;
	c->u = 0;
	c->nx = NULL;

	unsigned long m1, m2;
	int i1, i2;
	int k;
	nod *n2, *nn, *n1;
	do
	{
		i1=-1;
		m1=-1;
		for (c=n, i=0; c; c=c->nx, i++)
		{
			if ((!c->u)&&(c->val<m1)&&(c->val))
			{
				i1=i;
				m1 = c->val;
				n1 = c;
			}
		}

		i2=-1;
		m2=-1;
		for (c=n, i=0; c; c=c->nx, i++)
		{
			if ((!c->u)&&(c->val<m2)&&(i!=i1)&&(c->val))
			{
				i2=i;
				m2 = c->val;
				n2 = c;
			}
		}

		if (m2<m1)
		{
			k=m2;
			m2=m1;
			m1=k;

			k=i2;
			i2=i1;
			i1=k;

			nn = n2;
			n2 = n1;
			n1 = nn;
		}

		if ((i1==-1)||(i2==-1)) break;

		if (i1==0)
		{
			c = new nod;
			c->nx = n->nx;
			c->val = m1+m2;
			c->u = 0;
			c->l = n;
			c->r = n2;
			c->r->u = 1;
			n = c;
		} else {
			c=n;
			for (i=0;i<i1-1;i++) c=c->nx;
			nn = new nod;
			nn->val = m1+m2;
			nn->u = 0;
			nn->l = c->nx;
			nn->r = n2;
			nn->r->u = 1;
			nn->nx = c->nx->nx;
			c->nx = nn;
		}

	} while (1);

	return n1;
}

void gothrough(nod *n, int tot)
{
	if (!n->l)
	{
		total+=tot*n->val;
	} else {
		gothrough(n->l, tot+2);
		gothrough(n->r, tot+1);
	}
}

int main()
{

	input();
	nod *n;
	n=huffman();

	total=0;

	if (n->l) gothrough(n, 0);
	else total = n->val;

	FILE *f=fopen("telegraf.out", "w");
	fprintf(f,"%ld\n", total);
	fclose(f);

	return 0;
}