#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define byte unsigned char
#define COORD double

int n;
byte l[10000];
long x0,y0;
int sol = 1;
double d;

int readin()
{
  FILE *f = fopen("robot.in", "r");
  fscanf(f, "%d", &n);
  for (int i=1; i<=n; i++) fscanf(f, "%d", &l[i]);
  fscanf(f, "%d %d", &x0, &y0);
  fclose(f);
  return 0;
}

int writeout()
{
  int i;

  d = sqrt(x0*x0+y0*y0);

  long sl = 0;
  for (i=1; i<=n; i++) sl += l[i];
  if (sl<d) sol = 0;

  FILE *f = fopen("robot.out", "w");
  if (sol)
  {
    if (fabs(sl-d)<0.001)
    {
      int u = atan2(y0,x0)*180/M_PI;
      if (u<0) u+= 360;

      for (int i = 1; i<=n; i++)
	fprintf(f, "%d\n", u);
    }
    else
    {
      fprintf(f, "0\n");
    }
  }
  else
    fprintf(f, "0\n");
  fclose(f);
  return 0;
}

int main()
{
  readin();
  writeout();
  return 0;
}