#include <stdio.h>
#include <limits.h>

int n;
long s[50];
long a[50][50];

int readin()
{
  FILE *f = fopen("telegraf.in", "r");
  n = 0;
  for (int i = 1; i<=36; i++)
  {
    long t;

    fscanf(f, "%ld", &t);
    if (t) s[++n] = t;
  }
  fclose(f);
  return 0;
}

void qsort(int l, int r)
{
  int i, j;
  long x, y;

  i = l; j = r; x = s[(l+r)/2];
  do
  {
    while (s[i] < x) i++;
    while (x < s[j]) j--;
    if (i <= j)
    {
      y = s[i]; s[i] = s[j]; s[j] = y;
      i++; j--;
    }
  } while (i<=j);
  if (l < j) qsort(l, j);
  if (i < r) qsort(i, r);
}

int sort()
{
  qsort(1,n);
}

int dyna()
{
  int i,j,k;

  for (i=1; i<=n; i++) a[i][i] = 0;

  for (k=2; k<=n; k++) // k = coloana de inceput
  {
    j = k;
    for (i=1; i<=n-k+1; i++, j++) // i = linia curenta
    {                             // j = coloana curenta
      long min = LONG_MAX;
      long s1 = 0;
      long s2 = 0;
      long t;
      { for (int ii = i; ii<=j; ii++) s2 += s[ii]; }

      int ii = i;
      int jj = i+1;
      for (int l=0; l<=k-2; l++)
      {
	s1 += s[i+l]; s2 -= s[i+l];
	t = s1 * 2 + s2 * 1 + a[i][ii] + a[jj][j];
	if (t<min) min = t;
	t = s1 * 1 + s2 * 2 + a[i][ii] + a[jj][j];
	if (t<min) min = t;
	ii++;
	jj++;
      }

      a[i][j] = min;
    }
  }

  return 0;
}

int writeout()
{
  FILE *f = fopen("telegraf.out", "w");
  fprintf(f, "%ld\n", a[1][n]);
  fclose(f);
  return 0;
}

int main()
{
  readin();
  sort();
  dyna();
  writeout();
  return 0;
}