{$R+}
program large_numbers;
const
  sin='ex.in';
  sout='ex.out';
  maxn=100;
  MODULO=1000*1000;  {longint = 4 bytes... N=200 cifre... 100 numere 2 linii}
  NCifre=6;          {4 bytes * 2 linii * 100 numere * N cifre = 800 * ceva...}
  NDigits=200;       {800 * 400 = 320.000 = 320 Kilo} {daca NDigits=400}
type
  TBigNumber=array[0..NDigits]of longint;
  pBigNumber=^TBigNumber;
  tl=array[0..maxn]of TBigNumber;
var
  fin,fout:text;
  n,k,p:shortint;
  l:array[0..1]of ^tl; {Linia I-1, respectiv Linia I}

procedure read_data;
begin
  assign(fin,sin);
  reset(fin);
  read(fin,n,k,p);
  close(fin);
  new(l[0]);
  new(l[1]);
end;

procedure InitBigNumber(p:pBigNumber;q:shortint);
begin
  fillchar(p^,sizeof(p^),0);
  p^[0]:=0;
  if q=0 then
    exit;
  p^[0]:=1;
  p^[1]:=q;
end;

procedure Multiply(p:pBigNumber;q:longint);
var
  poz:shortint;
  rest:longint;
  new_rest:longint;
begin
  rest:=0;
  for poz:=1 to p^[0] do
    begin
      new_rest:=(rest+q*p^[poz]) div MODULO;
      p^[poz]:=(rest+q*p^[poz]) mod MODULO;
      rest:=new_rest;
    end;
  while rest<>0 do
    begin
      inc(p^[0]);
      p^[p^[0]]:=rest mod MODULO;
      rest:=rest div MODULO;
    end;
end;

function max_s(a,b:shortint):shortint;
begin
  if a>b then
    max_s:=a
  else
    max_s:=b;
end;

function min_s(a,b:shortint):shortint;
begin
  if a<b then
    min_s:=a
  else
    min_s:=b;
end;

procedure Add(p1,p2:pBigNumber);
var
  poz:shortint;
  maxp:shortint;
  minp:shortint;
  rest:longint;
  new_rest:longint;
  ret,p3:pBigNumber;
begin
  ret:=p1;
  maxp:=max_s(p1^[0],p2^[0]);
  minp:=min_s(p1^[0],p2^[0]);
  rest:=0;
  for poz:=1 to minp do
    begin
      new_rest:=(rest+p1^[poz]+p2^[poz]) DIV MODULO;
      ret^[poz]:=(rest+p1^[poz]+p2^[poz]) MOD MODULO;
      rest:=new_rest;
    end;
  if p1^[0]<p2^[0] then
    begin
      p3:=p1;
      p1:=p2;
      p2:=p3;
    end;
  {p1^[0]>p2^[0]}
  for poz:=minp+1 to maxp do
    begin
      new_rest:=(rest+p1^[poz]) DIV MODULO;
      ret^[poz]:=(rest+p1^[poz]) MOD MODULO;
      rest:=new_rest;
    end;
  ret^[0]:=maxp;
  while rest<>0 do
    begin
      inc(ret^[0]);
      ret^[p1^[0]]:=rest mod MODULO;
      rest:=rest div MODULO;
    end;
end;

procedure PrintNumber(p:pBigNumber);
var
  s:string;
  i,poz:longint;
begin
  Str(p^[p^[0]],s);
  write(fout,s);
  for poz:=p^[0]-1 downto 1 do
    begin
      Str(p^[poz]:NCifre,s);
      i:=1;
      while S[i]=' ' do
        begin
          s[i]:='0';
          inc(i);
        end;
      write(fout,s);
    end;
  writeln(fout);
end;

procedure write_sol(sol:pBigNumber);
begin
  assign(fout,sout);
  rewrite(fout);
  PrintNumber(sol);
  close(fout);
end;

procedure comp_data;
var
  IndexN,IndexP:shortint;
  current,last:shortint;
  BigNumber:TBigNumber;
begin
  for IndexN:=k to n do
    begin
      current:=IndexN mod 2;
      last:=1 - current;
      fillchar(l[current]^,sizeof(l[current]^),0);
      for IndexP:=k to min_s(IndexN,p) do
        begin
          if IndexN=IndexP then
            InitBigNumber(@l[current]^[IndexP],1)
          else
            if IndexP<K then
            else
              begin
                 l[current]^[IndexP]:=l[last]^[IndexP-1];
                 BigNumber:=l[last]^[IndexP];
                 Multiply(@BigNumber,IndexP);
                 Add(@l[current]^[IndexP],@BigNumber);
              end;
        end;
    end;
  write_sol(@l[current]^[P]);
end;

begin
  read_data;
  comp_data;
  halt(0);
end.