 #include <stdio.h>
 #include <string.h>
 #define MAX 5001
 #define prime_cnt 25

 int n, k, p, mprim[30];
 int prime[25] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53,
		  59, 61, 67, 71, 73, 79, 83, 89, 97};
 typedef int vect[MAX];
 vect rez, dr;

 int bnummult(vect &a, int b)
 { int i, carry;
   for (i=1;i<=a[0];i++)
     a[i] = a[i] * b;
   for (i=1, carry=0;i<=a[0]+1;i++)
     { a[i] += carry;
       if (a[i]>9)
	{ carry = a[i] / 10;
	  a[i] = a[i] % 10;
	}
     }
   if (a[a[0]+1])
     a[0] = a[0]+1;
   return 0;
 }

 int calc_comb(int n, int k)
 { int i, j, t;
   if (n==k) return 0;
   if (!k) return 0;
   memset(mprim, 0, sizeof mprim);
   for (i=2;i<=k;i++)
     for (j=0;j<prime_cnt&&prime[j]<=i;j++)
       if (!(i%prime[j])) mprim[j]++;
   for (i=n-k+1;i<=n;i++)
     { t=i;
       for (j=0;j<prime_cnt&&prime[j]<=t;j++)
	if (mprim[j]&&(t%prime[j]==0))
	 { mprim[j]--;
	   t /= prime[j];
	 }
       bnummult(rez, t);
     }
   return 0;
 }

 int bigdif(vect &a, vect b)
 { int i, t;
   for (i=1;i<=b[0];i++)
     { a[i] -= b[i];
       if (a[i]<0)
	 { a[i+1]--;
	   if (a[i+1]<0) a[i+1] += 10;
	   a[i] += 10;
	 }
     }
   if (!a[a[0]]) a[0]--;
   return 0;
 }

 int main()
 { int i;
   FILE *fi=fopen("ex.in", "rt");
   fscanf(fi, "%d %d %d", &n, &k, &p);
   fclose(fi);
   memset(rez, 0,sizeof rez);
   rez[0]=1;
   rez[1]=1;
   calc_comb(n-k, p-k);
   for (i=1;i<=n-p;i++)
     bnummult(rez, p);
   if ((p>k)&&(n>p))
     { dr[0] = 1;
       dr[1] = 1;
       for (i=1;i<=n-p;i++)
	 bnummult(dr, p-k);
       bigdif(rez, dr);
     }
   FILE *fo=fopen("ex.out", "wt");
   for (i=rez[0];i>=1;i--)
     fprintf(fo, "%d", rez[i]);
   fprintf(fo, "\n");
   fclose(fo);
   return 0;
 }