#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define fi "robot.in"
#define fo "robot.out"
#define NMAX 10010
#define pi 3.1514
int n;
double *u,x,y,*l,lmax;

void load()
{
FILE *f;
int i;
f=fopen(fi,"r");
fscanf(f,"%d",&n);
l=(double*)calloc(n+1,sizeof(double));
u=(double*)calloc(n+1,sizeof(double));
for(i=0;i<n;i++)
 { fscanf(f,"%lf",&l[i]);lmax+=l[i];}
fscanf(f,"%lf %lf",&x,&y);
fclose(f);
}

void go()
{
FILE *f;
int i;
double xx,deltax,deltay,alfa,lc;
f=fopen(fo,"w");
if ((lc=sqrt(x*x+y*y))>lmax) fprintf(f,"0\n");
else
  if (abs(sqrt(x*x+y*y)-lmax)<=0.001)
    {
      if (!x) xx=90;
      else xx=atan2(y,x)*180/pi;
      if (xx<0) xx=360-xx;
      for(i=0;i<n;i++)
	  fprintf(f,"%.4lf",xx);
    }
 else
   {
    alfa=atan2(y,x);
    deltax=(lmax-lc)*cos(alfa);
    deltay=(lmax-lc)*sin(alfa);
    for(i=0;(i<n) && (deltax);i++)
      if(deltax-2*l[i]>=0)
	  {
	    deltax-=2*l[i];
	    deltay+=sin(2*pi-alfa)*l[i];
	    u[i]=-alfa;
	  }
      else
       if (deltax-l[i]>=0)
	   {
	     u[i]=asin((deltax-l[i])/l[i]);
	     deltax-=asin((deltax-l[i])/l[i])*l[i];
	     deltay+=sin(u[i])*l[i];
	   }
       else {
	    u[i]=acos((deltax)/l[i]);
	    xx=cos(u[i])*l[i];
	    deltax-=xx;
	    deltay+=sin(u[i])*l[i];
	    }
    for(i=0;(i<n) && (deltay);i++)
      if (!u[i])
      {
       if(deltay-2*l[i]>0)
	    {
	      deltay-=2*l[i];
	      u[i]=-alfa;
	    }
      else
       if (deltay-l[i]>0)
	  {
	   u[i]=asin(-deltay/l[i]);
	   deltay-=l[i]*sin(alfa);
	  }
	    else {
	      deltay=0;
	      u[i]=asin(-deltay/l[i]);
	      }
      }

     if ((deltax!=0) || (deltay!=0)) fprintf(f,"0\n");
     else
     { if (!u[0]) u[0]=alfa;
      xx=u[0]*180/pi;
      if (xx<0) xx=360-xx;
      fprintf(f,"%.4lf\n",xx);
      for(i=1;i<n;i++)
       {
	 if (!u[i]) u[i]=alfa;
	 xx=u[i]-u[i-1];
	 xx=xx*180/pi;
	 if (xx<0)
	    { xx=360-xx;
	      if (xx<0) xx=-xx;
	    }
       if (xx>360) while (xx>360) xx-=360;
	 fprintf(f,"%.4lf\n",xx);
       }
   }
   }
fclose(f);
}


int main()
{
load();
go();
return 0;
}