{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

Type PTomb = ^TTomb;
     TTomb = Array[1..10000] Of Real;

Var N: Word;
    Karok: TTomb;
    Left : PTomb;
    DestX, DestY: LongInt;
    DestD, Dist: Real;
    HSave: Pointer;
    IsSol: Boolean;

    OXAngle, InAngle: Real;
    KarValt: Word;

Procedure Init;
Var F: Text;
    I: Word;
Begin
Mark(HSave);
Assign(F, 'robot.in');
Reset(F);
ReadLn(F, N);

For I:=1 To N Do
    ReadLn(F, Karok[I]);

ReadLn(F, DestX, DestY);
Close(F);
End;

Function RadToDeg(A: Real): Real;
Begin
While A<0 Do
      A:=A+2*Pi;
RadToDeg:=A*180/Pi;
End;

Function Sgn(A: Real): ShortInt;
Begin
If A<0 Then Sgn:=-1
       Else Sgn:=+1;
End;

Function Szog(X1, Y1, X2, Y2: Real): Real;
Var DX, DY, T: Real;
Begin
DX:=X2-X1;
DY:=Y2-Y1;
If DX<>0 Then Begin
              T:=ArcTan(DY/DX);
              If Sgn(DX)=-1 Then T:=T+Pi;
              If T<0 Then T:=T+2*Pi;
              End
         Else T:=Pi/2+(1-Sgn(DY))*Pi/2;
End;

Function ArcCos(X: Real): Real;
Begin
If X<>0 Then ArcCos:=ArcTan(Sqrt(1-X*X)/X)
        Else ArcCos:=Pi/2;
End;

Procedure Main;
Var I: Word;
Begin
IsSol:=True;

GetMem(Left,  (N-1)*4);
Left^[1]:=Karok[1];
For I:=2 To N-1 Do
    Left^[I]:=Left^[I-1]+Karok[I];


DestD:=Sqrt(DestX*DestX+DestY*DestY);
Dist:=Left^[N-1]+Karok[N];
If DestD>Dist Then IsSol:=False
   Else Begin
        If DestD=Dist Then Begin
                           OXAngle:=RadToDeg(Szog(0, 0, DestX, DestY));
                           InAngle:=0;
                           KarValt:=1;
                           End
        Else Begin
             I:=1;
             While ((Left^[I]+DestD<Dist-Left^[I]) Or
                   (Dist-Left^[I]+DestD<Left^[I])) And (I<N) Do Inc(I);
             If I>=N Then IsSol:=False
                     Else Begin
                          KarValt:=I;
                          InAngle:= DestD*DestD-Left^[I]*Left^[I]-
                                    (Dist-Left^[I])*(Dist-Left^[I]);
                          InAngle:=Abs(InAngle/(2*Left^[I]*(Dist-Left^[I])));
                          InAngle:=Pi-ArcCos(InAngle);
                          OXAngle:= (Dist-Left^[I])*(Dist-Left^[I])-
                                    DestD*DestD-Left^[I]*Left^[I];
                          OXAngle:=Abs(OXAngle/(2*Left^[I]*DestD))+Szog(0, 0, DestX, DestY);
                          OXAngle:=ArcCos(OXAngle);

If ((Abs(Cos(OXAngle)*Left^[I]+Cos(OXAngle+InAngle)*(Dist-Left^[I])-DestX))>0.001)
Or ((Abs(Sin(OXAngle)*Left^[I]+Sin(OXAngle+InAngle)*(Dist-Left^[I])-DestY))>0.001)
   Then InAngle:=-InAngle;

   If ((Abs(Cos(OXAngle)*Left^[I]+Cos(OXAngle+InAngle)*(Dist-Left^[I])-DestX))>0.001)
Or ((Abs(Sin(OXAngle)*Left^[I]+Sin(OXAngle+InAngle)*(Dist-Left^[I])-DestY))>0.001)
   Then OXAngle:=-OXAngle;

If ((Abs(Cos(OXAngle)*Left^[I]+Cos(OXAngle+InAngle)*(Dist-Left^[I])-DestX))>0.001)
Or ((Abs(Sin(OXAngle)*Left^[I]+Sin(OXAngle+InAngle)*(Dist-Left^[I])-DestY))>0.001)
   Then InAngle:=-InAngle;

                          InAngle:=RadToDeg(InAngle);
                          OXAngle:=RadToDeg(OXAngle);
                          End;
             End;
        End;
End;

Procedure Done;
Var F: Text;
    I: Word;
Begin
Assign(F, 'robot.out');
ReWrite(F);
If IsSol Then Begin
              WriteLn(F, OXAngle:0:10);
              For I:=1 To KarValt-1 Do
                  WriteLn(F, '0');
              WriteLn(F, InAngle:0:10);
              For I:=KarValt+1 To N-1 Do
                  WriteLn(F, '0');
              End
         Else WriteLn(F, '0');
Close(F);
Release(HSave);
End;

Begin
Init;
Main;
Done;
End.
