program telegraf;
type vec=array[1..37]of longint;
     tree=^elem;
     elem=record
       inf:integer;
       fv:longint;
       s,d:tree;
       end;
var f:vec;
    c:array[1..100]of integer;
    t:array[1..100]of tree;
    dc:integer;

procedure readdata;
var fi:text; i:integer; ff:longint;
begin
  assign(fi,'telegraf.in');reset(fi);
  dc:=0;
  for i:=1 to 36 do
  begin
    read(fi,ff);
    if ff>0 then
    begin
      inc(dc);
      f[dc]:=ff;
    end;
  end;
  close(fi);
  for i:=1 to dc do
  begin
    new(t[i]);
    t[i]^.inf:=0;
    t[i]^.fv:=f[i];
    t[i]^.s:=nil;
    t[i]^.d:=nil;
  end;
end;

procedure sift(k:integer;n:integer);
var p:integer; tt:tree; fv:longint;
begin
  while(k<=n div 2) do
  begin
    if f[k]>f[2*k] then p:=2*k else p:=k;
    if 2*k+1<=n then
      if f[p]>f[2*k+1] then p:=2*k+1;
    if p<>k then
    begin
      fv:=f[k]; f[k]:=f[p]; f[p]:=fv;
      tt:=t[k]; t[k]:=t[p]; t[p]:=tt;
      k:=p;
    end
    else k:=n+1;
  end;
end;

function cost(t:tree;cs:integer):longint;
begin
  if t^.s=nil then cost:=cs*t^.fv
  else cost:=cost(t^.s,cs+2)+cost(t^.d,cs+1);
end;

procedure solve;
var i:integer; ct:longint; t1,t2,tt:tree; fo:text;
begin
  for i:=(dc div 2) downto 1 do sift(i,dc);
  while(dc>1)do
  begin
    t1:=t[1];
    c[1]:=c[dc]; f[1]:=f[dc]; t[1]:=t[dc];
    sift(1,dc-1);
    dec(dc);
    t2:=t[1];
    new(tt);
    tt^.inf:=0;
    t2^.inf:=2;
    t1^.inf:=1;
    tt^.s:=t1;
    tt^.d:=t2;
    t[1]:=tt;
    f[1]:=2*t1^.fv+t2^.fv;
    tt^.fv:=f[1];
    sift(1,dc);
  end;
  ct:=cost(t[1],0);
  assign(fo,'telegraf.out');rewrite(fo);
  writeln(fo,ct);
  close(fo);
end;

begin
  readdata;
  solve;
end.