#include <stdio.h>
#include <stdlib.h>

#define	MAXS		36

int nh, ns = 0;
long sm = 0x7FFFFFFF;
long fs[MAXS], ss[MAXS], a[MAXS];

int int_cmp_fn( const void *pa, const void *pb )
{
	return -(((int*)pa)[0]-((int*)pb)[0]);
}

int main( )
{
	int i, j, k;

	freopen( "telegraf.in", "r", stdin );
	for( i = 0 ; i < MAXS ; i++ )
		scanf( "%ld", &fs[i] );
	fclose( stdin );

	for( i = 0 ; i < MAXS ; i++ )
		if( fs[i] )
			ss[ns++] = fs[i];
	qsort( ss, ns, sizeof( ss[0] ), int_cmp_fn );

	a[0] = 1;
	a[1] = 2;
	sm = ss[0]+2*ss[1];
	for( i = 2 ; i < ns ; i++ )
	{
		k = 0;
		for( j = 1 ; j < i ; j++ )
			if( ((a[j]+2)*ss[i]+ss[j]) < ((a[k]+2)*ss[i]+ss[k]) )
				k = j;

		a[k]++;
		a[i] = a[k]+1;
		sm += (a[i]*ss[i]+ss[k]);
	}

	freopen( "telegraf.out", "w", stdout );
	printf( "%ld\n", sm );
	fclose( stdout );
	return 0;
}
