
//	#define TESTING

	#include <stdio.h>
	#include <string.h>
	#include <stdlib.h>

	#define MAXN	40
	#define MAXL  1000

int n;
char *W[MAXN];
long ap[MAXN], sol, cost[MAXN];

void m_read()
{
	FILE *f=fopen("telegraf.in", "rt");

	int i;
	long t;

	for (i=0; i<36; i++)
		{
			fscanf(f, "%ld", &t);
			if (t)
				{
					ap[n]=t;
					W[n]=(char *)malloc(MAXL+1);
					n++;
				}
		}

	fclose(f);
}

#define a	*(int *)_a
#define b	*(int *)_b

int sf(const void *_a, const void *_b)
{
	if (a>b) return -1;
	else
		if (a<b) return 1;
		else return 0;
}

#undef b
#undef a

void m_solve()
{
	qsort((void *)ap, n, sizeof(ap[0]), sf);

	strcpy(W[0], "."); cost[0]=1;
	strcpy(W[1], "-"); cost[1]=2;

	int i, minj, j;
	long min;

	for (i=2; i<n; i++)
		{
			minj=-1; min=100;

			for (j=0; j<i; j++)
				{
					if (  (minj<0) || ( min > (cost[j]+1)*ap[j]+(cost[j]+2)*ap[i]))
						{
							min = (cost[j]+1)*ap[j]+(cost[j]+2)*ap[i];
							minj=j;
						}
				}

			cost[minj]+=1;
			cost[i]=cost[minj]+1;

			strcpy(W[i], W[minj]);
			strcat(W[minj], ".");
			strcat(W[i], "-");
		}

	// solutie
	sol=0;
	for (i=0; i<n; i++)
		sol+=ap[i]*cost[i];
}

void m_write()
{
	#ifdef TESTING
		FILE *f=stdout;
	#else
		FILE *f=fopen("telegraf.out", "w");
	#endif

	fprintf(f, "%ld\n", sol);

	fclose(f);
}

void m_free()
{
	int i;
	for(i=0; i<n; i++)
		free(W[i]);
}

int main(void)
{
	m_read();
	m_solve();
	m_write();

	m_free();

	return 0;
}
