
#include <fstream.h>
#include <stdlib.h>

void read();
void solve();
void write();

int main()
{
	read();
	solve();
	write();
	return (0);
}

#define MAXN 102
#define MAXL 200
int N, K, P, no_empty, no_free;

ofstream out("ex.out");


void read()
{
	ifstream in("ex.in");
	in>>N>>K>>P;
	in.close();
}

void end(long x)
{
	out<<x<<'\n';
	out.close();
	exit(0);
}

void Filtru()
{
	if(N<P) end(0);
	if(K>P) end(0);
	if(N==P || P==1) end(1);
}

int stiva[MAXN];
struct big{
				int num[MAXL+5], len;
			 };

void transf(int x, big &n)
{
	n.len=MAXL+1;
	if(x==0)n.num[--n.len]=0;
	else
	 {
		while(x)
		 {
			n.num[--n.len]=x%10;
			x=x/10;
		 }
	 }
}

void inmult(big x, big y, big &r)
{
	int i, j, cifra, rest, aux, poz;

	for(i=0;i<=MAXL;i++)r.num[i]=0;
	r.len=MAXL+1;

	for(j=MAXL;j>=y.len;j--)
	 if(y.num[j])
	 {
			cifra=y.num[j];
			poz=j;
			rest=0;

			for(i=MAXL;i>=x.len;i--)
				{
				 aux=r.num[poz]+rest+cifra*x.num[i];
				 r.num[poz--]=aux%10;
				 rest=aux/10;
				}

			if(rest)r.num[poz--]+=rest;
			poz++; if(r.len>poz)r.len=poz;
	 }
}

int cmmdc(int a, int b)
{
	if(b==0)return (a);
	else return cmmdc(b, a%b);
}

void copii(big x, big &y)
{
	int i;
	for(i=x.len;i<=MAXL;i++)
	 y.num[i]=x.num[i];
	y.len=x.len;
}

void adun(big x, big &y)
{
	int i;
	if(x.len<y.len){ y.len=x.len; for(i=y.len-1;i>=x.len-1;i--)y.num[i]=0;}

	for(i=MAXL;i>=x.len;i--)
	 {
		 y.num[i]+=x.num[i];
		 int q=i;

		 while(y.num[q]>9)
			 {
				y.num[q]=y.num[q]%10;
				y.num[--q]++;
			 }
		if(q<y.len)y.len=q;
	 }
}

void output(big x)
{
	int i;
	for(i=x.len;i<=MAXL;i++)
	 out<<x.num[i];
	out<<'\n';
}

void outpute(big x)
{
	int i;
	for(i=x.len;i<=MAXL;i++)
	 cout<<x.num[i];
	cout<<'\n';
}

void comb(int n, int k, big &r)
//combinari de n luate cate k
{
 if(k==0 || n==k){ transf(1, r); return ;}
 int vec[MAXN], i, max, min, j, aux, x, pp;

 if(k>n/2){ max=k; min=n-k; }
 else { max=n-k; min=k; }
 pp=min;

 for(i=max+1;i<=n;i++)vec[i-max]=i;

 for(j=2;j<=min;j++)
	{
	 x=j;
	 for(i=1;i<=pp;i++)
		{
		 aux=cmmdc(vec[i], x);
		 vec[i]=vec[i]/aux;
		 x=x/aux;
		 if(vec[i]==1)vec[i]=vec[pp--];
		 if(x==1)break;
		}
	}
 big nx, ny;

 for(i=0;i<=MAXL;i++){ ny.num[i]=0; nx.num[i]=0;}

 ny.len=MAXL; nx.len=MAXL;
 ny.num[ny.len]=1;

 for(i=1;i<=pp;i++)
	{
		transf(vec[i], nx);
		inmult(nx, ny, r);
		copii(r, ny);
	}
}

big _n_, nx, ny, sol;
int ii;

void go(int nivel, int sum)
{
	if(nivel==no_empty+1)
		{
		 int i, yupy=no_free-no_empty;
		 transf(0, _n_);
		 comb(no_free, ii, _n_);

		 for(i=1;i<=no_empty;i++)
			{
				comb(yupy, stiva[i]-1, nx);
				yupy-=(stiva[i]-1);

				inmult(nx, _n_, ny);
				copii(ny, _n_);
			 //	outpute(nx); outpute(_n_);
			}

		 if(yupy && K!=1)
			 {
				transf(yupy*K, nx);
				inmult(_n_, nx, ny);
				adun(ny, sol);
				//outpute(sol);
			 }
		 else adun(_n_, sol);

		}
	else
	 {
		int i;

		for(i=1;i<=stiva[nivel-1];i++)
		 if(sum-i>=no_empty-nivel)//##### Atentie aici!!
			{
			 stiva[nivel]=i;
			 ii+=i;
			 go(nivel+1, sum-stiva[nivel]);
			 ii-=i;
			}
		 else break;
	 }
}

int gigi[MAXN], viz[MAXN];

void bkt(int nivel)
{
	int i;
	if(nivel==no_empty+1)
		{
		 int  nr=0, go__;
		 for(i=1;i<=no_free;i++)
			{
			 nr+=viz[i];

			 if(viz[i]==0)
				 {
					go__=(nr+K);
					transf(go__, nx);
					adun(nx, sol);
				 }
			}
		}
	else
	 {
		 for(i=gigi[nivel-1];;i++)
			{
			 if(no_free-i<no_empty-nivel)break;

			 if(viz[i]==0)
				 {
					gigi[nivel]=i;
					viz[i]=1;
					bkt(nivel+1);
					viz[i]=0;
				 }
			}
   }
}

//#define TEST

int e_bine()
{
	big h;
	comb(no_free, no_empty, h);
	return (MAXL-h.len<5);
}

void solve()
{
	#ifdef TEST
		big kk;
		comb(100, 50, kk);
		output(kk);
	#endif

	Filtru();

	no_empty=P-K;
	no_free=N-K;
	//no_free-=no_empty;

	transf(0, sol);

	if(no_empty)
	 {
		if(e_bine())
		 {
			gigi[0]=1;
			bkt(1);
		 }
		else
		 {
			stiva[0]=no_free-no_empty+1;
			go(1, no_free);
		 }
	 }
	else
	 {
		end(no_free*K);
	 }
}

void write()
{
 output(sol);
 out.close();
}

