#include <fstream.h>
#include <math.h>

ifstream in("robot.in");
ofstream out("robot.out");

#if !defined(__BORLANDC__)
#define MAX 10004
#else
#define MAX 3003
#endif


#define P_I 3.14159275

int N;

int l[MAX];
double c[MAX];
double g[MAX];

double X,Y;
double T;

int main()
 {
  in>>N;
  int i;
  for(i=0;i<N;i++) in>>l[i];
  in>>X>>Y;
  T=sqrt(X*X+Y*Y);
  double D;
  D=l[0];
  c[0]=l[0];
  for(i=1;i<N;i++)
    {D+=l[i];c[i]=l[i];}
  for(i=N-1;i>0;i--)
   {
    D-=l[i];
    double mn;
    if(D>=l[i]) mn=-l[i];
    else mn=l[i]-2*D;
    if(D+mn>T)
     {
      D+=mn;
      if(mn!=-l[i])
       {
	out<<0<<"\n";
	return 0;
       }
      else
       c[i]=mn;
     }
    else
     {
      c[i]=T-D;
      break;
     }
   }
   if(D>T) {out<<0<<"\n";return 0;}
   g[0]=0;
   D=c[0];
   i=1;
   double orient=0;
   while(c[i]==l[i])
    {
     g[i]=0;
     D+=c[i];
     i++;
     if(i==N) break;
    }
   if(i!=N)
    {
     if(c[i]==-l[i])
      {
       g[i]=180;
       D+=c[i];
       i++;
      }
     else
      {
       double d1=D;
       double d2=D+c[i];
       double d3=l[i];
       double cs1=-((double)d2*d2-d1*d1-d3*d3)/(2.*d1*d2);
       double cs2=-((double)d1*d1-d2*d2-d3*d3)/(2.*d2*d3);
       double cs3=-((double)d3*d3-d1*d1-d2*d2)/(2.*d1*d2);
       double un1=acos(cs1);
       double un2=acos(cs2);
       orient=acos(cs3);
       g[i]=P_I-un1;
       g[i]=(g[i]/(2*P_I))*360;
       i++;
       if(i<N)
	{
	 g[i]=P_I-un2;
	 g[i]=(g[i]/(2*P_I))*360;
	 i++;
	}
      }
     while(i<N)
      {
       g[i]=0;
       D+=c[i];
       i++;
      }
    }
   double oc = Y/T;
   g[0]=oc-orient;
   if(g[0]<0) g[0]+=2*P_I;
   g[0]=(g[0]/(2*P_I))*360;

   for(i=0;i<N;i++)
    {
    unsigned long pm=g[i];
    out<<pm<<".";
    pm=(long)((g[i]-pm)*100000L);
    if(pm<10000) out<<0;
    if(pm<1000) out<<0;
    if(pm<100) out<<0;
    if(pm<10) out<<0;
    out<<pm;
    out<<"\n";
    }
   return 0;
 }