{$M 64000,0,655360}
program ex;
type vect = array[0..100] of longint;
var n,k,p : byte;
    config : longint;
    h : array[0..100] of longint;
    d : array[0..100,0..100] of longint;
    c : array[0..100] of ^vect;

procedure Init;
var i,j : byte;
begin
     for i:=0 to 100 do begin
         new(c[i]);
         for j:=0 to 100 do c[i]^[j]:=0;
     end;
end;

procedure ReadData;
var f : text;
begin
     assign(f,'ex.in'); reset(f);
     readln(f,n,k,p);
     close(f);
end;

function Comb(nn,pp:byte):longint;
var i : byte;
    r,rr : longint;
begin
     if pp>nn then Comb:=0
     else begin
         if c[nn]^[pp]=0 then begin
            if ((nn>0) and (pp=0)) or (nn=pp) then c[nn]^[pp]:=1
            else
                c[nn]^[pp]:=((nn-pp+1) div pp)*Comb(nn,pp-1);
         end;
         Comb:=c[nn]^[pp];
     end;
end;

function Dgd(z,rst:byte):longint;
var i : byte;
    m : longint;
begin
     if z<rst then Dgd:=0
     else
         if (z=rst) or (rst=1) then Dgd:=1
         else begin
              if d[z,rst]=0 then begin
                 for i:=1 to ((z-rst+1) div 2) do begin
                     m:=Comb(z,i-1)*Dgd(z-i,rst-1);
                     d[z,rst]:=d[z,rst]+m;
                 end;
              end;
              Dgd:=d[z,rst];
         end;
end;

function Hgh(z:byte):longint;
begin
     if h[z]=0 then begin
        h[z]:=k*Hgh(z-1);
        Hgh:=h[z];
     end
     else Hgh:=h[z];
end;

procedure Calcul;
var i : byte;
    cfg : longint;
begin
     h[0]:=1;
     for i:=p-k to n-k do begin
         cfg:=Comb(n-k,i)*Dgd(i,p-k)*Hgh(n-k-i);
         config:=config+cfg;
     end;
end;

procedure WriteData;
var f : text;
begin
     assign(f,'ex.out'); rewrite(f);
     writeln(f,config);
     close(f);
end;

begin
     Init;
     ReadData;
     Calcul;
     WriteData;
end.