program telegraf;
var ap,cm : array[1..36] of longint;
    nn : byte;
    nr : longint;

procedure ReadData;
var f : text;
    i : byte;
begin
     assign(f,'telegraf.in'); reset(f);
     nn:=0;
     for i:=1 to 36 do begin
         read(f,ap[i]);
         if ap[i]>0 then nn:=nn+1;
     end;
     readln(f);
     close(f);
end;

procedure FindCM(nn:byte);
var i,j : integer;
    aux : longint;
begin
     cm[1]:=nn-1;
     cm[nn]:=2;
     for i:=nn-1 downto 2 do cm[i]:=cm[i+1]+1;
     for i:=1 to nn-1 do
         for j:=i+1 to nn do
             if cm[i]>cm[j] then begin
                aux:=cm[i]; cm[i]:=cm[j]; cm[j]:=aux;
             end;
end;

procedure SortAp(nn:byte);
var i,j : integer;
    aux : longint;
begin
     for i:=1 to nn-1 do
         for j:=i+1 to nn do
             if ap[i]<ap[j] then begin
                aux:=ap[i]; ap[i]:=ap[j]; ap[j]:=aux;
             end;
end;

procedure GetNr;
var i : byte;
    w : longint;
begin
     nr:=0;
     for i:=1 to nn do begin
         w:=ap[i]*cm[i];
         nr:=nr+w;
     end;
end;

procedure WriteData;
var f : text;
begin
     assign(f,'telegraf.out'); rewrite(f);
     writeln(f,nr);
     close(f);
end;

begin
     ReadData;
     FindCM(nn);
     SortAp(nn);
     GetNr;
     WriteData;
end.