#include <fstream.h>
#define dim1 101
#define dim2 161

int n, k, p, ni, ki, pi, vec[dim2],
    mat1[dim1][dim1][dim2], mat2[dim1][dim1][dim2];

void readinput()
{
    ifstream in("ex.in");
    in>>n>>k>>p;
    in.close();
}

void copy(int *v1, int *v2)
{ int i;
    for(i=0; i<=v2[0]; i++) v1[i]=v2[i];
}

void inm(int *v, int val)
{ int i, t=0;

    for(i=1; i<=v[0]; i++)
       {
	   v[i]=v[i]*val+t;
	   if(v[i]>9)
	      {
		  t=v[i]/10;
		  v[i]%=10;
	      }
	   else t=0;
       }
    while(t)
       {
	   v[++v[0]]=t%10;
	   t/=10;
       }
}

void add(int *v1, int *v2)
{ int i, t=0, max;

    if(v1[0]>v2[0])
       {
	   max=v1[0];
	   for(i=v2[0]+1; i<=v1[0]; i++) v2[i]=0;
       }
    else
       {
	   max=v2[0];
	   for(i=v1[0]+1; i<=v2[0]; i++) v1[i]=0;
       }
    v1[0]=max;
    for(i=1; i<=max; i++)
       {
	   v1[i]+=v2[i]+t;
	   if(v1[i]>9)
	      {
		  t=v1[i]/10;
		  v1[i]%=10;
	      }
	   else t=0;
       }
    if(t) v1[++v1[0]]=1;
}

void go()
{
    mat1[1][1][0]=mat1[1][1][1]=1;
    for(ni=2; ni<=n; ni++)
       {
	   for(ki=1; ki<=k; ki++)
	      for(pi=ki; pi<=p; pi++)
		  {
		      copy(vec, mat1[ki][pi]);
		      inm(vec, pi);
		      copy(mat2[ki][pi], vec);
		      add(mat2[ki][pi], mat1[ki][pi-1]);
		  }
	   mat2[ni][ni][0]=mat2[ni][ni][1]=1;
	   for(ki=0; ki<dim2; ki++) vec[ki]=0;
	   for(ki=0; ki<=k; ki++)
	      for(pi=0; pi<=p; pi++)
		 {
		     copy(mat1[ki][pi], mat2[ki][pi]);
		     copy(mat2[ki][pi], vec);
		 }
       }
}

void writeoutput()
{ int i;
    ofstream out("ex.out");
    for(i=mat1[k][p][0]; i>=1; i--)
       out<<mat1[k][p][i];
    out<<endl;
    out.close();
}

int main()
{
    readinput();
    go();
    writeoutput();
    return 0;
}
