#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

ifstream in("ex.in");
ofstream out("ex.out");

#define MAXN 110
#define MAXK 110
#define MAXP 110

/*int slv[MAXN][MAXK][MAXP];

int solve(int n,int k,int p);
int rsolve(int n,int k,int p)
{
	//out<<"solve("<<n<<','<<k<<','<<p<<")\n";
	if (p==0) return 0;
	if (n==k)
		if (p==k)
			return 1;else return 0;
	if (n==p) return 1;
	return solve(n-1,k,p-1)+solve(n-1,k,p)*p;
	return 0;
}

int solve(int n,int k,int p)
{
	if (slv[n][k][p]>0)
		return slv[n][k][p];
	else
		return slv[n][k][p]=rsolve(n,k,p);
}*/

#define MAXC 50

struct vlint
{
	short v[MAXC];
	inline short&operator[](int i){return v[i];}
	inline const short&operator[](int i) const {return v[i];}
	vlint(){};
	vlint(int x);
};

vlint::vlint(int x)
{
	for (int i=0;i<MAXC;i++)
	{
		v[i]=x%10000;
		x=x/10000;
	}
}

void operator*=(vlint &v,int x)
{
	int t=0;
	for (int i=0;i<MAXC;i++)
	{
		t+=x*v[i];
		v[i]=t%10000;
		t=t/10000;
	}
	if (t) out<<"OVERFLOW\n";
}

void operator+=(vlint &a,const vlint& b)
{
	int t=0;
	for (int i=0;i<MAXC;i++)
	{
		t+=a[i]+b[i];
		a[i]=t%10000;
		t=t/10000;
	}
	if (t) out<<"OVERFLOW\n";
}

ostream& operator<<(ostream &os,const vlint &a)
{
	int i=MAXC-1;
	for (i=MAXC-1;a[i]==0&&i>0;i--);
	out<<a[i];
	for (i--;i>=0;i--)
		os<<setw(4)<<setfill('0')<<a[i];
	return os;
}

vlint solve1337(int n,int k,int p)
{
	vlint val[MAXP];
	int i,j;
	for (i=0;i<MAXP;i++) val[i]=0;
	for (i=1;i<=n;i++)
		for (j=p;j>0;j--)
		{
			if (j==0) {val[j]=0;continue;}
			if (i==k) {if (j==k) val[j]=1;else val[j]=0;continue;}
			if (i==j) {val[j]=1;continue;}
			val[j]*=j;
			val[j]+=val[j-1];
		}
	return val[p];
}

/*int stack[MAXN],n,sol,p;

void backsolve(int lev,int bst)
{
	if (lev==n)
	{
		if (bst!=p) return;
		//for (int i=0;i<n;i++) out<<stack[i]<<' ';out<<'\n';
		sol++;
		return;
	}
	// (n-lev<p-bst) return;
	for (stack[lev]=0;stack[lev]<bst;stack[lev]++)	
		backsolve(lev+1,bst);
	if (bst>=p) return;
	stack[lev]=bst;
	backsolve(lev+1,bst+1);
}

int bcksolve(int _n,int k,int _p)
{
	n=_n;p=_p;
	for (int i=0;i<k;i++) stack[i]=i;
	sol=0;
	backsolve(k,k);
	return sol;
}*/

int main()
{
	int n,k,p;
	/*for (int i=0;i<MAXN;i++)
		for (int j=0;j<MAXK;j++)
			for (int q=0;q<MAXP;q++)
				slv[i][j][q]=-1;*/
	in>>n>>k>>p;
	out<<solve1337(n,k,p)<<'\n';
/*	for (int i=0;i<10000;i++)
	{
		k=rand()%100;
		p=rand()%100;
		n=rand()%100;
		if (k>p||p>n||k>n)
			continue;
		out<<solve1337(n,k,p)<<'\n';
	}*/
	return 0;
}

