#include <stdio.h>

#define INF 1666666666

int N, freq[100], cost[200], sum[200];

void read()
{
    FILE *f;
    int i;

    f = fopen("telegraf.in", "r");
    for (i = 0; i < 36; i++)
        fscanf(f, "%d", &freq[i]),
        sum[i] = freq[i];
    fclose(f);
}

void solve()
{
    int i, j, k;
    int mj, mk, min;

    for (i = 0; i < 36; i++)
        if (freq[i]) N++;

    for (i = 36; i < 35 + N; i++)
    {
        min = INF, mj = -1, mk = -1;
        
        for (j = 0; j < i; j++) if (sum[j])
        for (k = 0; k < i; k++) if (j != k && sum[k])
        if (cost[j] + sum[j] + cost[k] + 2 * sum[k] < min)
           min = cost[j] + sum[j] + cost[k] + 2 * sum[k],
           mj = j, mk = k;

        cost[i] = min;
        sum[i] = sum[mj] + sum[mk];
        sum[mj] = 0; sum[mk] = 0;
    }
}

void write()
{
    FILE *f;

    f = fopen("telegraf.out", "w");
    fprintf(f, "%d\n", cost[34 + N]);
    fclose(f);
}

int main()
{
    read();
    solve();
    write();
    return 0;
}
