#include <stdio.h>
#include <string.h>

#define input "ex.in"
#define output "ex.out"

void readdata(void);
void dfs(int k);

int n, g, p, ghid[128], oc = 0, s[128], sub[128];
unsigned long nrs = 0;

int main(void)
{
	int i;
	FILE *f;

	memset(ghid, 0, sizeof(ghid));
	memset(sub, 0, sizeof(sub));
	memset(s, 0, sizeof(s));

	readdata();

	for (i = 0; i < g; i++)
	{
		ghid[i] = 1;
		s[i] = 1;
		oc++;
	}

	if (n == p)
		nrs = 1;
	else
		dfs(g);

	f = fopen(output, "w");

	fprintf(f, "%lu\n", nrs);

	fclose(f);

	return 0;
}

void readdata(void)
{
	FILE *f;

	f = fopen(input, "r");

	fscanf(f, "%d %d %d", &n, &g, &p);

	fclose(f);
}

void dfs(int k)
{
	int i, flag, limit;

	if (k == n && oc == p)
		nrs++;
	if (k < n)
	{
		for (i = 0; i < p; i++)
		{
			if (sub[k - 1] > i && i >= g)
				continue;
			flag = s[i];
			s[i] = 1;
			if (!flag)
				oc++;
			sub[k] = i;
			if (nrs == 10 && oc == p)
            	printf("");
			dfs(k + 1);
			if (!flag)
			{
				s[i] = 0;
				oc--;
			}
		}
	}
}
