#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define LMAX 32000
#define NMAX 456
#define SUPERMARE 1000000

int cst[NMAX][NMAX];
int csd[NMAX][NMAX];
int stxv[LMAX+1];
int styv[LMAX+1];

int x[NMAX];
int y[NMAX];
int ox[NMAX];
int oy[NMAX];
int cx[NMAX];
int cy[NMAX];
int dx[NMAX-1];
int dy[NMAX-1];

int n,m,i,j,t,px,py;

int min(int a,int b)
{
	if (a<b) return a; else return b;
}

void init_mat(void)
{
	int i,j,poz;

	for (i=0;i<n;i++)
	for (j=0;j<n;j++)
		csd[i][j]=SUPERMARE;

	for (i=0;i<n;i++)
	{
		poz=0;
		for (j=0;j<n;j++) if (y[oy[j]]==y[ox[i]]) poz=j;
		csd[poz][i]=0;
	}

}

void do_max(void)
{
	int i,j;
	for (i=0;i<n;i++)
	for (j=0;j<n;j++)
	cst[i][j]=min(cst[i][j],csd[i][j]);
}



int main()
{

	FILE* f;
	FILE* g;
	int mt,stx,sty;

	f=fopen("ajutor.in","r");
        g=fopen("ajutor.out","w");

	fscanf(f,"%d %d",&n,&m);
	for (i=0;i<n;i++)
	{
		fscanf(f,"%d %d",&x[i],&y[i]);
	}

//preprocesare
	for (i=0;i<n;i++) {ox[i]=i;oy[i]=i;};

	for (i=0;i<n-1;i++)
	for (j=i+1;j<n;j++)
	if (x[ox[i]]>x[ox[j]])
	{
	 t = ox[i]; ox[i]=ox[j]; ox[j]=t;
	}

	for (i=0;i<n-1;i++)
	for (j=i+1;j<n;j++)
	if (y[oy[i]]>y[oy[j]])
	{
	 t = oy[i]; oy[i]=oy[j]; oy[j]=t;
	}

	for (i=0;i<n-1;i++) dx[i]=x[ox[i+1]]-x[ox[i]];
	for (i=0;i<n-1;i++) dy[i]=y[oy[i+1]]-y[oy[i]];

	for (i=0;i<n;i++)
	for (j=0;j<n;j++)
		cst[i][j]=SUPERMARE;

	for (i=0;i<n-1;i++) 
	    for (j=x[ox[i]];j<x[ox[i+1]];j++) stxv[j]=i;
	for (i=0;i<x[ox[0]];i++) stxv[i]=0;
	for (i=x[ox[n-1]];i<LMAX+1;i++) stxv[i]=n-2;


	for (i=0;i<n-1;i++) 
	    for (j=y[oy[i]];j<y[oy[i+1]];j++) styv[j]=i;
	for (i=0;i<y[oy[0]];i++) styv[i]=0;
	for (i=y[oy[n-1]];i<LMAX+1;i++) styv[i]=n-2;

//stanga sus
	init_mat();

	for (i=1;i<n;i++) csd[0][i]=min(csd[0][i],csd[0][i-1]+dx[i-1]);
	for (i=1;i<n;i++) csd[i][0]=min(csd[i][0],csd[i-1][0]+dy[i-1]);
	for (i=1;i<n;i++)
	for (j=1;j<n;j++)
		csd[i][j]=min(csd[i][j],min(csd[i-1][j]+dy[i-1],csd[i][j-1]+dx[j-1]));

	do_max();

//dreapta sus
	init_mat();

	for (i=n-2;i>=0;i--) csd[0][i]=min(csd[0][i],csd[0][i+1]+dx[i]);
	for (i=1;i<n;i++) csd[i][0]=min(csd[i][0],csd[i-1][0]+dy[i-1]);
	for (i=1;i<n;i++)
	for (j=n-2;j>=0;j--)
		csd[i][j]=min(csd[i][j],min(csd[i-1][j]+dy[i-1],csd[i][j+1]+dx[j]));

	do_max();

//stanga jos
	init_mat();

	for (i=1;i<n;i++) csd[0][i]=min(csd[0][i],csd[0][i-1]+dx[i-1]);
	for (i=n-2;i>=0;i--) csd[i][0]=min(csd[i][0],csd[i+1][0]+dy[i]);
	for (i=n-2;i>=0;i--)
	for (j=1;j<n;j++)
		csd[i][j]=min(csd[i][j],min(csd[i+1][j]+dy[i],csd[i][j-1]+dx[j-1]));

	do_max();

//dreapta jos
	init_mat();

	for (i=n-2;i>=0;i--) csd[0][i]=min(csd[0][i],csd[0][i+1]+dx[i]);
	for (i=n-2;i>=0;i--) csd[i][0]=min(csd[i][0],csd[i+1][0]+dy[i]);
	for (i=n-2;i>=0;i--)
	for (j=n-2;j>=0;j--)
		csd[i][j]=min(csd[i][j],min(csd[i+1][j]+dy[i],csd[i][j+1]+dx[j]));

	do_max();


/*	for (i=0;i<n;i++)
	{
		for (j=0;j<n;j++) printf(" %d",cst[i][j]);
		printf("\n");
	}*/


//query-uri
	for (i=0;i<m;i++)
	{
		fscanf(f,"%d %d",&px,&py);
/*		l1 = 0;l2 = n-2;
		while (l1<l2)
		{
			mij=x[ox[(l1+l2)/2]];
			if (px<mij) l2=(l1+l2)/2-1; else l1=(l1+l2)/2+1;
		}
		if ((x[ox[l1]]>px)&&(l1>0)) l1--;
		stx=l1;

		l1 = 0;l2 = n-2;
		while (l1<l2)
		{
			mij=y[oy[(l1+l2)/2]];
			if (py<mij) l2=(l1+l2)/2-1; else l1=(l1+l2)/2+1;
		}
		if ((y[oy[l1]]>py)&&(l1>0)) l1--;
		sty=l1;
*/

		stx=stxv[px];
		sty=styv[py];

		mt=SUPERMARE;
		mt=min(mt,abs(x[ox[stx]]-px)+abs(y[oy[sty]]-py)+cst[sty][stx]);
		mt=min(mt,abs(x[ox[stx+1]]-px)+abs(y[oy[sty]]-py)+cst[sty][stx+1]);
		mt=min(mt,abs(x[ox[stx]]-px)+abs(y[oy[sty+1]]-py)+cst[sty+1][stx]);
		mt=min(mt,abs(x[ox[stx+1]]-px)+abs(y[oy[sty+1]]-py)+cst[sty+1][stx+1]);

		fprintf(g,"%d\n",mt);
	}


	fclose(f);
	fclose(g);

	return 0;

}
