
#include <stdio.h>
#include <mem.h>

typedef struct numar
{
	int nc;
	int one1;
	int c[300];
} numar;


numar operator+ (numar nr, int c)
{
	for (int i=0;i<nr.nc+1;i++)
	{
		nr.c[i] = nr.c[i] + c;
		c = nr.c[i] / 10;
		nr.c[i] %= 10;
	}
	if (nr.c[nr.nc]) nr.nc++;
	return nr;
}

numar operator* (numar n1, numar n2)
{
	numar r;

	memset(&r, 0, sizeof(r));

	int i, j, k;
	int c;

	int maxc=n1.nc;
	for (i=0;i<n1.nc; i++)
	{
		for (j=0;j<n2.nc; j++)
		{
			r.c[i+j] += n1.c[i]*n2.c[j];
			c=0;
			for (k=i+j;k<=n1.nc+n2.nc;k++)
			{
				r.c[k] += c;
				c = r.c[k]/10;
				r.c[k] %= 10;
				if (k+1>maxc) maxc=k+1;
				if (!c) break;
			}

		}
	}
	r.nc = maxc;
	return r;
}


numar operator/ (numar nr, int q)
{
	numar r;

	memset(&r, 0, sizeof(r));
	int c=0;
	int put;
	int still0=1;

	for (int i=nr.nc-1; i>=0; i--)
	{
		c = c*10 + nr.c[i];

		put = c/q;

		if (put)
		{
			still0=0;
			r.c[r.nc]=put;
			r.nc++;
		} else
		{
			if (!still0)
			{
				r.c[r.nc]=put;
				r.nc++;
			}
		}
		c=c%q;
	}
	if (c>q/2)
	{
		c=1;
		for (i=r.nc-1; i>=0; i--)
		{
			r.c[i] = r.c[i] + c;
			c = nr.c[i] / 10;
			r.c[i] %= 10;
		}
		if (c) r.one1=1;
	}
	return r;
}


void input(numar *n)
{
	FILE *f = fopen("sala.in", "r");

	int t;
	memset(n, 0, sizeof(numar));

	fscanf(f, "%d", &t);
	n->nc=t;
	for (int i=0;i<n->nc;i++)
	{
		fscanf(f, "%d", &t);
		n->c[n->nc-i-1]=t;
	}

	fclose(f);
}

void output(numar n)
{
	int i;

	FILE *f = fopen("sala.out", "w");

	if (n.one1) fprintf(f, "1");

	for(i=0;i<n.nc;i++)
	{

		fprintf(f, "%d", n.c[i]);
	}

	fprintf(f, "\n");

	fclose(f);
}

int main()
{

	numar nr;

	input(&nr);

	nr = (nr*(nr+1))/3;

	output(nr);

	return 0;
}