#include <stdio.h>

int N, K, nk;

struct time {
	int T1, T2, nr;
};
time *T;
int **G,t[101],*vout,nv;

void citire()
{
	FILE *f = fopen("ghizi.in","rt");
	fscanf(f,"%d%d",&N,&K);
	G = new int*[N+1];
	vout = new int[N+1];
	T = new time[N+1];
	for(int i=1;i<=N;i++) {
		fscanf(f,"%d%d",&T[i].T1,&T[i].T2);
		T[i].nr = i;
		if(!T[i].T1 && T[i].T2 == 100) nk++;
		G[i] = new int[N+1];
		for(int j=1;j<=N;j++)
			G[i][j] = 0;
	}
	fclose(f);
}

void initd()
{       int i,j,k;
	for(i=1;i<=N;i++)
		for(j=1;j<=N;j++)
			if(T[i].T2==T[j].T1) G[i][j] = 1;
	for(i=1;i<=N;i++)
		if(T[i].T1 || T[i].T2 != 100)
			for(j=T[i].T1;j<=T[i].T2;j++)
				t[j]++;
}

int ok(int k1, int k2)
{
	int i;
	for(i=T[k1].T1;i<=T[k1].T2;i++)
		if(t[i] != K-nk) return 0;
	for(i=T[k2].T1;i<=T[k2].T2;i++)
		if(t[i] != K-nk) return 0;
	return 1;
}

void fetch(int k)
{
	for(int i=1;i<=k;i++)
		if(G[i][k]) fetch(i);
	vout[++nv] = T[k].nr;
}

void ghizi()
{
	int i, j, k;
	for(i=N-nk;i>0;i--)
		for(j=i-1;j>0;j--)
			for(k=1;k<=N-nk;k++)
				if(!G[i][j] && ok(i,j)) G[i][j] = G[i][k] * G[k][j];

	for(j=1;j<=N;j++)
		if(G[j][N-nk]) {fetch(j);vout[++nv] = T[N-nk].nr;}

}

int part(int l, int r)
{
	int x = l;
	int i = l-1, j = r+1;
	while(1)
	{
		do i++; while(T[x].T2 > T[i].T2 || (T[x].T2 == T[i].T2 && T[x].T1 < T[i].T1));
		do j--; while(T[x].T2 < T[j].T2 || (T[x].T2 == T[j].T2 && T[x].T1 > T[j].T1));
		if(i < j) {
			T[i].T1 ^= T[j].T1 ^= T[i].T1 ^= T[j].T1;
			T[i].T2 ^= T[j].T2 ^= T[i].T2 ^= T[j].T2;
			T[i].nr ^= T[j].nr ^= T[i].nr ^= T[j].nr;
		}
		else return j;
	}
}

void Sort(int l, int r)
{
	if(l < r)
	{
		int q = part(l,r);
		Sort(l,q);
		Sort(q+1,r);
	}
}

void afisare()
{
	FILE *g = fopen("ghizi.out","wt");
	int i;
	int *f = new int[N+1];
	int nf = 0;
	for(i=1;i<=N;i++)
		if(!T[i].T1 && T[i].T2 == 100) f[++nf] = T[i].nr;
	int j = 1;
	for(i=1;i<=nv;i++)
	{
		if(j <= nf &&f[j] < vout[i]) fprintf(g,"%d %d",f[j++],vout[i]);
		else fprintf(g,"%d",vout[i]);
		if(i < nv) fprintf(g," ");
	}
	fprintf(g,"\n");
	fclose(g);
}


int main()
{
	citire();
	Sort(1,N);
	initd();
	ghizi();
	afisare();

	return 0;
}