type
  ghizi=record
    t1,t2:byte;
    nr:integer;
    a:boolean;
  end;

var
  a:array[0..100,0..100] of integer;
  index:array[0..100] of integer;
  gz:array[1..5000] of ghizi;
  x:array[0..5000] of integer;
  t:array[1..100] of integer;
  timpi:set of byte;
  nrt:integer;
  nrg:integer;
  nrx:integer;
  i,j,l,h:integer;
  n,e:integer;
  td:ghizi;
  xd:integer;
  xt:integer;
  tt:integer;
  k:integer;
  nr:integer;
  g:boolean;
  gasit:boolean;
  f:text;
  ft:text;

procedure sort(l,r:byte);
var
  i,j:byte;
begin
  i:=l;
  j:=r;
  xd:=gz[(i+j) div 2 + 1].t1;
  repeat
    while (gz[i].t1 < xd) and (i<r) do i:=i+1;
    while (gz[j].t1 > xd) and (j>l) do j:=j-1;
    if i<=j then
    begin
      td:=gz[i];
      gz[i]:=gz[j];
      gz[j]:=td;
      i:=i+1;
      j:=j-1;
    end;
  until i>j;
  if j > l then sort (l,j);
  if i < r then sort (i,r);
end;

procedure sortt(l,r:byte);
var
  i,j:byte;
begin
  i:=l;
  j:=r;
  xt:=t[(i+j) div 2 + 1];
  repeat
    while (t[i] < xt) and (i<r) do i:=i+1;
    while (t[j] > xt) and (j>l) do j:=j-1;
    if i<=j then
    begin
      tt:=t[i];
      t[i]:=t[j];
      t[j]:=tt;
      i:=i+1;
      j:=j-1;
    end;
  until i>j;
  if j > l then sortt (l,j);
  if i < r then sortt (i,r);
end;

procedure sortg(l,r:byte);
var
  i,j:byte;
begin
  i:=l;
  j:=r;
  xt:=gz[(i+j) div 2 + 1].nr;
  repeat
    while (gz[i].nr < xt) and (i<r) do i:=i+1;
    while (gz[j].nr > xt) and (j>l) do j:=j-1;
    if i<=j then
    begin
      td:=gz[i];
      gz[i]:=gz[j];
      gz[j]:=td;
      i:=i+1;
      j:=j-1;
    end;
  until i>j;
  if j > l then sortg (l,j);
  if i < r then sortg (i,r);
end;

function cauta (data:integer):integer;
var
  i,j:integer;
  x:integer;
  p:integer;
begin
  i:=1;
  j:=nrt;
  p:=-1;
  while (i<j) and (p=-1) do
  begin
    x:=t[(i+j) div 2 + 1];
    if data<x then j:=(i+j) div 2;
    if data=x then p:=(i+j) div 2 + 1;
    if data>x then i:=(i+j) div 2 + 1;
  end;
  if p=-1 then if data=t[i] then p:=i;
  cauta:=p;
end;

function cont:boolean;
var
  f:boolean;
begin
  if a[t[x[k-1]],t[x[k]]]>0 then f:=true
  else f:=false;
  cont:=f;
end;

begin
  for i:=0 to 100 do for j:=0 to 100 do a[i,j]:=0;
  for i:=0 to 100 do t[i]:=-1;
  for i:=0 to 5000 do x[i]:=0;
  timpi:=[];
  nrt:=0;
  nrx:=0;
  nrg:=0;
  assign (f,'ghizi.in');
  reset (f);
  readln (f,n,e);
  for i:=1 to n do
  begin
    readln (f,l,h);
    a[l,h]:=a[l,h]+1;
    nrg:=nrg+1;
    gz[nrg].t1:=l;
    gz[nrg].t2:=h;
    gz[nrg].nr:=i;
    gz[nrg].a:=false;
    if not (l in timpi) then
    begin
      timpi:=timpi+[l];
      nrt:=nrt+1;
      t[nrt]:=l;
    end;
    if not (h in timpi) then
    begin
      timpi:=timpi+[h];
      nrt:=nrt+1;
      t[nrt]:=h;
    end;
  end;
  close (f);
  sort (1,nrg);
  sortt (1,nrt);
  timpi:=[];
  for i:=1 to nrg do if not (gz[i].t1 in timpi) then
  begin
    timpi:=timpi+[gz[i].t1];
    index[gz[i].t1]:=i;
  end;
  k:=1;
  x[0]:=1;
  x[k]:=1;
  while (k > 0) and (e>0) do
  begin
    g:=false;
    x[k]:=x[k]+1;
    while (not g) and (x[k]<=nrt) do
      if cont then g:=true
      else x[k]:=x[k]+1;
    if g then if t[x[k]]=100 then
              begin
                e:=e-1;
                for i:=0 to k-1 do
                begin
                  j:=index[t[x[i]]];
                  gasit:=false;
                  while not gasit do
                  begin
                    if (gz[j].t1=t[x[i]]) and (gz[j].t2=t[x[i+1]]) then
                    begin
                      gz[j].a:=true;
                      gasit:=true;
                    end;
                    j:=j+1;
                  end;
                  dec(a[t[i],t[i+1]]);
                end;
              end
              else
              begin
                k:=k+1;
                x[k]:=cauta(t[x[k-1]])-1;
              end
    else
    begin
      a[t[x[k-1]],t[x[k]]]:=0;
      dec(k);
    end;
  end;
  sortg (1,nrg);
  nrx:=0;
  for i:=1 to nrg do if gz[i].a=true then nrx:=nrx+1;
  assign (ft,'ghizi.out');
  rewrite (ft);
  writeln (ft,nrx);
  for i:=1 to nrg do if gz[i].a=true then write (ft,gz[i].nr,' ');
  writeln (ft);
  close (ft);
end.