// Baraj - Ziua 2 - Ajutor

#include <stdio.h>

#define input "ajutor.in"
#define output "ajutor.out"

FILE *fi, *fo;
long m, n, x, y, min;
struct point
{
	long x, y;
} p[500];

long abs(long x)
{
	return x > 0 ? x : -x;
}

long dist(int p1, int p2)
{
	return abs(p[p1].x - p[p2].x) + abs(p[p1].y - p[p2].y);
}

void solve()
{
	long i, d;
	min = 1000000L;
	for (i = 0; i < n; i++)
	{
		d = dist(i, n);
		if (d < min) min = d;
	}
}

int main()
{
	long i;
	fi = fopen(input, "rt");
	fo = fopen(output, "wt");
	fscanf(fi, "%ld %ld", &n, &m);
	for (i = 0; i < n; i++)
		fscanf(fi, "%ld %ld", &p[i].x, &p[i].y);
	for (i = 0; i < m; i++)
	{
		fscanf(fi, "%ld %ld", &x, &y);
		p[n].x = x; p[n].y = y;
		solve();
		fprintf(fo, "%ld\n", min);
	}
	fclose(fi); fclose(fo);
	return 0;
}
