#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define fi "ajutor.in"
#define fo "ajutor.out"

typedef struct cel_ {int x, y;}cel;

long n1,n2;
cel a[410],b[410];
FILE *f;

long min1(long a, long b)
{
if (a<b) return a;
return b;
}

void load()
{
long i;
fscanf(f,"%ld %ld",&n1,&n2);
for(i=0;i<n1;i++)
 fscanf(f,"%d %d",&a[i].x,&a[i].y);
memcpy(b,a,sizeof(a));
}

int fcp(const void *a, const void *b)
{
cel *aa=(cel*)a, *bb=(cel*)b;
if ( (aa->x<bb->x) || ((aa->x==bb->x)&&(aa->y<bb->y))) return -1;
if ( (aa->x>bb->x) || ((aa->x==bb->x)&&(aa->y>bb->y))) return 1;
return 0;
}

int fcp1(const void *a, const void *b)
{
cel *aa=(cel*)a, *bb=(cel*)b;
if ( (aa->y<bb->y) || ((aa->y==bb->y)&&(aa->x<bb->x))) return -1;
if ( (aa->y>bb->y) || ((aa->y==bb->y)&&(aa->x>bb->x))) return 1;
return 0;
}


long dist(cel a, cel b)
{
return abs(a.x-b.x)+abs(a.y-b.y);
}

long sx(long aa, long bb, cel pct)
{
int m=(aa+bb)/2;
long minim;
if (((pct.x==a[m].x) && (pct.y==a[m].y))) return 0;
if (bb-aa>=2)
     {
       if ( (pct.x<a[m].x) || ((pct.x==a[m].x) && (pct.y<a[m].y)) )
		return sx(aa,m-1,pct);
	 else return sx(m+1,bb,pct);
     }
else
   {
     minim=dist(pct,a[aa]);
     minim=min1(minim,dist(pct,a[bb]));
     if (aa-1>=0) minim=min1(minim,dist(pct,a[aa-1]));
     if (aa-2>=0) minim=min1(minim,dist(pct,a[aa-2]));
     if (bb+1<n1) minim=min1(minim,dist(pct,a[bb+1]));
     if (bb+2<n1) minim=min1(minim,dist(pct,a[bb+2]));
     return minim;
   }
}

long sy(long aa, long bb, cel pct)
{
int m=(aa+bb)/2;
long minim;
if (((pct.x==a[m].x) && (pct.y==a[m].y))) return 0;
if (bb-aa>=2)
     {
       if ( (pct.y<a[m].y) || ((pct.y==a[m].y) && (pct.x<a[m].x)) )
		return sx(aa,m-1,pct);
	 else return sx(m+1,bb,pct);
     }
else
   {
     minim=dist(pct,a[aa]);
     minim=min1(minim,dist(pct,a[bb]));
     if (aa-1>=0) minim=min1(minim,dist(pct,a[aa-1]));
     if (aa-2>=0) minim=min1(minim,dist(pct,a[aa-2]));
     if (bb+1<n1) minim=min1(minim,dist(pct,a[bb+1]));
     if (bb+2<n1) minim=min1(minim,dist(pct,a[bb+2]));
     return minim;
   }
}




void go()
{
long i,minim;
cel pct;
FILE *g;
g=fopen(fo,"w");
qsort(a,n1,sizeof(cel),fcp);
qsort(b,n2,sizeof(cel),fcp1);
for(i=0;i<n2;i++)
  { minim=200000000;
    fscanf(f,"%d %d",&pct.x,&pct.y);
    minim=sx(0,n1-1,pct);
    minim=min1(minim,sy(0,n1-1,pct));
    fprintf(g,"%ld\n",minim);
  }
fclose(g);
}

int main()
{
f=fopen(fi,"r");
load();
go();
fclose(f);
return 0;
}