#include <stdio.h>
#define INPUT "ghizi.in"
#define OUTPUT "ghizi.out"

struct cap {
	int t,ap;
};
struct ghid {
	int x,y;
};
const int nmax=5000+2;  // **************************10
ghid a[nmax];
cap st[nmax],dr[nmax];
int n,k,used[nmax],nrsol=0,sol[nmax],gasitceva;

void citeste()
{
	FILE *fi=fopen(INPUT,"rt");
	fscanf(fi,"%d%d",&n,&k);
	int i;
	for (i=1;i<=n;i++)
		{
			fscanf(fi,"%d%d",&a[i].x,&a[i].y);
			st[i].t=a[i].x;
			st[i].ap=i;
			dr[i].t=a[i].y;
			dr[i].ap=i;
			used[i]=0;
		}
	fclose(fi);
}

void scrie()
{
	FILE *fo=fopen(OUTPUT,"wt");
	int i,ultim;
	fprintf(fo,"%d\n",nrsol);
	for (i=n;i;i--) // nuvreauspatiu
		if (sol[i]) break;
	ultim=i;
	for (i=1;i<=ultim-1;i++)
		if (sol[i]) fprintf(fo,"%d ",i);
	fprintf(fo,"%d\n",ultim);
	fclose(fo);
}

int partst(int p,int r)
{
	int i=p-1,j=r+1,x=st[(p+r)/2].t; //?
	cap aux;
	while (1) {
		do i++; while (st[i].t<x);
		do j--; while (st[j].t>x);
		if (i<j) {
			aux=st[i];
			st[i]=st[j];
			st[j]=aux;
			}
		else return j;
	}
}

void qsortst(int p,int r)
{
	int q;
	if (p<r)
		{
			q=partst(p,r);
			qsortst(p,q);
			qsortst(q+1,r);
		}
}

int partdr(int p,int r)
{
	int i=p-1,j=r+1,x=dr[(p+r)/2].t; //?
	cap aux;
	while (1) {
		do i++; while (dr[i].t<x);
		do j--; while (dr[j].t>x);
		if (i<j) {
			aux=dr[i];
			dr[i]=dr[j];
			dr[j]=aux;
			}
		else return j;
	}
}

void qsortdr(int p,int r)
{
	int q;
	if (p<r)
		{
			q=partdr(p,r);
			qsortdr(p,q);
			qsortdr(q+1,r);
		}
}

int findst(int nr)
{
	int i,l=1,r=n;
	while (l<=r) {
		if (st[(l+r)/2].t==nr) break;
		else if (st[(l+r)/2].t>nr) r=(l+r)/2-1;
		else l=(l+r)/2+1;
	}
	if (l>r) return 0;
	i=(l+r)/2;
	while (st[i-1].t==nr) i--;
	return i;
}

void baga()
{
	int i;
	for (i=1;i<=n;i++)
		if ((used[i]) && (!sol[i]))
			{
				sol[i]=1;
				nrsol++;
			}
	k--;
	gasitceva=1;
}

void trypls(int c)
{
	int i;
	used[c]=1;
	if (a[c].y==100) baga();
	else
		{
			if (gasitceva) return;
			i=findst(a[c].y);
			if (!i)
				{
					used[c]=0;
					return;
				}
			for (;st[i].t==a[c].y;i++)
				{
					if (gasitceva) return;
					if (!sol[st[i].ap]) trypls(st[i].ap);
				}
		}
	used[c]=0;
}

void rezolva()
{
	if (k==n) {
		int i;
		nrsol=n;
		for (i=1;i<=n;i++)
			used[i]=1;
		return;
	}
	////////////////////
	int start;
	qsortst(1,n);
	qsortdr(1,n);
	gasitceva=0;
	for (start=1;st[start].t==0;start++)
		{
			if (k>0) trypls(st[start].ap);
			gasitceva=0;
		}
}

int main()
{
	citeste();
	rezolva();
	scrie();
	return 0;
}

