#include <stdio.h>
#include <stdlib.h>

#define HW(a, b) (((a)+(b)) >> 1)
#define ABS(a) ((a) < 0 ? -(a) : (a))

typedef struct{
	int x, y;
} point;

point salv[401], a, b;
FILE *fi, *fo;
int n, m, i, d, dd, ddd, apar[401], bpar[401], r, s;

int cmpx(const void *a, const void *b)
{
	return ((const point *)a)->x - ((const point *)b)->x;
}

int cmpy(const void *a, const void *b)
{
	return ((const point *)a)->y - ((const point *)b)->y;
}

int findx(int start, int stop)
{
	if (start < stop) {
		if (salv[ HW(start, stop) ].x == a.x) return HW(start, stop);
		else if (ABS(salv[ HW(start, stop)+1 ].x - a.x) <
			ABS(salv[ HW(start, stop)-1 ].x - a.x)) return findx(HW(start, stop)+1, stop);
		else return findx(start, HW(start, stop)-1);
	}
	else return start;
}

int findy(int start, int stop)
{
	if (start < stop) {
	 	if (salv[ HW(start, stop) ].y == a.y) return HW(start, stop);
		else if (ABS(salv[ HW(start, stop)+1 ].y - a.y) <
			ABS(salv[ HW(start, stop)-1 ].y - a.y)) return findy(HW(start, stop)+1, stop);
		else return findy(start, HW(start, stop)-1);
	}
	else return start;
}

main()
{
	fi = fopen("ajutor.in", "rt");
	fo  = fopen("ajutor.out", "wt");
	fscanf(fi, "%d%d", &n, &m);
	for (i = 1; i <= n; i++)
		fscanf(fi, "%d%d", &salv[i].x, &salv[i].y);

	qsort(&salv[1], n, sizeof(point), cmpy);
	qsort(&salv[1], n, sizeof(point), cmpx);

	apar[n] = 1;
	for (i = n-1; i; i--)
		if (salv[i].x == salv[i+1].x) apar[i] = apar[i+1] + 1;
		else apar[i] = 1;
	bpar[1] = 1;
	for (i = 2; i <= n; i++)
		if (salv[i].x == salv[i-1].x) bpar[i] = bpar[i-1] + 1;
		else bpar[i] = 1;

	for (i = 1; i <= m; i++) {
		fscanf(fi, "%d%d", &a.x, &a.y);
		b.x = a.x; b.y = a.y;
		d = findx(1, n);
		d = d - bpar[d] + 1;
		d = findy(d, d + apar[d] - 1);

		s = r = d;
		r = r + apar[r];
		s = s - bpar[s] - bpar[s - bpar[s]] + 1;

		while(((r <= n) && (salv[r].x - salv[d].x < ABS(salv[d].y - b.y))) ||
			((s > 0) && (salv[d].x - salv[s].x < ABS(salv[d].y - b.y))))
		{
			a.x = salv[r].x;
			dd = findy(r, r + apar[r] - 1);
			a.x = salv[s].x;
			ddd = findy(s, s + apar[s] - 1);
			if (r <= n) {
				if (ABS(salv[dd].x - b.x) + ABS(salv[dd].y - b.y) <
					ABS(salv[d].x - b.x) + ABS(salv[d].y - b.y)) {
					s = r = d = dd;
				}
				r = r + apar[r];
			}
			if (s > 0) {
				if (ABS(salv[ddd].x - b.x) + ABS(salv[ddd].y - b.y) <
					ABS(salv[d].x - b.x) + ABS(salv[d].y - b.y)) {
					s = r = d = ddd;
				}
				if (s == 1) s = 0;
				else s = s - bpar[s] - bpar[s - bpar[s]] + 1;
			}
		}
		fprintf(fo, "%d\n", ABS(salv[d].x - b.x) + ABS(salv[d].y - b.y));
	}

	fclose(fo);
	fclose(fi);
	return 0;
}
