#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef int irv[3];

int n, k, i;
irv g[5001];			// just for security reason
int u[5000], d[5000];
int v[101];

int level, count;
int back(void)
{
	#define ret(x) { level --; return (x); }

	level ++;

	if(level != 0)
	{
		int value = g[level - 1][0];
		if(value != g[level][0] || level == n)
		{
			if(value != 0)
			{
				if(v[value] != 0) ret(0);
			}
			else
			{
				if(v[value] != k) ret(0);
			}
		}

		if(level == n) ret(v[100] == -k);
	}

	int v0 = g[level][0];
	int v1 = g[level][1];

	// cu ghid
	u[level] = 1;
	v[v0] ++; v[v1] --;

	if(v[v0] <= k)
	{
		int res = 0;
		if(level != 0)
		{
			if(g[level - 1][0] == v0 && g[level - 1][1] == v1)
			{
				if(u[level - 1])
					res = back();
			}
			else res = back();
		}
		else res = back();

		if(res) ret(1);
	}

	v[v0] --; v[v1] ++;
	u[level] = 0;

	// fara ghid
	if(back()) ret(1);
	ret(0);
}

int cmp_irv(const void *a, const void *b)
{
	int res0 = (*(irv *)a)[0] - (*(irv *)b)[0];
	int res1 = (*(irv *)a)[1] - (*(irv *)b)[1];
	if(res0) return res0;
	return res1;
}

int cmp_int(const void *a, const void *b)
{
	return *(int *)a - *(int *)b;
}

int main(void)
{
	freopen("ghizi.in", "rt", stdin);
	freopen("ghizi.out", "wt", stdout);

	scanf("%d %d", &n, &k);
	memset(u, 0, sizeof(int) * n);
	memset(v, 0, sizeof(int) * 101);

	for(i = 0; i < n; i ++)
	{
		scanf("%d %d", &g[i][0], &g[i][1]);
		g[i][2] = i;
	}

	qsort(g, n, sizeof(irv), cmp_irv);
	level = -1; back();

	count = 0;
	for(i = 0; i < n; i ++)
		if(u[i]) d[count ++] = g[i][2];

	printf("%d\n", count);
	qsort(d, count, sizeof(int), cmp_int);
	for(i = 0; i < count; i ++)
	{
		if(i != 0) printf(" ");
		printf("%d", d[i] + 1);
	}
	printf("\n");

	fclose(stdin);
	fclose(stdout);
	return 0;
}