{$I-,Q-,R-,S-}
{ limite, nume de fisiere, tipuri de date !!! }
{ integer pare ca merge }
{ atentie la sursa care e -1 }
{ !!! trebuie facute si liste inlantuite pentru afisare rapida }
const
  finame = 'ghizi.in';
  foname = 'ghizi.out';
  nmax = 5000; { ATENTIE!!! 5000 }
  sursa = -1; dest = 101;
type
  link = ^node;
  node = record
           v: longint;
           next: link;
         end;
var
  fi, fo: text;
  n, m, k, i, j, flow, grow, s1, s2, aux: longint;
  c, f: array[sursa..dest] of array[sursa..dest] of longint;
  t1, t2: array[1..nmax] of longint;

  u, t: array[sursa..dest] of longint;
  q: array[1..2*dest] of longint;
  folosit: array[1..nmax] of longint;

  a: array[sursa..dest] of array[sursa..dest] of link;

procedure insert(t1, t2, i: longint);
var p: link;
begin
  new(p);
  p^.v := i;
  p^.next := a[t1][t2];
  a[t1][t2] := p;
end;

procedure readdata;
begin
  assign(fi, finame);
  reset(fi);
  read(fi, n, k);
  fillchar(c, sizeof(c), 0);
  for i := 0 to 100 do
    for j := 0 to 100 do
      a[i][j] := nil;
  for i := 1 to n do
  begin
    read(fi, t1[i], t2[i]);
    inc( c[ t1[i] ][ t2[i] ] );
    insert(t1[i], t2[i], i);
  end;
  close(fi);
  c[sursa][0] := k;
  c[100][dest] := k;
end;

procedure bf;
begin { bf-ul se apeleaza daca sigur mai exista un drum }
  fillchar(u, sizeof(u), 0);
  q[1] := sursa; u[sursa] := 1; t[sursa] := sursa;
  s1 := 0; s2 := 1;

  while s1 < s2 do
  begin
    inc(s1);
    for i := sursa to dest do
      if u[i] = 0 then
        if c[ q[s1] ][i] - f[ q[s1] ][i] > 0 then
        begin
          inc(s2);
          q[s2] := i;
          u[i] := 1;
          t[i] := q[s1];
          if i = dest then exit;
        end;
  end;
end;

procedure refresh;
begin
  i := dest; grow := k; { drumul nu poate creste cu mai mult de k }
  while i <> sursa do
  begin
    aux := c[ t[i] ][ i ] - f[ t[i] ][ i ];
    if aux < grow then grow := aux;
    i := t[i];
  end;

  i := dest;
  while i <> sursa do
  begin
    inc(f[ t[i] ][ i ], grow);
    dec(f[ i ][ t[i] ], grow);
    i := t[i];
  end;

  inc(flow, grow);
end;

procedure solvprob;
begin
  fillchar(f, sizeof(f), 0);
  flow := 0;
  repeat
    bf; { daca nu s-a oprit din repeat inseamna ca mai exista un drum }
    refresh;
  until flow = k;
end;

procedure writesol;
var p: link;
begin
  assign(fo, foname);
  rewrite(fo);
  m := 0;
  fillchar(folosit, sizeof(folosit), 0);
  for i := 0 to 100 do
    for j := 0 to 100 do
      if f[i][j] > 0 then
    begin
      p := a[i][j];
      for k := 1 to f[i][j] do { acum putem sa refolosim k }
      begin
        inc(m);
        folosit[ p^.v ] := 1;
        p := p^.next;
      end;
    end;

  writeln(fo, m);
  for i := 1 to n do
    if folosit[i] = 1 then
      write(fo, i, ' ');
  writeln(fo);
  close(fo);
end;

begin
  readdata;
  solvprob;
  writesol;
end.
