#include <fstream.h>

ifstream in("ghizi.in");
ofstream out("ghizi.out");

#define MAX 112

#if !defined(__BORLANDC__)
#define far
#endif

int cap[MAX][MAX];
int fl[MAX][MAX];

int n,k;

int v[MAX];
int K;

int stk[MAX];
int is[MAX];
int st, ed;

int pi[MAX];

int este[5010];
int far T1[5010],far T2[5010];

int FindDrum()
 {
  int i,u;
  st=ed=0;
  for(i=0;i<MAX;i++) {is[i]=0;pi[i]=-1;}
  stk[ed++]=0;
  is[0]=1;
  while(st<ed)
   {
	u=stk[st++];
	if(u==100) break;
	int j;
	for(j=0;j<=100;j++) if(!is[j])
	 if(cap[u][j]-fl[u][j]>0)
	  {
	   stk[ed++]=j;
	   pi[j]=u;
	   is[j]=1;
	  }
   }
  if(pi[100]==-1) return 0;
  i=100;
  K=0;
  do
   {
	v[K++]=i;
	i=pi[i];
   } while(i!=-1);
  for(i=0;i<K/2;i++)
   {
	int t=v[i];
	v[i]=v[K-i-1];
	v[K-i-1]=t;
   }
  return 1;
 }

int FindMax()
 {
  int i,max=0;
  for(i=1;i<K;i++)
   if(cap[v[i-1]][v[i]]-fl[v[i-1]][v[i]]>max)
	max=cap[v[i-1]][v[i]]-fl[v[i-1]][v[i]];
  return max;
 }

void PushFlow(int f)
 {
  int i;
  for(i=1;i<K;i++)
   {
	fl[v[i-1]][v[i]]+=f;
	fl[v[i]][v[i-1]]-=f;
   }
 }

int main()
 {
  in>>n>>k;
  int i,t1,t2;
  for(i=0;i<n;i++)
   {
	in>>t1>>t2;
	T1[i]=t1;T2[i]=t2;
	cap[t1][t2]++;
   }
  do
   {
	if(FindDrum()==0) break;
	int m=FindMax();
	if(m>k) m=k;
	PushFlow(m);
	k-=m;
   } while(k);
  for(i=0;i<n;i++)
   if(fl[T1[i]][T2[i]]>0)
	{
	 este[i]=1;
	 fl[T1[i]][T2[i]]--;
	}
   else este[i]=0;
  K=0;
  for(i=0;i<n;i++) if(este[i]) K++;
  out<<K<<"\n";
  for(i=0;i<n;i++) if(este[i])
   out<<(i+1)<<' ';
  out<<"\n";
  return 0;
 }
