{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
program ajutor;
type punct =  record
        x,y,ind : word;
     end;
     pnod = ^nod;
     nod = record
          ind : word;
          urm : pnod;
     end;
     vect = array[1..400] of word;
     pvect = array[1..400] of pnod;
var fi,fo : text;
    p,pp : array[1..400] of punct;
    n : word;
    m : longint;
    xx,yy : vect;
    lx,ly : pvect;
    xxn,yyn : word;


procedure ReadData;
var i : word;
begin
     assign(fi,'ajutor.in'); reset(fi);
     readln(fi,n,m);
     for i:=1 to n do begin
         readln(fi,p[i].x,p[i].y);
         p[i].ind:=i;
     end;
end;

procedure SortX(l,r:word);
var i,j : integer;
    t : word;
    aux : punct;
begin
     i:=l; j:=r; t:=p[(l+r) div 2].x;
     repeat
           while p[i].x<t do i:=i+1;
           while t<p[j].x do j:=j-1;
           if i<=j then begin
              aux:=p[i]; p[i]:=p[j]; p[j]:=aux;
              i:=i+1; j:=j-1;
           end;
     until i>j;
     if l<j then SortX(l,j);
     if i<r then SortX(i,r);
end;

procedure SortY(l,r:word);
var i,j : integer;
    t : word;
    aux : punct;
begin
     i:=l; j:=r; t:=p[(l+r) div 2].y;
     repeat
           while p[i].y<t do i:=i+1;
           while t<p[j].y do j:=j-1;
           if i<=j then begin
              aux:=p[i]; p[i]:=p[j]; p[j]:=aux;
              i:=i+1; j:=j-1;
           end;
     until i>j;
     if l<j then SortY(l,j);
     if i<r then SortY(i,r);
end;

procedure Add(var l:pvect; poz:word; ind:word);
var q : pnod;
begin
     new(q); q^.ind:=ind; q^.urm:=nil;
     if l[poz]=nil then begin
        l[poz]:=q;
     end
     else begin
          q^.urm:=l[poz];
          l[poz]:=q;
     end;
end;

procedure CreateXXYY;
var i : word;
    min : longint;
begin
     SortX(1,n); min:=-1;
     for i:=1 to n do begin
         if p[i].x>min then begin
            xxn:=xxn+1;
            xx[xxn]:=p[i].x;
            Add(lx,xxn,p[i].ind);
            min:=p[i].x;
         end
         else
             if p[i].x=min then begin
                Add(lx,xxn,p[i].ind);
             end;
     end;
     SortY(1,n); min:=-1;
     for i:=1 to n do begin
         if p[i].y>min then begin
            yyn:=yyn+1;
            yy[yyn]:=p[i].y;
            Add(ly,yyn,p[i].ind);
            min:=p[i].y;
         end
         else
             if p[i].y=min then begin
                Add(ly,yyn,p[i].ind);
             end;
     end;

end;

procedure GetVE(x,y,l,r:word; var v,e:integer);
var m : word;
    v1,e1,v2,e2 : integer;
begin
     if l=r then begin
        v:=-1; e:=-1;
        if xx[l]=x then begin
           v:=x; e:=x;
        end
        else
            if xx[l]<x then v:=xx[l]
            else
                if xx[l]>x then e:=xx[l];
     end
     else begin
          m:=(l+r) div 2;
          v1:=-1; e1:=-1;
          if l<=m then GetVE(x,y,l,m,v1,e1);
          v2:=-1; e2:=-1;
          if m+1<=r then GetVE(x,y,m+1,r,v2,e2);
          {***}
          if (v1=-1) and (v2=-1) then v:=-1
          else
              if v1=-1 then v:=v2
              else
                  if v2=-1 then v:=v1
                  else
                      if v1<v2 then v:=v2
                      else v:=v1;
          {***}
          if (e1=-1) and (e2=-1) then e:=-1
          else
              if e1=-1 then e:=e2
              else
                  if e2=-1 then e:=e1
                  else
                      if e1<e2 then e:=e1
                      else e:=e2;
     end;
end;

procedure GetSN(x,y,l,r:word; var s,n:integer);
var m : word;
    s1,n1,s2,n2 : integer;
begin
     if l=r then begin
        s:=-1; n:=-1;
        if yy[l]=y then begin
           s:=y; n:=y;
        end
        else
            if yy[l]<y then s:=yy[l]
            else
                if yy[l]>y then n:=yy[l];
     end
     else begin
          m:=(l+r) div 2;
          s1:=-1; n1:=-1;
          if l<=m then GetSN(x,y,l,m,s1,n1);
          s2:=-1; n2:=-1;
          if m+1<=r then GetSN(x,y,m+1,r,s2,n2);
          {***}
          if (s1=-1) and (s2=-1) then s:=-1
          else
              if s1=-1 then s:=s2
              else
                  if s2=-1 then s:=s1
                  else
                      if s1<s2 then s:=s2
                      else s:=s1;
          {***}
          if (n1=-1) and (n2=-1) then n:=-1
          else
              if n1=-1 then n:=n2
              else
                  if n2=-1 then n:=n1
                  else
                      if n1<n2 then n:=n1
                      else n:=n2;
     end;
end;

function Manhattan(x,y:word):word;
var n,s,e,v : integer;
    dmin,dist : longint;
    i : word;
    q : pnod;
begin
     GetVE(x,y,1,xxn,v,e);
     GetSN(x,y,1,yyn,s,n);
     {Gasirea drumului minim (DE OPTIMIZAT)}
     dmin:=maxlongint;
     for i:=1 to xxn do
         if (xx[i]=v) or (xx[i]=e) then begin
            q:=lx[i];
            while q<>nil do begin
                  dist:=0;
                  if x>pp[q^.ind].x then dist:=dist+(x-pp[q^.ind].x)
                  else dist:=dist+(pp[q^.ind].x-x);
                  if y>pp[q^.ind].y then dist:=dist+(y-pp[q^.ind].y)
                  else dist:=dist+(pp[q^.ind].y-y);
                  if dist<dmin then dmin:=dist;
                  q:=q^.urm;
            end;
         end;
     for i:=1 to yyn do
         if (yy[i]=s) or (yy[i]=n) then begin
            q:=ly[i];
            while q<>nil do begin
                  dist:=0;
                  if x>pp[q^.ind].x then dist:=dist+(x-pp[q^.ind].x)
                  else dist:=dist+(pp[q^.ind].x-x);
                  if y>pp[q^.ind].y then dist:=dist+(y-pp[q^.ind].y)
                  else dist:=dist+(pp[q^.ind].y-y);
                  if dist<dmin then dmin:=dist;
                  q:=q^.urm;
            end;
         end;
     Manhattan:=dmin;
end;

procedure Query;
var i : longint;
    x,y,d : word;
begin
     pp:=p;
     CreateXXYY;
     assign(fo,'ajutor.out'); rewrite(fo);
     for i:=1 to m do begin
         readln(fi,x,y);
         d:=Manhattan(x,y);
         writeln(fo,d);
     end;
end;

procedure CloseFiles;
begin
     close(fi);
     close(fo);
end;

begin
     ReadData;
     Query;
     CloseFiles;
end.