#include <fstream.h>
#define dim 5001

int v[dim], i, k, r, vec1[dim], rest, aux[5], rez[dim], vec2[dim];

void readinput()
{
    ifstream in("sala.in");
    in>>v[0];
    for(i=1; i<=v[0]; i++) in>>v[i];
    for(i=1; i<=v[0]/2; i++)
       {
	   k=v[i];
	   v[i]=v[v[0]-i+1];
           v[v[0]-i+1]=k;
       }
    in.close();
}

void copy(int *v1, int *v2)
{ int i;

    for(i=0; i<dim; i++) v1[i]=v2[i];
}

void imp(int *v, int nr)
{ int i, val;

    for(i=v[0]; i>=1; i--)
       {
	   val=v[i];
	   v[i]=(r*10+v[i])/nr;
	   r=(r*10+val)%nr;
       }
    while(!v[v[0]] && v[0]) v[0]--;
}

void inms(int *v, int val)
{ int i, t=0;

    for(i=1; i<=v[0]; i++)
       {
	   v[i]=v[i]*val+t;
	   if(v[i]>9)
	      {
		  t=v[i]/10;
		  v[i]%=10;
	      }
	   else t=0;
       }
    while(t)
       {
	   v[++v[0]]=t%10;
	   t/=10;
       }
}

void inmv(int *v1, int *v2, int *rez)
{ int i, j;

    for(i=0; i<dim; i++) rez[0]=0;
    for(i=1; i<=v1[0]; i++)
       for(j=1; j<=v2[0]; j++)
	  rez[i+j-1]+=v1[i]*v2[j];
    rez[0]=v1[0]+v2[0];
    for(i=1; i<=rez[0]; i++)
       if(rez[i]>9)
	  {
	      rez[i+1]+=rez[i]/10;
	      rez[i]%=10;
	  }
    if(!rez[rez[0]]) rez[0]--;
}

void add(int *v1, int *v2)
{ int i, t=0, max;

    if(v1[0]>v2[0])
       {
	   max=v1[0];
	   for(i=v2[0]+1; i<=v1[0]; i++) v2[i]=0;
       }
    else
       {
	   max=v2[0];
	   for(i=v1[0]+1; i<=v2[0]; i++) v1[i]=0;
       }
    v1[0]=max;
    for(i=1; i<=max; i++)
       {
	   v1[i]+=v2[i]+t;
	   if(v1[i]>9)
	      {
		  t=v1[i]/10;
		  v1[i]%=10;
	      }
	   else t=0;
       }
    if(t) v1[++v1[0]]=1;
}


void go()
{
    copy(vec1, v);
    copy(vec2, v);
    imp(v, 3);
    rest=r;
    inmv(v, v, rez);
    copy(v, rez);
    inms(v, 3);

    r=0;
    imp(vec1, 3);
    add(v, vec1);
    aux[0]=aux[1]=1;
    r=0;
    imp(vec2, 3);
    inms(vec2, 2);
    add(vec2, aux);
    inms(vec2, rest);
    add(v, vec2);
}

void writeoutput()
{
    ofstream out("sala.out");
    for(i=v[0]; i>0; i--) out<<v[i];
    out<<'\n';
    out.close();
}

int main()
{
    readinput();
    go();
    writeoutput();
    return 0;
}