#include <stdio.h>
#include <stdlib.h>

typedef struct {
  int start, stop;
  int id;
  } ghid;

int n, k, chosen[5001], bgn[100], count, can_choose[5001];
ghid ghizi[5001];

int cmp_proc( const void *a, const void *b)
  {
  ghid g1, g2;
  g1 = *(ghid *)a;
  g2 = *(ghid *)b;
  if (g1.start != g2.start)
    return g1.start - g2.start;
  return g1.stop - g2.stop;
  }

int choose(int index)
  {
  if (ghizi[index].stop == 100)
    {
    chosen[ghizi[index].id] = 1;
    count++;
    return 1;
    }
  int i;
  i = bgn[ghizi[index].stop];
  if (i != 0)
    while (ghizi[i].start == ghizi[index].stop)
      {
      if ((chosen[i] == 0) && (can_choose[i] != -1) && (choose(i) == 1))
	{
	chosen[ghizi[index].id] = 1;
	count ++;
	return 1;
	};
      i++;
      }
  can_choose[index] = -1;
  return 0;
  }

int main()
  {
  FILE *f = fopen("ghizi.in", "r");
  fscanf(f, "%d %d", &n, &k);
  int i;
  for (i = 1; i <= n; i++)
    {
    fscanf(f, "%d %d", &ghizi[i].start, &ghizi[i].stop);
    ghizi[i].id = i;
    }
  fclose(f);
  qsort(ghizi, n+1, sizeof(ghid), cmp_proc);
  for (i = 1; i <= n; i++)
    if (bgn[ghizi[i].start] == 0)
      bgn[ghizi[i].start] = i;
  int index;
  index = 0;
  do {
    index++;
    k -= choose(index);
    } while (k > 0);
  f = fopen("ghizi.out", "w");
  fprintf(f, "%d\n", count);
  for (i = 1; i <= n; i++)
    if (chosen[i] == 1)
      {
      fprintf(f, "%d", i);
      break;
      }
  for (i = i+1; i <= n; i++)
    if (chosen[i] == 1)
      fprintf(f, " %d", i);
  fprintf(f, "\n");
  fclose(f);
  return 0;
  }