#include <fstream.h>
#include <math.h>
#define n_max 401
#define oo 100000

ifstream r("ajutor.in");
ofstream w("ajutor.out");

int m,n;
int dx,dy;
int x[n_max];
int y[n_max];

long min(long a, long b){return a<b?a:b;}

void sortlist(int a, int b){
	long t,t2;
	int i,j;
	i=a; j=b; t=x[(a+b)/2];
	while(i<=j){
		while(x[i]<t)i++;
		while(x[j]>t)j--;
		if(i<=j){
			t2=x[i];x[i]=x[j];x[j]=t2;
			t2=y[i];y[i]=y[j];y[j]=t2;
			i++;j--;
		}
	}
	if(a<j)sortlist(a,j);
	if(i<b)sortlist(i,b);
}

long explore(int& pos, int inc){
	long ret=oo, bx=x[pos];
	while((x[pos]==bx)&&(pos>0)&&(pos<n)){
		ret=min(ret,abs(x[pos]-dx)+abs(y[pos]-dy));
		pos+=inc;
	}
	return ret;
}

long getmin(){
	long dmin=oo,dc,dtx=0;
	int pmax=n,pmin=1;
	while(pmax>pmin)if(dtx>x[(pmax+pmin)/2])pmin=(pmax+pmin)/2+1; else pmax=(pmax+pmin)/2;
	while((dtx<dmin)&&((pmax<n)||(pmin>0))){
		if(pmax<n)dc=explore(pmax,1); if(dc<dmin)dmin=dc;
		if(pmin>0)dc=explore(pmin,-1); if(dc<dmin)dmin=dc;
		dtx=min(dx-x[pmin],x[pmax]-dx);
	}
	return dmin;
}

int main(){
	int i;

	r>>n; r>>m;
	for(i=1;i<=n;i++){r>>x[i]; r>>y[i];}
	sortlist(1,n);
	for(i=1;i<=m;i++){
		r>>dx; r>>dy;
		w<<getmin()<<"\n";
	}
	w.close();
	r.close();
	return 0;
}
