#include <fstream.h>

#define InFile "ghizi.in"
#define OutFile "ghizi.out"
#define NMax 5002
#define TMax 101


int n, k;
int t1[NMax], t2[NMax], fol[NMax];
int ord[NMax], _ord[NMax];
int out[NMax], gout, numout, found;


int pos ( int li , int ls )
{
	int i, j, modi = 1, modj = 0, m, aux;

	i = li; j = ls;

	while ( i < j )
	{
		if ( t1[i] > t1[j]  ||  ( t1[i] == t1[j] && t2[i] < t2[j] ) )
		{
			aux = t1[i]; t1[i] = t1[j]; t1[j] = aux;
			aux = t2[i]; t2[i] = t2[j]; t2[j] = aux;
			aux = ord[i]; ord[i] = ord[j];ord[j] = aux;
			m = modi; modi = -modj; modj = -m;
		}
		i += modi;
		j += modj;
	}
	return i;
}

void QSort (int li, int ls)
{
	if ( li < ls )
	{
		int mij;
		mij = pos ( li, ls );
		QSort ( li, mij-1 );
		QSort ( mij+1, ls );
	}
}

void ReadData ()
{
	ifstream fin ( InFile );
	fin >> n >> k;
	int i, j;

	for ( i = 1; i <= n; i++ )
	{
		fin >> t1[i] >> t2[i];
		ord[i] = i;
	}

	QSort ( 1, n );

	fin.close ();
}


void Solve ()
{
	int i, j;
	for ( i = n; i >= 1; i-- )
	{
		j = i+1;
		while ( t1[j] < t2[i] && j <= n )
			j++;
		while ( j <= n && t1[j] == t2[i] )
		{
			if ( out[ord[j]] != 0 && fol[j] == 0 )
			{
				out[ord[i]] = out[ord[j]];
				fol[j] = 1;
				break;
			}
			j++;

			if ( t1[i] == 0 )
				found ++;

			if ( found == k )
				return;
		}
		if ( !out[ord[i]] )
			if ( t2[i] == 100 )
				out[ord[i]] = ++numout;
	}
}


void WriteSol ()
{
	int i;
	ofstream fout ( OutFile );
	for ( i = 1; i <= n; i++ )
		if ( out[i] >= 1 && out[i] <= k )
			gout++;
	fout << gout << endl;
	for ( i = 1; i <= n; i++ )
		if ( out[i] >= 1 && out[i] <= k )
			fout << i << " ";
	fout.close ();
}


int main ()
{
	ReadData ();
	Solve ();
	WriteSol ();
	return 0;
}
