#include <stdio.h>
#include <stdlib.h>
#define intrare "ajutor.in"
#define iesire  "ajutor.out"

struct punct
{
 int x,y,np;
 bool sal;

};

int m,n;

inline bool operator > (punct &A, punct &B)
{
 return ((A.x>B.x)||(A.x==B.x&&A.y>B.y));
}

inline bool operator < (punct &A, punct &B)
{
 return ((A.x<B.x)||(A.x==B.x&&A.y<B.y));
}

inline void sc(punct &A,punct &B)
{
 punct aux;
 aux=A;
 A=B;
 B=aux;
}

void sort(punct *ss,int l,int r)
{
 int i,j;
 punct x=(ss[(l+r)/2]);
 i=l;j=r;
 do
   {
    while (ss[i]<x) i++;
    while (ss[j]>x) j--;
    if (i<=j)
      {
       sc(ss[i],ss[j]);
       i++;j--;
      }
   }
 while (i<=j);
 if (l<j) sort(ss,l,j);
 if (i<r) sort(ss,i,r);
}

punct acc[500005];
punct sal[405];
punct tot[500500];

int dist[500005];

void citire()
{
 int i,j;
 FILE *f=fopen(intrare,"r");
 fscanf(f,"%d%d",&n,&m);
 for (i=1;i<n+1;i++)
    {
     fscanf(f,"%d%d",&sal[i].x,&sal[i].y);
     sal[i].np=i;
     sal[i].sal=true;
    }
 for (i=1;i<m+1;i++)
    {
     fscanf(f,"%d%d",&acc[i].x,&acc[i].y);
     acc[i].np=i;
     acc[i].sal=false;
    }
 fclose(f);
}

inline int mdist(punct &A,punct &B)
{
 return abs(A.x-B.x)+abs(A.y-B.y);
}

void interc()
{
 int i=1,j=1,k=0,l;
 while (i<m+1&&j<n+1)
   tot[++k]=acc[i]<sal[j]?acc[i++]:sal[j++];
 if (i<m) while (i<m+1) tot[++k]=acc[i++];
 else if (j<n) while (j<n+1) tot[++k]=sal[j++];
}

void init()
{
 for (int i=1;i<m+1;i++) dist[i]=2000000000;
 tot[0].sal=true;
 tot[m+n+1].sal=true;
}

void rezolvare()
{
/*
 sort(sal,1,n);
 sort(acc,1,m);
 interc();
 int i,j,k,l,nr=m+n;
 for (i=1;i<nr+1;i++)
    if (tot[i].sal)
      {
       k=i-1;
       while (!tot[k].sal)
         {
          if (mdist(tot[k],tot[i])<dist[tot[k].np]) dist[tot[k].np]=mdist(tot[k],tot[i]);
          k--;
         }
       k=i+1;
       while (!tot[k].sal)
         {
          if (mdist(tot[k],tot[i])<dist[tot[k].np]) dist[tot[k].np]=mdist(tot[k],tot[i]);
          k++;
         }
      }
*/
 int i,j;
 for (i=1;i<m+1;i++)
    for (j=1;j<n+1;j++)
       if (mdist(acc[i],sal[j])<dist[i]) dist[i]=mdist(acc[i],sal[j]);
}

void scriere()
{
 int i;
 FILE *f=fopen(iesire,"w");
 for (i=1;i<m+1;i++) fprintf(f,"%d\n",dist[i]);
 fclose(f);
}

int main()
{
 citire();
 init();
 rezolvare();
 scriere();
 return 0;
}

