#include <stdio.h>

#define input "ghizi.in"
#define output "ghizi.out"

typedef struct t_ghid
		{
        	int x, y;
        } ghid;

void readdata(void);
int ok(int i);
void dec(int i);

int n, vec[128], s[6000], k;
ghid x[6000];

int main(void)
{
	int i, nr = 0;
    FILE *f;

	memset(x, 0, sizeof(x));
    memset(vec, 0, sizeof(vec));
    memset(s, 0, sizeof(s));

	readdata();

    for (i = 0; i < n; i++)
    	if (ok(i))
        {
        	s[i] = 1;
            nr++;
            dec(i);
        }

	f = fopen(output, "w");

    fprintf(f, "%d\n", n - nr);

    for (i = 0; i < n; i++)
    	if (!s[i])
        	fprintf(f, "%d ", i + 1);
    
    fclose(f);

    return 0;
}

void readdata(void)
{
	int i, j;
	FILE *f;

    f = fopen(input, "r");

    fscanf(f, "%d %d", &n, &k);

    for (i = 0; i < n; i++)
    {
    	fscanf(f, "%d %d", &x[i].x, &x[i].y);
		for (j = x[i].x; j < x[i].y; j++)
        	vec[j]++;
	}
    
    fclose(f);
}

int ok(int i)
{
	int j;

    for (j = x[i].x; j < x[i].y; j++)
    	if (vec[j] - 1 < k)
        	return 0;
            
   	return 1;
}

void dec(int i)
{
	int j;

    for (j = x[i].x; j < x[i].y; j++)
    	vec[j]--;
}
