#include <fstream.h>
#include <iomanip.h>
#define INFILE "scaune.in"
#define OUTFILE "scaune.out"
#define MAX 202

int s[MAX], ns, nc, k;

struct loc {
	int lin;
	int nw;
	int lf;
} l[MAX];

void Citeste();
void Solutie();
void Scrie();

int main()
{
	Citeste();
	Solutie();
	Scrie();

	return 0;
}

void Citeste()
{
	ifstream fin(INFILE);
	fin >> ns >> nc;

	int i = 1, j = 0;

	while ( i <= nc )
	{
		fin >> l[i].lin;
		l[i].nw = l[i].lin;
		i++;
	}

	k = 1;

	while ( !fin.eof() )
	{
		fin >> j;
		s[k++] = j;
	}

	k -= 2;

	fin.close();
}

void Solutie()
{
	int i, j = 1, ok;

	while ( j <= k )
	{
		ok = 0;
		for ( i = 1; i <= nc; i++ )
		{
			if ( l[i].nw == s[j] && !ok && !l[i].lf )
			{
				l[i].lf = s[j];
				s[j] = 0;
				ok = 1;
				l[i].nw = 0;
			}
			else if ( l[i].nw && l[i].nw < ns ) l[i].nw++;
				else if ( l[i].nw ) l[i].nw = 1;
		}
		if (ok) j++;
	}

}


void Scrie()
{
	ofstream fout(OUTFILE);

	int i;

	for ( i = 1; i <= nc; i++ )
		fout << l[i].lin << " " << l[i].lf << endl;

	fout.close();
}








