#include <fstream.h>
#include <string.h>
#define INFILE "seti.in"
#define OUTFILE "seti.out"
#define MAX 200001
#define LMAX 5
#define MAXN 11

char alfabet[MAXN], cuv[MAX][LMAX];
unsigned long int k;

void Citeste();
void Qsort(int l, int r);
void Scrie();
int MaiMic(char cuv1[LMAX], char cuv2[LMAX]);

int main()
{
	Citeste();
	Qsort (1, k);
	Scrie();

	return 0;
}

void Citeste()
{
	ifstream fin(INFILE);

	fin >> alfabet;

        fin.get();

	k = 1;

	while ( !fin.eof() )
	{
		fin.getline(cuv[k], LMAX);
		k++;
	}

	k--;

	fin.close();
}

void Qsort (int l, int r )
{
	unsigned long int i = l - 1, j = r + 1;
	char x[LMAX], aux[LMAX];
	x[0] = NULL;
	aux[0] = NULL;
	strcpy (x, cuv[l]);

	do
	{
		do { i++; } while ( MaiMic(cuv[i], x));
		do { j--; } while ( MaiMic(x, cuv[j]));
		if ( i <= j )
		{
			aux[0] = NULL;
			strcpy ( aux, cuv[i] );
			strcpy ( cuv[i], cuv[j] );
			strcpy ( cuv[j], aux );
		}
	} while ( i <= j );

	if ( i < r ) Qsort (i, r);
	if ( j > l ) Qsort (l, j);
}

int MaiMic(char cuv1[LMAX], char cuv2[LMAX] )
{
	char * p1 = NULL;
	char * p2 = NULL;

	int i;

	for ( i = 0; i <= 3; i++ )
	{
		p1 = strchr ( alfabet, cuv1[i] );
		p2 = strchr ( alfabet, cuv2[i] );
		if ( (p1 - alfabet) < (p2 - alfabet) ) return 1;
			else if ( (p1 - alfabet) > (p2 - alfabet) ) return 0;
	}

	return 0;
}

void Scrie()
{
	ofstream fout(OUTFILE);

        unsigned long int i;

	for ( i = 1; i <= k; i++ )
		fout << cuv[i] << endl;

	fout.close();
}
