#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define input "masina.in"
#define output "masina.out"

void readdata(void);
int getdif(int vertex);

int n, fuel[30000], *len, nofuel = 32000;

int main(void)
{
	int i, d = 0;
	FILE *f;

	len = malloc(30000 * sizeof(int));
	memset(len, 0, 30000 * sizeof(int));

	readdata();

	f = fopen(output, "w");

	for (i = n - 1; i >= 0; i--)
	{
		if (nofuel != i)
		{
			d += fuel[i] - len[i];
			if (d >= 0)
				d = getdif(i);
			if (!d)
			{
				fprintf(f, "%d", i + 1);
				return 0;
			}
		}
		else
		{
			d = getdif(i);
			if (!d)
			{
				fprintf(f, "%d", i + 1);
				return 0;
			}
		}
	}

	fclose(f);

	return 0;
}

void readdata(void)
{
	int i;
	FILE *f;

	f = fopen(input, "r");

	fscanf(f, "%d", &n);
	for (i = 0; i < n; i++)
		fscanf(f, "%d", &fuel[i]);

	for (i = 0; i < n; i++)
		fscanf(f, "%d", &len[i]);

	fclose(f);
}

int getdif(int vertex)
{
	int i, d = 0;

	for (i = vertex; i < n - 1; i++)
	{
		d += fuel[i];
		d -= len[i];
		if (d < 0)
		{
			nofuel = i;
			return d;
		}
	}

	d += fuel[n - 1];
	d -= len[n - 1];
	if (d < 0)
	{
		nofuel = n - 1;
		return d;
	}

	for (i = 0; i < vertex; i++)
	{
		d += fuel[i];
		d -= len[i];
		if (d < 0)
		{
			nofuel = i;
			return d;
		}
	}

	return 0;
}