#include <stdio.h>
#include <stdlib.h>

#define max(i, j) (((i) > (j)) ? (i) : (j))

int N, M, len;
int bitn[32], bitm[32], ln, lm;

int main()
{
    FILE *f;
    int i, j;

    f = fopen("operatii.in", "r");
    fscanf(f, "%d %d\n", &N, &M);
    fclose(f);

    while (N) bitn[ln++] = N & 1, N >>= 1;
    while (M) bitm[lm++] = M & 1, M >>= 1;

    int nz1 = 0, nz2 = 0;
    for (i = 0; i < ln; i++)
        nz1 += !bitn[i];
    for (i = 0; i < lm; i++)
        nz2 += !bitm[i];
    len = max(ln - nz1, lm - nz2);

    f = fopen("operatii.out", "w");
    
    fprintf(f, "%d\n", (1 << len) - 1);
    
    fprintf(f, "%d\n", len - ln + (nz1 << 1));
    for (i = j = 0; i < ln; i++)
        if (!bitn[i]) fprintf(f, "2 %d\n", i + 1 - j), j++;
    for (i = 0; i < len - ln + nz1; i++)
        fprintf(f, "1 %d\n", i + 1);
        
    fprintf(f, "%d\n", len - lm + (nz2 << 1));
    for (i = j = 0; i < lm; i++)
        if (!bitm[i]) fprintf(f, "2 %d\n", i + 1 - j), j++;
    for (i = 0; i < len - lm + nz2; i++)
        fprintf(f, "1 %d\n", i + 1);
        
    fclose(f);

    return 0;
}

