#include <fstream.h>
#include <math.h>
#define MAX 101
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
ifstream fin("munte.in");
ofstream fout("munte.out");
long H[MAX],i,j,N,X[MAX],L,K,Sol[MAX],n,ok,Sol2[MAX],i1,Ramase,Flag[MAX],l,found,eliminated,x0,y0,x1,y1,x2,y2,CP;
double Lung=0;

void Read()
{
 fin>>N>>K>>L;
 for (i=1;i<=N;i++)
  fin>>X[i]>>H[i];
 fin.close();
}

int dist(int x1,int y1,int x2,int y2)
{
 return ((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

int LungimeOK(int i,int j)
{
 return (dist(1,1,1,1)<=L*L);
}

int RemoveStation()
{
 for (i=2;i<=n-1;i++)
  if ((H[Sol[i-1]]>H[Sol[i]])&&(H[Sol[i+1]]>H[Sol[i]])&&(LungimeOK(Sol[i-1],Sol[i+1])))
  {
   Ramase--;
   Flag[Sol[i]]=0;
   return 1;
  }
 return 0;
}

int CrossProduct(int i,int j,int l)
{
 x0=X[i]; y0=H[i];
 x1=X[j]; y1=H[j];
 x2=X[l]; y2=H[l];
 x1-=x0; x2-=x0; y1-=y0; y2-=y0;
 return ((x1)*(y2)-(x2)*(y1));
}

int RemoveStation2()
{
 for (i=2;i<=n-1;i++)
  if (CP=CrossProduct(Sol[i-1],Sol[i],Sol[i+1])>0)
  {
   Ramase--;
   Flag[Sol[i]]--;
   return 1;
  }
 return 0;
}

void FindStations()
{
// Adaug toate statiile posibile
 for (i=1;i<=N;i++)
  { Flag[i]=1; Sol[i]=i; }
 n=N;
// Elimin cate statii trebuie
 Ramase=N-K;
 while (Ramase>0)
 {
  eliminated=RemoveStation();
  if (!eliminated) RemoveStation2();
  for (i=1;i<=n;i++)
   Sol[i]=0;
  n=0;
  for (i=1;i<=N;i++)
   if (Flag[i]) Sol[++n]=i;
 }
// Calculez lungimea drumului
 for (i=1;i<=K-1;i++)
  Lung+=sqrt(dist(X[Sol[i]],H[Sol[i]],X[Sol[i+1]],H[Sol[i+1]]));
}

void Print()
{
 if (Lung-floor(Lung)>=0.5) fout<<ceil(Lung)<<endl;
		       else fout<<floor(Lung)<<endl;
 for (i=1;i<=K-1;i++)
  fout<<Sol[i]<<" ";
 if (K>0) fout<<Sol[K];
 fout.close();
}

int main()
{
 Read();
 FindStations();
 Print();
 return 0;
}