#include <fstream.h>

int n, m;
const int di[] = {1, 0, -1, 0};
const int dj[] = {0, 1, 0, -1};
const char dir[] = {'S', 'E', 'N', 'V'};
int a[51][51], w[51][51], fol[51][51];
int cost[11], t[51][51];

struct nod {
	nod * urm;
	int l, c, sum;
	char s[11];
} * prim, * ultim;

void Add ( int l, int c, int b, nod *q )
{
	if ( prim == NULL )
	{
		prim = new nod;
		prim->urm = NULL;
		prim->l = l;
		prim->c = c;
		prim->sum = 0;
		int k;
		for ( k = 0; k < 11; k++ )
			prim->s[k] = 0;
		ultim = prim;
	}
	else
	{
		nod *p;
		p = new nod;
		p->urm = NULL;
		p->l = l;
		p->c = c;
		int k;
		for ( k = 0; k < 11; k++ )
			p->s[k] = q->s[k];
		p->s[b] = 1;
		p->sum = cost[b] + q->sum;
		ultim->urm = p;
		ultim = p;
	}
}

void Remove ()
{
	nod *p;
	p = prim;
	prim = prim->urm;
	delete p;
}

int Pret ( char q[], int sum, int b )
{
	if  (q[b] == 0)
		return sum + cost[b];
	else return sum;
}

void Rezolva ()
{
	int i, j, k;
	nod * p;
	p = prim;

	w[1][1] = -1;
	while ( p != NULL )
	{
		int inou, jnou;
		for ( k = 0; k < 4; k++ )
		{
			inou = di[k] + p->l;
			jnou = dj[k] + p->c;
			if ( inou >= 1 && inou <= n && jnou >= 1 && jnou <= m )
				if ( fol[inou][jnou] == 0 || t[inou][jnou] > Pret (p->s, p->sum, a[inou][jnou]))
				{
					t[inou][jnou] = Pret (p->s, p->sum, a[inou][jnou]);
					fol[inou][jnou] = 1;
					w[inou][jnou] = k;
					Add ( inou, jnou, a[inou][jnou], p );
				}
		}
		p = p->urm;
		Remove ();
	}
	k=0;

}

void Scrie ()
{
	char sol[10001]={0};
	ofstream fout ( "muzeu.out" );
	fout << t[n][m] << '\n';
	int i, j, aux;
	i = n; j = m;
	while ( i != 1 || j != 1 )
	{
		sol[++sol[0]] = dir[w[i][j]];
		aux = w[i][j];
		i -= di[aux];
		j -= dj[aux];

	}
	fout << (int)sol[0] << '\n';
	for ( i = sol[0]; i >= 1; i-- )
		fout << sol[i];

	fout.close ();
}


int main ()
{
	int i, j;
	ifstream fin ("muzeu.in");
	fin >> n >> m;
	for ( i = 1; i <= n; i++ )
		for ( j = 1; j <= m;j++ )
			fin >> a[i][j];

	for ( i = 1; i <= 10; i++)
		fin >> cost[i];
	Add ( 1, 1, 0, NULL );
	Rezolva ();
	Scrie ();
	return 0;
}