#include <iostream.h>
#include <fstream.h>
#define max 200000

int m, n, a[51][51], cost[11], coada1[2501][2], coada2[2501][2], c[51][51];
long int b[51][51];
char traseu[10001];
const int di[] = { -1, 0, 1, 0 };
const int dj[] = { 0, 1, 0, -1 };

void Citeste();
void Solutie();
void Afiseaza();
int Bun(int i, int j);

int main()
{
	Citeste();
	Solutie();
	Afiseaza();
	return 0;
}

void Citeste()
{
	ifstream fin ( "muzeu.in" );
	int i = 0, j = 0;
	fin >> m >> n;
	for ( i = 1; i <= m; i++ )
		for ( j = 1; j <= n; j++ )
		{
			fin >> a[i][j];
			b[i][j] = max;
		}
	for ( i = 1; i <= 10; i++ )
		fin >> cost[i];
	fin.close();
}

void Solutie()
{
	int fin1 = 0, fin2 = 0, k = 0, p = 0, x = 0, y = 0, in = 0, jn = 0;
	b[1][1] = 0;
	coada1[0][0] = 1;
	coada1[0][1] = 1;
	fin1 = 1;
	fin2 = 0;
	while ( fin1 )
	{
		for ( k = 0; k < fin1; k++ )
		{
			x = coada1[k][0];
			y = coada1[k][1];
			for ( p = 0; p < 4; p++ )
			{
				in = x + di[p];
				jn = y + dj[p];
				if ( Bun(in, jn) )
					if ( b[in][jn] > b[x][y] + cost[a[in][jn]] )
					{
						b[in][jn] = b[x][y] + cost[a[in][jn]];
						coada2[fin2][0] = in;
						coada2[fin2][1] = jn;
						fin2++;
						c[in][jn] = c[x][y] + 1;
					}
			}
		}
		memcpy(coada1, coada2, sizeof(coada2) );
		fin1 = fin2;
		fin2 = 0;
	}
}

int Bun(int i, int j)
{
	if ( i < 1 || j < 1 || i > m || j > n )return 0;
	return 1;
}

void Afiseaza()
{
	ofstream fout ( "muzeu.out" );
	int i = 0, j = 0, pas = 0, p = 0, gasit = 0, indice = 0;
	pas = c[m][n];
	i = m, j = n;
	while ( pas > 1 )
	{
		for ( p = 0; p < 4; p++ )
		{
			if ( c[i+di[p]][j+dj[p]] == pas - 1 && b[i+di[p]][j+dj[p]] < max)
			{
				i += di[p];
				j += dj[p];
				gasit = p;
				p = 4;
			}
		}
		pas--;
		switch ( gasit )
		{
			case 0 : traseu[indice++] = 'S'; break;
			case 1 : traseu[indice++] = 'V'; break;
			case 2 : traseu[indice++] = 'N'; break;
			case 3 : traseu[indice++] = 'E'; break;
		}
	}
	if ( i - 1 == 1 )traseu[indice++] = 'S';
	else             if ( j - 1 == 1 )traseu[indice++] = 'E';
	fout << b[m][n] << endl;
	fout << c[m][n] << endl;
	for ( i = indice - 1; i >= 0; i-- )
		fout << traseu[i];
	fout.close();
}