#include <iostream.h>
#include <stdio.h>
#include <math.h>

float *a[2],**b;
int n,K,l,L,**c,*d;

void citire();
void rezolv();
void shtdwn();
float pune(int a1,int a2);
void drum(int a1,int a2);
void scrier();
int mic(int a);
int mare(int a);

int main()
{
  citire();
  rezolv();
  shtdwn();
  return 0;
}

void citire()
{
  int i;
  FILE *f;
  f = fopen("munte.in","r");
  fscanf(f,"%d %d %d\n",&n,&K,&l);
  a[0] = new float [n+1];
  a[1] = new float [n+1];
  for(i=1;i<=n;i++)
    fscanf(f,"%f %f\n",&a[0][i],&a[1][i]);
  fclose(f);
}

void rezolv()
{
  int i,j,k,aux;

  b = new float *[n+1];
  for(i=0;i<=n;i++)
    b[i] = new float [n+1];
  c = new int *[n+1];
  for(i=0;i<=n;i++)
    c[i] = new int [n+1];
  d = new int[n+1];
  for(i=0;i<=n;i++)
    d[i] = 0;

  for(i=0;i<=n;i++)
    for(j=0;j<=n;j++)
      c[i][j]=0;

  L = l*l;

  for(i=1;i<=n;i++)
    for(j=i+1;j<=n;j++)
    {
      b[i][j] = pune(i,j);
      if(b[i][j])
	c[i][j]=1;
    }
  delete []a[1];
  delete []a[0];

  for(k=1;k<=n;k++)
    for(i=1;i<=n;i++)
      for(j=i+1;j<=n;j++)
	if(c[i][k] && c[k][j])
	  if(!b[i][j] || (b[i][j]>b[i][k]+b[k][j]))
	  {
	    c[i][j] = c[i][k]+ c[k][j];
	    b[i][j] = b[i][k]+ b[k][j];
	  }

  d[1]=1;
  drum(1,n);
  if(c[1][n] == K-1)
    scrier();
  else
  {
    float cost,C;
    int poz,m,M;
    aux = K - 1 - c[1][n];
    while(aux)
    {
      cost= 99999999999999999999999999999.f;
      for(i=2;i<n;i++)
	if(!d[i])
	{
	  m = mic(i);
	  M = mare(i);
	  C = b[m][i] + b[i][M];
	  if(C<cost)
	  {
	    cost = C;
	    poz = i;
	  }
	}
      b[1][n]+=cost;
      d[poz]=1;
      aux--;
    }
    scrier();
  }
}

void shtdwn()
{
  int i;
  for(i=1;i<=n;i++)
    delete []b[i];
  delete []b;
  for(i=1;i<=n;i++)
    delete []c[i];
  delete []c;
  delete []d;
}

float pune(int a1,int a2)
{
  int i;
  float d,difx,dify;
  difx = a[0][a1]-a[0][a2];
  dify = a[1][a1]-a[1][a2];
  d = difx*difx + dify*dify;
  if(d>L)
    return 0;
  for(i=a1+1; i<a2; i++)
    if(a[1][i] >= ( (a[0][i]-a[0][a1])*dify + a[1][a1]*difx )/difx )
      return 0;
  return (float)sqrt(d);
}

void drum(int a1,int a2)
{
  int k;
  if(a1>=a2)
    return;
  if(c[a1][a2]==1)
    d[a2]=1;
  else
    for(k=a1+1;k<=n;k++)
      if(c[a1][k] && c[k][a2])
	if(b[a1][a2] == b[a1][k] + b[k][a2])
	{
	  drum(a1,k);
	  drum(k,a2);
	  return;
	}
}

void scrier()
{
  FILE *f;
  f = fopen("munte.out","w");
  fprintf(f,"%d\n",(int)b[1][n]);
  for(int i=1;i<=n;i++)
    if(d[i])
      fprintf(f,"%d ",i);
  fclose(f);
}

int mic(int a)
{
  for(int i=a; i>0; i--)
    if(d[i])
      return i;
  return 0;
}

int mare(int a)
{
  for(int i=a; i<=n; i++)
    if(d[i])
      return i;
  return 0;
}
