#include <iostream.h>
#include <stdio.h>

int m,n,c[11],xx[]={-1,0,1,0},yy[]={0,1,0,-1},M;
char **a[3];
long **b;
int **d;
int *sol;

void citire();
void rezolv();
void shtdwn();
void pune_cartela(int i,int j,int k);
int ia_cartela(int i,int j,int k);
void reconst(int i,int j,int poz);
void scrier();

int main()
{
  citire();
  rezolv();
  scrier();
  shtdwn();
  return 0;
}

void citire()
{
  int i,j;
  FILE *f;
  f = fopen("muzeu.in","r");
  fscanf(f,"%d %d\n",&m,&n);
  for(i=0;i<3;i++)
  {
    a[i] = new char *[m];
    for(j=0;j<m;j++)
      a[i][j] = new char [n];
  }
  b = new long *[m];
  for(i=0;i<m;i++)
    b[i] = new long [n];
  d = new int *[m];
  for(i=0;i<m;i++)
    d[i] = new int [n];

  for(i=0;i<m;i++)
    for(j=0;j<n;j++)
      a[0][i][j] = a[1][i][j] = a[2][i][j] = b[i][j] = d[i][j] = 0;

  for(i=0;i<m;i++,fscanf(f,"\n"))
    for(j=0;j<n;j++)
      fscanf(f,"%d ",&a[0][i][j]);

  for(i=1;i<=10;i++)
    fscanf(f,"%d ",&c[i]);

  fclose(f);
}

void rezolv()
{
  int i,j,x,y,k;
  b[0][0]=0;
  d[0][0]=1;
  int num = 1;
  m--;
  n--;
  while(!b[m][n])
  {
    for(i=0;i<=m;i++)
      for(j=0;j<=n;j++)
	if(d[i][j]==num)
	  for(k=0;k<4;k++)
	  {
	    x = i + xx[k];
	    y = j + yy[k];
	    if(x>=0 && x<=m && y>=0 && y<=n)
	    {
	      if(!d[x][y])
	      {
		if(a[0][x][y] == 0)
		{
		  a[1][x][y] = a[1][i][j];
		  a[2][x][y] = a[1][i][j];
		  b[x][y] = b[i][j];
		  d[x][y] = d[i][j]+1;
		}
		else
		{
		  a[1][x][y] = a[1][i][j];
		  a[2][x][y] = a[1][i][j];
		  if(!ia_cartela(x,y,a[0][x][y]))
		  {
		    pune_cartela(x,y,a[0][x][y]);
		    b[x][y] = b[i][j] + c[a[0][x][y]];
		    d[x][y] = d[i][j]+1;
		  }
		  else
		  {
		    b[x][y] = b[i][j];
		    d[x][y] = d[i][j]+1;
		  }
		}
	      }
	      else
	      {
		if(a[0][x][y] == 0)
		  if(b[x][y] > b[i][j])
		  {
		    a[1][x][y] = a[1][i][j];
		    a[2][x][y] = a[1][i][j];
		    b[x][y] = b[i][j];
		    d[x][y] = d[i][j]+1;
		  }
		  else ;
		else
		{
		  long cost;
		  if(!ia_cartela(i,j,a[0][x][y]))
		    cost = b[i][j] + c[a[0][x][y]];
		  else
		    cost = b[i][j];
		  if(b[x][y] > cost)
		  {
		    a[1][x][y] = a[1][i][j];
		    a[2][x][y] = a[1][i][j];
		    pune_cartela(x,y,a[0][x][y]);
		    b[x][y] = cost;
		    d[x][y] = d[i][j]+1;
		  }
		}
	      }
	    }
	  }
    num++;
  }
  M = d[m][n];
  sol = new int [M];
  reconst(m,n,1);
}

void shtdwn()
{
  int i,j;

  for(i=1;i<m;i++)
    delete a[2][i];
  delete []a[2];
  for(i=1;i<m;i++)
    delete a[1][i];
  delete []a[1];
#ifdef __STDIO_H
  for(i=1;i<m;i++)
    delete a[0][i];
#else
  delete []a[0];
#endif
  for(i=0;i<m;i++)
    delete b[j];
  delete b;
  for(i=0;i<m;i++)
    delete d[j];
  delete d;
}

void pune_cartela(int i,int j, int k)
{
  switch(k)
  {
    case  1: a[1][i][j] |= 1<<6; break;
    case  2: a[1][i][j] |= 1<<5; break;
    case  3: a[1][i][j] |= 1<<4; break;
    case  4: a[1][i][j] |= 1<<3; break;
    case  5: a[1][i][j] |= 1<<2; break;
    case  6: a[1][i][j] |= 1<<1; break;
    case  7: a[1][i][j] |= 1<<0; break;
    case  8: a[2][i][j] |= 1<<7; break;
    case  9: a[2][i][j] |= 1<<6; break;
    case 10: a[2][i][j] |= 1<<5; break;
  }
}

int ia_cartela(int i,int j,int k)
{
  switch(k)
  {
    case  1: return ( (a[1][i][j]&1<<6) >> 6);
    case  2: return ( (a[1][i][j]&1<<5) >> 5);
    case  3: return ( (a[1][i][j]&1<<4) >> 4);
    case  4: return ( (a[1][i][j]&1<<3) >> 3);
    case  5: return ( (a[1][i][j]&1<<2) >> 2);
    case  6: return ( (a[1][i][j]&1<<1) >> 1);
    case  7: return ( (a[1][i][j]&1<<0) >> 0);
    case  8: return ( (a[2][i][j]&1<<7) >> 7);
    case  9: return ( (a[2][i][j]&1<<6) >> 6);
    case 10: return ( (a[2][i][j]&1<<5) >> 5);
  }
  return 0;
}

void reconst(int i,int j,int poz)
{
  int k,x,y,sw;
  for(k=0;k<4;k++)
  {
    sw = 0;
    x = i + xx[k];
    y = j + yy[k];
    if(x>=0 && x<=m && y>=0 && y<=n)
      if(d[x][y]+1 == d[i][j])
      {
	if(!a[0][i][j])
	  if(b[i][j] == b[x][y]) sw = 1;
	  else                   sw = 0;
	else
	  if(ia_cartela(x,y,a[0][i][j]))
	    if(b[i][j] == b[x][y]) sw = 1;
	    else                   sw = 0;
	  else
	    if(b[x][y]+c[a[0][i][j]] == b[i][j]) sw = 1;
	    else                                 sw = 0;
	if(sw)
	{
	  sol[poz] = k;
	  reconst(x,y,poz+1);
	  return ;
	}
      }
  }
}

void scrier()
{
  FILE *f;
  f = fopen("muzeu.out","w");
  fprintf(f,"%lu\n%d\n",b[m][n],d[m][n]-1);
  for(int i=M;i>=1;i--)
    switch(sol[i])
    {
      case 0:fprintf(f,"S");break;
      case 1:fprintf(f,"V");break;
      case 2:fprintf(f,"N");break;
      case 3:fprintf(f,"E");break;
    }
  fclose(f);
  delete []sol;
}