#include <fstream.h>
#define n_max 50
#define oo 1000000

struct node{
	char x;
	char y;
	int td;
	node* next;
};

const int dx[4]={1,0,-1,0};
const int dy[4]={0,1,0,-1};
const char dc[4]={'N','V','S','E'};
int m,n;
int mt[n_max][n_max];
int c[10];
int cmin[n_max][n_max];
int nmin[n_max][n_max];
char p[n_max][n_max];
node* head=NULL;
node* tail=NULL;

void setbit(int& x, int b){x=x|1<<b;}
int getbit(int x, int b){return (x&(1<<b))>>b;}

int check(char x, char y, char xp, char yp){
	int cx=xp, cy=yp;
	while(p[cx][cy]!=-1){
		if((cx==x)&&(cy==y))return 0;
		cx+=dx[p[cx][cy]];
		cy+=dy[p[cx][cy]];
	}
	return 1;
}

void qadd(char x, char y, int td){
	node* tmp=new node;
	tmp->x=x;
	tmp->y=y;
	tmp->td=td;
	tmp->next=NULL;
	tail->next=tmp;
	tail=tmp;
}

void in(){
	int i,j;

	ifstream r(".in");
	r>>m; r>>n;
	for(i=1;i<=m;i++)for(j=1;j<=n;j++){
		p[i][j]=-1;
		r>>mt[i][j];
	}
	for(i=1;i<=10;i++)r>>c[i];
	c[0]=0;
	r.close();
}

void out(){
	ofstream w(".out");
	w<<nmin[m][n];
	w.close();
}

void qprocess(){
	node* tmp=head;
	head=head->next;
	int i,x,y,td;
	long cost;
	for(i=0;i<=3;i++)if(check(x+dx[i],y+dy[i],tmp->x,tmp->y)){
		x=tmp->x+dx[i];
		y=tmp->y+dy[i];
		td=tmp->td;
		cost=cmin[tmp->x][tmp->y];
		if(! getbit(td,mt[x][y])){
			setbit(td,mt[x][y]);
			cost+=c[mt[x][y]];
			if((cost<cmin[x][y])||((cost==cmin[x][y])&&(nmin[tmp->x][tmp->y]+1<nmin[x][y]))){
				cmin[x][y]=cost;
				nmin[x][y]=nmin[tmp->x][tmp->y]+1;
				p[x][y]=i;
            qadd(x,y,td);
			}
		}
	}
	delete tmp;
}

void main(){
	in();
	while(head!=NULL)qprocess();
	out();
}