{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 64000,0,655360}
program munte;
const max = 50000000;
type coord = record
           x,y : real;
     end;
     vect = array[0..30] of real;
     statie = record
            st : byte;
            np : byte;
     end;
     sta = array[1..100,1..30] of statie;

var n,k : byte;
    l : longint;
    pct : array[1..100] of coord;
    dm : array[1..100,1..100] of ^vect;
    sti : array[1..100] of ^sta;
    fo : text;

    a,b,c,x1,y1,x2,y2,vl : real;
    v : byte;

procedure ReadData;
var f : text;
    i : byte;
begin
     assign(f,'munte.in'); reset(f);
     readln(f,n,k,l);
     for i:=1 to n do readln(f,pct[i].x,pct[i].y);
     close(f);
end;

procedure Init;
var i : byte;
begin
     for i:=1 to n do new(sti[i]);
end;

function Distanta(a,b:byte):real;
begin
     Distanta:=sqrt(sqr(pct[a].x-pct[b].x)+sqr(pct[a].y-pct[b].y));
end;

function Poate_Direct(i,j:byte):boolean;
begin
     {calc. coef. dr. det. de pct. i,j}
     x1:=pct[i].x; y1:=pct[i].y;
     x2:=pct[j].x; y2:=pct[j].y;
     a:=y1-y2;
     b:=x2-x1;
     c:=x1*y2-x2*y1;
     {verific fiec. pct i<v<j}
     Poate_Direct:=true;
     for v:=i+1 to j-1 do begin
         vl:=a*pct[v].x + b*pct[v].y + c;
         if vl>=0 then Poate_Direct:=false;
     end;
end;

procedure Dzinamica;
var i,j,jj,t,ni,np : byte;
    nd : real;
begin
     for i:=1 to n-1 do begin
         new(dm[i,i+1]);
         for t:=0 to k do dm[i,i+1]^[t]:=max;
         dm[i,i+1]^[0]:=Distanta(i,i+1);
         if dm[i,i+1]^[0]>l then dm[i,i+1]^[0]:=max;
     end;
     for jj:=1 to n-1 do begin
         i:=0; j:=jj;
         repeat
               i:=i+1; j:=j+1;
               new(dm[i,j]);
               for t:=0 to k do dm[i,j]^[t]:=max;
               if Poate_Direct(i,j) then begin
                  dm[i,j]^[0]:=Distanta(i,j);
                  if dm[i,j]^[0]>l then dm[i,j]^[0]:=max;
               end;
               for ni:=1 to j-i-1 do begin
                   for t:=i+1 to j-1 do begin
                       np:=0;
                       while (np<=t-i-1) and (ni-np-1>=0) do begin
                             nd:=dm[i,t]^[np]+dm[t,j]^[ni-np-1];
                             if nd<max then begin
                                if nd<dm[i,j]^[ni] then begin
                                   dm[i,j]^[ni]:=nd;
                                   sti[i]^[j,ni].st:=t;
                                   sti[i]^[j,ni].np:=np;
                                end;
                             end;
                             np:=np+1;
                       end;
                   end;
               end;
         until (i>=n) or (j>=n);
     end;
end;

procedure Rec(i,j,w:byte);
begin
     if w=0 then write(fo,i,' ')
     else begin
          Rec(i,sti[i]^[j,w].st,sti[i]^[j,w].np);
          Rec(sti[i]^[j,w].st,j,w-sti[i]^[j,w].np-1);
     end;
end;

procedure WriteData;
begin
     assign(fo,'munte.out'); rewrite(fo);
     writeln(fo,round(dm[1,n]^[k-2]));
     Rec(1,n,k-2);
     writeln(fo,n);
     close(fo);
end;

begin
     ReadData;
     Init;
     Dzinamica;
     WriteData;
end.