{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program muzeu;
type vect = array[1..10] of byte;
     pnod = ^nod;
     nod = record
         l,c : byte;
         urm : pnod;
     end;
const dl : array[1..4] of shortint = (-1,0,1,0);
      dc : array[1..4] of shortint = (0,1,0,-1);
var m,n : byte;
    a : array[1..50,1..50] of byte;
    cst : array[0..10] of word;
    dmin : array[1..50,1..50] of longint;
    cmin : array[1..50,1..50] of longint;
    b : array[1..50,1..50] of vect;
    dir : array[1..50,1..50] of byte;
    cap,coa : pnod;

procedure ReadData;
var f : text;
    i,j : byte;
begin
     assign(f,'muzeu.in'); reset(f);
     readln(f,m,n);
     for i:=1 to m do begin
         for j:=1 to n do read(f,a[i,j]);
         readln(f);
     end;
     for i:=1 to 10 do read(f,cst[i]);
     close(f);
end;

procedure Init;
var i,j : byte;
begin
     for i:=1 to m do
         for j:=1 to n do begin
             dmin[i,j]:=maxlongint;
             cmin[i,j]:=maxlongint;
         end;
end;

procedure Push(l,c:byte);
var p : pnod;
begin
     new(p); p^.l:=l; p^.c:=c; p^.urm:=nil;
     if cap=nil then begin
        cap:=p; coa:=p;
     end
     else begin
          coa^.urm:=p; coa:=p;
     end;
end;

procedure Pop(var l,c:byte);
var p : pnod;
begin
     l:=cap^.l; c:=cap^.c;
     if cap=coa then begin
        dispose(cap); cap:=nil; coa:=nil;
     end
     else begin
          p:=cap; cap:=cap^.urm;
          dispose(p);
     end;
end;

procedure Dzinamica;
var l,c,d : byte;
    nl,nc : integer;
    cost : longint;
begin
     dmin[m,n]:=0; cmin[m,n]:=0; Push(m,n);
     while cap<>nil do begin
           Pop(l,c);
           for d:=1 to 4 do begin
               nl:=l+dl[d]; nc:=c+dc[d];
               if (1<=nl) and (nl<=m) and (1<=nc) and (1<=n) then begin
                  if b[l,c][a[nl,nc]]=0 then cost:=cmin[l,c]+cst[a[nl,nc]]
                  else cost:=cmin[l,c];
                  if cost<=cmin[nl,nc] then begin
                     if ((cost=cmin[nl,nc]) and (dmin[l,c]+1<dmin[nl,nc])) or
                        (cost<cmin[nl,nc]) then
                     begin
                        cmin[nl,nc]:=cost;
                        dmin[nl,nc]:=dmin[l,c]+1;
                        b[nl,nc]:=b[l,c];
                        if b[l,c][a[nl,nc]]=0 then b[nl,nc][a[nl,nc]]:=1;
                        case d of
                             1 : dir[nl,nc]:=3;
                             2 : dir[nl,nc]:=4;
                             3 : dir[nl,nc]:=1;
                             4 : dir[nl,nc]:=2;
                        end;
                        Push(nl,nc);
                     end;
                  end;
               end;
           end;
     end;
end;

procedure WriteData;
var f : text;
    l,c,nl,nc : byte;
begin
     assign(f,'muzeu.out'); rewrite(f);
     writeln(f,cmin[1,1]);
     writeln(f,dmin[1,1]);
     l:=1; c:=1;
     repeat
           case dir[l,c] of
                1 : write(f,'N');
                2 : write(f,'E');
                3 : write(f,'S');
                4 : write(f,'V');
           end;
           nl:=l+dl[dir[l,c]];
           nc:=c+dc[dir[l,c]];
           l:=nl; c:=nc;
     until (l=m) and (c=n);
     close(f);
end;

begin
     ReadData;
     Init;
     Dzinamica;
     WriteData;
end.