{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const dx:array[1..4]of longint=(-1,0,1,0);
const dy:array[1..4]of longint=(0,1,0,-1);
const mut:string='NESV';
var a,b,x:array[0..11,0..11]of longint;
    suma,conc,optim,ii,jj,xl,yl,max,mp,i,j,k,l,m,n:longint;
    fi,fo:text;
    st,sol,lup,sumalup:array[0..100]of longint;
    s:string;

procedure eroare(scor:integer;s:string);
begin
  writeln('Scor=',scor,': ',s);
  halt;
end;

procedure readdata;
begin
  writeln;
  assign(fi,'scufita.in');
  assign(fo,'scufita.out');
  reset(fi);
  readln(fi,n);
  for i:=1 to n do
      begin
        for j:=1 to n do
            read(fi,a[i,j]);
        readln(fi);
      end;
  for i:=1 to n do
      begin
        for j:=1 to n do
            read(fi,b[i,j]);
        readln(fi);
      end;
  close(fi);
end;

procedure mutaLupul;
begin
  xl:=1;
  yl:=1;
  sumalup[0]:=b[1,1];
  for i:=1 to 15 do
      begin
        b[xl,yl]:=0;
        max:=b[xl+dx[1],yl+dy[1]];
        mp:=1;
        for j:=2 to 4 do
            if b[xl+dx[j],yl+dy[j]]>max then
               begin
                 max:=b[xl+dx[j],yl+dy[j]];
                 mp:=j;
               end;
        for j:=mp+1 to 4 do
            if b[xl+dx[j],yl+dy[j]]=max then
               begin
                 writeln('Test eronat: lupul nu are drum unic');
                 exit;
               end;
        sumalup[i]:=sumalup[i-1]+max;
        xl:=xl+dx[mp];
        yl:=yl+dy[mp];
      end;
end;

procedure react(cost:longint);
begin
  if cost>optim then
     begin
       optim:=cost;
       sol:=st;
     end;

end;

procedure back(k,i,j,suma:longint);
var d:integer;
begin
  inc(m);
  if suma<sumalup[k] then
     exit;


  if k=15 then
     begin
       react(suma);
       exit;
     end;

  if suma<sumalup[k] then
     exit;

  for d:=1 to 4 do
      begin
        ii:=i+dx[d];
        jj:=j+dy[d];
        if x[ii,jj]=0 then
           begin
             x[ii,jj]:=k+2;
             st[k]:=d;
             back(k+1,ii,jj,suma+a[ii,jj]);
             x[i+dx[d],j+dy[d]]:=0;
           end;



      end;

end;

procedure solve;
begin
  mutaLupul;
  optim:=-1;

  for i:=0 to n+1 do
      for j:=0 to n+1 do
          if a[i,j]=0 then
             x[i,j]:=1;
  x[1,1]:=1;
  back(0,1,1,a[1,1]);

  reset(fo);
  if ioresult<>0 then
     eroare(0,'Eroare la deschiderea fisierului de iesire.');

  readln(fo,conc);
  if ioresult<>0 then
     eroare(0,'Eroare la citirea numarului de ciupercute.');

  readln(fo,s);
  close(fo);

  if conc<optim then
     eroare(0,'Solutie neoptima');

  suma:=a[1,1];
  a[1,1]:=0;
  i:=1;
  j:=1;
  for k:=1 to 15 do
      begin
        case s[k] of
        'N': i:=i-1;
        'E': j:=j+1;
        'S': i:=i+1;
        'V': j:=j-1;
        else
        eroare(0,'Caracter invalid in fisier');
        end;
        if (i<1)or(j<1)or(i>n)or(j>n) then
           eroare(0,'Scufita iese din matrice');
        if a[i,j]=0 then
           eroare(0,'Scufita ajunge intr-o casuta goala');
        suma:=suma+a[i,j];
        if suma<sumalup[k] then
           eroare(0,'Scufita pierde din cauza sumei prea mici dupa K<=15 minute');
      end;
  if suma<>conc then
     eroare(0,'Scufita nu culege atatea ciupercute cate a declarat');
  if conc>optim then
     eroare(1000,'OK, dar mai multe decat mine');
  if conc=optim then
     eroare(10,'Corect');

end;

begin
  readdata;
  solve;
end.