#include <fstream.h>
#define MAX 12
ifstream fin("scufita.in");
ofstream fout("scufita.out");
short int L[MAX][MAX],S[MAX][MAX],T[MAX][MAX],Max[MAX][MAX],dir;
int i,j,N,CLup[20],n,dx[]={0,-1,0,1,0},dy[]={0,0,-1,0,1},x,y,x1,y1,max,CLup2[20],CScufita[20],k,CMax;

void ReadData()
{
 fin>>N;
 for (i=1;i<=N;i++)
  for (j=1;j<=N;j++)
   fin>>S[i][j];
 for (i=1;i<=N;i++)
  for (j=1;j<=N;j++)
   fin>>L[i][j];
 fin.close();
}

void FindWolfPath()
{
 x=y=1; n=0;
 CLup[++n]=L[x][y]; L[x][y]=0;
 while (n<=15)
 {
  x1=y1=0; CLup[++n]=0;
  for (i=1;i<=4;i++)
  {
   x+=dx[i]; y+=dy[i];
   if ((x>=1)&&(x<=N)&&(y>=1)&&(y<=N))
    if (L[x][y]>CLup[n]) { x1=x; y1=y; CLup[n]=L[x][y]; }
   x-=dx[i]; y-=dy[i];
  }
  x=x1; y=y1; L[x][y]=0;
 }
 for (i=1;i<=16;i++)
  CLup2[i]=CLup2[i-1]+CLup[i];
}

void Fill()
{
 if (k<=15)
 {
  k++;
  for (int i=1;i<=4;i++)
  {
   x+=dx[i]; y+=dy[i];
   if ((x>=1)&(x<=N)&&(y>=1)&&(y<=N)&&(S[x][y])&&(!T[x][y]))
    if (CScufita[k-1]+S[x][y]>=CLup2[k])
    {
     CScufita[k]=CScufita[k-1]+S[x][y];
     T[x][y]=k;
     Fill();
     T[x][y]=0;
     CScufita[k]=0;
    }
   x-=dx[i]; y-=dy[i];
  }
  k--;
 }
 else
 {
  if (CScufita[k]>CMax)
  {
   CMax=CScufita[k];
   for (int i=1;i<=N;i++)
    for (int j=1;j<=N;j++)
     Max[i][j]=T[i][j];
  }
 }
}

void FindPath()
{
 x=y=k=1; CScufita[k]=S[x][y]; T[x][y]=1;
 Fill();
}

void Print()
{
 fout<<CMax<<endl;
 n=1; x=y=1;
 while (n<=15)
 {
  if (Max[x+1][y]==n+1) dir='S';
  if (Max[x][y+1]==n+1) dir='E';
  if (Max[x-1][y]==n+1) dir='N';
  if (Max[x][y-1]==n+1) dir='V';
  fout<<(char)dir;
  switch (dir)
  {
   case 'S': x++; break;
   case 'E': y++; break;
   case 'N': x--; break;
   case 'V': y--; break;
  }
  n++;
 }
 fout.close();
}

int main()
{
 ReadData();
 FindWolfPath();
 FindPath();
 Print();
 return 0;
}