#include <fstream.h>

#define InFile "scufita.in"
#define OutFile "scufita.out"

int n, s[13][13], l[13][13];
int w[13][13], sum, sumax, _w[13][13];
int pasl[18];

const int di[] = {1, 0, -1, 0};
const int dj[] = {0, -1, 0, 1};
const char dir[] = "SVNE";

void citeste ()
{
	int i, j;
	ifstream fin( InFile );
	fin >> n;
	for ( i = 1; i <= n; i++ )
		for ( j = 1; j <= n; j++ )
			fin >> s[i][j];
	for ( i = 1; i <= n; i++ )
		for ( j = 1; j <= n; j++ )
			fin >> l[i][j];
	fin.close ();
}


void recons_lup ()
{
	int i=1, j=1, k=0;
	int pas = 0;
	pasl[0] = l[1][1];
	while ( pas <= 15 )
	{
		int max=0, dmax=0;
		max = 0;
		l[i][j] = 0;
		for ( k = 0; k < 4; k++ )
		{
			int inou=0, jnou=0;
			inou = i+di[k];
			jnou = j+dj[k];
			if ( inou >= 1 && inou <= n && jnou >= 1 && jnou <= n )
				if ( l[inou][jnou] > max )
				{
					max = l[inou][jnou];
					dmax = k;
				}
		}
		pas++;
		pasl[pas] = max + pasl[pas-1];
		i += di[dmax];
		j += dj[dmax];
	}
}


void rezolva ( int i, int j, int pas )
{

	if ( pas == 17 )
	{
		if ( sum > sumax )
		{
			sumax = sum;
			int i=0, j=0;
			for ( i = 1; i <= n; i++ )
				for ( j = 1; j <= n; j++ )
					_w[i][j] = w[i][j];
		}
	}
	else
	{
		int inou=0, jnou=0, k=0;
		for ( k = 0; k < 4; k++ )
		{
			inou = i+di[k];
			jnou = j+dj[k];
			if ( w[inou][jnou] == 0 && inou >= 1 && inou <= n &&
			     jnou >= 1 && jnou <= n && s[i][j] != 0
			     && (sum+s[inou][jnou] >= pasl[pas-1]))
			   {
				w[inou][jnou] = pas;
				sum += s[inou][jnou];
				rezolva ( inou, jnou, pas+1 );
				w[inou][jnou] = 0;
				sum -= s[inou][jnou];
			   }

		}
	}

}

void Scrie ()
{
	int k=0;
	int i=1, j=1;
	ofstream fout (OutFile);
	fout << sumax << "\n";
	while ( _w[i][j] != 16 )
	{
		for ( k = 0; k < 4; k++ )
		{
			int inou=0, jnou=0;
			inou = i+di[k];
			jnou = j+dj[k];

			if ( _w[inou][jnou] == _w[i][j]+1 )
			{
				fout << dir[k];
				i = inou;
				j = jnou;
			}
		}
	}
	fout.close ();
}




int main ()
{
	citeste ();
        recons_lup ();
	sum += s[1][1];
	w[1][1] = 1;
	rezolva ( 1, 1, 2 );
	Scrie ();
	return 0;
}