#include <iostream.h>
#include <stdio.h>

int m,n,k, xx[]={-1,-1,-1,0,1,1,1,0}, yy[]={-1,0,1,1,1,0,-1,-1};
char a[51][51],x[51],y[51],b[51][51],c[51],d[51];
int s[51],S;

void citire();
void rezolv();
int lee(int x,int y);
void heapsort();
void faina(int k,int n);

int main()
{
  citire();
  rezolv();
  return 0;
}

void citire()
{
  int i,j;
  FILE *f;
  f = fopen("rubine.in","r");
  fscanf(f,"%d %d\n",&m,&n);
  for(i=1;i<=m;i++,fscanf(f,"\n"))
    for(j=1;j<=n;j++)
      fscanf(f,"%d ",&a[i][j]);
  fscanf(f,"%d\n",&k);
  for(i=1;i<=k;i++)
    fscanf(f,"%d %d\n",&x[i],&y[i]);
  while(!feof(f))
  {
    fscanf(f,"%d %d\n",&i,&j);
    b[i][j] = 1;
  }
  fclose(f);
}

void rezolv()
{
  int i,j,l;
  for(l=1;l<=n;l++)
    for(i=1;i<=n;i++)
      for(j=1;j<=n;j++)
	if(b[i][l] && b[l][j])
	  if(!b[i][j] || b[i][j] > b[i][l]+b[l][j])
	    b[i][j] = b[i][l] + b[l][j];
  for(i=1;i<=k;i++)
    s[i] = lee(x[i],y[i]);

  for(i=1;i<=n;i++)
    for(j=1;j<=n;j++)
      if(b[i][j])
	b[i][0]++;

  for(i=1;i<=n;i++)
    c[i] = i;

  heapsort();

  FILE *f;
  f = fopen("rubine.out","w");
  fprintf(f,"%d\n",b[n][0]);
  for(i=1;i<=n;i++)
    for(j=1;j<=n;j++)
      if(b[j][c[i]] == 1)
      {
	fprintf(f,"%d %d %d %d\n",j,s[j],c[i],s[c[i]]);
	d[c[i]]=1;
	break;
      }
  for(i=1;i<=k;i++)
    if(!d[i])
    {
      fprintf(f,"%d ",i);
      S+=s[i];
    }
  fprintf(f,"\n%d\n",S);
  fclose(f);
}

int lee(int x,int y)
{
  char c[51][51],d[51][51];
  int i,j,k,num,pozx,pozy;
  for(i=1;i<=n;i++)
    for(j=1;j<=n;j++)
      c[i][j] = d[i][j] = 0;
  d[x][y] = 1;
  c[x][y] = a[x][y];
  num = 1;
  while(!d[m][n])
  {
    for(i=1;i<=m;i++)
      for(j=1;j<=n;j++)
	if(d[i][j] == num)
	  for(k=0;k<8;k++)
	  {
	    pozx = i + xx[k];
	    pozy = j + yy[k];
	    if(pozx>=1 && pozx<=m && pozy>=1 && pozy<=n)
	      if(!d[pozx][pozy])
	      {
		d[pozx][pozy] = d[i][j] + 1;
		c[pozx][pozy] = c[i][j] + a[pozx][pozy];
	      }
	      else
		if(d[pozx][pozy] == d[i][j] + 1)
		  if(a[pozx][pozy] + c[i][j] > c[pozx][pozy])
		  {
		    d[pozx][pozy] = d[i][j] + 1;
		    c[pozx][pozy] = c[i][j] + a[pozx][pozy];
		  }
	}
    num++;
  }
  return c[m][n];
}

void heapsort()
{
  int i,m=n;
  for(i=n/2; i ;i--)
    faina(i,m);
  for(i=1;i<=n;i++,m--)
  {
    faina(1,m);
    b[m][0] = b[1][0] + b[m][0] - (b[1][0]=b[m][0]);
    c[m] = c[1] + c[m] - (c[1]=c[m]);
  }
}

void faina(int k,int n)
{
  int C;
  FAINA:
    C = k<<1;
    if(C<=n)
      if(C<n && b[C+1][0] > b[C][0]) C++;
      else;
    else
      return;
    if(b[C][0] <= b[k][0])
      return;
    b[k][0] = b[k][0] + b[C][0] - (b[C][0] = b[k][0]);
    c[k] = c[k] + c[C] - (c[C] = c[k]);
    k = C;
    goto FAINA;
}