#include <fstream.h>
#include <string.h>
#define InFile "nr.in"
#define OutFile "nr.out"
#define NMax 1001
#define NAN 100

char x[NMax], xi[NMax];
char sol[NMax];
int m[10], uz[10], n, L, Lg, cifra;
ofstream fout(OutFile);

void citire(void);
int ok (void);
void afiseaza(int );
int distribuie();
int succesor();
int total (void);

int main()
{ citire();
  cifra=ok();
  if (cifra==NAN) {afiseaza(0); return 0;}
  int gata=distribuie();
  if (gata==1)   {afiseaza(1); return 0;}
  if (gata==NAN) {afiseaza(0); return 0;}
  if (succesor()) afiseaza(1);
      else afiseaza(0);
  return 0;
}

void citire(void)
{ ifstream fin(InFile);
  fin>>n; fin.get(); fin.getline(x,NMax);
  fin.close();
  strcpy(xi,x);
  for (int i=0; i<n; i++)
      {if (!(x[i]>='0'&&x[i]<='9'))
	  {cout<<"fisier de intrare eronat!";return;}
      uz[x[i]-'0']++;}
  L=n/2-1;
}

int ok(void)
{ int i, nrimpar=0, cine=10;
  for (i=0; i<10; i++)
      {if (uz[i]%2) {nrimpar++; cine=i;}
       m[i]=uz[i]/2; //m[i]=numarul de aparitii necesare ale cifrei i intr-o jumatate de palindrom
       uz[i]=0;}
  for (i=0; i<=L+n%2;i++)  uz[x[i]-'0']++;
  //uz[i]=numarul de aparitii existente in prima jumatate ale cifrei i
  if (cine<10) m[cine]++;
  if (nrimpar<2) return cine; //cifra din mijloc
  return NAN; //nu exista solutie
}

int succesor()
{//determina anagrama urmatoare>x, daca este posibil
 int i, j, aux;
 char fostx=x[L+1], fosts=sol[L+1];
 x[L+1]=sol[L+1]=NULL;
 if (strcmp(x,sol)==0 && fostx<fosts) {sol[L+1]=fosts;return 1;}
 while (strcmp(x,sol)>=0)
       { if (strcmp(x,sol)==0)
	    if (total()) {sol[L+1]=cifra+'0'; sol[L+2]=NULL;return 1;}
	 for (i=L-1; i>=0 && sol[i]>=sol[i+1]; i--);
	 if (i<0)
	    {if (strcmp(x,sol)>0 || strcmp(x,sol)==0 && fostx>fosts)
	       return 0;//nu exista succesor
	     return 1;}
	 for (j=L; sol[j]<=sol[i]; j--);
	 aux=sol[j]; sol[j]=sol[i];sol[i]=aux;
	 for (j=L, i++; j>i; j--, i++)
	     {aux=sol[i]; sol[i]=sol[j]; sol[j]=aux;}
       }
 sol[L+1]=fosts;
 return 1;
}

void afiseaza(int k)
{int i;
 if (k)
    {fout<<sol;
     for (i=L; i>=0; i--) fout<<sol[i];}
     else fout<<0;
 fout<<endl;
 fout.close();}

int distribuie ()
{int i, j, aux=10, min, poz, k, sch;
 int pus[10];
 if (cifra<10) //completez separat mijlocul, in caz de lg impara
    {sol[L+1]=cifra+'0'; m[cifra]--; aux=x[L+1]-'0';}
 //pus[i]= numarul de cifre i pe care trebuie sa le mai pun
 for (i=0; i<10; i++)
     if (m[i]>uz[i]) pus[i]=m[i]-uz[i];
	else pus[i]=0;
 if (aux<10) pus[aux]++;
 for (i=L; i>=0; i--)
     {sol[i]=x[i];
      if (m[x[i]-'0']<uz[x[i]-'0'])//sterg o aparitie a cifrei i
	 {uz[x[i]-'0']--;
	  sol[i]=NAN;}
     }
if (sol[0]==NAN)
   {for (i=x[0]-'0'; i<10 && !pus[i]; i++);
    if (i==10) return NAN;
    sol[0]=i+'0'; pus[i]--;}
j=1;
for (i=0; i<10;)
    if (pus[i])
       {if (sol[j]==NAN) {sol[j]=i+'0'; pus[i]--;}
	j++;}
	else i++;
if (!strcmp(x,sol)) if (total()) return 1;
i=0;
while (1)
      { for (; i<=L && x[i]==sol[i];i++);
	if (i>L) return 0;
	//caut cea mai mica valoare >=de dupa
	min='9'+1;
	for (j=i; j<=L; j++)
	    if (sol[j]>=x[i] && min>sol[j]) {min=sol[j]; poz=j;}
	if (min!='9'+1) //am gasit
	   {sol[poz]=sol[i]; sol[i]=min;
	    if (min>x[i])
	       {//ordonez crescator restul si gata
		for (k=0; k<10; k++) pus[k]=0;
		for (k=i+1; k<=L; k++) pus[sol[k]-'0']++;
		j=i+1;
		for (i=0; i<10;)
		    if (pus[i]) {sol[j]=i+'0'; pus[i]--;j++;}
		       else i++;
	       return 1;
	      }
	   }
	  else
	  {
	  //ordonez descrescator restul
	  for (k=0; k<10; k++) pus[k]=0;
	  for (k=i; k<=L; k++) pus[sol[k]-'0']++;
	  j=i;
	  for (i=9; i>=0;)
	      if (pus[i]) {sol[j]=i+'0'; pus[i]--;j++;}
		 else i--;
	  return 0;
          }
       }
}

int total (void)
{
char aux[NMax];
int i, j;
strcpy(aux,sol);
j=strlen(aux);
if (cifra>=0&&cifra<=9)
   aux[j++]=cifra+'0';
for (i=strlen(sol)-1; i>=0; i--) aux[j++]=sol[i];
aux[j]=NULL;
if (strcmp(xi,aux)<0) return 1;
return 0;
}