const eps=0.00000001;
var f:text;
    a:array[1..5001] of record x1,y1,x2,y2:real; end;
    b:array[1..100000] of record x,y:real; end;
    n,i,j,nr,cat:longint;
    sol:real;

procedure load;
begin
 assign(f,'inter.in');reset(f);
 readln(f,n);
 for i:=1 to n do
     readln(f,a[i].x1,a[i].y1,a[i].x2,a[i].y2);
 close(f);
end;

procedure ec(x1,y1,x2,y2:real; var aa,bb,cc:real);
begin
 aa:=y2-y1;
 bb:=x1-x2;
 cc:=y1*(x2-x1)-x1*(y2-y1);
end;


function same(i,j:longint):boolean;
var a1,a2,b1,b2,c1,c2:real;
begin
 same:=true;
 ec(a[i].x1,a[i].y1,a[i].x2,a[i].y2,a1,b1,c1);
 ec(a[j].x1,a[j].y1,a[j].x2,a[j].y2,a2,b2,c2);
 if (abs(a1-a2)<eps) and (abs(b1-b2)<eps) and (abs(c1-c2)<eps) then exit;
 if (abs(a2)>eps) and (abs(b2)>eps) and (abs(c2)>eps) then
    if (abs((a1/a2)-(b1/b2))<eps) and (abs((b1/b2)-(c1/c2))<eps) then exit;
 if (abs(a1)>eps) and (abs(b1)>eps) and (abs(c1)>eps) then
    if (abs((a2/a1)-(b2/b1))<eps) and (abs((b2/b1)-(c2/c1))<eps) then exit;
 same:=false;
end;

function para(i,j:longint):boolean;
begin
 para:=true;
 if (abs(a[i].x2-a[i].x1)<eps) and (abs(a[j].x2-a[j].x1)<eps) then exit;
 if (abs(a[i].x2-a[i].x1)>eps) and (abs(a[j].x2-a[j].x1)>eps) then
if (abs((a[i].y2-a[i].y1)/(a[i].x2-a[i].x1)-(a[j].y2-a[j].y1)/(a[j].x2-a[j].x1))<eps) then exit;
 para:=false;
end;

procedure qsort(lo,hi:longint);

    procedure sort(l,r: longint);
      var
         i,j: longint;
         x,y:real;
      begin
         i:=l;
         j:=r;
         x:=b[(l+r) div 2].y;
         repeat
           while b[i].y<x do
            inc(i);
           while x<b[j].y do
            dec(j);
           if not(i>j) then
             begin
                y:=b[i].y;
                b[i].y:=b[j].y;
                b[j].y:=y;
                y:=b[i].x;
                b[i].x:=b[j].x;
                b[j].x:=y;
                inc(i);
                j:=j-1;
             end;
         until i>j;
         if l<j then
           sort(l,j);
         if i<r then
           sort(i,r);
      end;

    begin
       sort(lo,hi);
    end;

procedure q2(lo,hi:longint);

    procedure sort(l,r: longint);
      var
         i,j: longint;
         x,y:real;
      begin
         i:=l;
         j:=r;
         x:=b[(l+r) div 2].x;
         repeat
           while b[i].x<x do
            inc(i);
           while x<b[j].x do
            dec(j);
           if not(i>j) then
             begin
                y:=b[i].y;
               b[i].y:=b[j].y;
                b[j].y:=y;
                y:=b[i].x;
                b[i].x:=b[j].x;
                b[j].x:=y;
                inc(i);
                j:=j-1;
             end;
         until i>j;
         if l<j then
           sort(l,j);
         if i<r then
           sort(i,r);
      end;

    begin
       sort(lo,hi);
    end;

function otherside(i:longint):boolean;
var a1,b1,c1:real;
begin
 ec(a[cat].x1,a[cat].y1,a[cat-1].x1,a[cat-1].y1,a1,b1,c1);
 if (a1*a[cat-2].x1+b1*a[cat-2].y1+c1)*(a1*b[i].x+b1*b[i].y+c1)<-eps
    then otherside:=true
    else otherside:=false;
end;


procedure hull(nr:longint);
var i,p:longint;
    he:boolean;
begin
 qsort(1,nr);
 p:=1;
 repeat
  i:=p;
  while (i<=nr) and (abs(b[i].y-b[p].y)<eps) do
        inc(i);
  if i=nr+1 then q2(p,nr)
     else q2(p,i-1);
  p:=i;
 until p>nr;

 fillchar(a,sizeof(a),0);

 cat:=3;
 a[1].x1:=b[1].x;
 a[1].y1:=b[1].y;
 a[2].x1:=b[2].x;
 a[2].y1:=b[2].y;
 a[3].x1:=b[3].x;
 a[3].y1:=b[3].y;
 for i:=4 to nr do
     begin
      he:=otherside(i);
      if not he then inc(cat);
      while otherside(i) do
            dec(cat);
      a[cat].x1:=b[i].x;
      a[cat].y1:=b[i].y;
     end;
end;

procedure area(cat:longint);
begin
 a[cat+1].x1:=a[1].x1;
 a[cat+1].x2:=a[1].x2;
 sol:=0;
 for i:=1 to cat do
     sol:=sol+(a[i].x1*a[i+1].y1-a[i+1].x1*a[i].y1)/2;
 sol:=abs(sol);
end;

procedure solve;
var a1,a2,b1,b2,c1,c2:real;
begin
 nr:=0;
 for i:=1 to n do
     for j:=i+1 to n do
         if not same(i,j) then
            if not para(i,j) then
               begin
                ec(a[i].x1,a[i].y1,a[i].x2,a[i].y2,a1,b1,c1);
                ec(a[j].x1,a[j].y1,a[j].x2,a[j].y2,a2,b2,c2);
                inc(nr);
                b[nr].x:=(c1*b2-c2*b1)/(a1*b2-a2*b1);
                b[nr].y:=(a1*c2-a2*c1)/(a1*b2-a2*b1);
               end;
 hull(nr);
 area(cat);
end;

procedure afish;
begin
 assign(f,'inter.out');rewrite(f);
 writeln(f,sol:2:2);
 close(f);
end;

begin
 load;
 solve;
 afish;
end.
