
#include <fstream.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

void read();
void solve();
void write();

int main()
{
	read();
	solve();
	write();
	return (0);
}

#define MAXN 5002
#define MAXP
int N, count, piv_loc=-1;

struct point{
				double x, y;
			 }piv;

struct dreapta{
				 point A, B;
			 };

#ifdef __BORLANDC__
	dreapta huge d[MAXN];
	point huge vec[10010];
#else
	dreapta d[MAXN];
	point vec[10011];
#endif

void seeinter(point A, point B, point C, point D, point &X)
{
	double a, b, c, d, aux;

	a=B.y-A.y;
	b=B.x-A.x;

	c=D.y-C.y;
	d=D.x-C.x;

	aux=(c*b-a*d);

	//if(aux==0){cout<<"super_erorr!!\n"; exit(0);}

	X.y=(a*(c*C.x-d*C.y)-c*(a*A.x-b*A.y))/aux;
	X.x=(d*(a*A.x-b*A.y)-b*(c*C.x-d*C.y))/aux*(-1);
}

void read()
{
	ifstream in("inter.in");
	in>>N;
	int i, j, gas;

	double x, y;
	point M, min, max;

	for(i=1;i<=N;i++)
	 {
		gas=0;
		in>>x>>y;
		d[i].A.x=x;	d[i].A.y=y;

		in>>x>>y;
		d[i].B.x=x;	d[i].B.y=y;

		for(j=i-1;j>0;j--)
		 {
			seeinter(d[i].A, d[i].B, d[j].A, d[j].B, M);
			if(gas==0){ min=max=M; gas=1;}
			else
			 {
				if(M.y<min.y || (M.y==min.y && M.x>min.x))min=M;
				if(M.y>max.y || (M.y==max.y && M.x<max.x))max=M;
			 }
		 }
		if(gas)
		 {
			vec[count++]=min;
			if(piv_loc==-1){ piv=min; piv_loc=count-1; }
			else if(min.y<piv.y || (min.y==piv.y && min.x>piv.x))
						 {
							piv=min;
							piv_loc=count-1;
						 }

			if(max.x!=min.x || max.y!=min.y)
				{
				 vec[count++]=max;

				 if(max.y<piv.y || (max.y==piv.y && max.x>piv.x))
					{
					 piv=max;
					 piv_loc=count-1;
					}
				}
		 }
	 }
	in.close();
}

int LaDreapta(point A, point B, point X)
{
	double ans;
	ans=(X.x-A.x)*(B.y-A.y)-(X.y-A.y)*(B.x-A.x);
	if(ans>0)return (1);
	if(ans<0)return (-1);
	return (0);
}

double dist(point A, point B)
{
	return sqrt( (A.x-B.x)*(A.x-B.x) + (A.y-B.y)*(A.y-B.y));
}

int SortFun(const void *a, const void *b)
{
	int u=LaDreapta(piv, *(point *)a, *(point *)b);
	if(u)return (u);

	double d1, d2;

	d1=dist(piv, *(point *)a);
	d2=dist(piv, *(point *)b);

	if(d1>d2)return (1);
	if(d1<d2)return (-1);

	return (0);
}

int stiva[10002], vf;

void solve()
{
	vec[piv_loc]=vec[count-1]; count--;
	vec[count]=piv;
	qsort( (void*) vec, count, sizeof(vec[0]), SortFun);

	stiva[vf++]=count;
	int i, u;

	for(i=0;i<count;i++)
	 {
		while(vf>1)
		 {
			u=LaDreapta(vec[stiva[vf-2]], vec[stiva[vf-1]], vec[i]);
			if(u>=0)vf--;
			else break;
		 }
		stiva[vf++]=i;
	 }
}

double area;

void write()
{
	int i;

	for(i=0;i<vf-1;i++)
	 {
		area+=(vec[stiva[i+1]].x - vec[stiva[i]].x )
							*(vec[stiva[i+1]].y + vec[stiva[i]].y)/2;
	 }

	area-=(vec[stiva[vf-1]].x - vec[stiva[0]].x )
				 *(vec[stiva[vf-1]].y + vec[stiva[0]].y)/2;

	if(area<0)area*=(-1);
	FILE *out=fopen("inter.out", "w");
	fprintf(out, "%.2lf\n", area);
	fclose(out);
}

