
#include <fstream.h>
#include <stdlib.h>

void read();
void solve();

int main()
{
	read();
	solve();
	return (0);
}

long N, K, P, min=0, max;

void end(long x)
{
	ofstream out("proc.out");
	out<<x<<'\n';
	out.close();
	exit(0);
}

void read()
{
	ifstream in("proc.in");
	in>>N>>K>>P;
	in.close();

	max=(N-K)*2+K;

	if(max==0)end(0);
	if(P==1)end(max);

}


int posibil(long x)
{
	long a=K, b=N-K, i, j, k, best1=0, best2=0, time=0;

	for(i=1;i<=P;i++)
	 {
		for(j=0;j<=a;j++)
		 if(j*i<=x)
			{
			 for(k=0;k<=b;k++)
				 {
					if((j+2*k)*i<=x)
					 {
						if((j+2*k)*i>time)
						 {
							best1=j;
							best2=k;
							time=(j+2*k)*i;
						 }
					 }
					else break;
				 }
			 if(time==x) break;
			}
		 else break;

		a-=best1; b-=best2;
		best1=best2=0;
		time=0;
	 }

	return (a<=0 && b<=0);
}

void solve()
{
	long m, sol=2000000001;

	if(P>=10000)max=max/2;
	else if(P>=1000)max=max-100;


	while(min<=max)
	 {
		m=(min+max)/2;
		if(posibil(m))
		 {
			if(sol>m)sol=m;
			max=m-1;
		 }
		else min=m+1;
	 }
	end(sol);
}

