{$I-,Q-,R-,S-}
const
  nmax = 1001;
  finame = 'nr.in';
  foname = 'nr.out';
type
  huge = array[1..nmax] of longint;
var
  fi, fo: text;
  n, impar, grow: longint;
  a, b, z: huge;
  count, count2: array[0..9] of longint;

procedure readdata;
var
  c: char;
  i: longint;
begin
  assign(fi, finame);
  reset(fi);
  readln(fi, n);
  for i := 1 to n do
  begin
    read(fi, c);
    a[i] := ord(c) - ord('0');
    inc(count[a[i]]);
  end;
  close(fi);
end;

procedure go_nosol;
begin
  assign(fo, foname);
  rewrite(fo);
  writeln(fo, 0);
  close(fo);
  halt(0);
end;

procedure build_number;
var i: longint;
begin
  for i := 1 to n div 2 do
  begin
    z[i] := b[i];
    z[n-i+1] := b[i];
  end;
  if impar <> -1 then z[n div 2 + 1] := impar;
end;

function greater(z, a: huge): boolean;
var i: longint;
begin
  for i := 1 to n do
    if z[i] > a[i] then
      begin greater := true; exit; end
    else if z[i] < a[i] then
      begin greater := false; exit; end;
  greater := false;
end;

procedure grow_b;
var i, j, k, d: longint;
begin
  fillchar(count2, sizeof(count2), 0);
  grow := 69;
  for i := n div 2 downto 0 do
    if i = 0 then go_nosol else
    begin
      for j := i+1 to n div 2 do
        if b[j] > b[i] then
          if b[j] < grow then
          begin
            grow := b[j]; k := j;
          end;

      if grow <> 69 then
      begin
        dec(count2[ b[k] ]);
        inc(count2[ b[i] ]);
        b[i] := b[k]; k := i;
        for d := 0 to 9 do
          for j := 1 to count2[d] do
          begin
            inc(k); b[k] := d;
          end;
        exit;
      end;

      inc(count2[ b[i] ]);
    end;
end;

procedure solvprob;
var i, d: longint; ok: boolean;
begin
  impar := -1;
  for i := 0 to 9 do
  begin
    if odd(count[i]) then
      if impar = -1 then impar := i else go_nosol;
    count[i] := count[i] div 2;
  end;

  ok := false;
  for i := 1 to n div 2 do
    if not ok then
    begin
      for d := a[i] to 9 do
        if count[d] > 0 then
        begin
          b[i] := d;
          dec(count[d]);
          if d > a[i] then ok := true;
          break;
        end;
    end else
    begin
      for d := 0 to 9 do
        if count[d] > 0 then
        begin
          b[i] := d;
          dec(count[d]);
          break;
        end;
    end;

  build_number;
  if not greater(z, a) then grow_b;
end;

procedure writesol;
var i: longint;
begin
  assign(fo, foname);
  rewrite(fo);
  build_number;
  for i := 1 to n do
    write(fo, z[i]);
  writeln(fo);
  close(fo);
end;

begin
  readdata;
  solvprob;
  writesol;
end.
