#include <stdio.h>

int n, k, p;
int pt[65536];
int hp[65536];

void pull(int pos)
{
	int next = pos * 2;
	while(next <= p)
	{
		if(next < p) if(pt[hp[next]] > pt[hp[next + 1]]) next ++;
		if(pt[hp[pos]] <= pt[hp[next]]) break;

		int tmp = hp[pos];
		hp[pos] = hp[next];
		hp[next] = tmp;

		pos = next;
		next = pos * 2;
	}
}

void calc(void)
{
	for(int i = n; i > 0; i --)
		pull(i);
}

int get(void)
{
	int i, max = 0;
	if(p == 1) return 2 * n - k;

	for(i = 1; i <= p; i ++)
		pt[i] = hp[i] = i;
	calc();

	for(i = 1; i <= k; i ++)
	{
		int mch = hp[1];
		if(pt[mch] > max) max = pt[mch];
		pt[mch] += mch; pull(1);
	}

	for(i = 1; i <= p; i ++)
		pt[i] += i;
	calc();
	
	for(i = k + 1; i <= n; i ++)
	{
		int mch = hp[1];
		if(pt[mch] > max) max = pt[mch];
		pt[mch] += 2*mch; pull(1);
	}

	return max;
}

int main(void)
{
	freopen("proc.in", "rt", stdin);
	freopen("proc.out", "wt", stdout);

	scanf("%d %d %d", &n, &k, &p);
	printf("%d\n", get());
/*
	for(n = 0; n <= 40; n ++)
	{
		for(k = 0; k <= n; k ++)
		{
			p = 1; printf(" (%4d", get());
			p = 2; printf(" %4d)", get());
		}
		printf("\n");
	}
*/
	fclose(stdin);
	fclose(stdout);
	return 0;
}
