
	#include <stdio.h>

	#define MAXN	1010

int n, nri[MAXN], sol[MAXN], cate[20], corect, pereche[MAXN], pc, s[MAXN], c1, emaimare;
char ts[1024];

void m_read()
{
	FILE *f=fopen("nr.in", "r");

  fscanf(f, "%d\n", &n);

  fgets(ts, 1005, f);
  int i;

  for (i=0; i<n; i++) nri[i]=ts[i]-'0';

  fclose(f);
}

void fa_solutie_minima(int start)
{
  // construim palindrom mimin de la poz. start la n/2
	int i=start; int j=0;
  for (j=0; j<pc; j++)
  	if (!s[j])
	  	{
        sol[i]=sol[n-1-i]=pereche[j];
        i++;
        if (i>=n/2) break;
	    }
}

int pot_alege(int start)
{
  // prima cifra nu poate fi 0
  if (!sol[0]) return 0;

  if (emaimare) return 1;

  // construim palindrom maxim de la poz. start la n/2
	int i=start; int j=0;
  for (j=pc-1; j>=0; j--)
  	if (!s[j])
	  	{
        sol[i]=sol[n-1-i]=pereche[j];
        i++;
        if (i>=n/2) break;
	    }

  // comparam palindrom maxim cu nri
  if (!emaimare)
  	{
		  for (i=0; i<n; i++)
		  	if (sol[i]<nri[i]) return 0;
				else
					if (sol[i]>nri[i])
						{
            	if (i<start) emaimare=1;
							return 1;
            }
    }
  else return 1;

	return 0;
}

void m_solve()
{
	int i, j, ok;

  emaimare=0;
	corect=0;

	// verificam corectitudine
  for (i=0; i<10; i++) cate[i]=0;
	for (i=0; i<n; i++)
  	cate[nri[i]]++;

  pc=0; c1=-1;
  for (i=0; i<10; i++)
  	if (cate[i]%2)
      {
	    	if (c1>=0) return;
	      else
					{
						c1=i;
          }
      }
    else
    	{
        for (j=0; j<cate[i]/2; j++)
        	pereche[pc++]=i;
      }

  if (n%2) sol[n/2]=c1;

	// construim palindrom (perechile sunt deja sortare)
  for (i=0; i<pc; i++) s[i]=0;

  for (i=0; i<n/2; i++)
  	{
      ok=0;
			for (j=0; j<pc; j++)
      	if (!s[j])
	      	{
						sol[i]=pereche[j];
						sol[n-1-i]=pereche[j];

            s[j]=1;
            if ((i<n/2)&&(pot_alege(i+1)))
            	{
                ok=1;

                if (emaimare)
                	{
                  	fa_solutie_minima(i+1);
                    corect=1;
                    return;
                  }

                break;
              }
            else s[j]=0;
	        }
      if (!ok)
      	{
				  return;
        }
    }

  corect=1;
}

void m_write()
{
  FILE *f=fopen("nr.out", "w");
  int i;

  if (corect)
  	{
		  for (i=0; i<n; i++)
		  	fprintf(f, "%d", sol[i]);
			fprintf(f, "\n");
    }
  else fprintf(f, "0\n");

  fclose(f);
}

int main(void)
{
	m_read();
  m_solve();
  m_write();

  return 0;
}
