{$B-}
program inter;
type pct=record x,y:real; end;
     dr=record p1,p2:pct; end;
var d:array[1..5000] of dr;
    p,s:array[1..20000] of pct;
    n,dp,vf:integer;
    p0:pct;

procedure readdata;
var f:text;
    i:integer;
begin
     assign(f,'inter.in');
     reset(f);
     readln(f,n);
     for i:=1 to n do
     readln(f,d[i].p1.x,d[i].p1.y,d[i].p2.x,d[i].p2.y);
     close(f);
end;

procedure make_p;
var i,j:integer;
    a1,a2,b1,b2,c1,c2:real;
begin
     for i:=1 to n-1 do
     for j:=i+1 to n do
     begin
          a1:=d[i].p2.y-d[i].p1.y;
          b1:=d[i].p1.x-d[i].p2.x;
          c1:=d[i].p2.x*d[i].p1.y-d[i].p1.x*d[i].p2.y;
          a2:=d[j].p2.y-d[j].p1.y;
          b2:=d[j].p1.x-d[j].p2.x;
          c2:=d[j].p2.x*d[j].p1.y-d[j].p1.x*d[j].p2.y;
          if not(abs(a1*b2-a2*b1)<0.00001) then
          begin
               if a1=0 then
               begin
                    inc(dp);
                    p[dp].y:=-c1/b1;
                    p[dp].x:=(b2*c1/b1-c2)/a2;
               end
               else
               if a2=0 then
               begin
                    inc(dp);
                    p[dp].y:=-c2/b2;
                    p[dp].x:=(b1*c2/b2-c1)/a1;
               end
               else
               if b1=0 then
               begin
                    inc(dp);
                    p[dp].x:=-c1/a1;
                    p[dp].y:=(c1*a2/a1-c2)/b2;
               end
               else
               if b2=0 then
               begin
                    inc(dp);
                    p[dp].x:=-c2/a2;
                    p[dp].y:=(c2*a1/a2-c1)/b1;
               end
               else
               begin
                    inc(dp);
                    p[dp].y:=(a2*c1-a1*c2)/(b2*a1-a2*b1);
                    p[dp].x:=(-c1-b1*p[dp].y)/a1;
               end;
          end;
     end;

end;


function dist(a,b:pct):real;
begin
     dist:=((a.x-b.x)*(a.x-b.x)+((a.y-b.y)*(a.y-b.y)));
end;

procedure sort(l, r: integer);
var
  i, j: integer;
  x,y:pct;
begin
  i := l; j := r; x := p[(l+r) DIV 2];
  repeat
    while ((p[i].y-p0.y)*(x.x-p0.x) < (x.y-p0.y)*(p[i].x-p0.x)){or
          (((p[i].y-p0.y)*(x.x-p0.x)=(x.y-p0.y)*(p[i].x-p0.x))and
           (dist(p0,p[i])<dist(p0,x)))} do i := i + 1;
    while ((x.y-p0.y)*(p[j].x-p0.x)<(p[j].y-p0.y)*(x.x-p0.x)){or
          (((x.y-p0.y)*(p[j].x-p0.x)=(p[j].y-p0.y)*(x.x-p0.x))and
          (dist(p0,x)<dist(p0,p[j])))} do j := j - 1;
    if i <= j then
    begin
      y := p[i]; p[i] := p[j]; p[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then sort(l, j);
  if i < r then sort(i, r);
end;



procedure convex_hul;
var i,poz,j:integer;
    p0,aux:pct;
begin
     p0:=p[1];
     poz:=1;
     for i:=2 to dp do
     if (p[i].x<p0.x)or((p[i].x=p0.x)and(p[i].y<p0.y)) then
     begin
          p0:=p[i];
          poz:=i;
     end;


     for i:=poz+1 to dp do
     p[i-1]:=p[i];
     dp:=dp-1;
     sort(1,dp);
     s[1]:=p0;
     s[2]:=p[1];
     s[3]:=p[2];
     vf:=3;
     for i:=3 to dp do
     begin
          while (p[i].x-s[vf-1].x)*(s[vf].y-s[vf-1].y)-
                (s[vf].x-s[vf-1].x)*(p[i].y-s[vf-1].y)>=0 do
          vf:=vf-1;
          inc(vf);
          s[vf]:=p[i];
     end;
end;

function tri(a,b,c:pct):real;
var p:real;
begin
     tri:=0.5*abs(a.x*(b.y-c.y)-a.y*(b.x-c.x)+(b.x*c.y-b.y*c.x));
end;



function arie:real;
var ss:real;
    i:integer;
begin
     ss:=0;
     for i:=2 to vf-1 do
     ss:=ss+tri(s[1],s[i],s[i+1]);
     arie:=ss;
end;

procedure print;
var f:text;
begin
     assign(f,'inter.out');
     rewrite(f);
     writeln(f,arie:0:2);
     close(f);
end;




begin
     readdata;
     make_p;
     convex_hul;
     print;
end.




