program nr;
const
  sin='nr.in';
  sout='nr.out';
  maxn=1000;
type
  ts=array[1..maxn]of shortint;
  ta=array[0..9]of integer;
  tmodulo=array[0..1]of integer;
  tm=array[1..maxn]of ta;
  tb=array[1..maxn]of boolean;
var
  fin,fout:text;
  s,s2:ts;
  n:longint;
  initial:ta;
  modulo:tmodulo;
  primele:tm;
  ultimele:tm;
  diferenta:tm;
  simetric:^tm;
  okwith:tb;

procedure read_data;
var
  c:char;
  i:longint;
begin
  assign(fin,sin);reset(fin);
  read(fin,n);
  repeat
    read(fin,c);
  until c in ['0'..'9'];
  s[1]:=ord(c)-ord('0');
  initial[s[1]]:=1;
  for i:=2 to n do
    begin
      read(fin,c);
      s[i]:=ord(c)-ord('0');
      inc(initial[s[i]]);
    end;
  close(fin);
end;

function GetImpar:longint;
var
  i:longint;
begin
  for i:=0 to 9 do
    if odd(initial[i]) then
      begin
        GetImpar:=i;
        exit;
      end;
end;

procedure NoSol;
begin
  assign(fout,sout);
  rewrite(fout);
  writeln(fout,0);
  close(fout);
  halt(0);
end;
{
procedure comp_data;forward;}

procedure init_data;
var
  i,j:longint;
  ok:longint;
  inii:longint;
  impar:longint;
begin
  for i:=0 to 9 do
    begin
      inii:=initial[i];
      inii:=inii mod 2;
      inc(modulo[inii]);
    end;
  if odd(n) then
    ok:=1
  else
    ok:=0;
  if modulo[1]<>ok then
    NoSol;
  primele[1,s[1]]:=1;
  for i:=2 to n do
    begin
      primele[i]:=primele[i-1];
      inc(primele[i,s[i]]);
    end;
  ultimele[n,s[n]]:=1;
  for i:=n-1 downto 1 do
    begin
      ultimele[i]:=ultimele[i+1];
      inc(ultimele[i,s[i]]);
    end;
  for i:=n downto 2 do
  begin
    okwith[i]:=true;
    fillchar(modulo,sizeof(modulo),0);
    for j:=0 to 9 do
      begin
        diferenta[i,j]:=ultimele[i,j]-primele[i-1,j];
        if diferenta[i,j]<0 then
          okwith[i]:=false;
        inc(modulo[diferenta[i,j] mod 2]);
      end;
      if modulo[1]<>ok then
        okwith[i]:=false;
  end;
  new(simetric);
  fillchar(simetric^,sizeof(simetric),0);
  impar:=GetImpar;
  for i:=1 to n do
    begin
      simetric^[i]:=initial;
      for j:=0 to 9 do
        begin
          simetric^[i,j]:=simetric^[i,j]-2*primele[i,j];
        end;
      if odd(n) then
        dec(simetric^[i,impar]);
    end;
end;

{procedure write_sol;forward;}

function different(a1,a2:ta):boolean;
var
  i:longint;
begin
  different:=true;
  for i:=0 to 9 do
    if a1[i]<>a2[i] then
      exit;
  different:=false;
end;

function TestIfGreater(i0,i1:longint):boolean;
var
  i:longint;
begin
  for i:=i0 downto 1 do
    begin
      if s[i]>s[i1] then
        begin
          TestIfGreater:=true;
          exit;
        end
      else
        if s[i]<s[i1] then
          begin
            TestIfGreater:=false;
            exit;
          end;
      inc(i1);
    end;
end;

procedure modify(i0,i1:longint);
var
  i:longint;
begin
  for i:=i1 to n do
    s[i]:=s[n-i+1];
end;

procedure modify2(var s:ts;i0,i1:longint);
var
  i:longint;
begin
  for i:=i1 to n do
    s[i]:=s[n-i+1];
end;

procedure write_sol;forward;

procedure TryMakeSolution(poz:longint); {from poz to end}
begin
  if odd(n) and (poz=n div 2 + 1) then
    if GetImpar>s[n div 2 + 1] then
      begin
        s[n div 2 + 1]:=GetImpar;
        modify(n div 2-1, n div 2 + 1);
        write_sol;
      end
    else
      exit;
  s2:=s;
  modify2(s2,poz-1,n-(poz-1));
  if odd(n) then
    s2[n div 2 + 1]:=GetImpar;
end;

procedure comp_data;
var
  mij:longint;
  mij0:longint;
  i_mij:longint;
  i:longint;
begin
  {incepem sa vedem de la mijloc daca e palindrom}
  mij:=n div 2 + n mod 2; mij0:=mij;
  while mij<>n-2 do
    begin
      inc(mij);
      if s[mij]<>s[n-mij+1] then
        begin
          dec(mij);
          break;
        end;
    end;
  {apoi sa incercam sa refacem partea dreapta}
  for i_mij:=mij downto mij0 do
    begin
      if different(ultimele[i_mij],primele[n-i_mij+1]) then
        continue;
      if not TestIfGreater({backwards}n-i_mij+1,{forwards}i_mij) then
        continue;
      {WE HAVE OURSELVES A SIMPLE SOLUTION}
      modify(n-i_mij+1,i_mij);
      write_sol;
    end;
  for i:=mij0 downto 2 do
    if okwith[i] then
      TryMakeSolution(i);
  NoSol;
end;

procedure write_sol;
var
  i:longint;
begin
  assign(fout,sout);rewrite(fout);
  for i:=1 to n do
    write(fout,s[i]);
  close(fout);
  halt(0);
end;

begin
  read_data;
  init_data;
  comp_data;
  write_sol;
end.
