// Ziua 2 - Inter

#include <stdio.h>
#include <math.h>

#define input "inter.in"
#define output "inter.out"
#define NODS 5001

FILE *f;
int n, np, hnp, ic[NODS];
double arie;
struct point
{
	double x, y;
} ch[NODS];
struct
{
	double a, b, c;
} a[NODS];

void readdata()
{
	int i;
	double x1, y1, x2, y2;              // pune double!
	f = fopen(input, "rt");
	fscanf(f, "%d", &n);
	for (i = 0; i < n; i++)         // pune %lf !!!
	{
		fscanf(f, "%lf %lf %lf %lf", &x1, &y1, &x2, &y2);
		a[i].a = y1 - y2; a[i].b = x2 - x1; a[i].c = x1 * y2 - x2 * y1;
	}
	fclose(f);
}

void sift(int pos)
{
	point pp;
	int son, minpos = pos;
	do
	{
		son = 2 * pos + 1;
		if (son < hnp && (ch[son].y > ch[minpos].y ||
		(ch[son].y == ch[minpos].y && ch[son].x > ch[minpos].x))) minpos = son;
		son = 2 * pos + 2;
		if (son < hnp && (ch[son].y > ch[minpos].y ||
		(ch[son].y == ch[minpos].y && ch[son].x > ch[minpos].x))) minpos = son;
		if (pos == minpos) break;
		pp = ch[pos]; ch[pos] = ch[minpos]; ch[minpos] = pp;
		pos = minpos;
	}
	while (1);
}

void heapsort()
{
	point pp;
	int i;
	hnp = np;
	for (i = hnp / 2; i >= 0; sift(i--));
	while (hnp)
	{
		pp = ch[hnp - 1]; ch[hnp - 1] = ch[0]; ch[0] = pp;
		hnp--;
		sift(0);
	}
}

int good(int p1, int p2, int p3)
{
	return (ch[p2].x - ch[p1].x) * (ch[p3].y - ch[p1].y) -
		   (ch[p3].x - ch[p1].x) * (ch[p2].y - ch[p1].y);
}

void solve()
{
	int i, j, pnt, l;
	point pp;
	double  x, y, jos;
	for (np = i = 0; i < n; i++)
		for (j = i + 1; j < n; j++)
		{
			jos = a[i].a * a[j].b - a[j].a * a[i].b;
			if (jos == 0) continue;
			x = (a[i].b * a[j].c - a[j].b * a[i].c) / jos;
			y = (a[i].a * a[j].c - a[j].a * a[i].c) / -jos;
			ch[np].x = x; ch[np++].y = y;
		}
	for (i = 0; i < np; i++)
		for (j = i + 1; j < n; j++)
			if (ch[i].x == ch[j].x && ch[i].y == ch[j].y)
			{
				pp = ch[i]; ch[i] = ch[np - 1]; ch[np - 1] = pp;
				np--;
			}
	heapsort();
	l = 1;
	ic[0] = 0; ic[1] = 1;
	for (i = 2; i < np; i++)
	{
		while (!good(ic[l - 1], ic[l], i) && l > 1) l--;
		ic[++l] = i;
	}
	ic[++l] = 0; arie = 0;
	for (i = 0; i < l; i++)
		arie += fabs(ch[ic[i]].x * ch[ic[i + 1]].y - ch[ic[i]].y * ch[ic[i + 1]].x);
	if (arie < 0) arie *= -1;
	arie /= (float)2;
	f = fopen(output, "wt");
	fprintf(f, "%.2f", arie);
	fclose(f);
}

int main()
{
	readdata();
	solve();
	return 0;
}