
#include <stdio.h>
#include <alloc.h>
#include <values.h>
#include <mem.h>
#include <math.h>

typedef struct punct
{
	float x, y;
} punct;

int n, nh;
float my, mx;
int ind;

punct *p;

void input()
{
	typedef struct linie
	{
		float x1, y1, x2, y2;
		float a, b;
		float mx, my, Mx, My;
	} linie;


	FILE *f = fopen("inter.in", "r");

	fscanf(f, "%d", &n);

	linie *l;

	l=NULL;
	l = new linie[n];
	float x1, y1, x2, y2;
	for (int i=0;i<n;i++)
	{
		fscanf(f, "%f%f%f%f", &x1, &y1, &x2, &y2);

		l[i].x1=x1;
		l[i].x2=x2;
		l[i].y1=y1;
		l[i].y2=y2;
	}

	for (i=0;i<n;i++)
	{
		if (l[i].x2-l[i].x1!=0)
			l[i].a = (l[i].y2-l[i].y1) / (l[i].x2-l[i].x1);
		else
			l[i].a = 0;

		l[i].b = l[i].a * l[i].x1 - l[i].y1;
	}

	float ix, iy;
	int fm;


	for (i=0;i<n;i++)
	{

		fm=1;
		for (int j=0;j<n;j++)
		{
			if (i==j) continue;
			if (l[i].x1 == l[i].x2)
			{
				ix = l[i].x1;
				iy = ix * l[j].a + l[j].b;
			} else
			if (l[j].x1 == l[j].x2)
			{
				ix = l[j].x1;
				iy = ix * l[i].a + l[i].b;
			} else {
				if (l[i].a - l[j].a!=0) ix = (l[j].b - l[i].b) / (l[i].a - l[j].a);
										 else ix = 0;

				iy = l[i].a * ix + l[i].b;
			}
			ix=-ix;
			iy=-iy;
			if (fm) { l[i].mx = ix; l[i].my=iy;
						 l[i].Mx = ix; l[i].My=iy; fm=0;}
			else {
				if (ix<l[i].mx) { l[i].mx = ix; l[i].my = iy; }
				if (ix>l[i].Mx) { l[i].Mx = ix; l[i].My = iy; }
				if (ix==l[i].mx)
				{
					if (iy<l[i].my) { l[i].mx = ix; l[i].my = iy; }
				}
				if (ix==l[i].Mx)
				{
					if (iy>l[i].My) { l[i].Mx = ix; l[i].My = iy; }
				}
			}
		}
	}

	p = new punct[i*2];

	mx=MAXFLOAT;
	my=MAXFLOAT;

	for (i=0;i<n;i++)
	{
		p[i*2].x   = l[i].mx;
		p[i*2].y   = l[i].my;
		p[i*2+1].x = l[i].Mx;
		p[i*2+1].y = l[i].My;

		if (p[i*2  ].y<my) { mx=p[i*2  ].x; my=p[i*2  ].y;ind=i*2;   }
		if (p[i*2+1].y<my) { mx=p[i*2+1].x; my=p[i*2+1].y;ind=i*2+1; }
		if (p[i*2  ].y==my) if (p[i*2  ].x>mx) { mx=p[i*2  ].x; my=p[i*2  ].y;ind=i*2  ; }
		if (p[i*2+1].y==my) if (p[i*2+1].x>mx) { mx=p[i*2+1].x; my=p[i*2+1].y;ind=i*2+1;}
	}
	nh = n*2;
	printf("\n\n\n");

	fclose(f);

	delete[] l;
}


void convexhull()
{
	int i, j;
	char u[10000];
	int list[10000];
	int nl=0;

	memset(&u, 0, sizeof(u));

	float angl;
	float mang;
	float ipot;

	int mid;


	for (i=0;i<n;i++)
	{
		mang=-1;
		if (!u[i])
		for (j=i; j<n;j++)
		{
			if (u[j]) continue;


			ipot = sqrt((p[i].x-p[j].x)*(p[i].x-p[j].x)+(p[i].y-p[j].y)*(p[i].y-p[j].y));
			if (ipot!=0) angl = (p[j].y - p[i].y) / ( ipot );
			else	angl=0;

			if ((angl>=0)&&(p[j].x>=p[i].x)) angl *= 90;    			 // cadr1;
			if ((angl>=0)&&(p[j].x< p[i].x)) angl = (1-angl) * 90+ 90;// cadr2;
			if ((angl< 0)&&(p[j].x< p[i].x)) angl = angl * 90    +180;// cadr3;
			if ((angl< 0)&&(p[j].x>=p[i].x)) angl = (1-angl) * 90+270;// cadr2;

			if (angl<mang)
			{
				mid = j;
				mang = angl;
				u[j]=1;
			}
		}
		list[nl++] = mid;
	}

	float aria=0;
	float x1, y1, x2, y2;

	for (i=1;i<mid-1;i++)
	{

		x1 = (p[list[i  ]].x - p[list[0]].x);
		x2 = (p[list[i+1]].x - p[list[0]].x);
		y1 = (p[list[i  ]].y - p[list[0]].y);
		y2 = (p[list[i+1]].y - p[list[0]].y);

		aria+=(x1*y2)-(x2*y1);
	}
	FILE *f = fopen("inter.out", "w");

	fprintf(f, "%.2f", aria);

	fclose(f);
}


void main()
{
	input();
	convexhull();
}