#include <stdio.h>
#include <memory.h>

struct proc {
    unsigned long k1, k2, T;
};

inline unsigned long min(unsigned long a, unsigned long b)
{
   if (a < b) return a;
   else return b;
}

inline unsigned long max(unsigned long a, unsigned long b)
{
   if (a > b) return a;
   else return b;
}


int main(void)
{
    proc *m_p[2000];

    unsigned long n, k, k1, k2, time = 0, m_op, cT;
    long i, j, p;
    FILE *f = fopen("proc.in", "r");
    fscanf(f, "%lu %lu %ld", &n, &k, &p);
    fclose(f);

    for (i=0; i<p; i++)
    {
       m_p[i] = new proc;
       memset(m_p[i], 0, sizeof(proc));
    }

    k1 = k;
    k2 = n-k1;

    m_p[0]->k1 = k1;
    m_p[0]->k2 = k2;
    m_p[0]->T  = k1 + k2*2;

    for (i=1; i<p; i++)
    {
	for (j=i-1; j>=0; j--)
	{
	    m_op = (m_p[j]->T + i) / (i+1);

	    k2 = min(m_op / 2   , m_p[j]->k2);
	    k1 = min(m_op - k2*2, m_p[j]->k1);
	    cT = k1 + k2 * 2;

	    m_p[j]->k1 -= k1;
	    m_p[j]->k2 -= k2;
	    m_p[j]->T  -= cT * (j+1);

	    m_p[i]->k1 += k1;
	    m_p[i]->k2 += k2;
	}
	m_p[i]->T  += (m_p[i]->k1 + m_p[i]->k2 * 2) * (i+1);
    }

    time = 0;
    for (i=0; i<p; i++) time = max(time, m_p[i]->T);

    f = fopen("proc.out", "w");
    fprintf(f, "%lu", time);
    fclose(f);

    return 0;
}
